module     p0_ddbar_neepdubar_abbrevd35h0
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh0
   implicit none
   private
   complex(ki), public :: rat2d35
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      rat2d35 = 0
      rat2 = rat2 + rat2d35
   end subroutine
end module p0_ddbar_neepdubar_abbrevd35h0
