module     p0_ddbar_neepdubar_diagramsh0l0
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity0/diagramsl0.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_color, only: numcs
   use p0_ddbar_neepdubar_config, only: ki
   implicit none

   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   complex(ki), dimension(numcs), parameter :: zero_col = 0.0_ki

   public :: amplitude

contains
   function     amplitude()
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_color
      use p0_ddbar_neepdubar_config, only: debug_lo_diagrams, &
        & use_sorted_sum
      use p0_ddbar_neepdubar_accu, only: sorted_sum
      use p0_ddbar_neepdubar_util, only: inspect_lo_diagram
      implicit none
      complex(ki), dimension(numcs) :: amplitude
      complex(ki), dimension(4,numcs) :: diagrams
      integer :: i
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      diagrams(:,:) = (0.0_ki, 0.0_ki)
      t1 = es34+i_*mW*wW-mW*mW
      t2 = spak1k2*spbk4k2*spbk6k2
      t3 = t1*es12*es345
      t4 = spak1k6*spbk6k2*spbk6k4
      t5 = t1*NC*es12*es345
      diagrams(2, :) = (spak3k5*i_*TR*(4.0_ki)*((-(t4/t3+t2/t3))*c2+(t2/t5+t4/t5&
      &)*c1))
      t2 = spak1k3*spbk2k1*spbk6k4
      t1 = (es12+es34-(es56+es345))*t1
      t3 = t1*es12
      t4 = spak3k5*spbk5k2*spbk6k4
      t1 = t1*NC*es12
      diagrams(1, :) = (spak1k5*i_*TR*(4.0_ki)*((t2/t1-t4/t1)*c1+(t4/t3-t2/t3)*c&
      &2))
      if (debug_lo_diagrams) then
         call inspect_lo_diagram(diagrams(1,:), 1, 0, 19)
         call inspect_lo_diagram(diagrams(2,:), 2, 0, 19)
         call inspect_lo_diagram(diagrams(3,:), 3, 0, 19)
         call inspect_lo_diagram(diagrams(4,:), 4, 0, 19)
      end if

      if (use_sorted_sum) then
         do i=1,numcs
            amplitude(i) = sorted_sum(diagrams(:,i))
         end do
      else
         do i=1,numcs
            amplitude(i) = sum(diagrams(:,i))
         end do
      end if
   end function     amplitude
end module p0_ddbar_neepdubar_diagramsh0l0
