module     p0_ddbar_neepdubar_abbrevd54h1
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb54n1
   complex(ki), public :: abb54n2
   complex(ki), public :: abb54n3
   complex(ki), public :: abb54n4
   complex(ki), public :: abb54n5
   complex(ki), public :: abb54n6
   complex(ki), public :: abb54n7
   complex(ki), public :: abb54n8
   complex(ki), public :: abb54n9
   complex(ki), public :: rat2d54
   complex(ki), public :: abb54n11
   complex(ki), public :: abb54n12
   complex(ki), public :: abb54n13
   complex(ki), public :: abb54n14
   complex(ki), public :: abb54n15
   complex(ki), public :: abb54n16
   complex(ki), public :: abb54n17
   complex(ki), public :: abb54n18
   complex(ki), public :: abb54n19
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   real(ki) :: t40
   real(ki) :: t41
   real(ki) :: t42
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = c2*i_
      t2 = t1*spak2k3
      t3 = t2*spak2k5*spbk4k2
      t40 = TR*TR
      t4 = t40*t3*spbk6k1
      t5 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t6 = es234*t5
      t7 = t2*spak3k5*spbk4k3
      t8 = t40*t7*spbk6k1
      t9 = NC*NC*t6
      t10 = c1*i_
      t11 = t10*spak2k3
      t12 = t11*spak2k5*spbk4k2
      t13 = t40*t12*spbk6k1
      t14 = NC*t5
      t15 = es234*t14
      t16 = t11*spak3k5*spbk4k3
      t17 = t40*t16*spbk6k1
      t18 = NC*c1
      t19 = t18*i_
      t20 = t19*spak2k3
      t21 = t20*spak2k5*spbk4k2
      t22 = t40*t21*spbk6k1
      t23 = t20*spak3k5*spbk4k3
      t24 = t40*t23*spbk6k1
      t25 = es61*c2*i_*spak2k3
      t26 = t40*t25*spak2k5*spbk4k2*spbk6k1
      t41 = es234*es234
      t27 = t41*t5
      t25 = t40*t25*spak3k5*spbk4k3*spbk6k1
      t28 = t1*spak1k2*spak2k3
      t29 = TR*spbk6k1
      t29 = t29*t29
      t30 = t28*t29*spak5k6*spbk4k2
      t31 = t1*spak1k3*spak2k3
      t32 = t29*t31*spak5k6*spbk4k3
      t1 = t1*spak1k5*spak2k3
      t33 = t1*t29*spak2k6*spbk4k2
      t34 = t1*t29*spak3k6*spbk4k3
      t42 = NC*es234
      t5 = t42*t42*t5
      t35 = es61*c1*i_*spak2k3
      t14 = t41*t14
      t36 = t10*spak1k2*spak2k3
      t37 = t10*spak1k3*spak2k3
      t10 = t10*spak1k5*spak2k3
      t18 = es61*t18*i_*spak2k3
      t38 = t19*spak1k2*spak2k3
      t39 = t19*spak1k3*spak2k3
      t19 = t19*spak1k5*spak2k3
      abb54n1 = ((4.0_ki)*(t17/t15+t22/t6+t25/t5+t26/t27+t32/t27+t33/t27+t30/t5+&
      &t34/t5+t4/t9+t8/t6+t10/t14*t29*spak2k6*spbk4k2+t29/t14*t37*spak5k6*spbk4k&
      &3+t19/t27*t29*spak3k6*spbk4k3+t29/t27*t38*spak5k6*spbk4k2+t40*t35/t14*spa&
      &k2k5*spbk4k2*spbk6k1+t40*t18/t27*spak3k5*spbk4k3*spbk6k1-(t40*t18/t27*spa&
      &k2k5*spbk4k2*spbk6k1+t40*t35/t14*spak3k5*spbk4k3*spbk6k1+t29/t27*t39*spak&
      &5k6*spbk4k3+t19/t27*t29*spak2k6*spbk4k2+t29/t14*t36*spak5k6*spbk4k2+t10/t&
      &14*t29*spak3k6*spbk4k3+t8/t9+t4/t6+t33/t5+t32/t5+t34/t27+t30/t27+t26/t5+t&
      &25/t27+t24/t6+t13/t15)))
      t6 = t40*t1*spbk4k2*spbk6k1
      abb54n2 = ((4.0_ki)*(t6/t5+t40*t19/t27*spbk4k2*spbk6k1-(t40*t10/t14*spbk4k&
      &2*spbk6k1+t6/t27)))
      t1 = t40*t1*spbk4k3*spbk6k1
      abb54n3 = ((4.0_ki)*(t1/t27+t40*t10/t14*spbk4k3*spbk6k1-(t40*t19/t27*spbk4&
      &k3*spbk6k1+t1/t5)))
      t1 = t2*spak5k6
      t6 = t40*t1*spbk4k2*spbk6k1
      t9 = t11*spak5k6
      t10 = t20*spak5k6
      abb54n4 = ((4.0_ki)*(t6/t5+t40*t10/t27*spbk4k2*spbk6k1-(t40/t14*t9*spbk4k2&
      &*spbk6k1+t6/t27)))
      t6 = t4/t27
      t15 = t8/t27
      t4 = t4/t5
      t8 = t8/t5
      t13 = t13/t14
      t17 = t17/t14
      t18 = t22/t27
      t19 = t24/t27
      abb54n5 = ((16.0_ki)*(t13+t19+t6+t8-(t4+t18+t17+t15)))
      abb54n6 = ((16.0_ki)*(t15+t17+t18+t4-(t8+t6+t19+t13)))
      t4 = t40*t3*spbk5k1
      t6 = t40*t2*spak2k6*spbk4k2*spbk6k1
      t8 = t40*t7*spbk5k1
      t2 = t40*t2*spak3k6*spbk4k3*spbk6k1
      abb54n7 = ((8.0_ki)*(t2/t5+t4/t27+t6/t27+t8/t5+t40*t12/t14*spbk5k1+t40*t23&
      &/t27*spbk5k1+t40*t11/t14*spak2k6*spbk4k2*spbk6k1+t40*t20/t27*spak3k6*spbk&
      &4k3*spbk6k1-(t40*t20/t27*spak2k6*spbk4k2*spbk6k1+t40*t11/t14*spak3k6*spbk&
      &4k3*spbk6k1+t40*t21/t27*spbk5k1+t40*t16/t14*spbk5k1+t6/t5+t4/t5+t8/t27+t2&
      &/t27)))
      t1 = t40*t1*spbk4k3*spbk6k1
      abb54n8 = ((4.0_ki)*(t1/t27+t40/t14*t9*spbk4k3*spbk6k1-(t40*t10/t27*spbk4k&
      &3*spbk6k1+t1/t5)))
      t1 = t40*t28*spbk4k2*spbk6k1
      t2 = t40*t31*spbk4k3*spbk6k1
      t3 = t40*t3*spbk6k5
      t4 = t40*t7*spbk6k5
      abb54n9 = ((8.0_ki)*(t1/t27+t2/t5+t3/t27+t4/t5+t40*t12/t14*spbk6k5+t40*t23&
      &/t27*spbk6k5+t40*t36/t14*spbk4k2*spbk6k1+t40*t39/t27*spbk4k3*spbk6k1-(t40&
      &*t38/t27*spbk4k2*spbk6k1+t40*t37/t14*spbk4k3*spbk6k1+t40*t21/t27*spbk6k5+&
      &t40*t16/t14*spbk6k5+t3/t5+t4/t27+t2/t27+t1/t5)))
      rat2d54 = 0
      rat2 = rat2 + rat2d54
      abb54n11 = abb54n1
      abb54n12 = -(abb54n2)
      abb54n13 = -(abb54n3)
      abb54n14 = -(abb54n4)
      abb54n15 = -(abb54n5)
      abb54n16 = -(abb54n6)
      abb54n17 = -(abb54n7)
      abb54n18 = -(abb54n8)
      abb54n19 = -(abb54n9)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd54h1
