module     p0_ddbar_neepdubar_d63h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity1/d63h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d63
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd63h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      real(ki) :: t24
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t2 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t3 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t4 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t5 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t6 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t22 = dotproduct(k3, qshift)
      t23 = dotproduct(k4, qshift)
      t24 = dotproduct(k6, qshift)
      t7 = (spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-sp&
      &vak5k4(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb63n17+t1*abb63n36+t2*abb63n38+abb63n32*dotproduct(k5, q&
         &shift)+abb63n37*dotproduct(k2, qshift)+t1*t22*abb63n30+t1*t23*abb63n30&
         &+t1*t24*abb63n30+t1*t3*abb63n28+t1*t4*abb63n29+t1*t6*abb63n21+t1*t8*ab&
         &b63n24+t2*t22*abb63n22+t2*t23*abb63n22+t2*t24*abb63n22+t2*t3*abb63n18+&
         &t2*t4*abb63n19+t2*t5*abb63n20+t2*t7*abb63n23)
         return
      end if
      t9 = spvak2k1(iv1)
      t10 = spvak5k1(iv1)
      t11 = k3(iv1)
      t12 = k4(iv1)
      t13 = k6(iv1)
      t14 = t9*abb63n41
      t15 = spvak2k4(iv1)
      t16 = spvak2k6(iv1)
      t17 = spvak3k4(iv1)
      t18 = spvak3k6(iv1)
      t19 = t10*abb63n33
      t20 = spvak5k4(iv1)
      t21 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb63n26+k5(iv1)*abb63n31+t10*abb63n27+t14*t22+t14&
         &*t23+t14*t24+t19*t22+t19*t23+t19*t24+t9*abb63n25+t1*t11*abb63n33+t1*t1&
         &2*abb63n33+t1*t13*abb63n33+t1*t15*abb63n39+t1*t16*abb63n42+t1*t17*abb6&
         &3n34+t1*t18*abb63n35+t10*t3*abb63n35+t10*t4*abb63n34+t10*t6*abb63n42+t&
         &10*t8*abb63n39+t11*t2*abb63n41+t12*t2*abb63n41+t13*t2*abb63n41+t17*t2*&
         &abb63n44+t18*t2*abb63n45+t2*t20*abb63n40+t2*t21*abb63n43+t3*t9*abb63n4&
         &5+t4*t9*abb63n44+t5*t9*abb63n43+t7*t9*abb63n40)
         return
      end if
      t1 = spvak2k1(iv2)
      t2 = spvak5k1(iv2)
      t3 = k3(iv2)
      t4 = k4(iv2)
      t5 = k6(iv2)
      t6 = spvak3k4(iv2)
      t7 = spvak3k6(iv2)
      if(deg.eq.2) then
         numerator = (spvak2k4(iv2)*t10*abb63n24+spvak2k6(iv2)*t10*abb63n21+spva&
         &k5k4(iv2)*t9*abb63n23+spvak5k6(iv2)*t9*abb63n20+t1*t11*abb63n22+t1*t12&
         &*abb63n22+t1*t13*abb63n22+t1*t17*abb63n19+t1*t18*abb63n18+t1*t20*abb63&
         &n23+t1*t21*abb63n20+t10*t3*abb63n30+t10*t4*abb63n30+t10*t5*abb63n30+t1&
         &0*t6*abb63n29+t10*t7*abb63n28+t11*t2*abb63n30+t12*t2*abb63n30+t13*t2*a&
         &bb63n30+t15*t2*abb63n24+t16*t2*abb63n21+t17*t2*abb63n29+t18*t2*abb63n2&
         &8+t3*t9*abb63n22+t4*t9*abb63n22+t5*t9*abb63n22+t6*t9*abb63n19+t7*t9*ab&
         &b63n18)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d63:
   subroutine     reconstruct_d63(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_63:
      coeffs%coeffs_63%c0 = derivative(czip)
      coeffs%coeffs_63%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_63%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_63%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_63%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_63%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_63%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_63%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_63%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_63%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_63%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_63%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_63%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_63%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_63%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_63:
   end subroutine reconstruct_d63
!---#] subroutine reconstruct_d63:
end module p0_ddbar_neepdubar_d63h1l1d
