module     p1_ddbar_neepscbar_abbrevd30h0
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb30n1
   complex(ki), public :: abb30n2
   complex(ki), public :: abb30n3
   complex(ki), public :: abb30n4
   complex(ki), public :: rat2d30
   complex(ki), public :: abb30n6
   complex(ki), public :: abb30n7
   complex(ki), public :: abb30n8
   complex(ki), public :: abb30n9
   complex(ki), public :: abb30n10
   complex(ki), public :: abb30n11
   complex(ki), public :: abb30n12
   complex(ki), public :: abb30n13
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   real(ki) :: t10
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak3k5
      t10 = TR*TR
      t4 = es345*NC*t1
      t5 = c1*i_
      t6 = t5*spak3k5
      t7 = t10*t6*spak3k6*spbk4k3*spbk6k2
      t1 = es345*t1
      t8 = t10*t6*spak5k6*spbk5k4*spbk6k2
      t9 = NC*NC*t1
      abb30n1 = ((8.0_ki)*(t10*t3/t4*spak5k6*spbk5k4*spbk6k2-t10*t3/t4*spak3k6*s&
      &pbk4k3*spbk6k2)+(4.0_ki)*(t7/t1+t7/t9-(t8/t9+t8/t1)))
      t7 = t10*t5*spak1k3*spak3k5*spbk4k3*spbk6k2
      t5 = t10*t5*spak1k5*spak3k5*spbk5k4*spbk6k2
      abb30n2 = ((16.0_ki)*(t10*t2/t4*spak1k5*spak3k5*spbk5k4*spbk6k2-t10*t2/t4*&
      &spak1k3*spak3k5*spbk4k3*spbk6k2)+(8.0_ki)*(t7/t1+t7/t9-(t5/t9+t5/t1)))
      t2 = t10*t6*spbk4k3
      abb30n3 = ((4.0_ki)*(t2/t1+t2/t9-(2.0_ki)*t10*t3/t4*spbk4k3))
      t2 = t10*t6*spbk5k4
      abb30n4 = ((4.0_ki)*((2.0_ki)*t10*t3/t4*spbk5k4-(t2/t9+t2/t1)))
      rat2d30 = 0
      rat2 = rat2 + rat2d30
      abb30n6 = -(abb30n1)
      abb30n7 = abb30n4
      abb30n8 = abb30n3
      abb30n9 = abb30n2
      abb30n10 = abb30n1
      abb30n11 = -(abb30n2)
      abb30n12 = -(abb30n3)
      abb30n13 = -(abb30n4)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd30h0
