module     p1_ddbar_neepscbar_abbrevd27h1
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb27n1
   complex(ki), public :: abb27n2
   complex(ki), public :: abb27n3
   complex(ki), public :: abb27n4
   complex(ki), public :: abb27n5
   complex(ki), public :: abb27n6
   complex(ki), public :: abb27n7
   complex(ki), public :: abb27n8
   complex(ki), public :: abb27n9
   complex(ki), public :: rat2d27
   complex(ki), public :: abb27n11
   complex(ki), public :: abb27n12
   complex(ki), public :: abb27n13
   complex(ki), public :: abb27n14
   complex(ki), public :: abb27n15
   complex(ki), public :: abb27n16
   complex(ki), public :: abb27n17
   complex(ki), public :: abb27n18
   complex(ki), public :: abb27n19
   complex(ki), public :: abb27n20
   complex(ki), public :: abb27n21
   complex(ki), public :: abb27n22
   complex(ki), public :: abb27n23
   complex(ki), public :: abb27n24
   complex(ki), public :: abb27n25
   complex(ki), public :: abb27n26
   complex(ki), public :: abb27n27
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   real(ki) :: t46
   real(ki) :: t47
   real(ki) :: t48
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak2k3*spak3k5
      t4 = t3*spbk4k3
      t46 = TR*TR
      t5 = t46*t4*spbk6k1
      t6 = es12*t1
      t7 = es345*t6
      t8 = t2*spak2k5*spak3k5
      t9 = t8*spbk5k4
      t10 = t46*t9*spbk6k1
      t11 = NC*NC*t7
      t12 = c2*i_
      t13 = t12*spak2k3*spak3k5
      t14 = t13*spbk4k3
      t15 = t46*t14*spbk6k1
      t1 = es12*NC*t1
      t16 = es345*t1
      t17 = t12*spak2k5*spak3k5
      t18 = t17*spbk5k4
      t19 = t46*t18*spbk6k1
      t20 = NC*c2
      t21 = t20*i_
      t22 = t21*spak2k3*spak3k5
      t23 = t22*spbk4k3
      t24 = t46*t23*spbk6k1
      t25 = t21*spak2k5*spak3k5
      t26 = t25*spbk5k4
      t27 = t46*t26*spbk6k1
      t28 = es61*c1*i_
      t29 = t46*t28*spak2k3*spak3k5*spbk4k3*spbk6k1
      t47 = es345*es345
      t30 = t47*t6
      t28 = t46*t28*spak2k5*spak3k5*spbk5k4*spbk6k1
      t31 = t2*spak1k2*spak3k5
      t32 = TR*spbk6k1
      t32 = t32*t32
      t33 = t31*t32*spak3k6*spbk4k3
      t34 = t31*t32*spak5k6*spbk5k4
      t35 = t2*spak1k3
      t36 = t32*t35*spak2k6*spak3k5*spbk4k3
      t37 = t2*spak1k5
      t38 = t32*t37*spak2k6*spak3k5*spbk5k4
      t48 = NC*es345
      t6 = t48*t48*t6
      t39 = es61*c2*i_
      t1 = t47*t1
      t40 = t12*spak1k2*spak3k5
      t41 = t12*spak1k3
      t42 = t12*spak1k5
      t20 = es61*t20*i_
      t43 = t21*spak1k2*spak3k5
      t44 = t21*spak1k3
      t45 = t21*spak1k5
      abb27n1 = ((4.0_ki)*(t10/t7+t5/t11+t19/t16+t24/t7+t28/t6+t29/t30+t34/t30+t&
      &36/t30+t33/t6+t38/t6+t32/t1*t40*spak5k6*spbk5k4+t32/t30*t43*spak3k6*spbk4&
      &k3+t32/t1*t41*spak2k6*spak3k5*spbk4k3+t32/t30*t45*spak2k6*spak3k5*spbk5k4&
      &+t46*t39/t1*spak2k3*spak3k5*spbk4k3*spbk6k1+t46*t20/t30*spak2k5*spak3k5*s&
      &pbk5k4*spbk6k1-(t46*t20/t30*spak2k3*spak3k5*spbk4k3*spbk6k1+t46*t39/t1*sp&
      &ak2k5*spak3k5*spbk5k4*spbk6k1+t32/t30*t44*spak2k6*spak3k5*spbk4k3+t32/t1*&
      &t42*spak2k6*spak3k5*spbk5k4+t32/t30*t43*spak5k6*spbk5k4+t32/t1*t40*spak3k&
      &6*spbk4k3+t5/t7+t36/t6+t34/t6+t38/t30+t33/t30+t29/t6+t28/t30+t27/t7+t15/t&
      &16+t10/t11)))
      t7 = t46*t31*spbk4k3*spbk6k1
      abb27n2 = ((4.0_ki)*(t7/t30+t46*t40/t1*spbk4k3*spbk6k1-(t46*t43/t30*spbk4k&
      &3*spbk6k1+t7/t6)))
      t7 = t46*t31*spbk5k4*spbk6k1
      abb27n3 = ((4.0_ki)*(t7/t6+t46*t43/t30*spbk5k4*spbk6k1-(t46*t40/t1*spbk5k4&
      &*spbk6k1+t7/t30)))
      t7 = t5/t30
      t11 = t10/t30
      t5 = t5/t6
      t10 = t10/t6
      t15 = t15/t1
      t16 = t19/t1
      t19 = t24/t30
      t20 = t27/t30
      abb27n4 = ((16.0_ki)*(t10+t15+t20+t7-(t5+t19+t16+t11)))
      abb27n5 = ((16.0_ki)*(t11+t16+t19+t5-(t7+t20+t15+t10)))
      t5 = t2*spak2k6*spak3k5
      t7 = t46*t5*spbk4k3*spbk6k1
      t10 = t12*spak2k6*spak3k5
      t11 = t21*spak2k6*spak3k5
      abb27n6 = ((4.0_ki)*(t7/t30+t46*t10/t1*spbk4k3*spbk6k1-(t46*t11/t30*spbk4k&
      &3*spbk6k1+t7/t6)))
      t5 = t46*t5*spbk5k4*spbk6k1
      abb27n7 = ((4.0_ki)*(t5/t6+t46*t11/t30*spbk5k4*spbk6k1-(t46*t10/t1*spbk5k4&
      &*spbk6k1+t5/t30)))
      t3 = t46*t3*spbk2k1*spbk4k3
      t5 = t46*t8*spbk2k1*spbk5k4
      t2 = t2*spak3k5
      t7 = t46*t2*spak3k6*spbk4k3*spbk6k1
      t2 = t46*t2*spak5k6*spbk5k4*spbk6k1
      t8 = t12*spak3k5
      t10 = t21*spak3k5
      abb27n8 = ((8.0_ki)*(t2/t30+t3/t6+t5/t30+t7/t6+t46*t17/t1*spbk2k1*spbk5k4+&
      &t46*t22/t30*spbk2k1*spbk4k3+t46/t1*t8*spak5k6*spbk5k4*spbk6k1+t46*t10/t30&
      &*spak3k6*spbk4k3*spbk6k1-(t46*t10/t30*spak5k6*spbk5k4*spbk6k1+t46/t1*t8*s&
      &pak3k6*spbk4k3*spbk6k1+t46*t25/t30*spbk2k1*spbk5k4+t46*t13/t1*spbk2k1*spb&
      &k4k3+t5/t6+t7/t30+t3/t30+t2/t6)))
      t2 = t46*t35*spak3k5*spbk4k3*spbk6k1
      t3 = t46*t37*spak3k5*spbk5k4*spbk6k1
      t4 = t46*t4*spbk6k2
      t5 = t46*t9*spbk6k2
      abb27n9 = ((8.0_ki)*(t2/t6+t3/t30+t5/t30+t4/t6+t46*t18/t1*spbk6k2+t46*t23/&
      &t30*spbk6k2+t46*t42/t1*spak3k5*spbk5k4*spbk6k1+t46*t44/t30*spak3k5*spbk4k&
      &3*spbk6k1-(t46*t45/t30*spak3k5*spbk5k4*spbk6k1+t46*t41/t1*spak3k5*spbk4k3&
      &*spbk6k1+t46*t26/t30*spbk6k2+t46*t14/t1*spbk6k2+t5/t6+t4/t30+t3/t6+t2/t30&
      &)))
      rat2d27 = 0
      rat2 = rat2 + rat2d27
      abb27n11 = abb27n1
      abb27n12 = abb27n9
      abb27n13 = abb27n8
      abb27n14 = abb27n7
      abb27n15 = abb27n6
      abb27n16 = abb27n5
      abb27n17 = abb27n4
      abb27n18 = abb27n3
      abb27n19 = abb27n2
      abb27n20 = -(abb27n2)
      abb27n21 = -(abb27n3)
      abb27n22 = -(abb27n4)
      abb27n23 = -(abb27n5)
      abb27n24 = -(abb27n6)
      abb27n25 = -(abb27n7)
      abb27n26 = -(abb27n8)
      abb27n27 = -(abb27n9)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd27h1
