module     p1_ddbar_neepscbar_abbrevd28h1
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb28n1
   complex(ki), public :: abb28n2
   complex(ki), public :: abb28n3
   complex(ki), public :: abb28n4
   complex(ki), public :: abb28n5
   complex(ki), public :: abb28n6
   complex(ki), public :: abb28n7
   complex(ki), public :: abb28n8
   complex(ki), public :: abb28n9
   complex(ki), public :: abb28n10
   complex(ki), public :: abb28n11
   complex(ki), public :: abb28n12
   complex(ki), public :: abb28n13
   complex(ki), public :: abb28n14
   complex(ki), public :: abb28n15
   complex(ki), public :: abb28n16
   complex(ki), public :: abb28n17
   complex(ki), public :: abb28n18
   complex(ki), public :: abb28n19
   complex(ki), public :: rat2d28
   complex(ki), public :: abb28n21
   complex(ki), public :: abb28n22
   complex(ki), public :: abb28n23
   complex(ki), public :: abb28n24
   complex(ki), public :: abb28n25
   complex(ki), public :: abb28n26
   complex(ki), public :: abb28n27
   complex(ki), public :: abb28n28
   complex(ki), public :: abb28n29
   complex(ki), public :: abb28n30
   complex(ki), public :: abb28n31
   complex(ki), public :: abb28n32
   complex(ki), public :: abb28n33
   complex(ki), public :: abb28n34
   complex(ki), public :: abb28n35
   complex(ki), public :: abb28n36
   complex(ki), public :: abb28n37
   complex(ki), public :: abb28n38
   complex(ki), public :: abb28n39
   complex(ki), public :: abb28n40
   complex(ki), public :: abb28n41
   complex(ki), public :: abb28n42
   complex(ki), public :: abb28n43
   complex(ki), public :: abb28n44
   complex(ki), public :: abb28n45
   complex(ki), public :: abb28n46
   complex(ki), public :: abb28n47
   complex(ki), public :: abb28n48
   complex(ki), public :: abb28n49
   complex(ki), public :: abb28n50
   complex(ki), public :: abb28n51
   complex(ki), public :: abb28n52
   complex(ki), public :: abb28n53
   complex(ki), public :: abb28n54
   complex(ki), public :: abb28n55
   complex(ki), public :: abb28n56
   complex(ki), public :: abb28n57
   complex(ki), public :: abb28n58
   complex(ki), public :: abb28n59
   complex(ki), public :: abb28n60
   complex(ki), public :: abb28n61
   complex(ki), public :: abb28n62
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   real(ki) :: t22
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak2k6
      t4 = t3*spak3k5
      t22 = TR*TR
      t5 = NC*NC*t1
      t6 = c2*i_
      t7 = t6*spak2k6
      t8 = t7*spak3k5
      t9 = NC*t1
      t10 = NC*c2*i_
      t11 = t10*spak2k6
      t12 = t11*spak3k5
      abb28n1 = ((4.0_ki)*(t22*t12/t1*spbk6k4*spbk6k5+t22*t4/t5*spbk6k4*spbk6k5-&
      &(2.0_ki)*t22*t8/t9*spbk6k4*spbk6k5))
      t13 = t2*spak2k3
      t14 = t6*spak2k3
      t15 = t10*spak2k3
      abb28n2 = ((4.0_ki)*(t22*(2.0_ki)*t14/t9*spbk4k1-(t22*t13/t5*spbk4k1+t22*t&
      &15/t1*spbk4k1)))
      t16 = t2*spak3k5
      t17 = t6*spak3k5
      t18 = t10*spak3k5
      abb28n3 = ((8.0_ki)*(t22*t18/t1*spbk4k1+t22*t16/t5*spbk4k1-t22*(2.0_ki)*t1&
      &7/t9*spbk4k1))
      t19 = t22*t13/t5*spbk6k1
      t20 = t22*(2.0_ki)*t14/t9*spbk6k1
      t21 = t22*t15/t1*spbk6k1
      abb28n4 = ((8.0_ki)*(t19+t21-t20))
      t19 = t20-(t21+t19)
      abb28n5 = ((4.0_ki)*t19)
      abb28n6 = ((8.0_ki)*t19)
      abb28n7 = ((8.0_ki)*((2.0_ki)*t22*t8/t9*spbk6k1*spbk6k4-(t22*t4/t5*spbk6k1&
      &*spbk6k4+t22*t12/t1*spbk6k1*spbk6k4)))
      abb28n8 = ((4.0_ki)*((2.0_ki)*t22*t7/t9*spbk6k1-(t22*t3/t5*spbk6k1+t22*t11&
      &/t1*spbk6k1)))
      abb28n9 = ((8.0_ki)*(-(t22*t6/t9*spak3k6*spbk6k1+t22*t14/t9*spbk2k1))+(4.0&
      &_ki)*(t22*t15/t1*spbk2k1+t22*t13/t5*spbk2k1+t22*t10/t1*spak3k6*spbk6k1+t2&
      &2*t2/t5*spak3k6*spbk6k1))
      abb28n10 = ((8.0_ki)*(-(t22*t6/t9*spak1k3*spbk4k1+t22*t14/t9*spbk4k2))+(4.&
      &0_ki)*(t22*t15/t1*spbk4k2+t22*t13/t5*spbk4k2+t22*t10/t1*spak1k3*spbk4k1+t&
      &22*t2/t5*spak1k3*spbk4k1))
      t4 = t22*t13/t5*spbk6k2
      t8 = t22*(2.0_ki)*t14/t9*spbk6k2
      t12 = t22*t15/t1*spbk6k2
      abb28n11 = ((4.0_ki)*(t12+t4-t8))
      abb28n12 = ((4.0_ki)*(t8-(t4+t12)))
      abb28n13 = ((4.0_ki)*(t22*(2.0_ki)*t14/t9*spbk5k4-(t22*t13/t5*spbk5k4+t22*&
      &t15/t1*spbk5k4)))
      t4 = t22*t15/t1*spbk6k4+t22*t13/t5*spbk6k4-t22*(2.0_ki)*t14/t9*spbk6k4
      abb28n14 = ((8.0_ki)*t4)
      abb28n15 = ((4.0_ki)*t4)
      abb28n16 = ((8.0_ki)*(t22*t7/t9*spbk6k4+t22*t6/t9*spak1k2*spbk4k1-t22*t6/t&
      &9*spak2k5*spbk5k4)+(4.0_ki)*(t22*t10/t1*spak2k5*spbk5k4+t22*t2/t5*spak2k5&
      &*spbk5k4-(t22*t2/t5*spak1k2*spbk4k1+t22*t10/t1*spak1k2*spbk4k1+t22*t3/t5*&
      &spbk6k4+t22*t11/t1*spbk6k4)))
      t3 = t22*t16/t5*spbk6k4
      t4 = t22*(2.0_ki)*t17/t9*spbk6k4
      t7 = t22*t18/t1*spbk6k4
      abb28n17 = ((8.0_ki)*(t3+t7-t4))
      abb28n18 = ((4.0_ki)*(t4-(t7+t3)))
      abb28n19 = ((4.0_ki)*(t22*t10/t1+t22*t2/t5-(2.0_ki)*t22*t6/t9))
      rat2d28 = 0
      rat2 = rat2 + rat2d28
      abb28n21 = -(abb28n1)
      abb28n22 = abb28n19
      abb28n23 = abb28n18
      abb28n24 = abb28n17
      abb28n25 = abb28n16
      abb28n26 = abb28n15
      abb28n27 = abb28n14
      abb28n28 = abb28n13
      abb28n29 = abb28n12
      abb28n30 = abb28n11
      abb28n31 = abb28n10
      abb28n32 = abb28n9
      abb28n33 = abb28n8
      abb28n34 = abb28n7
      abb28n35 = abb28n6
      abb28n36 = abb28n5
      abb28n37 = abb28n4
      abb28n38 = abb28n3
      abb28n39 = abb28n2
      abb28n40 = abb28n1
      abb28n41 = -(abb28n2)
      abb28n42 = -(abb28n3)
      abb28n43 = -(abb28n4)
      t1 = (2.0_ki)*abb28n5
      abb28n44 = t1
      abb28n45 = -(abb28n5)
      abb28n46 = -(t1)
      abb28n47 = -(abb28n6)
      abb28n48 = -(abb28n7)
      abb28n49 = -(abb28n8)
      abb28n50 = -(abb28n9)
      abb28n51 = -(abb28n10)
      abb28n52 = -(abb28n11)
      abb28n53 = -(abb28n12)
      abb28n54 = -(abb28n13)
      abb28n55 = -(abb28n14)
      t1 = (2.0_ki)*abb28n15
      abb28n56 = t1
      abb28n57 = -(abb28n15)
      abb28n58 = -(t1)
      abb28n59 = -(abb28n16)
      abb28n60 = -(abb28n17)
      abb28n61 = -(abb28n18)
      abb28n62 = -(abb28n19)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd28h1
