module     p7_udbar_neepuubar_abbrevd56h1
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb56n1
   complex(ki), public :: abb56n2
   complex(ki), public :: abb56n3
   complex(ki), public :: abb56n4
   complex(ki), public :: abb56n5
   complex(ki), public :: abb56n6
   complex(ki), public :: abb56n7
   complex(ki), public :: abb56n8
   complex(ki), public :: abb56n9
   complex(ki), public :: abb56n10
   complex(ki), public :: abb56n11
   complex(ki), public :: abb56n12
   complex(ki), public :: abb56n13
   complex(ki), public :: rat2d56
   complex(ki), public :: abb56n15
   complex(ki), public :: abb56n16
   complex(ki), public :: abb56n17
   complex(ki), public :: abb56n18
   complex(ki), public :: abb56n19
   complex(ki), public :: abb56n20
   complex(ki), public :: abb56n21
   complex(ki), public :: abb56n22
   complex(ki), public :: abb56n23
   complex(ki), public :: abb56n24
   complex(ki), public :: abb56n25
   complex(ki), public :: abb56n26
   complex(ki), public :: abb56n27
   complex(ki), public :: abb56n28
   complex(ki), public :: abb56n29
   complex(ki), public :: abb56n30
   complex(ki), public :: abb56n31
   complex(ki), public :: abb56n32
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   real(ki) :: t20
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_udbar_neepuubar_config, only: deltaOS
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_model
      use p7_udbar_neepuubar_color, only: TR
      use p7_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak2k3
      t4 = t3*spak2k5
      t20 = TR*TR
      t5 = NC*t1
      t6 = t2*spak2k5
      t7 = t6*spak3k5
      t8 = c2*i_
      t9 = t8*spak2k3
      t10 = t9*spak2k5
      t11 = t20*t10*spbk6k2*spbk6k4
      t12 = t8*spak2k5
      t13 = t12*spak3k5
      t14 = t20*t13*spbk6k4*spbk6k5
      t15 = NC*NC*t1
      abb56n1 = ((8.0_ki)*(t20*t4/t5*spbk6k2*spbk6k4+t20/t5*t7*spbk6k4*spbk6k5)+&
      &(4.0_ki)*(-(t14/t15+t11/t15+t14/t1+t11/t1)))
      t11 = t4*spbk2k1
      t14 = t7*spbk4k1
      t16 = t10*spbk2k1
      t17 = t20*t16*spbk4k1
      t18 = t13*spbk4k1
      t19 = t20*t18*spbk5k1
      abb56n2 = ((8.0_ki)*(t20*t11/t5*spbk4k1+t20*t14/t5*spbk5k1)+(4.0_ki)*(-(t1&
      &9/t15+t17/t15+t19/t1+t17/t1)))
      t17 = t20*t10*spbk4k1*spbk6k2
      t18 = t20*t18*spbk6k5
      abb56n3 = ((16.0_ki)*(t20*t14/t5*spbk6k5+t20*t4/t5*spbk4k1*spbk6k2)+(8.0_k&
      &i)*(-(t18/t15+t17/t15+t18/t1+t17/t1)))
      t14 = t20*t12*spbk4k1
      t17 = t14/t1
      t14 = t14/t15
      t18 = (2.0_ki)*t20/t5*t6*spbk4k1
      abb56n4 = ((8.0_ki)*(t14+t17-t18))
      t14 = t18-(t17+t14)
      abb56n5 = ((4.0_ki)*t14)
      abb56n6 = ((8.0_ki)*t14)
      t14 = t20*t16*spbk6k4
      t16 = t20*t13*spbk5k1*spbk6k4
      abb56n7 = ((16.0_ki)*(t20*t11/t5*spbk6k4+t20/t5*t7*spbk5k1*spbk6k4)+(8.0_k&
      &i)*(-(t16/t15+t14/t15+t16/t1+t14/t1)))
      t11 = t20*t12*spbk6k1
      t14 = t11/t1
      t11 = t11/t15
      t16 = (2.0_ki)*t20/t5*t6*spbk6k1
      abb56n8 = ((8.0_ki)*(t11+t14-t16))
      abb56n9 = ((8.0_ki)*(t16-(t14+t11)))
      t11 = t20*t8*spak1k2*spak3k5*spbk4k1*spbk6k1
      t14 = t20*t8*spak1k5*spak2k3*spbk4k1*spbk6k1
      t10 = t20*t10*spbk4k2*spbk6k1
      t9 = t20*t9*spak5k6*spbk6k1*spbk6k4
      t13 = t20*t13*spbk5k4*spbk6k1
      t8 = t20*t8*spak2k6*spak3k5*spbk6k1*spbk6k4
      abb56n10 = ((8.0_ki)*(t20/t5*t7*spbk5k4*spbk6k1+t20*t2/t5*spak1k2*spak3k5*&
      &spbk4k1*spbk6k1+t20*t2/t5*spak1k5*spak2k3*spbk4k1*spbk6k1-(t20*t2/t5*spak&
      &2k6*spak3k5*spbk6k1*spbk6k4+t20*t3/t5*spak5k6*spbk6k1*spbk6k4+t20*t4/t5*s&
      &pbk4k2*spbk6k1))+(4.0_ki)*(t10/t1+t8/t1+t9/t1+t10/t15+t8/t15+t9/t15-(t14/&
      &t15+t13/t15+t11/t15+t14/t1+t13/t1+t11/t1)))
      t2 = t20*t12*spbk6k4
      t1 = t2/t1
      t2 = t2/t15
      t3 = (2.0_ki)*t20/t5*t6*spbk6k4
      abb56n11 = ((8.0_ki)*(t1+t2-t3))
      t1 = t3-(t2+t1)
      abb56n12 = ((4.0_ki)*t1)
      abb56n13 = ((8.0_ki)*t1)
      rat2d56 = 0
      rat2 = rat2 + rat2d56
      abb56n15 = -(abb56n1)
      abb56n16 = abb56n13
      abb56n17 = abb56n11
      abb56n18 = abb56n10
      abb56n19 = abb56n9
      abb56n20 = abb56n8
      abb56n21 = abb56n6
      abb56n22 = abb56n4
      abb56n23 = -(abb56n2)
      abb56n24 = -(abb56n3)
      abb56n25 = -(abb56n5)
      abb56n26 = (-2.0_ki)*abb56n5
      abb56n27 = -(abb56n7)
      abb56n28 = -(abb56n8)
      abb56n29 = (-2.0_ki)*abb56n8
      abb56n30 = ((2.0_ki)*abb56n10)
      abb56n31 = -(abb56n12)
      abb56n32 = (-2.0_ki)*abb56n12
   end subroutine
end module p7_udbar_neepuubar_abbrevd56h1
