module     p7_udbar_neepuubar_abbrevd65h1
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb65n1
   complex(ki), public :: abb65n2
   complex(ki), public :: abb65n3
   complex(ki), public :: abb65n4
   complex(ki), public :: abb65n5
   complex(ki), public :: abb65n6
   complex(ki), public :: abb65n7
   complex(ki), public :: abb65n8
   complex(ki), public :: abb65n9
   complex(ki), public :: abb65n10
   complex(ki), public :: abb65n11
   complex(ki), public :: rat2d65
   complex(ki), public :: abb65n13
   complex(ki), public :: abb65n14
   complex(ki), public :: abb65n15
   complex(ki), public :: abb65n16
   complex(ki), public :: abb65n17
   complex(ki), public :: abb65n18
   complex(ki), public :: abb65n19
   complex(ki), public :: abb65n20
   complex(ki), public :: abb65n21
   complex(ki), public :: abb65n22
   complex(ki), public :: abb65n23
   complex(ki), public :: abb65n24
   complex(ki), public :: abb65n25
   complex(ki), public :: abb65n26
   complex(ki), public :: abb65n27
   complex(ki), public :: abb65n28
   complex(ki), public :: abb65n29
   complex(ki), public :: abb65n30
   complex(ki), public :: abb65n31
   complex(ki), public :: abb65n32
   complex(ki), public :: abb65n33
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   real(ki) :: t13
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_udbar_neepuubar_config, only: deltaOS
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_model
      use p7_udbar_neepuubar_color, only: TR
      use p7_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es12*c1*i_*spak2k5
      t13 = TR*TR
      t2 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t3 = NC*t2
      t4 = es12*c2*i_*spak2k5
      t5 = NC*NC*t2
      t6 = NC*c1
      t7 = es12*t6*i_*spak2k5
      abb65n1 = ((8.0_ki)*(-(t13*t1/t3*spak3k6*spbk6k1*spbk6k4+t13*t1/t3*spak3k4&
      &*spbk4k1*spbk6k4))+(4.0_ki)*(t13/t2*t7*spak3k4*spbk4k1*spbk6k4+t13/t2*t7*&
      &spak3k6*spbk6k1*spbk6k4+t13*t4/t5*spak3k4*spbk4k1*spbk6k4+t13*t4/t5*spak3&
      &k6*spbk6k1*spbk6k4))
      t1 = c1*i_
      t4 = t1*spak1k2
      t7 = c2*i_
      t8 = t7*spak1k2
      t6 = t6*i_
      t9 = t6*spak1k2
      abb65n2 = ((8.0_ki)*(t13/t3*t4*spak3k4*spbk4k1*spbk6k4+t13/t3*t4*spak3k6*s&
      &pbk6k1*spbk6k4)+(4.0_ki)*(-(t13/t5*t8*spak3k6*spbk6k1*spbk6k4+t13/t5*t8*s&
      &pak3k4*spbk4k1*spbk6k4+t13/t2*t9*spak3k6*spbk6k1*spbk6k4+t13/t2*t9*spak3k&
      &4*spbk4k1*spbk6k4)))
      t4 = t1*spak2k5
      t8 = t4*spak3k4
      t4 = t4*spak3k6
      t9 = t7*spak2k5
      t10 = t9*spak3k4
      t9 = t9*spak3k6
      t11 = t6*spak2k5
      t12 = t11*spak3k4
      t11 = t11*spak3k6
      abb65n3 = ((16.0_ki)*(t13/t3*t4*spbk6k1*spbk6k4+t13/t3*t8*spbk4k1*spbk6k4)&
      &+(8.0_ki)*(-(t13/t5*t9*spbk6k1*spbk6k4+t13*t12/t2*spbk4k1*spbk6k4+t13*t11&
      &/t2*spbk6k1*spbk6k4+t13*t10/t5*spbk4k1*spbk6k4)))
      abb65n4 = ((8.0_ki)*(-(t13/t3*t8*spbk4k2*spbk6k4+t13/t3*t4*spbk6k2*spbk6k4&
      &))+(4.0_ki)*(t13*t10/t5*spbk4k2*spbk6k4+t13*t11/t2*spbk6k2*spbk6k4+t13*t1&
      &2/t2*spbk4k2*spbk6k4+t13/t5*t9*spbk6k2*spbk6k4))
      t4 = t13/t5*t7*spak3k4*spbk6k4
      t8 = t13*(2.0_ki)*t1/t3*spak3k4*spbk6k4
      t9 = t13/t2*t6*spak3k4*spbk6k4
      abb65n5 = ((4.0_ki)*(t4+t9-t8))
      abb65n6 = ((4.0_ki)*(t8-(t9+t4)))
      t4 = t7*spak3k5
      t8 = t1*spak3k5
      t9 = t6*spak3k5
      abb65n7 = ((8.0_ki)*(t13/t2*t9*spbk6k4+t13*t4/t5*spbk6k4-(2.0_ki)*t13/t3*t&
      &8*spbk6k4))
      t10 = t13/t5*t7*spak3k6*spbk6k4
      t11 = t13*(2.0_ki)*t1/t3*spak3k6*spbk6k4
      t12 = t13/t2*t6*spak3k6*spbk6k4
      abb65n8 = ((4.0_ki)*(t10+t12-t11))
      abb65n9 = ((4.0_ki)*(t11-(t12+t10)))
      abb65n10 = ((8.0_ki)*(t13/t3*t8*spbk6k3+t13*t1/t3*spak4k5*spbk6k4)+(4.0_ki&
      &)*(-(t13/t5*t7*spak4k5*spbk6k4+t13/t2*t6*spak4k5*spbk6k4+t13*t4/t5*spbk6k&
      &3+t13/t2*t9*spbk6k3)))
      abb65n11 = ((8.0_ki)*(-(t13*t1/t3*spak5k6*spbk6k4+t13/t3*t8*spbk4k3))+(4.0&
      &_ki)*(t13/t2*t9*spbk4k3+t13*t4/t5*spbk4k3+t13/t2*t6*spak5k6*spbk6k4+t13/t&
      &5*t7*spak5k6*spbk6k4))
      rat2d65 = 0
      rat2 = rat2 + rat2d65
      abb65n13 = abb65n1
      abb65n14 = abb65n11
      abb65n15 = abb65n10
      abb65n16 = abb65n9
      abb65n17 = abb65n8
      abb65n18 = abb65n7
      abb65n19 = abb65n6
      abb65n20 = abb65n5
      abb65n21 = abb65n4
      abb65n22 = abb65n3
      abb65n23 = abb65n2
      abb65n24 = -(abb65n2)
      abb65n25 = -(abb65n3)
      abb65n26 = -(abb65n4)
      abb65n27 = -(abb65n5)
      abb65n28 = -(abb65n6)
      abb65n29 = -(abb65n7)
      abb65n30 = -(abb65n8)
      abb65n31 = -(abb65n9)
      abb65n32 = -(abb65n10)
      abb65n33 = -(abb65n11)
   end subroutine
end module p7_udbar_neepuubar_abbrevd65h1
