module     p7_udbar_neepuubar_abbrevd67h1
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb67n1
   complex(ki), public :: abb67n2
   complex(ki), public :: abb67n3
   complex(ki), public :: abb67n4
   complex(ki), public :: abb67n5
   complex(ki), public :: abb67n6
   complex(ki), public :: abb67n7
   complex(ki), public :: abb67n8
   complex(ki), public :: abb67n9
   complex(ki), public :: abb67n10
   complex(ki), public :: abb67n11
   complex(ki), public :: abb67n12
   complex(ki), public :: abb67n13
   complex(ki), public :: rat2d67
   complex(ki), public :: abb67n15
   complex(ki), public :: abb67n16
   complex(ki), public :: abb67n17
   complex(ki), public :: abb67n18
   complex(ki), public :: abb67n19
   complex(ki), public :: abb67n20
   complex(ki), public :: abb67n21
   complex(ki), public :: abb67n22
   complex(ki), public :: abb67n23
   complex(ki), public :: abb67n24
   complex(ki), public :: abb67n25
   complex(ki), public :: abb67n26
   complex(ki), public :: abb67n27
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   complex(ki) :: t50
   complex(ki) :: t51
   complex(ki) :: t52
   complex(ki) :: t53
   complex(ki) :: t54
   complex(ki) :: t55
   complex(ki) :: t56
   complex(ki) :: t57
   real(ki) :: t58
   real(ki) :: t59
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_udbar_neepuubar_config, only: deltaOS
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_model
      use p7_udbar_neepuubar_color, only: TR
      use p7_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak1k3
      t4 = t3*spak2k5*spbk4k1
      t58 = TR*TR
      t5 = t58*t4*spbk6k1
      t6 = (es34+es56-(es234+es12))*t1
      t7 = es56*t6
      t8 = t5/t7
      t9 = t2*spak2k5*spak3k4*spbk4k1
      t10 = t58*t9*spbk6k4
      t11 = t10/t7
      t12 = t2*spak2k3
      t13 = t12*spak2k5*spbk4k2
      t14 = t58*t13*spbk6k1
      t15 = es234*t1
      t16 = es56*t15
      t17 = t14/t16
      t18 = t12*spak3k5*spbk4k3
      t19 = t58*t18*spbk6k1
      t20 = t19/t16
      t59 = NC*NC
      t21 = t59*t7
      t22 = t5/t21
      t23 = t10/t21
      t24 = c2*i_
      t25 = t24*spak1k3
      t26 = t25*spak2k5*spbk4k1
      t27 = t58*t26*spbk6k1
      t28 = NC*t6
      t29 = es56*t28
      t30 = t27/t29
      t31 = t24*spak2k5*spak3k4*spbk4k1
      t32 = t58*t31*spbk6k4
      t33 = t32/t29
      t34 = NC*c2*i_
      t35 = t34*spak1k3
      t36 = t35*spak2k5*spbk4k1
      t37 = t58*t36/t7*spbk6k1
      t38 = t34*spak2k5*spak3k4*spbk4k1
      t39 = t58*t38/t7*spbk6k4
      t40 = t59*t16
      t41 = t14/t40
      t42 = t19/t40
      t43 = t24*spak2k3
      t44 = t43*spak2k5*spbk4k2
      t45 = t58*t44*spbk6k1
      t1 = es234*NC*t1
      t46 = es56*t1
      t47 = t45/t46
      t48 = t43*spak3k5*spbk4k3
      t49 = t58*t48*spbk6k1
      t50 = t49/t46
      t51 = t34*spak2k3
      t52 = t51*spak2k5*spbk4k2
      t53 = t58*t52/t16*spbk6k1
      t54 = t51*spak3k5*spbk4k3
      t55 = t58*t54/t16*spbk6k1
      abb67n1 = ((2.0_ki)*(t11+t20+t30+t33+t41+t50+t53+t8-(t55+t47+t42+t39+t37+t&
      &23+t22+t17)))
      t56 = t58*t12/t7*spbk4k1
      t57 = t58*t51/t7*spbk4k1
      abb67n2 = ((8.0_ki)*(t56-t57))
      abb67n3 = ((8.0_ki)*(t57-t56))
      abb67n4 = ((4.0_ki)*(t58*t51/t7*spbk3k1+t58*t34/t7*spak2k4*spbk4k1-(t58*t2&
      &/t7*spak2k4*spbk4k1+t58*t12/t7*spbk3k1)))
      t56 = t2*spak3k4
      t24 = t24*spak3k4
      abb67n5 = ((4.0_ki)*(t58*t24/t29*spbk4k1-t58*t56/t21*spbk4k1))
      t6 = t59*t6
      t15 = t59*t15
      abb67n6 = ((4.0_ki)*(t49/t1+t14/t15+t27/t28+t32/t28-(t5/t6+t19/t15+t10/t6+&
      &t45/t1)))
      t1 = t58*t4*spbk5k1
      t4 = t58*t9*spbk5k4
      t5 = t58*t13*spbk5k1
      t6 = t58*t18*spbk5k1
      abb67n7 = ((4.0_ki)*(t5/t40+t58*t26/t29*spbk5k1+t58*t31/t29*spbk5k4+t58*t4&
      &8/t46*spbk5k1-(t58*t44/t46*spbk5k1+t6/t40+t4/t21+t1/t21))+(2.0_ki)*(t1/t7&
      &+t6/t16+t4/t7+t58*t52/t16*spbk5k1+t58*t12/t16*spak3k6*spbk4k3*spbk6k1+t58&
      &*t51/t16*spak2k6*spbk4k2*spbk6k1+t58*t3/t7*spak2k6*spbk4k1*spbk6k1+t58*t2&
      &/t7*spak2k6*spak3k4*spbk4k1*spbk6k4-(t58*t34/t7*spak2k6*spak3k4*spbk4k1*s&
      &pbk6k4+t58*t35/t7*spak2k6*spbk4k1*spbk6k1+t58*t51/t16*spak3k6*spbk4k3*spb&
      &k6k1+t58*t12/t16*spak2k6*spbk4k2*spbk6k1+t58*t38/t7*spbk5k4+t58*t36/t7*sp&
      &bk5k1+t58*t54/t16*spbk5k1+t5/t16)))
      t1 = t58*t3*spak5k6*spbk4k1*spbk6k1
      t4 = t58*t56*spak5k6*spbk4k1*spbk6k4
      t5 = t12*spak5k6
      t6 = t58*t5*spbk4k2*spbk6k1
      t9 = t43*spak5k6
      t10 = t51*spak5k6
      abb67n8 = ((4.0_ki)*(t1/t21+t6/t16+t4/t21+t58/t46*t9*spbk4k2*spbk6k1+t58*t&
      &35/t7*spak5k6*spbk4k1*spbk6k1+t58*t34/t7*spak3k4*spak5k6*spbk4k1*spbk6k4-&
      &(t58*t25/t29*spak5k6*spbk4k1*spbk6k1+t58*t24/t29*spak5k6*spbk4k1*spbk6k4+&
      &t58*t10/t16*spbk4k2*spbk6k1+t6/t40+t4/t7+t1/t7)))
      t1 = t17+t22+t23+t37+t39+t42+t47+t55-(t8+t53+t50+t41+t33+t30+t20+t11)
      abb67n9 = ((8.0_ki)*t1)
      abb67n10 = ((4.0_ki)*t1)
      t1 = t58*t5*spbk4k3*spbk6k1
      abb67n11 = ((4.0_ki)*(t1/t40+t58*t10/t16*spbk4k3*spbk6k1-(t58/t46*t9*spbk4&
      &k3*spbk6k1+t1/t16)))
      t1 = t58*t12*spbk4k2
      abb67n12 = ((4.0_ki)*(t1/t16+t1/t40+t58*t25/t29*spbk4k1-(t58*t43/t46*spbk4&
      &k2+t58*t3/t21*spbk4k1+t58*t51/t16*spbk4k2)))
      t1 = t58*t12*spbk4k3
      t3 = t58*t51*spbk4k3
      abb67n13 = ((4.0_ki)*(t3/t16+t3/t7+t58*t43/t46*spbk4k3+t58*t34/t7*spak1k2*&
      &spbk4k1-(t58*t2/t7*spak1k2*spbk4k1+t1/t7+t1/t40+t1/t16)))
      rat2d67 = abb67n1
      rat2 = rat2 + rat2d67
      abb67n15 = abb67n6
      abb67n16 = abb67n13
      abb67n17 = abb67n12
      abb67n18 = abb67n10
      abb67n19 = abb67n5
      abb67n20 = abb67n4
      abb67n21 = abb67n3
      abb67n22 = abb67n2
      abb67n23 = -(abb67n7)
      abb67n24 = -(abb67n8)
      abb67n25 = -(abb67n9)
      abb67n26 = ((2.0_ki)*abb67n10)
      abb67n27 = -(abb67n11)
   end subroutine
end module p7_udbar_neepuubar_abbrevd67h1
