module     p9_udbar_neepgg_abbrevd37h0
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh0
   implicit none
   private
   complex(ki), public :: abb37n1
   complex(ki), public :: abb37n2
   complex(ki), public :: abb37n3
   complex(ki), public :: abb37n4
   complex(ki), public :: abb37n5
   complex(ki), public :: abb37n6
   complex(ki), public :: abb37n7
   complex(ki), public :: abb37n8
   complex(ki), public :: abb37n9
   complex(ki), public :: abb37n10
   complex(ki), public :: rat2d37
   complex(ki), public :: abb37n12
   complex(ki), public :: abb37n13
   complex(ki), public :: abb37n14
   complex(ki), public :: abb37n15
   complex(ki), public :: abb37n16
   complex(ki), public :: abb37n17
   complex(ki), public :: abb37n18
   complex(ki), public :: abb37n19
   complex(ki), public :: abb37n20
   complex(ki), public :: abb37n21
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   real(ki) :: t44
   real(ki) :: t45
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t44 = es234-(es61+es56)
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c2
      t3 = t2*i_
      t4 = t3*spak2k3
      t5 = t4*spak2k5
      t6 = t44*(es345-(es61+es12))*t1
      t7 = NC*t6
      t8 = t7*spak5k6
      t9 = t5/t8*spbk5k1*spbk5k4*spbk6k2
      t10 = NC*TR*c2
      t11 = t10*i_
      t12 = t11*spak2k3
      t13 = t12*spak2k5
      t14 = t6*spak5k6
      t15 = t13/t14*spbk5k1*spbk5k4*spbk6k2
      t16 = es56*t2*i_*spak2k3
      t1 = t44*t1
      t17 = es234*NC*t1
      t18 = spak5k6*spak5k6
      t19 = t17*t18
      t20 = t16/t19*spak2k5*spbk4k2*spbk5k1
      t16 = t16/t19*spak3k5*spbk4k3*spbk5k1
      t21 = t15+t20-(t9+t16)
      t2 = es61*t2*i_*spak2k3
      t22 = t2/t19*spak2k5*spbk4k2*spbk5k1
      t2 = t2/t19*spak3k5*spbk4k3*spbk5k1
      t23 = es56*t10
      t24 = t23*i_
      t25 = t24*spak2k3
      t26 = t25*spak2k5
      t27 = t26*spbk4k2
      t28 = t27*spbk5k1
      t29 = es234*t1*t18
      t30 = t28/t29
      t25 = t25*spak3k5*spbk4k3
      t31 = t25*spbk5k1
      t32 = t31/t29
      t33 = es61*t10*i_
      t34 = t33*spak2k3
      t35 = t34*spak2k5
      t36 = t35*spbk4k2
      t37 = t36*spbk5k1
      t38 = t37/t29
      t34 = t34*spak3k5*spbk4k3
      t39 = t34*spbk5k1
      t40 = t39/t29
      t7 = t18*t7
      t3 = t3/t7*spak1k6*spak2k3*spak2k5*spbk4k1*spbk5k1*spbk6k2
      t6 = t18*t6
      t11 = t11/t6*spak1k6*spak2k3*spak2k5*spbk4k1*spbk5k1*spbk6k2
      abb37n1 = ((2.0_ki)*(t11+t21+t22+t32+t40-(t38+t30+t3+t2)))
      t23 = es61*t23*i_*spak2k3
      t1 = t1*t18
      t18 = t13*spbk4k2
      t41 = t18*spbk5k1
      t44 = es56*es56
      t12 = t12*spak3k5*spbk4k3
      t42 = t12*spbk5k1
      t10 = es234*t10*i_
      t43 = t10*spak2k3*spak2k5
      t45 = es61*es61
      abb37n2 = ((6.0_ki)*(t23/t29*spak2k5*spbk4k2*spbk5k1-t23/t29*spak3k5*spbk4&
      &k3*spbk5k1)+(4.0_ki)*(t31/t1+t44*t41/t29+t43/t14*spbk5k1*spbk5k4*spbk6k2-&
      &(t35/t14*spbk5k1*spbk5k4*spbk6k2+t26/t14*spbk5k1*spbk5k4*spbk6k2+t44*t42/&
      &t29+t28/t1))+(2.0_ki)*(t39/t1+t45*t41/t29+t10/t6*spak1k6*spak2k3*spak2k5*&
      &spbk4k1*spbk5k1*spbk6k2-(t33/t6*spak1k6*spak2k3*spak2k5*spbk4k1*spbk5k1*s&
      &pbk6k2+t24/t6*spak1k6*spak2k3*spak2k5*spbk4k1*spbk5k1*spbk6k2+t45*t42/t29&
      &+t37/t1)))
      abb37n3 = ((8.0_ki)*(t11+t15+t32+t40-(t38+t30)))
      t10 = t18*spbk6k1
      t14 = t12*spbk6k1
      abb37n4 = ((2.0_ki)*(t10/t1+t25/t29*spbk6k1+t34/t29*spbk6k1+t43/t6*spbk4k1&
      &*spbk6k2-(t35/t6*spbk4k1*spbk6k2+t26/t6*spbk4k1*spbk6k2+t36/t29*spbk6k1+t&
      &27/t29*spbk6k1+t14/t1)))
      t18 = t18*spbk6k5
      t12 = t12*spbk6k5
      abb37n5 = ((2.0_ki)*(t18/t1+t25/t29*spbk6k5+t34/t29*spbk6k5+t26/t6*spbk5k4&
      &*spbk6k2+t35/t6*spbk5k4*spbk6k2-(t43/t6*spbk5k4*spbk6k2+t36/t29*spbk6k5+t&
      &27/t29*spbk6k5+t12/t1)))
      abb37n6 = ((8.0_ki)*(t11+t21+t32+t40-(t38+t30)))
      abb37n7 = ((4.0_ki)*(t16+t2+t3+t30+t38+t9-(t40+t32+t22+t20+t15+t11)))
      t1 = t5*spbk4k1
      t2 = t5*spbk4k2
      t3 = t17*spak5k6
      t4 = t4*spak3k5*spbk4k3
      abb37n8 = ((4.0_ki)*(t4/t3*spbk5k1*spbk6k1-(t2/t3*spbk5k1*spbk6k1+t1/t8*sp&
      &bk5k1*spbk6k2)))
      abb37n9 = ((8.0_ki)*(t14/t29+t4/t19*spbk6k1-(t13/t6*spbk4k1*spbk6k2+t2/t19&
      &*spbk6k1+t1/t7*spbk6k2+t10/t29)))
      abb37n10 = ((4.0_ki)*(t18/t29+t2/t19*spbk6k5-(t5/t7*spbk5k4*spbk6k2+t13/t6&
      &*spbk5k4*spbk6k2+t4/t19*spbk6k5+t12/t29)))
      rat2d37 = abb37n1
      rat2 = rat2 + rat2d37
      abb37n12 = abb37n2
      abb37n13 = abb37n10
      abb37n14 = abb37n9
      abb37n15 = abb37n7
      abb37n16 = -(abb37n3)
      abb37n17 = -(abb37n4)
      abb37n18 = -(abb37n5)
      abb37n19 = -(abb37n6)
      abb37n20 = ((2.0_ki)*abb37n7)
      abb37n21 = -(abb37n8)
   end subroutine
end module p9_udbar_neepgg_abbrevd37h0
