module     p9_udbar_neepgg_abbrevd7h0
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh0
   implicit none
   private
   complex(ki), public :: abb7n1
   complex(ki), public :: rat2d7
   complex(ki), public :: abb7n3
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   real(ki) :: t7
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t7 = NC*TR
      t2 = t7*c1*i_
      t3 = spak5k6*spak5k6
      t4 = (es34+es56-(es234+es12))*t1*t3
      t5 = t7*c2*i_
      t6 = t2*spak2k3
      t1 = es234*t1*t3
      t3 = t5*spak2k3
      abb7n1 = ((9.0_ki/2.0_ki)*(t3/t1*spak2k6*spbk4k2*spbk6k1+t6/t1*spak3k6*spb&
      &k4k3*spbk6k1+t2/t4*spak1k3*spak2k6*spbk4k1*spbk6k1+t2/t4*spak2k6*spak3k4*&
      &spbk4k1*spbk6k4-(t5/t4*spak2k6*spak3k4*spbk4k1*spbk6k4+t5/t4*spak1k3*spak&
      &2k6*spbk4k1*spbk6k1+t6/t1*spak2k6*spbk4k2*spbk6k1+t3/t1*spak3k6*spbk4k3*s&
      &pbk6k1)))
      rat2d7 = 0
      rat2 = rat2 + rat2d7
      abb7n3 = abb7n1
   end subroutine
end module p9_udbar_neepgg_abbrevd7h0
