module     p9_udbar_neepgg_d22h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d22h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d22
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd22h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb22n46
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k6(iv1)
      t7 = spvak6k1(iv1)
      t8 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb22n77+t2*abb22n71+t3*abb22n79+t4*abb22n78+t5*abb22n7&
         &0+t6*abb22n81+t7*abb22n75+t8*abb22n80)
         return
      end if
      t35 = d(iv1,iv2)
      t9 = k1(iv2)
      t10 = k5(iv2)
      t11 = k2(iv2)
      t12 = k6(iv2)
      t13 = spvak3k4(iv2)
      t14 = t1*t13
      t15 = spvak5k6(iv2)
      t16 = spvak6k1(iv2)
      t17 = spvak6k5(iv2)
      t18 = t5*t9
      t19 = t13*t3
      t20 = t10*t5
      t21 = t15*t5
      t22 = t13*t6
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t35*abb22n59+t1*t9*abb22n50+t10*t3*abb22n50)+t14&
         &*abb22n68+t18*abb22n68+t19*abb22n69+t20*abb22n69+t21*abb22n62+t22*abb2&
         &2n62+spvak2k4(iv1)*t15*abb22n61+spvak2k4(iv2)*t6*abb22n61+t1*t10*abb22&
         &n52+t1*t11*abb22n55+t1*t12*abb22n51+t1*t15*abb22n47+t1*t16*abb22n63+t1&
         &*t17*abb22n53+t10*t2*abb22n56+t10*t4*abb22n50+t10*t6*abb22n48+t10*t7*a&
         &bb22n64+t10*t8*abb22n54+t11*t3*abb22n56+t11*t6*abb22n57+t11*t7*abb22n6&
         &6+t12*t3*abb22n50+t12*t5*abb22n68+t12*t6*abb22n58+t12*t7*abb22n64+t12*&
         &t8*abb22n54+t13*t4*abb22n68+t13*t7*abb22n65+t13*t8*abb22n67+t15*t2*abb&
         &22n57+t15*t3*abb22n48+t15*t4*abb22n58+t15*t7*abb22n60+t15*t8*abb22n49+&
         &t16*t2*abb22n66+t16*t3*abb22n64+t16*t4*abb22n64+t16*t5*abb22n65+t16*t6&
         &*abb22n60+t17*t3*abb22n54+t17*t4*abb22n54+t17*t5*abb22n67+t17*t6*abb22&
         &n49+t2*t9*abb22n55+t3*t9*abb22n52+t4*t9*abb22n51+t6*t9*abb22n47+t7*t9*&
         &abb22n63+t8*t9*abb22n53)
         return
      end if
      t36 = d(iv2,iv3)
      t37 = d(iv1,iv3)
      t2 = k1(iv3)
      t4 = k5(iv3)
      t11 = spvak3k4(iv3)
      t12 = spvak5k6(iv3)
      t23 = spvak6k1(iv3)
      t24 = spvak6k5(iv3)
      t25 = spvak2k1(iv1)
      t26 = spvak2k1(iv2)
      t27 = spvak2k1(iv3)
      t28 = spvak2k5(iv1)
      t29 = spvak2k5(iv2)
      t30 = spvak2k5(iv3)
      t31 = t12*t5
      t32 = t12*t13
      t33 = t11*t6
      t34 = t11*t15
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t36*abb22n84+t10*t37*abb22n85+t11*t35*abb22n7&
         &2+t12*t35*abb22n82+t13*t37*abb22n72+t15*t37*abb22n82+t16*t37*abb22n74+&
         &t17*t37*abb22n83+t2*t35*abb22n84+t23*t35*abb22n74+t24*t35*abb22n83+t3*&
         &t36*abb22n85+t35*t4*abb22n85+t36*t5*abb22n72+t36*t6*abb22n82+t36*t7*ab&
         &b22n74+t36*t8*abb22n83+t37*t9*abb22n84)+t12*t14*abb22n88+t12*t18*abb22&
         &n88+t12*t19*abb22n87+t12*t20*abb22n87+t16*t31*abb22n73+t16*t33*abb22n7&
         &3+t17*t31*abb22n86+t17*t33*abb22n86+t21*t23*abb22n73+t21*t24*abb22n86+&
         &t22*t23*abb22n73+t22*t24*abb22n86+t32*t7*abb22n73+t32*t8*abb22n86+t34*&
         &t7*abb22n73+t34*t8*abb22n86+t1*t11*t15*abb22n88+t10*t11*t6*abb22n87+t1&
         &1*t15*t25*abb22n76+t11*t15*t28*abb22n89+t11*t15*t3*abb22n87+t11*t26*t6&
         &*abb22n76+t11*t29*t6*abb22n89+t11*t6*t9*abb22n88+t12*t13*t25*abb22n76+&
         &t12*t13*t28*abb22n89+t12*t26*t5*abb22n76+t12*t29*t5*abb22n89+t13*t2*t6&
         &*abb22n88+t13*t27*t6*abb22n76+t13*t30*t6*abb22n89+t13*t4*t6*abb22n87+t&
         &15*t2*t5*abb22n88+t15*t27*t5*abb22n76+t15*t30*t5*abb22n89+t15*t4*t5*ab&
         &b22n87)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d22:
   subroutine     reconstruct_d22(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_22:
      coeffs%coeffs_22%c0 = derivative(czip)
      coeffs%coeffs_22%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_22%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_22%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_22%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_22%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_22%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_22%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_22%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_22%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_22%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_22%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_22%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_22%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_22%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_22%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_22%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_22%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_22%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_22%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_22%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_22%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_22%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_22%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_22%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_22%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_22%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_22%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_22%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_22%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_22%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_22%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_22%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_22%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_22%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_22:
   end subroutine reconstruct_d22
!---#] subroutine reconstruct_d22:
end module p9_udbar_neepgg_d22h0l1d
