module     p9_udbar_neepgg_d93h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d93h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d93
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd93h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      complex(ki) :: t158
      complex(ki) :: t159
      complex(ki) :: t160
      complex(ki) :: t161
      complex(ki) :: t162
      complex(ki) :: t163
      complex(ki) :: t164
      complex(ki) :: t165
      complex(ki) :: t166
      complex(ki) :: t167
      complex(ki) :: t168
      complex(ki) :: t169
      complex(ki) :: t170
      complex(ki) :: t171
      complex(ki) :: t172
      complex(ki) :: t173
      complex(ki) :: t174
      complex(ki) :: t175
      complex(ki) :: t176
      complex(ki) :: t177
      complex(ki) :: t178
      complex(ki) :: t179
      complex(ki) :: t180
      complex(ki) :: t181
      complex(ki) :: t182
      complex(ki) :: t183
      complex(ki) :: t184
      complex(ki) :: t185
      complex(ki) :: t186
      complex(ki) :: t187
      complex(ki) :: t188
      complex(ki) :: t189
      complex(ki) :: t190
      complex(ki) :: t191
      complex(ki) :: t192
      complex(ki) :: t193
      real(ki) :: t194
      real(ki) :: t195
      real(ki) :: t196
      real(ki) :: t197
      real(ki) :: t198
      real(ki) :: t199
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t194 = dotproduct(k5, qshift)
      t195 = dotproduct(qshift, qshift)
      t196 = dotproduct(k2, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t197 = dotproduct(k1, qshift)
      t3 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t4 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t198 = dotproduct(k6, qshift)
      t5 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t6 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t7 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t9 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb93n85+t1*abb93n129+t194*abb93n149+t194*t194*abb93n105+t&
         &195*abb93n113+t195*t195*abb93n106+t196*abb93n128+t197*abb93n133+t198*a&
         &bb93n147+t2*abb93n130+t3*abb93n134+t4*abb93n141+t5*abb93n162+t1*t194*a&
         &bb93n119+t1*t195*abb93n139+t1*t197*abb93n126+t1*t198*abb93n118+t1*t2*a&
         &bb93n120+t1*t3*abb93n123+t1*t4*abb93n114+t1*t5*abb93n115+t194*t195*abb&
         &93n155+t194*t196*abb93n127+t194*t197*abb93n108+t194*t198*abb93n107+t19&
         &4*t3*abb93n97+t194*t4*abb93n109+t194*t5*abb93n99+t194*t6*abb93n122+t19&
         &5*t196*abb93n131+t195*t197*abb93n150+t195*t198*abb93n150+t195*t2*abb93&
         &n135+t195*t3*abb93n170+t195*t4*abb93n157+t195*t5*abb93n166+t195*t6*abb&
         &93n137+t196*t197*abb93n127+t196*t2*abb93n125+t196*t4*abb93n112+t196*t5&
         &*abb93n117+t197*t198*abb93n104+t197*t4*abb93n103+t197*t5*abb93n98+t197&
         &*t6*abb93n121+t198*t2*abb93n124+t198*t3*abb93n96+t198*t4*abb93n111+t19&
         &8*t5*abb93n110+t2*t4*abb93n88+t2*t5*abb93n89+t3*t4*abb93n92+t3*t5*abb9&
         &3n93+t4*t5*abb93n101+t1*t194*t3*abb93n184+t1*t194*t4*abb93n159+t1*t194&
         &*t5*abb93n164+t1*t195*t3*abb93n90+t1*t195*t4*abb93n102+t1*t195*t5*abb9&
         &3n100+t1*t197*t4*abb93n159+t1*t197*t5*abb93n164+t1*t198*t3*abb93n182+t&
         &1*t198*t5*abb93n163+t1*t4*t5*abb93n168+t194*t4*t5*abb93n142+t194*t4*t6&
         &*abb93n185+t194*t5*t6*abb93n179+t195*t2*t5*abb93n94+t195*t3*t4*abb93n9&
         &5+t195*t4*t5*abb93n116+t195*t4*t6*abb93n87+t195*t5*t6*abb93n91+t196*t2&
         &*t5*abb93n178+t196*t3*t4*abb93n175+t196*t4*t5*abb93n144+t197*t4*t6*abb&
         &93n187+t197*t5*t6*abb93n181+t198*t2*t5*abb93n176+t198*t3*t4*abb93n173+&
         &t198*t4*t5*abb93n143+t2*t4*t5*abb93n172+t3*t4*t5*abb93n178+t4*t5*t6*ab&
         &b93n188+t4*t5*t7*abb93n146+t4*t5*t8*abb93n161+t4*t5*t9*abb93n169+t1*t4&
         &*t5*t9*abb93n86)
         return
      end if
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak6k1(iv1)
      t19 = spvak6k5(iv1)
      t20 = t11*abb93n127
      t21 = t14*abb93n151
      t22 = spvak3k1(iv1)
      t23 = spvak2k1(iv1)
      t24 = spvak2k4(iv1)
      t25 = spvak2k6(iv1)
      t26 = t15*abb93n159
      t27 = t15*abb93n164
      t28 = t17*abb93n159
      t29 = t19*abb93n164
      t30 = t19*abb93n178
      if(deg.eq.1) then
         numerator = (t10*abb93n133+t11*abb93n128+t12*abb93n149+t13*abb93n147+t1&
         &4*abb93n148+t15*abb93n129+t16*abb93n130+t17*abb93n141+t18*abb93n134+t1&
         &9*abb93n162+t194*t20+t197*t20+t197*t21+t198*t21+t1*t10*abb93n126+t1*t1&
         &2*abb93n119+t1*t13*abb93n118+t1*t14*abb93n140+t1*t16*abb93n120+t1*t17*&
         &abb93n114+t1*t18*abb93n123+t1*t19*abb93n115+t1*t194*t28+t1*t194*t29+t1&
         &*t197*t28+t1*t197*t29+t10*t194*abb93n108+t10*t195*abb93n150+t10*t196*a&
         &bb93n127+t10*t198*abb93n104+t10*t4*abb93n103+t10*t5*abb93n98+t10*t6*ab&
         &b93n121+t11*t195*abb93n131+t11*t2*abb93n125+t11*t4*abb93n112+t11*t5*ab&
         &b93n117+t12*t194*abb93n154+t12*t195*abb93n155+t12*t196*abb93n127+t12*t&
         &197*abb93n108+t12*t198*abb93n107+t12*t3*abb93n97+t12*t4*abb93n109+t12*&
         &t5*abb93n99+t12*t6*abb93n122+t13*t194*abb93n107+t13*t195*abb93n150+t13&
         &*t197*abb93n104+t13*t2*abb93n124+t13*t3*abb93n96+t13*t4*abb93n111+t13*&
         &t5*abb93n110+t14*t194*abb93n156+t14*t195*abb93n152+t14*t196*abb93n132+&
         &t14*t2*abb93n136+t14*t3*abb93n171+t14*t4*abb93n158+t14*t5*abb93n167+t1&
         &4*t6*abb93n138+t15*t194*abb93n119+t15*t195*abb93n139+t15*t197*abb93n12&
         &6+t15*t198*abb93n118+t15*t2*abb93n120+t15*t3*abb93n123+t15*t4*abb93n11&
         &4+t15*t5*abb93n115+t16*t195*abb93n135+t16*t196*abb93n125+t16*t198*abb9&
         &3n124+t16*t4*abb93n88+t16*t5*abb93n89+t17*t194*abb93n109+t17*t195*abb9&
         &3n157+t17*t196*abb93n112+t17*t197*abb93n103+t17*t198*abb93n111+t17*t2*&
         &abb93n88+t17*t3*abb93n92+t17*t5*abb93n101+t18*t194*abb93n97+t18*t195*a&
         &bb93n170+t18*t198*abb93n96+t18*t4*abb93n92+t18*t5*abb93n93+t19*t194*ab&
         &b93n99+t19*t195*abb93n166+t19*t196*abb93n117+t19*t197*abb93n98+t19*t19&
         &8*abb93n110+t19*t2*abb93n89+t19*t3*abb93n93+t19*t4*abb93n101+t194*t22*&
         &abb93n122+t194*t26*t4+t194*t27*t5+t195*t22*abb93n137+t196*t2*t30+t197*&
         &t22*abb93n121+t197*t26*t4+t197*t27*t5+t3*t30*t4+t1*t10*t4*abb93n159+t1&
         &*t10*t5*abb93n164+t1*t12*t3*abb93n184+t1*t12*t4*abb93n159+t1*t12*t5*ab&
         &b93n164+t1*t13*t3*abb93n182+t1*t13*t5*abb93n163+t1*t14*t3*abb93n183+t1&
         &*t14*t4*abb93n160+t1*t14*t5*abb93n165+t1*t17*t195*abb93n102+t1*t17*t5*&
         &abb93n168+t1*t18*t194*abb93n184+t1*t18*t195*abb93n90+t1*t18*t198*abb93&
         &n182+t1*t19*t195*abb93n100+t1*t19*t198*abb93n163+t1*t19*t4*abb93n168+t&
         &10*t4*t6*abb93n187+t10*t5*t6*abb93n181+t11*t2*t5*abb93n178+t11*t3*t4*a&
         &bb93n175+t11*t4*t5*abb93n144+t12*t4*t5*abb93n142+t12*t4*t6*abb93n185+t&
         &12*t5*t6*abb93n179+t13*t2*t5*abb93n176+t13*t3*t4*abb93n173+t13*t4*t5*a&
         &bb93n143+t14*t2*t5*abb93n177+t14*t3*t4*abb93n174+t14*t4*t5*abb93n145+t&
         &14*t4*t6*abb93n186+t14*t5*t6*abb93n180+t15*t194*t3*abb93n184+t15*t195*&
         &t3*abb93n90+t15*t195*t4*abb93n102+t15*t195*t5*abb93n100+t15*t198*t3*ab&
         &b93n182+t15*t198*t5*abb93n163+t15*t4*t5*abb93n168+t16*t195*t5*abb93n94&
         &+t16*t196*t5*abb93n178+t16*t198*t5*abb93n176+t16*t4*t5*abb93n172+t17*t&
         &194*t5*abb93n142+t17*t194*t6*abb93n185+t17*t195*t3*abb93n95+t17*t195*t&
         &5*abb93n116+t17*t195*t6*abb93n87+t17*t196*t3*abb93n175+t17*t196*t5*abb&
         &93n144+t17*t197*t6*abb93n187+t17*t198*t3*abb93n173+t17*t198*t5*abb93n1&
         &43+t17*t2*t5*abb93n172+t17*t3*t5*abb93n178+t17*t5*t6*abb93n188+t17*t5*&
         &t7*abb93n146+t17*t5*t8*abb93n161+t17*t5*t9*abb93n169+t18*t195*t4*abb93&
         &n95+t18*t196*t4*abb93n175+t18*t198*t4*abb93n173+t18*t4*t5*abb93n178+t1&
         &9*t194*t4*abb93n142+t19*t194*t6*abb93n179+t19*t195*t2*abb93n94+t19*t19&
         &5*t4*abb93n116+t19*t195*t6*abb93n91+t19*t196*t4*abb93n144+t19*t197*t6*&
         &abb93n181+t19*t198*t2*abb93n176+t19*t198*t4*abb93n143+t19*t2*t4*abb93n&
         &172+t19*t4*t6*abb93n188+t19*t4*t7*abb93n146+t19*t4*t8*abb93n161+t19*t4&
         &*t9*abb93n169+t194*t22*t4*abb93n185+t194*t22*t5*abb93n179+t195*t22*t4*&
         &abb93n87+t195*t22*t5*abb93n91+t197*t22*t4*abb93n187+t197*t22*t5*abb93n&
         &181+t22*t4*t5*abb93n188+t23*t4*t5*abb93n169+t24*t4*t5*abb93n161+t25*t4&
         &*t5*abb93n146+t1*t17*t5*t9*abb93n86+t1*t19*t4*t9*abb93n86+t1*t23*t4*t5&
         &*abb93n86+t15*t4*t5*t9*abb93n86)
         return
      end if
      t199 = d(iv1,iv2)
      t20 = k5(iv2)
      t21 = qshift(iv2)
      t26 = t199*abb93n150
      t27 = k2(iv2)
      t28 = k6(iv2)
      t29 = spvak3k1(iv2)
      t30 = t10*t29
      t31 = spvak3k4(iv2)
      t32 = t10*t31
      t33 = spvak5k6(iv2)
      t34 = t10*t33
      t35 = spvak6k5(iv2)
      t36 = t10*t35
      t37 = k1(iv2)
      t38 = t22*t37
      t39 = t15*t37
      t40 = t17*t37
      t41 = t19*t37
      t42 = spvak5k1(iv2)
      t43 = t11*t42
      t44 = t11*t33
      t45 = t11*t35
      t46 = t16*t27
      t47 = t17*t27
      t48 = t19*t27
      t49 = t12*t29
      t50 = t12*t31
      t51 = t12*t33
      t52 = spvak6k1(iv2)
      t53 = t12*t52
      t54 = t12*t35
      t55 = t20*t22
      t56 = t15*t20
      t57 = t17*t20
      t58 = t18*t20
      t59 = t19*t20
      t60 = t13*t31
      t61 = t13*t42
      t62 = t13*t33
      t63 = t13*t52
      t64 = t13*t35
      t65 = t15*t28
      t66 = t16*t28
      t67 = t17*t28
      t68 = t18*t28
      t69 = t19*t28
      t70 = t14*t29
      t71 = t14*t31
      t72 = t14*t42
      t73 = t14*t33
      t74 = t14*t52
      t75 = t14*t35
      t76 = t21*t22
      t77 = t15*t21
      t78 = t16*t21
      t79 = t17*t21
      t80 = t18*t21
      t81 = t19*t21
      t82 = t15*t33
      t83 = t15*t52
      t84 = t15*t35
      t85 = t17*t31
      t86 = t18*t31
      t87 = t19*t31
      t88 = t16*t33
      t89 = t16*t35
      t90 = t17*t42
      t91 = t19*t42
      t92 = t17*t52
      t93 = t17*t35
      t94 = t18*t33
      t95 = t19*t33
      t96 = t18*t35
      t97 = t19*t52
      t98 = t23*t33
      t99 = t23*t35
      t100 = spvak2k1(iv2)
      t101 = t100*t17
      t102 = t100*t19
      t103 = t24*t33
      t104 = spvak2k4(iv2)
      t105 = t104*t17
      t106 = t25*t33
      t107 = spvak2k6(iv2)
      t108 = t107*t17
      t109 = t22*t33
      t110 = t22*t35
      t111 = t17*t29
      t112 = t19*t29
      t113 = t82*abb93n159
      t114 = t84*abb93n164
      t115 = t85*abb93n159
      t116 = t87*abb93n164
      t117 = t23*t31
      t118 = t100*t15
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t197*t26+t198*t26+t199*abb93n113+t1*t199*abb93n1&
         &39+t12*t20*abb93n105+t14*t21*abb93n152+t194*t199*abb93n155+t195*t199*a&
         &bb93n153+t196*t199*abb93n131+t199*t2*abb93n135+t199*t3*abb93n170+t199*&
         &t4*abb93n157+t199*t5*abb93n166+t199*t6*abb93n137+t1*t199*t3*abb93n90+t&
         &1*t199*t4*abb93n102+t1*t199*t5*abb93n100+t199*t2*t5*abb93n94+t199*t3*t&
         &4*abb93n95+t199*t4*t5*abb93n116+t199*t4*t6*abb93n87+t199*t5*t6*abb93n9&
         &1)+t113*t194+t113*t197+t114*t194+t114*t197+t115*t194+t115*t197+t116*t1&
         &94+t116*t197+t30*abb93n121+t32*abb93n126+t34*abb93n103+t36*abb93n98+t3&
         &8*abb93n121+t39*abb93n126+t40*abb93n103+t41*abb93n98+t43*abb93n125+t44&
         &*abb93n112+t45*abb93n117+t46*abb93n125+t47*abb93n112+t48*abb93n117+t49&
         &*abb93n122+t50*abb93n119+t51*abb93n109+t53*abb93n97+t54*abb93n99+t55*a&
         &bb93n122+t56*abb93n119+t57*abb93n109+t58*abb93n97+t59*abb93n99+t60*abb&
         &93n118+t61*abb93n124+t62*abb93n111+t63*abb93n96+t64*abb93n110+t65*abb9&
         &3n118+t66*abb93n124+t67*abb93n111+t68*abb93n96+t69*abb93n110+t70*abb93&
         &n138+t71*abb93n140+t72*abb93n136+t73*abb93n158+t74*abb93n171+t75*abb93&
         &n167+t76*abb93n138+t77*abb93n140+t78*abb93n136+t79*abb93n158+t80*abb93&
         &n171+t81*abb93n167+t82*abb93n114+t83*abb93n123+t84*abb93n115+t85*abb93&
         &n114+t86*abb93n123+t87*abb93n115+t88*abb93n88+t89*abb93n89+t90*abb93n8&
         &8+t91*abb93n89+t92*abb93n92+t93*abb93n101+t94*abb93n92+t95*abb93n101+t&
         &96*abb93n93+t97*abb93n93+t1*t34*abb93n159+t1*t36*abb93n164+t1*t40*abb9&
         &3n159+t1*t41*abb93n164+t1*t51*abb93n159+t1*t53*abb93n184+t1*t54*abb93n&
         &164+t1*t57*abb93n159+t1*t58*abb93n184+t1*t59*abb93n164+t1*t63*abb93n18&
         &2+t1*t64*abb93n163+t1*t68*abb93n182+t1*t69*abb93n163+t1*t73*abb93n160+&
         &t1*t74*abb93n183+t1*t75*abb93n165+t1*t79*abb93n160+t1*t80*abb93n183+t1&
         &*t81*abb93n165+t1*t93*abb93n168+t1*t95*abb93n168+t10*t20*abb93n108+t10&
         &*t21*abb93n151+t10*t27*abb93n127+t10*t28*abb93n104+t101*t5*abb93n169+t&
         &102*t4*abb93n169+t103*t5*abb93n161+t105*t5*abb93n161+t106*t5*abb93n146&
         &+t108*t5*abb93n146+t109*t194*abb93n185+t109*t195*abb93n87+t109*t197*ab&
         &b93n187+t109*t5*abb93n188+t11*t20*abb93n127+t11*t21*abb93n132+t11*t37*&
         &abb93n127+t110*t194*abb93n179+t110*t195*abb93n91+t110*t197*abb93n181+t&
         &110*t4*abb93n188+t111*t194*abb93n185+t111*t195*abb93n87+t111*t197*abb9&
         &3n187+t111*t5*abb93n188+t112*t194*abb93n179+t112*t195*abb93n91+t112*t1&
         &97*abb93n181+t112*t4*abb93n188+t12*t21*abb93n156+t12*t27*abb93n127+t12&
         &*t28*abb93n107+t12*t37*abb93n108+t13*t20*abb93n107+t13*t21*abb93n151+t&
         &13*t37*abb93n104+t14*t20*abb93n156+t14*t27*abb93n132+t14*t28*abb93n151&
         &+t14*t37*abb93n151+t15*t42*abb93n120+t16*t31*abb93n120+t194*t83*abb93n&
         &184+t194*t86*abb93n184+t194*t93*abb93n142+t194*t95*abb93n142+t195*t82*&
         &abb93n102+t195*t83*abb93n90+t195*t84*abb93n100+t195*t85*abb93n102+t195&
         &*t86*abb93n90+t195*t87*abb93n100+t195*t89*abb93n94+t195*t91*abb93n94+t&
         &195*t92*abb93n95+t195*t93*abb93n116+t195*t94*abb93n95+t195*t95*abb93n1&
         &16+t196*t89*abb93n178+t196*t91*abb93n178+t196*t92*abb93n175+t196*t93*a&
         &bb93n144+t196*t94*abb93n175+t196*t95*abb93n144+t198*t83*abb93n182+t198&
         &*t84*abb93n163+t198*t86*abb93n182+t198*t87*abb93n163+t198*t89*abb93n17&
         &6+t198*t91*abb93n176+t198*t92*abb93n173+t198*t93*abb93n143+t198*t94*ab&
         &b93n173+t198*t95*abb93n143+t2*t45*abb93n178+t2*t48*abb93n178+t2*t64*ab&
         &b93n176+t2*t69*abb93n176+t2*t75*abb93n177+t2*t81*abb93n177+t2*t93*abb9&
         &3n172+t2*t95*abb93n172+t3*t44*abb93n175+t3*t47*abb93n175+t3*t50*abb93n&
         &184+t3*t56*abb93n184+t3*t60*abb93n182+t3*t62*abb93n173+t3*t65*abb93n18&
         &2+t3*t67*abb93n173+t3*t71*abb93n183+t3*t73*abb93n174+t3*t77*abb93n183+&
         &t3*t79*abb93n174+t3*t93*abb93n178+t3*t95*abb93n178+t30*t4*abb93n187+t3&
         &0*t5*abb93n181+t32*t4*abb93n159+t32*t5*abb93n164+t34*t6*abb93n187+t36*&
         &t6*abb93n181+t38*t4*abb93n187+t38*t5*abb93n181+t39*t4*abb93n159+t39*t5&
         &*abb93n164+t4*t45*abb93n144+t4*t48*abb93n144+t4*t49*abb93n185+t4*t50*a&
         &bb93n159+t4*t54*abb93n142+t4*t55*abb93n185+t4*t56*abb93n159+t4*t59*abb&
         &93n142+t4*t63*abb93n173+t4*t64*abb93n143+t4*t68*abb93n173+t4*t69*abb93&
         &n143+t4*t70*abb93n186+t4*t71*abb93n160+t4*t74*abb93n174+t4*t75*abb93n1&
         &45+t4*t76*abb93n186+t4*t77*abb93n160+t4*t80*abb93n174+t4*t81*abb93n145&
         &+t4*t84*abb93n168+t4*t87*abb93n168+t4*t89*abb93n172+t4*t91*abb93n172+t&
         &4*t96*abb93n178+t4*t97*abb93n178+t4*t99*abb93n169+t40*t6*abb93n187+t41&
         &*t6*abb93n181+t43*t5*abb93n178+t44*t5*abb93n144+t46*t5*abb93n178+t47*t&
         &5*abb93n144+t49*t5*abb93n179+t5*t50*abb93n164+t5*t51*abb93n142+t5*t55*&
         &abb93n179+t5*t56*abb93n164+t5*t57*abb93n142+t5*t60*abb93n163+t5*t61*ab&
         &b93n176+t5*t62*abb93n143+t5*t65*abb93n163+t5*t66*abb93n176+t5*t67*abb9&
         &3n143+t5*t70*abb93n180+t5*t71*abb93n165+t5*t72*abb93n177+t5*t73*abb93n&
         &145+t5*t76*abb93n180+t5*t77*abb93n165+t5*t78*abb93n177+t5*t79*abb93n14&
         &5+t5*t82*abb93n168+t5*t85*abb93n168+t5*t88*abb93n172+t5*t90*abb93n172+&
         &t5*t92*abb93n178+t5*t94*abb93n178+t5*t98*abb93n169+t51*t6*abb93n185+t5&
         &4*t6*abb93n179+t57*t6*abb93n185+t59*t6*abb93n179+t6*t73*abb93n186+t6*t&
         &75*abb93n180+t6*t79*abb93n186+t6*t81*abb93n180+t6*t93*abb93n188+t6*t95&
         &*abb93n188+t7*t93*abb93n146+t7*t95*abb93n146+t8*t93*abb93n161+t8*t95*a&
         &bb93n161+t9*t93*abb93n169+t9*t95*abb93n169+t1*t101*t5*abb93n86+t1*t102&
         &*t4*abb93n86+t1*t4*t99*abb93n86+t1*t5*t98*abb93n86+t1*t9*t93*abb93n86+&
         &t1*t9*t95*abb93n86+t104*t19*t4*abb93n161+t107*t19*t4*abb93n146+t11*t4*&
         &t52*abb93n175+t117*t4*t5*abb93n86+t118*t4*t5*abb93n86+t18*t27*t4*abb93&
         &n175+t24*t35*t4*abb93n161+t25*t35*t4*abb93n146+t4*t84*t9*abb93n86+t4*t&
         &87*t9*abb93n86+t5*t82*t9*abb93n86+t5*t85*t9*abb93n86)
         return
      end if
      t194 = d(iv2,iv3)
      t195 = d(iv1,iv3)
      t7 = k1(iv3)
      t8 = k2(iv3)
      t26 = k5(iv3)
      t34 = k6(iv3)
      t36 = qshift(iv3)
      t40 = t194*t22
      t41 = t195*t29
      t45 = spvak3k1(iv3)
      t48 = t199*t45
      t53 = t15*t194
      t54 = t195*t31
      t58 = spvak3k4(iv3)
      t59 = t199*t58
      t63 = t16*t194
      t64 = t195*t42
      t68 = spvak5k1(iv3)
      t69 = t199*t68
      t74 = t17*t194
      t75 = t195*t33
      t80 = spvak5k6(iv3)
      t81 = t199*t80
      t96 = t18*t194
      t97 = t195*t52
      t99 = spvak6k1(iv3)
      t102 = t199*t99
      t113 = t19*t194
      t114 = t195*t35
      t115 = spvak6k5(iv3)
      t116 = t115*t199
      t119 = t10*t45
      t120 = t10*t58
      t121 = t37*t45
      t122 = t37*t58
      t123 = t22*t7
      t124 = t29*t7
      t125 = t15*t7
      t126 = t31*t7
      t127 = t11*t80
      t128 = t27*t80
      t129 = t17*t8
      t130 = t33*t8
      t131 = t12*t45
      t132 = t12*t58
      t133 = t20*t45
      t134 = t20*t58
      t135 = t22*t26
      t136 = t26*t29
      t137 = t15*t26
      t138 = t26*t31
      t139 = t13*t58
      t140 = t13*t80
      t141 = t28*t58
      t142 = t28*t80
      t143 = t15*t34
      t144 = t31*t34
      t145 = t17*t34
      t146 = t33*t34
      t147 = t14*t45
      t148 = t14*t58
      t149 = t14*t80
      t150 = t21*t45
      t151 = t21*t58
      t152 = t21*t80
      t153 = t22*t36
      t154 = t29*t36
      t155 = t15*t36
      t156 = t31*t36
      t157 = t17*t36
      t158 = t33*t36
      t98 = t115*t98
      t159 = t23*t35*t80
      t101 = t101*t115
      t160 = t100*t19*t80
      t161 = spvak2k1(iv3)
      t162 = t161*t17*t35
      t163 = t161*t19*t33
      t164 = spvak2k4(iv3)
      t165 = spvak2k6(iv3)
      t166 = t22*t80
      t167 = t29*t80
      t168 = t17*t45
      t169 = t33*t45
      t170 = t115*t82
      t171 = t15*t80
      t172 = t171*t35
      t173 = t115*t85
      t174 = t31*t80
      t175 = t174*t19
      t176 = t17*t58
      t177 = t176*t35
      t178 = t33*t58
      t179 = t178*t19
      t180 = t17*t99
      t181 = t33*t99
      t182 = t18*t80
      t183 = t52*t80
      t184 = t117*t80
      t185 = t23*t58
      t186 = t185*t33
      t187 = t118*t80
      t188 = t100*t58
      t189 = t17*t188
      t190 = t15*t161
      t191 = t190*t33
      t192 = t161*t31
      t193 = t17*t192
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t102*abb93n170+t113*abb93n166+t114*abb93n166+t11&
         &6*abb93n166+t40*abb93n137+t41*abb93n137+t48*abb93n137+t53*abb93n139+t5&
         &4*abb93n139+t59*abb93n139+t63*abb93n135+t64*abb93n135+t69*abb93n135+t7&
         &4*abb93n157+t75*abb93n157+t81*abb93n157+t96*abb93n170+t97*abb93n170+t1&
         &*t102*abb93n90+t1*t113*abb93n100+t1*t114*abb93n100+t1*t116*abb93n100+t&
         &1*t74*abb93n102+t1*t75*abb93n102+t1*t81*abb93n102+t1*t96*abb93n90+t1*t&
         &97*abb93n90+t10*t194*abb93n150+t102*t4*abb93n95+t11*t194*abb93n131+t11&
         &3*t2*abb93n94+t113*t4*abb93n116+t113*t6*abb93n91+t114*t2*abb93n94+t114&
         &*t4*abb93n116+t114*t6*abb93n91+t116*t2*abb93n94+t116*t4*abb93n116+t116&
         &*t6*abb93n91+t12*t194*abb93n155+t13*t194*abb93n150+t14*t194*abb93n152+&
         &t195*t20*abb93n155+t195*t21*abb93n152+t195*t27*abb93n131+t195*t28*abb9&
         &3n150+t195*t37*abb93n150+t199*t26*abb93n155+t199*t34*abb93n150+t199*t3&
         &6*abb93n152+t199*t7*abb93n150+t199*t8*abb93n131+t3*t53*abb93n90+t3*t54&
         &*abb93n90+t3*t59*abb93n90+t3*t74*abb93n95+t3*t75*abb93n95+t3*t81*abb93&
         &n95+t4*t40*abb93n87+t4*t41*abb93n87+t4*t48*abb93n87+t4*t53*abb93n102+t&
         &4*t54*abb93n102+t4*t59*abb93n102+t4*t96*abb93n95+t4*t97*abb93n95+t40*t&
         &5*abb93n91+t41*t5*abb93n91+t48*t5*abb93n91+t5*t53*abb93n100+t5*t54*abb&
         &93n100+t5*t59*abb93n100+t5*t63*abb93n94+t5*t64*abb93n94+t5*t69*abb93n9&
         &4+t5*t74*abb93n116+t5*t75*abb93n116+t5*t81*abb93n116+t6*t74*abb93n87+t&
         &6*t75*abb93n87+t6*t81*abb93n87)+t101*abb93n169+t159*abb93n169+t160*abb&
         &93n169+t162*abb93n169+t163*abb93n169+t170*abb93n168+t172*abb93n168+t17&
         &3*abb93n168+t175*abb93n168+t177*abb93n168+t179*abb93n168+t98*abb93n169&
         &+t1*t101*abb93n86+t1*t159*abb93n86+t1*t160*abb93n86+t1*t162*abb93n86+t&
         &1*t163*abb93n86+t1*t98*abb93n86+t103*t115*abb93n161+t105*t115*abb93n16&
         &1+t106*t115*abb93n146+t108*t115*abb93n146+t109*t115*abb93n188+t111*t11&
         &5*abb93n188+t115*t30*abb93n181+t115*t32*abb93n164+t115*t38*abb93n181+t&
         &115*t39*abb93n164+t115*t43*abb93n178+t115*t44*abb93n144+t115*t46*abb93&
         &n178+t115*t47*abb93n144+t115*t49*abb93n179+t115*t50*abb93n164+t115*t51&
         &*abb93n142+t115*t55*abb93n179+t115*t56*abb93n164+t115*t57*abb93n142+t1&
         &15*t60*abb93n163+t115*t61*abb93n176+t115*t62*abb93n143+t115*t65*abb93n&
         &163+t115*t66*abb93n176+t115*t67*abb93n143+t115*t70*abb93n180+t115*t71*&
         &abb93n165+t115*t72*abb93n177+t115*t73*abb93n145+t115*t76*abb93n180+t11&
         &5*t77*abb93n165+t115*t78*abb93n177+t115*t79*abb93n145+t115*t88*abb93n1&
         &72+t115*t90*abb93n172+t115*t92*abb93n178+t115*t94*abb93n178+t119*t33*a&
         &bb93n187+t119*t35*abb93n181+t120*t33*abb93n159+t120*t35*abb93n164+t121&
         &*t17*abb93n187+t121*t19*abb93n181+t122*t17*abb93n159+t122*t19*abb93n16&
         &4+t123*t33*abb93n187+t123*t35*abb93n181+t124*t17*abb93n187+t124*t19*ab&
         &b93n181+t125*t33*abb93n159+t125*t35*abb93n164+t126*t17*abb93n159+t126*&
         &t19*abb93n164+t127*t35*abb93n144+t127*t52*abb93n175+t128*t18*abb93n175&
         &+t128*t19*abb93n144+t129*t35*abb93n144+t129*t52*abb93n175+t130*t18*abb&
         &93n175+t130*t19*abb93n144+t131*t33*abb93n185+t131*t35*abb93n179+t132*t&
         &33*abb93n159+t132*t35*abb93n164+t132*t52*abb93n184+t133*t17*abb93n185+&
         &t133*t19*abb93n179+t134*t17*abb93n159+t134*t18*abb93n184+t134*t19*abb9&
         &3n164+t135*t33*abb93n185+t135*t35*abb93n179+t136*t17*abb93n185+t136*t1&
         &9*abb93n179+t137*t33*abb93n159+t137*t35*abb93n164+t137*t52*abb93n184+t&
         &138*t17*abb93n159+t138*t18*abb93n184+t138*t19*abb93n164+t139*t35*abb93&
         &n163+t139*t52*abb93n182+t140*t35*abb93n143+t140*t52*abb93n173+t141*t18&
         &*abb93n182+t141*t19*abb93n163+t142*t18*abb93n173+t142*t19*abb93n143+t1&
         &43*t35*abb93n163+t143*t52*abb93n182+t144*t18*abb93n182+t144*t19*abb93n&
         &163+t145*t35*abb93n143+t145*t52*abb93n173+t146*t18*abb93n173+t146*t19*&
         &abb93n143+t147*t33*abb93n186+t147*t35*abb93n180+t148*t33*abb93n160+t14&
         &8*t35*abb93n165+t148*t52*abb93n183+t149*t35*abb93n145+t149*t52*abb93n1&
         &74+t150*t17*abb93n186+t150*t19*abb93n180+t151*t17*abb93n160+t151*t18*a&
         &bb93n183+t151*t19*abb93n165+t152*t18*abb93n174+t152*t19*abb93n145+t153&
         &*t33*abb93n186+t153*t35*abb93n180+t154*t17*abb93n186+t154*t19*abb93n18&
         &0+t155*t33*abb93n160+t155*t35*abb93n165+t155*t52*abb93n183+t156*t17*ab&
         &b93n160+t156*t18*abb93n183+t156*t19*abb93n165+t157*t35*abb93n145+t157*&
         &t52*abb93n174+t158*t18*abb93n174+t158*t19*abb93n145+t166*t35*abb93n188&
         &+t167*t19*abb93n188+t168*t35*abb93n188+t169*t19*abb93n188+t170*t9*abb9&
         &3n86+t172*t9*abb93n86+t173*t9*abb93n86+t175*t9*abb93n86+t177*t9*abb93n&
         &86+t179*t9*abb93n86+t180*t35*abb93n178+t181*t19*abb93n178+t182*t35*abb&
         &93n178+t183*t19*abb93n178+t184*t5*abb93n86+t186*t5*abb93n86+t187*t5*ab&
         &b93n86+t189*t5*abb93n86+t191*t5*abb93n86+t193*t5*abb93n86+t30*t80*abb9&
         &3n187+t32*t80*abb93n159+t38*t80*abb93n187+t39*t80*abb93n159+t44*t99*ab&
         &b93n175+t47*t99*abb93n175+t49*t80*abb93n185+t50*t80*abb93n159+t50*t99*&
         &abb93n184+t55*t80*abb93n185+t56*t80*abb93n159+t56*t99*abb93n184+t60*t9&
         &9*abb93n182+t62*t99*abb93n173+t65*t99*abb93n182+t67*t99*abb93n173+t70*&
         &t80*abb93n186+t71*t80*abb93n160+t71*t99*abb93n183+t73*t99*abb93n174+t7&
         &6*t80*abb93n186+t77*t80*abb93n160+t77*t99*abb93n183+t79*t99*abb93n174+&
         &t104*t19*t80*abb93n161+t107*t19*t80*abb93n146+t11*t35*t68*abb93n178+t1&
         &15*t117*t4*abb93n86+t115*t118*t4*abb93n86+t12*t35*t80*abb93n142+t13*t3&
         &5*t68*abb93n176+t14*t35*t68*abb93n177+t16*t34*t35*abb93n176+t16*t35*t3&
         &6*abb93n177+t16*t35*t8*abb93n178+t16*t35*t80*abb93n172+t164*t17*t35*ab&
         &b93n161+t164*t19*t33*abb93n161+t165*t17*t35*abb93n146+t165*t19*t33*abb&
         &93n146+t17*t26*t35*abb93n142+t17*t35*t68*abb93n172+t185*t35*t4*abb93n8&
         &6+t188*t19*t4*abb93n86+t19*t192*t4*abb93n86+t19*t20*t80*abb93n142+t19*&
         &t21*t68*abb93n177+t19*t26*t33*abb93n142+t19*t27*t68*abb93n178+t19*t28*&
         &t68*abb93n176+t19*t33*t68*abb93n172+t19*t34*t42*abb93n176+t19*t36*t42*&
         &abb93n177+t19*t42*t8*abb93n178+t19*t42*t80*abb93n172+t190*t35*t4*abb93&
         &n86+t24*t35*t80*abb93n161+t25*t35*t80*abb93n146)
         return
      end if
      t196 = d(iv3,iv4)
      t197 = d(iv2,iv4)
      t198 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak6k5(iv4)
      t3 = spvak3k1(iv4)
      t4 = spvak6k1(iv4)
      t5 = spvak3k4(iv4)
      t6 = spvak5k1(iv4)
      t7 = t23*t5
      t8 = t100*t5
      t9 = t161*t5
      t10 = spvak2k1(iv4)
      t11 = t10*t15
      t12 = t10*t31
      t10 = t10*t58
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t194*t198*abb93n106+t195*t197*abb93n106+t196*t19&
         &9*abb93n106)+(2.0_ki)*(t109*t196*abb93n87+t110*t196*abb93n91+t111*t196&
         &*abb93n87+t112*t196*abb93n91+t166*t197*abb93n87+t167*t198*abb93n87+t16&
         &8*t197*abb93n87+t169*t198*abb93n87+t171*t197*abb93n102+t174*t198*abb93&
         &n102+t176*t197*abb93n102+t178*t198*abb93n102+t180*t197*abb93n95+t181*t&
         &198*abb93n95+t182*t197*abb93n95+t183*t198*abb93n95+t196*t82*abb93n102+&
         &t196*t83*abb93n90+t196*t84*abb93n100+t196*t85*abb93n102+t196*t86*abb93&
         &n90+t196*t87*abb93n100+t196*t89*abb93n94+t196*t91*abb93n94+t196*t92*ab&
         &b93n95+t196*t93*abb93n116+t196*t94*abb93n95+t196*t95*abb93n116+t1*t115&
         &*t199*abb93n116+t1*t15*t194*abb93n102+t1*t18*t194*abb93n95+t1*t19*t194&
         &*abb93n116+t1*t194*t22*abb93n87+t1*t195*t29*abb93n87+t1*t195*t31*abb93&
         &n102+t1*t195*t35*abb93n116+t1*t195*t52*abb93n95+t1*t199*t45*abb93n87+t&
         &1*t199*t58*abb93n102+t1*t199*t99*abb93n95+t115*t15*t197*abb93n100+t115&
         &*t16*t197*abb93n94+t115*t17*t197*abb93n116+t115*t197*t22*abb93n91+t115&
         &*t198*t29*abb93n91+t115*t198*t31*abb93n100+t115*t198*t33*abb93n116+t11&
         &5*t198*t42*abb93n94+t115*t199*t3*abb93n91+t115*t199*t5*abb93n100+t115*&
         &t199*t6*abb93n94+t15*t194*t2*abb93n100+t15*t194*t4*abb93n90+t15*t197*t&
         &99*abb93n90+t16*t194*t2*abb93n94+t17*t194*t2*abb93n116+t17*t194*t3*abb&
         &93n87+t17*t194*t4*abb93n95+t17*t194*t5*abb93n102+t18*t194*t5*abb93n90+&
         &t18*t197*t58*abb93n90+t19*t194*t3*abb93n91+t19*t194*t5*abb93n100+t19*t&
         &194*t6*abb93n94+t19*t197*t45*abb93n91+t19*t197*t58*abb93n100+t19*t197*&
         &t68*abb93n94+t19*t197*t80*abb93n116+t194*t2*t22*abb93n91+t195*t2*t29*a&
         &bb93n91+t195*t2*t31*abb93n100+t195*t2*t33*abb93n116+t195*t2*t42*abb93n&
         &94+t195*t3*t33*abb93n87+t195*t3*t35*abb93n91+t195*t31*t4*abb93n90+t195&
         &*t33*t4*abb93n95+t195*t33*t5*abb93n102+t195*t35*t5*abb93n100+t195*t35*&
         &t6*abb93n94+t195*t5*t52*abb93n90+t198*t31*t99*abb93n90+t198*t35*t45*ab&
         &b93n91+t198*t35*t58*abb93n100+t198*t35*t68*abb93n94+t198*t35*t80*abb93&
         &n116+t198*t52*t58*abb93n90+t199*t2*t45*abb93n91+t199*t2*t58*abb93n100+&
         &t199*t2*t68*abb93n94+t199*t2*t80*abb93n116+t199*t3*t80*abb93n87+t199*t&
         &4*t58*abb93n90+t199*t4*t80*abb93n95+t199*t5*t80*abb93n102+t199*t5*t99*&
         &abb93n90)+t184*t2*abb93n86+t186*t2*abb93n86+t187*t2*abb93n86+t189*t2*a&
         &bb93n86+t191*t2*abb93n86+t193*t2*abb93n86+t1*t115*t117*abb93n86+t1*t11&
         &5*t118*abb93n86+t1*t185*t35*abb93n86+t1*t188*t19*abb93n86+t1*t19*t192*&
         &abb93n86+t1*t190*t35*abb93n86+t10*t17*t35*abb93n86+t10*t19*t33*abb93n8&
         &6+t11*t115*t33*abb93n86+t11*t35*t80*abb93n86+t115*t12*t17*abb93n86+t11&
         &5*t17*t8*abb93n86+t115*t33*t7*abb93n86+t12*t19*t80*abb93n86+t17*t35*t9&
         &*abb93n86+t19*t33*t9*abb93n86+t19*t8*t80*abb93n86+t35*t7*t80*abb93n86)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d93:
   subroutine     reconstruct_d93(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_93:
      coeffs%coeffs_93%c0 = derivative(czip)
      coeffs%coeffs_93%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_93%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_93%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_93%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_93%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_93%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_93%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_93%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_93%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_93%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_93%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_93%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_93%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_93%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_93%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_93%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_93%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_93%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_93%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_93%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_93%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_93%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_93%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_93%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_93%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_93%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_93%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_93%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_93%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_93%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_93%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_93%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_93%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_93%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_93%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_93%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_93%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_93%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_93%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_93%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_93%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_93%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_93%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_93%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_93%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_93%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_93%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_93%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_93%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_93%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_93%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_93%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_93%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_93%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_93%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_93%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_93%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_93%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_93%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_93%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_93%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_93%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_93%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_93%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_93%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_93%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_93:
   end subroutine reconstruct_d93
!---#] subroutine reconstruct_d93:
end module p9_udbar_neepgg_d93h0l1d
