module     p9_udbar_neepgg_abbrevd115h1
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb115n1
   complex(ki), public :: abb115n2
   complex(ki), public :: abb115n3
   complex(ki), public :: abb115n4
   complex(ki), public :: abb115n5
   complex(ki), public :: abb115n6
   complex(ki), public :: abb115n7
   complex(ki), public :: abb115n8
   complex(ki), public :: abb115n9
   complex(ki), public :: abb115n10
   complex(ki), public :: abb115n11
   complex(ki), public :: abb115n12
   complex(ki), public :: rat2d115
   complex(ki), public :: abb115n14
   complex(ki), public :: abb115n15
   complex(ki), public :: abb115n16
   complex(ki), public :: abb115n17
   complex(ki), public :: abb115n18
   complex(ki), public :: abb115n19
   complex(ki), public :: abb115n20
   complex(ki), public :: abb115n21
   complex(ki), public :: abb115n22
   complex(ki), public :: abb115n23
   complex(ki), public :: abb115n24
   complex(ki), public :: abb115n25
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c1*i_
      t3 = t2*spak1k3
      t4 = (es34+es56-(es234+es12))*t1
      t5 = es56*t4
      t6 = t5*spak5k6
      t7 = t6*spbk6k5
      t8 = TR*c2*i_
      t9 = t8*spak1k3
      t10 = t9*spak2k5*spbk4k1
      t11 = t8*spak2k5*spak3k4*spbk4k1
      t12 = t2*spak2k3
      t13 = es234*t1
      t14 = es56*t13
      t15 = t14*spak5k6
      t16 = t15*spbk6k5
      t17 = t8*spak2k3
      t18 = t17*spak2k5*spbk4k2
      t19 = t17*spak3k5*spbk4k3
      t20 = TR*c3*i_
      t21 = t20*spak1k3
      t22 = t21*spak2k5*spbk4k1
      t23 = es56*NC*t4
      t24 = t23*spak5k6
      t25 = t24*spbk6k5
      t26 = t20*spak2k5*spak3k4*spbk4k1
      t27 = t20*spak2k3
      t28 = t27*spak2k5*spbk4k2
      t1 = es56*es234*NC*t1
      t29 = t1*spak5k6
      t30 = t29*spbk6k5
      t31 = t27*spak3k5*spbk4k3
      abb115n1 = ((8.0_ki)*(t18/t16*spbk5k1+t22/t25*spbk5k1+t26/t25*spbk5k4+t31/&
      &t30*spbk5k1+t12/t16*spak2k6*spbk4k2*spbk6k1+t21/t25*spak2k6*spbk4k1*spbk6&
      &k1+t27/t30*spak3k6*spbk4k3*spbk6k1+t20/t25*spak2k6*spak3k4*spbk4k1*spbk6k&
      &4-(t2/t7*spak2k6*spak3k4*spbk4k1*spbk6k4+t3/t7*spak2k6*spbk4k1*spbk6k1+t2&
      &7/t30*spak2k6*spbk4k2*spbk6k1+t12/t16*spak3k6*spbk4k3*spbk6k1+t28/t30*spb&
      &k5k1+t19/t16*spbk5k1+t11/t7*spbk5k4+t10/t7*spbk5k1)))
      t32 = t2*spak3k4*spbk4k1
      t8 = t8*spak3k4*spbk4k1
      abb115n2 = ((8.0_ki)*(t32/t7-t8/t7))
      t2 = t2*spak2k5*spak3k4*spbk4k1
      abb115n3 = ((4.0_ki)*((2.0_ki)/t24*t26-(t2/t6+t11/t6)))
      t33 = sqrt((mT*mT))
      t34 = t3*spak2k5*spbk4k1
      t35 = t34*spbk6k1
      t33 = t33*t33
      t2 = t2*spbk6k4
      t36 = t10*spbk6k1
      t11 = t11*spbk6k4
      t37 = t12*spak2k5*spbk4k2
      t38 = t37*spbk6k1
      t39 = t12*spak3k5*spbk4k3
      t40 = t39*spbk6k1
      t41 = t18*spbk6k1
      t42 = t19*spbk6k1
      t4 = t4*spak5k6*spbk6k5
      t13 = t13*spak5k6*spbk6k5
      abb115n4 = ((4.0_ki)*(t40/t13+t41/t13+t2/t4+t35/t4-(t36/t4+t42/t13+t38/t13&
      &+t11/t4))+(8.0_ki)*(t33/t16*t40+t33/t16*t41+t2*t33/t7+t33*t35/t7-(t33*t36&
      &/t7+t33/t16*t42+t33/t16*t38+t11*t33/t7)))
      t4 = t35/t7
      t2 = t2/t7
      t13 = t36/t7
      t11 = t11/t7
      t33 = t38/t16
      t35 = t40/t16
      t36 = t41/t16
      t38 = t42/t16
      abb115n5 = ((8.0_ki)*(t11+t13+t33+t38-(t4+t36+t35+t2)))
      t3 = t3*spbk4k1
      t9 = t9*spbk4k1
      t40 = t12*spbk4k2
      t41 = t17*spbk4k2
      abb115n6 = ((8.0_ki)*(t41/t16+t3/t7-(t9/t7+t40/t16)))
      t7 = t12*spbk4k3
      t12 = t17*spbk4k3
      abb115n7 = ((8.0_ki)*(t7/t16-t12/t16))
      t16 = t23*spbk6k5
      t1 = t1*spbk6k5
      t5 = t5*spbk6k5
      t14 = t14*spbk6k5
      abb115n8 = ((8.0_ki)*(t27/t1*spbk4k2*spbk6k1-(t20/t16*spak3k4*spbk4k1*spbk&
      &6k4+t21/t16*spbk4k1*spbk6k1))+(4.0_ki)*(t3/t5*spbk6k1+t32/t5*spbk6k4+t8/t&
      &5*spbk6k4+t9/t5*spbk6k1-(t41/t14*spbk6k1+t40/t14*spbk6k1)))
      t3 = t22/t25*spbk6k1
      t5 = t26/t25*spbk6k4
      t8 = t28/t30*spbk6k1
      t9 = t31/t30*spbk6k1
      abb115n9 = ((16.0_ki)*(t2+t35+t4+t8-(t9+t5+t33+t3)))
      abb115n10 = ((16.0_ki)*(t11+t13+t38+t8-(t9+t5+t36+t3)))
      abb115n11 = ((4.0_ki)*(t12/t14*spbk6k1+t7/t14*spbk6k1-(2.0_ki)/t1*t27*spbk&
      &4k3*spbk6k1))
      abb115n12 = ((8.0_ki)*(t22/t24+t31/t29-t28/t29)+(4.0_ki)*(t18/t15+t37/t15-&
      &(t34/t6+t39/t15+t19/t15+t10/t6)))
      rat2d115 = 0
      rat2 = rat2 + rat2d115
      abb115n14 = abb115n1
      abb115n15 = abb115n12
      abb115n16 = abb115n11
      abb115n17 = abb115n10
      abb115n18 = abb115n9
      abb115n19 = abb115n8
      abb115n20 = abb115n3
      abb115n21 = -(abb115n2)
      abb115n22 = -(abb115n4)
      abb115n23 = -(abb115n5)
      abb115n24 = -(abb115n6)
      abb115n25 = -(abb115n7)
   end subroutine
end module p9_udbar_neepgg_abbrevd115h1
