module     p9_udbar_neepgg_abbrevd43h1
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb43n1
   complex(ki), public :: abb43n2
   complex(ki), public :: abb43n3
   complex(ki), public :: abb43n4
   complex(ki), public :: abb43n5
   complex(ki), public :: abb43n6
   complex(ki), public :: abb43n7
   complex(ki), public :: abb43n8
   complex(ki), public :: abb43n9
   complex(ki), public :: abb43n10
   complex(ki), public :: abb43n11
   complex(ki), public :: abb43n12
   complex(ki), public :: abb43n13
   complex(ki), public :: abb43n14
   complex(ki), public :: abb43n15
   complex(ki), public :: rat2d43
   complex(ki), public :: abb43n17
   complex(ki), public :: abb43n18
   complex(ki), public :: abb43n19
   complex(ki), public :: abb43n20
   complex(ki), public :: abb43n21
   complex(ki), public :: abb43n22
   complex(ki), public :: abb43n23
   complex(ki), public :: abb43n24
   complex(ki), public :: abb43n25
   complex(ki), public :: abb43n26
   complex(ki), public :: abb43n27
   complex(ki), public :: abb43n28
   complex(ki), public :: abb43n29
   complex(ki), public :: abb43n30
   complex(ki), public :: abb43n31
   complex(ki), public :: abb43n32
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = TR*c2*i_
      t2 = t1*spak1k5*spak2k3
      t3 = spbk6k1*spbk6k1
      t4 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t5 = es234*NC*t4
      t6 = t5*spak5k6
      t7 = t6*spbk6k5
      t8 = t2*t3/t7*spak2k5*spbk4k2
      t9 = t2*t3/t7*spak3k5*spbk4k3
      t10 = NC*TR*c2
      t11 = t10*i_
      t12 = t11*spak1k5*spak2k3
      t13 = t12*spak2k5*spbk4k2
      t4 = es234*t4*spak5k6
      t14 = t4*spbk6k5
      t15 = t13/t14*t3
      t16 = t12*spak3k5*spbk4k3
      t17 = t16/t14*t3
      abb43n1 = ((2.0_ki)*(t15+t9-(t8+t17)))
      t18 = es56*t10*i_*spak1k5*spak2k3
      t10 = es61*t10*i_*spak1k5*spak2k3
      t19 = t11*spak2k3
      t20 = spak1k5*spbk6k1
      t20 = t20*t20
      abb43n2 = ((2.0_ki)*(t19/t14*t20*spak2k6*spbk4k2*spbk6k1-t19/t14*t20*spak3&
      &k6*spbk4k3*spbk6k1)+(4.0_ki)*(t10/t14*t3*spak2k5*spbk4k2+t18/t14*t3*spak2&
      &k5*spbk4k2-(t18/t14*t3*spak3k5*spbk4k3+t10/t14*t3*spak3k5*spbk4k3)))
      abb43n3 = ((8.0_ki)*(t17-t15))
      abb43n4 = ((8.0_ki)*(t15-t17))
      abb43n5 = ((2.0_ki)*(t12/t14*t3*spak2k6*spbk4k2-t12/t14*t3*spak3k6*spbk4k3&
      &))
      t10 = t11*spak1k2
      t11 = t11*spak1k3
      abb43n6 = ((2.0_ki)*(t16/t4*spbk6k1+t11/t14*t3*spak1k5*spak2k3*spbk4k3-(t1&
      &0/t14*t3*spak1k5*spak2k3*spbk4k2+t13/t4*spbk6k1)))
      t13 = t2*spbk4k2
      t5 = t5*spbk6k5
      abb43n7 = (-4.0_ki)*t13*t3/t5
      abb43n8 = ((4.0_ki)*(t17+t8-(t9+t15)))
      t2 = t2*spbk4k3
      abb43n9 = ((4.0_ki)*t2*t3/t5)
      abb43n10 = ((4.0_ki)*(t13/t7*spbk6k1+t12/t14*spbk4k2*spbk6k1))
      abb43n11 = ((4.0_ki)*(-(t12/t14*spbk4k3*spbk6k1+t2/t7*spbk6k1)))
      t2 = t1*spak2k3
      t3 = t2*spak2k5*spbk4k2
      t2 = t2*spak3k5*spbk4k3
      t5 = t19*spak2k5*spbk4k2
      t8 = t19*spak3k5*spbk4k3
      abb43n12 = ((8.0_ki)*(t8/t14*spbk5k1+t2/t7*spbk5k1-(t3/t7*spbk5k1+t5/t14*s&
      &pbk5k1)))
      t9 = t3/t7*spbk6k1
      t12 = t2/t7*spbk6k1
      t13 = t5/t14*spbk6k1
      t15 = t8/t14*spbk6k1
      abb43n13 = ((16.0_ki)*(t12+t15-(t9+t13)))
      abb43n14 = ((16.0_ki)*(t13+t9-(t15+t12)))
      abb43n15 = ((8.0_ki)*(t2/t6+t8/t4+t11/t14*spak2k3*spbk4k3*spbk6k1+t1/t7*sp&
      &ak1k3*spak2k3*spbk4k3*spbk6k1-(t1/t7*spak1k2*spak2k3*spbk4k2*spbk6k1+t10/&
      &t14*spak2k3*spbk4k2*spbk6k1+t5/t4+t3/t6)))
      rat2d43 = abb43n1
      rat2 = rat2 + rat2d43
      abb43n17 = abb43n2
      abb43n18 = abb43n15
      abb43n19 = abb43n14
      abb43n20 = abb43n13
      abb43n21 = abb43n12
      abb43n22 = abb43n11
      abb43n23 = abb43n10
      abb43n24 = abb43n8
      abb43n25 = -(abb43n3)
      abb43n26 = -(abb43n4)
      abb43n27 = -(abb43n5)
      abb43n28 = -(abb43n6)
      abb43n29 = -(abb43n7)
      abb43n30 = ((2.0_ki)*abb43n8)
      abb43n31 = -(abb43n9)
      abb43n32 = ((2.0_ki)*abb43n12)
   end subroutine
end module p9_udbar_neepgg_abbrevd43h1
