module     p9_udbar_neepgg_abbrevd87h1
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb87n1
   complex(ki), public :: abb87n2
   complex(ki), public :: abb87n3
   complex(ki), public :: abb87n4
   complex(ki), public :: abb87n5
   complex(ki), public :: abb87n6
   complex(ki), public :: abb87n7
   complex(ki), public :: abb87n8
   complex(ki), public :: abb87n9
   complex(ki), public :: abb87n10
   complex(ki), public :: abb87n11
   complex(ki), public :: abb87n12
   complex(ki), public :: abb87n13
   complex(ki), public :: abb87n14
   complex(ki), public :: abb87n15
   complex(ki), public :: abb87n16
   complex(ki), public :: abb87n17
   complex(ki), public :: abb87n18
   complex(ki), public :: abb87n19
   complex(ki), public :: abb87n20
   complex(ki), public :: rat2d87
   complex(ki), public :: abb87n22
   complex(ki), public :: abb87n23
   complex(ki), public :: abb87n24
   complex(ki), public :: abb87n25
   complex(ki), public :: abb87n26
   complex(ki), public :: abb87n27
   complex(ki), public :: abb87n28
   complex(ki), public :: abb87n29
   complex(ki), public :: abb87n30
   complex(ki), public :: abb87n31
   complex(ki), public :: abb87n32
   complex(ki), public :: abb87n33
   complex(ki), public :: abb87n34
   complex(ki), public :: abb87n35
   complex(ki), public :: abb87n36
   complex(ki), public :: abb87n37
   complex(ki), public :: abb87n38
   complex(ki), public :: abb87n39
   complex(ki), public :: abb87n40
   complex(ki), public :: abb87n41
   complex(ki), public :: abb87n42
   complex(ki), public :: abb87n43
   complex(ki), public :: abb87n44
   complex(ki), public :: abb87n45
   complex(ki), public :: abb87n46
   complex(ki), public :: abb87n47
   complex(ki), public :: abb87n48
   complex(ki), public :: abb87n49
   complex(ki), public :: abb87n50
   complex(ki), public :: abb87n51
   complex(ki), public :: abb87n52
   complex(ki), public :: abb87n53
   complex(ki), public :: abb87n54
   complex(ki), public :: abb87n55
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c3
      t3 = t2*i_
      t4 = t3*spak2k3
      t5 = t1*spak5k6
      t6 = t5*spbk6k5
      t7 = t4/t6*spbk6k4
      t8 = TR*c1
      t9 = t8*i_
      t10 = t9*spak2k3
      t11 = NC*t1
      t12 = t11*spak5k6
      t13 = t12*spbk6k5
      t14 = t10/t13*spbk6k4
      abb87n1 = ((4.0_ki)*(t14-t7))
      t15 = t3*spak1k3
      t16 = t9*spak1k3
      abb87n2 = ((4.0_ki)*(t16/t13*spak2k6*spbk6k1*spbk6k4+es12*t8/t13*i_*spak2k&
      &3*spbk6k4+es61*t8/t13*i_*spak2k3*spbk6k4+es345*t2/t6*i_*spak2k3*spbk6k4-(&
      &es61*t2/t6*i_*spak2k3*spbk6k4+es12*t2/t6*i_*spak2k3*spbk6k4+es345*t8/t13*&
      &i_*spak2k3*spbk6k4+t15/t6*spak2k6*spbk6k1*spbk6k4)))
      t1 = t1*spbk6k5
      t2 = t11*spbk6k5
      abb87n3 = ((4.0_ki)*(t15/t1*spbk6k1*spbk6k4-t16/t2*spbk6k1*spbk6k4))
      t8 = t4/t6*spbk4k1
      t11 = t10/t13*spbk4k1
      abb87n4 = ((8.0_ki)*(t11-t8))
      abb87n5 = ((8.0_ki)*(t8-t11))
      t8 = t3*spak2k5
      t11 = t9*spak2k5
      t17 = t4*spak2k5
      t18 = t10*spak2k5
      abb87n6 = ((4.0_ki)*(t17/t6*spbk2k1*spbk6k4+t8/t5*spak3k5*spbk4k1-(t18/t13&
      &*spbk2k1*spbk6k4+t11/t12*spak3k5*spbk4k1)))
      abb87n7 = ((8.0_ki)*(t4/t1*spbk6k1*spbk6k4-t10/t2*spbk6k1*spbk6k4))
      abb87n8 = ((4.0_ki)*(t8/t6*spbk6k1-t11/t13*spbk6k1))
      t5 = t3*spak3k5
      t12 = t5/t6*spbk6k1
      t19 = t9*spak3k5
      t20 = t19/t13*spbk6k1
      abb87n9 = ((4.0_ki)*(t20-t12))
      abb87n10 = ((8.0_ki)*(t12-t20))
      abb87n11 = ((4.0_ki)*(t19/t13*spbk5k1+t9/t13*spak3k6*spbk6k1-(t3/t6*spak3k&
      &6*spbk6k1+t5/t6*spbk5k1)))
      abb87n12 = ((4.0_ki)*(t3/t1*spbk6k1-t9/t2*spbk6k1))
      abb87n13 = ((4.0_ki)*(t16/t13*spbk4k1+t4/t6*spbk4k2-(t15/t6*spbk4k1+t10/t1&
      &3*spbk4k2)))
      abb87n14 = ((4.0_ki)*(t17/t6*spbk6k2*spbk6k4+t15/t6*spak2k5*spbk6k1*spbk6k&
      &4-(t16/t13*spak2k5*spbk6k1*spbk6k4+t18/t13*spbk6k2*spbk6k4)))
      abb87n15 = ((4.0_ki)*(t10/t13*spbk5k4-t4/t6*spbk5k4))
      abb87n16 = ((8.0_ki)*(t7-t14))
      t1 = t8/t6*spbk6k4
      t2 = t11/t13*spbk6k4
      abb87n17 = ((8.0_ki)*(t2-t1))
      abb87n18 = ((4.0_ki)*(t1-t2))
      abb87n19 = ((4.0_ki)*(t8/t6*spbk5k4+t3/t6*spak1k2*spbk4k1+t3/t6*spak2k6*sp&
      &bk6k4-(t9/t13*spak2k6*spbk6k4+t9/t13*spak1k2*spbk4k1+t11/t13*spbk5k4)))
      abb87n20 = ((4.0_ki)*(t9/t13-t3/t6))
      rat2d87 = 0
      rat2 = rat2 + rat2d87
      abb87n22 = -(abb87n1)
      abb87n23 = abb87n20
      abb87n24 = abb87n18
      abb87n25 = abb87n14
      abb87n26 = abb87n9
      abb87n27 = abb87n8
      abb87n28 = abb87n7
      abb87n29 = abb87n3
      abb87n30 = abb87n2
      abb87n31 = abb87n1
      t1 = (2.0_ki)*abb87n1
      abb87n32 = t1
      abb87n33 = -(t1)
      abb87n34 = -(abb87n4)
      abb87n35 = (-2.0_ki)*abb87n4
      abb87n36 = -(abb87n5)
      abb87n37 = (-2.0_ki)*abb87n5
      abb87n38 = -(abb87n6)
      abb87n39 = (-2.0_ki)*abb87n6
      abb87n40 = ((2.0_ki)*abb87n8)
      abb87n41 = ((2.0_ki)*abb87n9)
      abb87n42 = -(abb87n10)
      abb87n43 = -(abb87n11)
      abb87n44 = (-2.0_ki)*abb87n11
      abb87n45 = -(abb87n12)
      abb87n46 = -(abb87n13)
      abb87n47 = (-2.0_ki)*abb87n13
      abb87n48 = -(abb87n15)
      abb87n49 = (-2.0_ki)*abb87n15
      abb87n50 = -(abb87n16)
      abb87n51 = -(abb87n17)
      abb87n52 = ((2.0_ki)*abb87n18)
      abb87n53 = -(abb87n19)
      abb87n54 = (-2.0_ki)*abb87n19
      abb87n55 = ((2.0_ki)*abb87n20)
   end subroutine
end module p9_udbar_neepgg_abbrevd87h1
