module     p9_udbar_neepgg_d83h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d83h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d83
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd83h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      real(ki) :: t132
      real(ki) :: t133
      real(ki) :: t134
      real(ki) :: t135
      real(ki) :: t136
      real(ki) :: t137
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t132 = dotproduct(qshift, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = t1*t1
      t133 = dotproduct(k6, qshift)
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t134 = dotproduct(k5, qshift)
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t135 = dotproduct(k2, qshift)
      t136 = dotproduct(k1, qshift)
      t5 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t6 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t8 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t9 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb83n66+t1*abb83n134+t132*abb83n102+t132*t132*abb83n98+t1&
         &33*abb83n130+t134*abb83n135+t135*abb83n142+t136*abb83n145+t2*abb83n127&
         &+t3*abb83n133+t4*abb83n137+t1*t132*abb83n181+t1*t133*abb83n128+t1*t134&
         &*abb83n128+t1*t135*abb83n106+t1*t136*abb83n103+t1*t3*abb83n123+t1*t4*a&
         &bb83n84+t1*t5*abb83n105+t1*t7*abb83n85+t1*t9*abb83n75+t132*t133*abb83n&
         &177+t132*t135*abb83n171+t132*t3*abb83n167+t132*t4*abb83n205+t132*t5*ab&
         &b83n189+t132*t9*abb83n221+t133*t4*abb83n119+t133*t5*abb83n115+t134*t13&
         &5*abb83n99+t134*t4*abb83n82+t134*t5*abb83n90+t134*t9*abb83n72+t135*t13&
         &6*abb83n96+t135*t2*abb83n147+t135*t3*abb83n108+t135*t4*abb83n120+t135*&
         &t5*abb83n116+t136*t2*abb83n147+t136*t3*abb83n100+t136*t4*abb83n80+t136&
         &*t5*abb83n92+t136*t9*abb83n74+t2*t4*abb83n209+t2*t5*abb83n155+t2*t6*ab&
         &b83n162+t2*t7*abb83n201+t2*t8*abb83n215+t2*t9*abb83n230+t3*t4*abb83n12&
         &1+t3*t5*abb83n107+t1*t132*t3*abb83n94+t1*t132*t4*abb83n78+t1*t132*t5*a&
         &bb83n111+t1*t132*t6*abb83n88+t1*t132*t9*abb83n69+t1*t133*t4*abb83n217+&
         &t1*t133*t5*abb83n149+t1*t133*t9*abb83n225+t1*t134*t4*abb83n212+t1*t134&
         &*t6*abb83n192+t1*t134*t9*abb83n227+t1*t135*t3*abb83n186+t1*t135*t4*abb&
         &83n212+t1*t135*t5*abb83n153+t1*t135*t9*abb83n227+t1*t136*t3*abb83n186+&
         &t1*t136*t4*abb83n217+t1*t136*t6*abb83n196+t1*t136*t9*abb83n225+t1*t3*t&
         &4*abb83n141+t1*t3*t5*abb83n197+t1*t3*t7*abb83n224+t2*t3*t7*abb83n67)
         return
      end if
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak2k1(iv1)
      t19 = spvak2k4(iv1)
      t20 = spvak2k6(iv1)
      t21 = spvak3k1(iv1)
      t22 = t17*abb83n131
      t23 = spvak6k1(iv1)
      t24 = t21*abb83n69
      t25 = t21*abb83n70
      t26 = t15*abb83n93
      t27 = t16*abb83n76
      t28 = t16*abb83n78
      t29 = t17*abb83n146
      t30 = t17*abb83n69
      t31 = t17*abb83n70
      t32 = t17*abb83n76
      t33 = t17*abb83n78
      t34 = t17*abb83n93
      if(deg.eq.1) then
         numerator = (t10*abb83n114+t11*abb83n117+t12*abb83n124+t13*abb83n129+t1&
         &33*t22+t134*t22+t14*abb83n165+t15*abb83n126+t16*abb83n122+t17*abb83n12&
         &5+t1*t10*abb83n164+t1*t11*abb83n159+t1*t12*abb83n131+t1*t13*abb83n131+&
         &t1*t133*t25+t1*t133*t27+t1*t134*t24+t1*t134*t28+t1*t135*t24+t1*t135*t2&
         &6+t1*t135*t28+t1*t135*t29+t1*t136*t25+t1*t136*t26+t1*t136*t27+t1*t136*&
         &t29+t1*t14*abb83n180+t1*t15*abb83n136+t1*t16*abb83n199+t1*t17*abb83n13&
         &2+t1*t18*abb83n198+t1*t20*abb83n160+t1*t21*abb83n218+t10*t135*abb83n17&
         &9+t10*t2*abb83n113+t10*t3*abb83n169+t10*t4*abb83n207+t10*t5*abb83n187+&
         &t10*t9*abb83n219+t11*t132*abb83n99+t11*t134*abb83n171+t11*t136*abb83n1&
         &79+t11*t2*abb83n113+t11*t3*abb83n157+t11*t4*abb83n139+t11*t5*abb83n143&
         &+t12*t135*abb83n171+t12*t4*abb83n203+t12*t5*abb83n191+t12*t9*abb83n223&
         &+t13*t132*abb83n97+t13*t4*abb83n140+t13*t5*abb83n144+t132*t14*abb83n17&
         &5+t132*t15*abb83n101+t132*t16*abb83n81+t132*t17*abb83n95+t132*t20*abb8&
         &3n91+t132*t21*abb83n73+t133*t14*abb83n176+t133*t16*abb83n140+t133*t20*&
         &abb83n144+t133*t31*t9+t133*t32*t4+t134*t16*abb83n203+t134*t20*abb83n19&
         &1+t134*t21*abb83n223+t134*t30*t9+t134*t33*t4+t135*t14*abb83n170+t135*t&
         &15*abb83n157+t135*t16*abb83n139+t135*t17*abb83n159+t135*t20*abb83n143+&
         &t135*t3*t34+t135*t30*t9+t135*t33*t4+t136*t15*abb83n169+t136*t16*abb83n&
         &207+t136*t17*abb83n164+t136*t20*abb83n187+t136*t21*abb83n219+t136*t3*t&
         &34+t136*t31*t9+t136*t32*t4+t14*t3*abb83n166+t14*t4*abb83n204+t14*t5*ab&
         &b83n188+t14*t9*abb83n220+t15*t4*abb83n138+t15*t5*abb83n158+t16*t2*abb8&
         &3n79+t16*t3*abb83n138+t17*t3*abb83n136+t17*t4*abb83n199+t17*t5*abb83n1&
         &60+t17*t7*abb83n198+t17*t9*abb83n218+t18*t2*abb83n83+t19*t2*abb83n104+&
         &t2*t20*abb83n109+t2*t21*abb83n68+t2*t23*abb83n77+t20*t3*abb83n158+t1*t&
         &10*t3*abb83n93+t1*t10*t4*abb83n76+t1*t10*t6*abb83n87+t1*t10*t9*abb83n7&
         &0+t1*t11*t3*abb83n93+t1*t11*t4*abb83n78+t1*t11*t5*abb83n110+t1*t11*t9*&
         &abb83n69+t1*t12*t4*abb83n78+t1*t12*t6*abb83n89+t1*t12*t9*abb83n69+t1*t&
         &13*t4*abb83n76+t1*t13*t5*abb83n112+t1*t13*t9*abb83n70+t1*t132*t15*abb8&
         &3n184+t1*t132*t16*abb83n212+t1*t132*t19*abb83n194+t1*t132*t20*abb83n15&
         &1+t1*t132*t21*abb83n227+t1*t133*t20*abb83n112+t1*t134*t19*abb83n89+t1*&
         &t135*t20*abb83n110+t1*t136*t19*abb83n87+t1*t14*t3*abb83n185+t1*t14*t4*&
         &abb83n213+t1*t14*t5*abb83n152+t1*t14*t6*abb83n195+t1*t14*t9*abb83n228+&
         &t1*t15*t4*abb83n118+t1*t15*t5*abb83n86+t1*t15*t7*abb83n71+t1*t16*t3*ab&
         &b83n118+t1*t17*t4*abb83n208+t1*t17*t5*abb83n154+t1*t17*t6*abb83n161+t1&
         &*t17*t7*abb83n200+t1*t17*t8*abb83n214+t1*t17*t9*abb83n229+t1*t18*t3*ab&
         &b83n71+t1*t20*t3*abb83n86+t132*t17*t3*abb83n184+t132*t17*t4*abb83n212+&
         &t132*t17*t5*abb83n151+t132*t17*t6*abb83n194+t132*t17*t9*abb83n227+t133&
         &*t17*t5*abb83n112+t134*t17*t6*abb83n89+t135*t17*t5*abb83n110+t136*t17*&
         &t6*abb83n87+t15*t2*t7*abb83n233+t17*t3*t4*abb83n118+t17*t3*t5*abb83n86&
         &+t17*t3*t7*abb83n71+t18*t2*t3*abb83n233+t1*t17*t3*t7*abb83n234)
         return
      end if
      t137 = d(iv1,iv2)
      t22 = qshift(iv2)
      t24 = spvak5k6(iv2)
      t25 = t17*t24
      t26 = t25*abb83n147
      t27 = k2(iv2)
      t28 = spvak2k6(iv2)
      t29 = spvak3k1(iv2)
      t30 = t10*t29
      t31 = spvak3k4(iv2)
      t32 = t10*t31
      t33 = spvak5k1(iv2)
      t34 = t10*t33
      t35 = t10*t24
      t36 = k1(iv2)
      t37 = t21*t36
      t38 = t15*t36
      t39 = t16*t36
      t40 = t17*t36
      t41 = k5(iv2)
      t42 = t11*t28
      t43 = t11*t31
      t44 = t11*t33
      t45 = t11*t24
      t46 = t20*t27
      t47 = t15*t27
      t48 = t16*t27
      t49 = t17*t27
      t50 = t12*t29
      t51 = t12*t33
      t52 = t12*t24
      t53 = t21*t41
      t54 = t16*t41
      t55 = t17*t41
      t56 = t13*t28
      t57 = t13*t33
      t58 = t13*t24
      t59 = k6(iv2)
      t60 = t20*t59
      t61 = t16*t59
      t62 = t17*t59
      t63 = t14*t28
      t64 = t14*t29
      t65 = t14*t31
      t66 = t14*t33
      t67 = t14*t24
      t68 = t20*t22
      t69 = t21*t22
      t70 = t15*t22
      t71 = t16*t22
      t72 = t17*t22
      t73 = t18*t24
      t74 = spvak2k1(iv2)
      t75 = t17*t74
      t76 = t20*t31
      t77 = t20*t24
      t78 = t15*t28
      t79 = t17*t28
      t80 = t21*t24
      t81 = t17*t29
      t82 = t15*t33
      t83 = t15*t24
      t84 = t16*t31
      t85 = t17*t31
      t86 = t16*t24
      t87 = t17*t33
      t88 = spvak2k4(iv2)
      t89 = t10*t88
      t90 = t19*t36
      t91 = t11*t29
      t92 = t21*t27
      t93 = t12*t88
      t94 = t19*t41
      t95 = t13*t29
      t96 = t21*t59
      t97 = t14*t88
      t98 = t19*t22
      t99 = t18*t31
      t100 = t15*t74
      t101 = t19*t24
      t102 = t17*t88
      t103 = t80*abb83n225
      t104 = t80*abb83n227
      t105 = t81*abb83n225
      t106 = t81*abb83n227
      t107 = t83*abb83n186
      t108 = t85*abb83n186
      t109 = t86*abb83n212
      t110 = t86*abb83n217
      t111 = t87*abb83n212
      t112 = t87*abb83n217
      t113 = spvak6k1(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t135*t26+t136*t26+t137*abb83n102+t25*abb83n127+t&
         &1*t137*abb83n181+t132*t137*abb83n174+t133*t137*abb83n177+t135*t137*abb&
         &83n171+t137*t3*abb83n167+t137*t4*abb83n205+t137*t5*abb83n189+t137*t9*a&
         &bb83n221+t14*t22*abb83n173+t25*t4*abb83n209+t25*t5*abb83n155+t25*t6*ab&
         &b83n162+t25*t7*abb83n201+t25*t8*abb83n215+t25*t9*abb83n230+t1*t137*t3*&
         &abb83n94+t1*t137*t4*abb83n78+t1*t137*t5*abb83n111+t1*t137*t6*abb83n88+&
         &t1*t137*t9*abb83n69+t25*t3*t7*abb83n67)+t103*t133+t103*t136+t104*t134+&
         &t104*t135+t105*t133+t105*t136+t106*t134+t106*t135+t107*t135+t107*t136+&
         &t108*t135+t108*t136+t109*t134+t109*t135+t110*t133+t110*t136+t111*t134+&
         &t111*t135+t112*t133+t112*t136+t30*abb83n74+t32*abb83n100+t34*abb83n80+&
         &t35*abb83n103+t37*abb83n74+t38*abb83n100+t39*abb83n80+t40*abb83n103+t4&
         &2*abb83n116+t43*abb83n108+t44*abb83n120+t45*abb83n106+t46*abb83n116+t4&
         &7*abb83n108+t48*abb83n120+t49*abb83n106+t50*abb83n72+t51*abb83n82+t52*&
         &abb83n128+t53*abb83n72+t54*abb83n82+t55*abb83n128+t56*abb83n115+t57*ab&
         &b83n119+t58*abb83n128+t60*abb83n115+t61*abb83n119+t62*abb83n128+t63*ab&
         &b83n190+t64*abb83n222+t65*abb83n168+t66*abb83n206+t67*abb83n182+t68*ab&
         &b83n190+t69*abb83n222+t70*abb83n168+t71*abb83n206+t72*abb83n182+t73*ab&
         &b83n85+t75*abb83n85+t76*abb83n107+t77*abb83n105+t78*abb83n107+t79*abb8&
         &3n105+t80*abb83n75+t81*abb83n75+t82*abb83n121+t83*abb83n123+t84*abb83n&
         &121+t85*abb83n123+t86*abb83n84+t87*abb83n84+t1*t100*abb83n224+t1*t101*&
         &abb83n163+t1*t102*abb83n163+t1*t30*abb83n225+t1*t32*abb83n186+t1*t34*a&
         &bb83n217+t1*t35*abb83n148+t1*t37*abb83n225+t1*t38*abb83n186+t1*t39*abb&
         &83n217+t1*t40*abb83n148+t1*t42*abb83n153+t1*t43*abb83n186+t1*t44*abb83&
         &n212+t1*t45*abb83n148+t1*t46*abb83n153+t1*t47*abb83n186+t1*t48*abb83n2&
         &12+t1*t49*abb83n148+t1*t50*abb83n227+t1*t51*abb83n212+t1*t53*abb83n227&
         &+t1*t54*abb83n212+t1*t56*abb83n149+t1*t57*abb83n217+t1*t60*abb83n149+t&
         &1*t61*abb83n217+t1*t63*abb83n150+t1*t64*abb83n226+t1*t65*abb83n183+t1*&
         &t66*abb83n211+t1*t68*abb83n150+t1*t69*abb83n226+t1*t70*abb83n183+t1*t7&
         &1*abb83n211+t1*t73*abb83n202+t1*t75*abb83n202+t1*t76*abb83n197+t1*t77*&
         &abb83n156+t1*t78*abb83n197+t1*t79*abb83n156+t1*t80*abb83n231+t1*t81*ab&
         &b83n231+t1*t82*abb83n141+t1*t84*abb83n141+t1*t86*abb83n210+t1*t87*abb8&
         &3n210+t1*t89*abb83n196+t1*t90*abb83n196+t1*t91*abb83n227+t1*t92*abb83n&
         &227+t1*t93*abb83n192+t1*t94*abb83n192+t1*t95*abb83n225+t1*t96*abb83n22&
         &5+t1*t97*abb83n193+t1*t98*abb83n193+t1*t99*abb83n224+t10*t27*abb83n96+&
         &t10*t28*abb83n92+t100*t2*abb83n67+t101*t132*abb83n88+t101*t134*abb83n1&
         &92+t101*t136*abb83n196+t102*t132*abb83n88+t102*t134*abb83n192+t102*t13&
         &6*abb83n196+t11*t22*abb83n172+t11*t36*abb83n96+t11*t41*abb83n99+t12*t2&
         &7*abb83n99+t12*t28*abb83n90+t13*t22*abb83n178+t132*t77*abb83n111+t132*&
         &t79*abb83n111+t132*t80*abb83n69+t132*t81*abb83n69+t132*t83*abb83n94+t1&
         &32*t85*abb83n94+t132*t86*abb83n78+t132*t87*abb83n78+t133*t77*abb83n149&
         &+t133*t79*abb83n149+t135*t77*abb83n153+t135*t79*abb83n153+t14*t27*abb8&
         &3n172+t14*t59*abb83n178+t2*t99*abb83n67+t20*t36*abb83n92+t20*t41*abb83&
         &n90+t3*t35*abb83n186+t3*t40*abb83n186+t3*t45*abb83n186+t3*t49*abb83n18&
         &6+t3*t67*abb83n183+t3*t72*abb83n183+t3*t73*abb83n224+t3*t75*abb83n224+&
         &t3*t77*abb83n197+t3*t79*abb83n197+t3*t86*abb83n141+t3*t87*abb83n141+t3&
         &5*t4*abb83n217+t35*t6*abb83n196+t35*t9*abb83n225+t4*t40*abb83n217+t4*t&
         &45*abb83n212+t4*t49*abb83n212+t4*t52*abb83n212+t4*t55*abb83n212+t4*t58&
         &*abb83n217+t4*t62*abb83n217+t4*t67*abb83n211+t4*t72*abb83n211+t4*t83*a&
         &bb83n141+t4*t85*abb83n141+t40*t6*abb83n196+t40*t9*abb83n225+t45*t5*abb&
         &83n153+t45*t9*abb83n227+t49*t5*abb83n153+t49*t9*abb83n227+t5*t58*abb83&
         &n149+t5*t62*abb83n149+t5*t67*abb83n150+t5*t72*abb83n150+t5*t83*abb83n1&
         &97+t5*t85*abb83n197+t52*t6*abb83n192+t52*t9*abb83n227+t55*t6*abb83n192&
         &+t55*t9*abb83n227+t58*t9*abb83n225+t6*t67*abb83n193+t6*t72*abb83n193+t&
         &62*t9*abb83n225+t67*t9*abb83n226+t7*t83*abb83n224+t7*t85*abb83n224+t72&
         &*t9*abb83n226+t1*t113*t17*abb83n216+t1*t23*t24*abb83n216+t1*t3*t73*abb&
         &83n232+t1*t3*t75*abb83n232+t1*t7*t83*abb83n232+t1*t7*t85*abb83n232)
         return
      end if
      t132 = d(iv2,iv3)
      t133 = d(iv1,iv3)
      t2 = k2(iv3)
      t8 = k6(iv3)
      t26 = qshift(iv3)
      t52 = t132*t20
      t55 = t133*t28
      t58 = spvak2k6(iv3)
      t62 = t137*t58
      t67 = t132*t21
      t72 = t133*t29
      t103 = spvak3k1(iv3)
      t104 = t103*t137
      t105 = t132*t15
      t106 = t133*t31
      t107 = spvak3k4(iv3)
      t108 = t107*t137
      t109 = t132*t16
      t110 = t133*t33
      t111 = spvak5k1(iv3)
      t112 = t111*t137
      t114 = t132*t17
      t115 = t133*t24
      t116 = spvak5k6(iv3)
      t117 = t116*t137
      t118 = k1(iv3)
      t73 = t116*t73
      t75 = t116*t75
      t119 = spvak2k1(iv3)
      t120 = t119*t17*t24
      t121 = spvak2k4(iv3)
      t122 = t121*t17
      t123 = t17*t58
      t124 = t103*t17
      t125 = t111*t17
      t126 = t107*t17
      t127 = k5(iv3)
      t99 = t116*t99
      t128 = t107*t18*t24
      t100 = t100*t116
      t129 = t107*t17*t74
      t130 = t119*t15*t24
      t131 = t119*t17*t31
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t104*abb83n73+t105*abb83n101+t106*abb83n101+t108&
         &*abb83n101+t109*abb83n81+t110*abb83n81+t112*abb83n81+t114*abb83n95+t11&
         &5*abb83n95+t117*abb83n95+t120*abb83n83+t52*abb83n91+t55*abb83n91+t62*a&
         &bb83n91+t67*abb83n73+t72*abb83n73+t73*abb83n83+t75*abb83n83+spvak6k1(i&
         &v3)*t25*abb83n77+t1*t104*abb83n227+t1*t105*abb83n184+t1*t106*abb83n184&
         &+t1*t108*abb83n184+t1*t109*abb83n212+t1*t110*abb83n212+t1*t112*abb83n2&
         &12+t1*t52*abb83n151+t1*t55*abb83n151+t1*t62*abb83n151+t1*t67*abb83n227&
         &+t1*t72*abb83n227+t101*t116*abb83n104+t102*t116*abb83n104+t11*t132*abb&
         &83n99+t114*t3*abb83n184+t114*t4*abb83n212+t114*t5*abb83n151+t114*t6*ab&
         &b83n194+t114*t9*abb83n227+t115*t3*abb83n184+t115*t4*abb83n212+t115*t5*&
         &abb83n151+t115*t6*abb83n194+t115*t9*abb83n227+t116*t35*abb83n113+t116*&
         &t40*abb83n113+t116*t45*abb83n113+t116*t49*abb83n113+t116*t77*abb83n109&
         &+t116*t79*abb83n109+t116*t80*abb83n68+t116*t81*abb83n68+t116*t86*abb83&
         &n79+t116*t87*abb83n79+t117*t3*abb83n184+t117*t4*abb83n212+t117*t5*abb8&
         &3n151+t117*t6*abb83n194+t117*t9*abb83n227+t120*t3*abb83n233+t122*t24*a&
         &bb83n104+t123*t24*abb83n109+t124*t24*abb83n68+t125*t24*abb83n79+t13*t1&
         &32*abb83n97+t132*t14*abb83n175+t133*t22*abb83n175+t133*t27*abb83n99+t1&
         &33*t59*abb83n97+t137*t2*abb83n99+t137*t26*abb83n175+t137*t8*abb83n97+t&
         &3*t73*abb83n233+t3*t75*abb83n233+t1*t121*t137*abb83n194+t1*t132*t19*ab&
         &b83n194+t1*t133*t88*abb83n194+t113*t116*t17*abb83n77+t116*t23*t24*abb8&
         &3n77+t116*t7*t83*abb83n233+t116*t7*t85*abb83n233+t118*t17*t24*abb83n11&
         &3+t126*t24*t7*abb83n233+t17*t2*t24*abb83n113)+t100*abb83n71+t128*abb83&
         &n71+t129*abb83n71+t130*abb83n71+t131*abb83n71+t99*abb83n71+t1*t100*abb&
         &83n234+t1*t128*abb83n234+t1*t129*abb83n234+t1*t130*abb83n234+t1*t131*a&
         &bb83n234+t1*t99*abb83n234+t116*t30*abb83n70+t116*t32*abb83n93+t116*t34&
         &*abb83n76+t116*t37*abb83n70+t116*t38*abb83n93+t116*t39*abb83n76+t116*t&
         &42*abb83n110+t116*t43*abb83n93+t116*t44*abb83n78+t116*t46*abb83n110+t1&
         &16*t47*abb83n93+t116*t48*abb83n78+t116*t50*abb83n69+t116*t51*abb83n78+&
         &t116*t53*abb83n69+t116*t54*abb83n78+t116*t56*abb83n112+t116*t57*abb83n&
         &76+t116*t60*abb83n112+t116*t61*abb83n76+t116*t63*abb83n152+t116*t64*ab&
         &b83n228+t116*t65*abb83n185+t116*t66*abb83n213+t116*t68*abb83n152+t116*&
         &t69*abb83n228+t116*t70*abb83n185+t116*t71*abb83n213+t116*t76*abb83n86+&
         &t116*t78*abb83n86+t116*t82*abb83n118+t116*t84*abb83n118+t116*t89*abb83&
         &n87+t116*t90*abb83n87+t116*t91*abb83n69+t116*t92*abb83n69+t116*t93*abb&
         &83n89+t116*t94*abb83n89+t116*t95*abb83n70+t116*t96*abb83n70+t116*t97*a&
         &bb83n195+t116*t98*abb83n195+t10*t103*t24*abb83n70+t10*t107*t24*abb83n9&
         &3+t10*t111*t24*abb83n76+t10*t121*t24*abb83n87+t103*t11*t24*abb83n69+t1&
         &03*t12*t24*abb83n69+t103*t13*t24*abb83n70+t103*t14*t24*abb83n228+t103*&
         &t17*t22*abb83n228+t103*t17*t27*abb83n69+t103*t17*t36*abb83n70+t103*t17&
         &*t41*abb83n69+t103*t17*t59*abb83n70+t107*t11*t24*abb83n93+t107*t14*t24&
         &*abb83n185+t107*t16*t24*abb83n118+t107*t17*t22*abb83n185+t107*t17*t27*&
         &abb83n93+t107*t17*t28*abb83n86+t107*t17*t33*abb83n118+t107*t17*t36*abb&
         &83n93+t107*t20*t24*abb83n86+t11*t111*t24*abb83n78+t11*t24*t58*abb83n11&
         &0+t111*t12*t24*abb83n78+t111*t13*t24*abb83n76+t111*t14*t24*abb83n213+t&
         &111*t15*t24*abb83n118+t111*t17*t22*abb83n213+t111*t17*t27*abb83n78+t11&
         &1*t17*t31*abb83n118+t111*t17*t36*abb83n76+t111*t17*t41*abb83n78+t111*t&
         &17*t59*abb83n76+t118*t15*t24*abb83n93+t118*t16*t24*abb83n76+t118*t17*t&
         &29*abb83n70+t118*t17*t31*abb83n93+t118*t17*t33*abb83n76+t118*t17*t88*a&
         &bb83n87+t118*t19*t24*abb83n87+t118*t21*t24*abb83n70+t12*t121*t24*abb83&
         &n89+t121*t14*t24*abb83n195+t121*t17*t22*abb83n195+t121*t17*t36*abb83n8&
         &7+t121*t17*t41*abb83n89+t127*t16*t24*abb83n78+t127*t17*t29*abb83n69+t1&
         &27*t17*t33*abb83n78+t127*t17*t88*abb83n89+t127*t19*t24*abb83n89+t127*t&
         &21*t24*abb83n69+t13*t24*t58*abb83n112+t14*t24*t58*abb83n152+t15*t2*t24&
         &*abb83n93+t15*t24*t26*abb83n185+t15*t24*t58*abb83n86+t16*t2*t24*abb83n&
         &78+t16*t24*t26*abb83n213+t16*t24*t8*abb83n76+t17*t2*t28*abb83n110+t17*&
         &t2*t29*abb83n69+t17*t2*t31*abb83n93+t17*t2*t33*abb83n78+t17*t22*t58*ab&
         &b83n152+t17*t26*t28*abb83n152+t17*t26*t29*abb83n228+t17*t26*t31*abb83n&
         &185+t17*t26*t33*abb83n213+t17*t26*t88*abb83n195+t17*t27*t58*abb83n110+&
         &t17*t28*t8*abb83n112+t17*t29*t8*abb83n70+t17*t31*t58*abb83n86+t17*t33*&
         &t8*abb83n76+t17*t58*t59*abb83n112+t19*t24*t26*abb83n195+t2*t20*t24*abb&
         &83n110+t2*t21*t24*abb83n69+t20*t24*t26*abb83n152+t20*t24*t8*abb83n112+&
         &t21*t24*t26*abb83n228+t21*t24*t8*abb83n70)
         return
      end if
      t134 = d(iv3,iv4)
      t135 = d(iv2,iv4)
      t136 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak2k6(iv4)
      t4 = spvak3k1(iv4)
      t5 = spvak3k4(iv4)
      t6 = spvak5k1(iv4)
      t7 = spvak2k1(iv4)
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t132*t136*abb83n98+t133*t135*abb83n98+t134*t137*&
         &abb83n98)+(2.0_ki)*(t1*t100*abb83n67+t1*t128*abb83n67+t1*t129*abb83n67&
         &+t1*t130*abb83n67+t1*t131*abb83n67+t1*t99*abb83n67+t101*t134*abb83n88+&
         &t102*t134*abb83n88+t122*t135*abb83n88+t123*t135*abb83n111+t124*t135*ab&
         &b83n69+t125*t135*abb83n78+t126*t135*abb83n94+t134*t77*abb83n111+t134*t&
         &79*abb83n111+t134*t80*abb83n69+t134*t81*abb83n69+t134*t83*abb83n94+t13&
         &4*t85*abb83n94+t134*t86*abb83n78+t134*t87*abb83n78+t1*t103*t137*abb83n&
         &69+t1*t107*t137*abb83n94+t1*t111*t137*abb83n78+t1*t121*t137*abb83n88+t&
         &1*t132*t15*abb83n94+t1*t132*t16*abb83n78+t1*t132*t19*abb83n88+t1*t132*&
         &t20*abb83n111+t1*t132*t21*abb83n69+t1*t133*t28*abb83n111+t1*t133*t29*a&
         &bb83n69+t1*t133*t31*abb83n94+t1*t133*t33*abb83n78+t1*t133*t88*abb83n88&
         &+t1*t137*t58*abb83n111+t103*t136*t24*abb83n69+t107*t136*t24*abb83n94+t&
         &111*t136*t24*abb83n78+t116*t135*t15*abb83n94+t116*t135*t16*abb83n78+t1&
         &16*t135*t19*abb83n88+t116*t135*t20*abb83n111+t116*t135*t21*abb83n69+t1&
         &16*t136*t28*abb83n111+t116*t136*t29*abb83n69+t116*t136*t31*abb83n94+t1&
         &16*t136*t33*abb83n78+t116*t136*t88*abb83n88+t116*t137*t2*abb83n88+t116&
         &*t137*t3*abb83n111+t116*t137*t4*abb83n69+t116*t137*t5*abb83n94+t116*t1&
         &37*t6*abb83n78+t121*t136*t24*abb83n88+t132*t17*t2*abb83n88+t132*t17*t3&
         &*abb83n111+t132*t17*t4*abb83n69+t132*t17*t5*abb83n94+t132*t17*t6*abb83&
         &n78+t133*t2*t24*abb83n88+t133*t24*t3*abb83n111+t133*t24*t4*abb83n69+t1&
         &33*t24*t5*abb83n94+t133*t24*t6*abb83n78+t136*t24*t58*abb83n111+t107*t1&
         &7*t24*t7*abb83n67+t116*t15*t24*t7*abb83n67+t116*t17*t31*t7*abb83n67+t1&
         &16*t17*t5*t74*abb83n67+t116*t18*t24*t5*abb83n67+t119*t17*t24*t5*abb83n&
         &67))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d83:
   subroutine     reconstruct_d83(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group10
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group10), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_83:
      coeffs%coeffs_83%c0 = derivative(czip)
      coeffs%coeffs_83%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_83%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_83%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_83%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_83%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_83%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_83%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_83%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_83%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_83%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_83%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_83%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_83%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_83%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_83%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_83%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_83%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_83%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_83%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_83%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_83%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_83%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_83%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_83%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_83%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_83%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_83%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_83%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_83%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_83%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_83%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_83%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_83%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_83%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_83%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_83%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_83%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_83%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_83%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_83%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_83%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_83%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_83%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_83%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_83%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_83%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_83%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_83%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_83%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_83%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_83%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_83%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_83%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_83%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_83%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_83%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_83%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_83%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_83%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_83%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_83%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_83%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_83%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_83%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_83%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_83%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_83%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_83%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_83%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_83:
   end subroutine reconstruct_d83
!---#] subroutine reconstruct_d83:
end module p9_udbar_neepgg_d83h1l1d
