module     p9_udbar_neepgg_d86h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d86h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d86
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd86h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      real(ki) :: t123
      real(ki) :: t124
      real(ki) :: t125
      real(ki) :: t126
      real(ki) :: t127
      real(ki) :: t128
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t123 = dotproduct(k2, qshift)
      t124 = dotproduct(k6, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t125 = dotproduct(k5, qshift)
      t126 = dotproduct(k1, qshift)
      t2 = t1*t1
      t127 = dotproduct(qshift, qshift)
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t5 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t6 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t8 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t9 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t10 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-s&
      &pvak2k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb86n63+t1*abb86n104+t123*abb86n102+t124*abb86n103+t125*a&
         &bb86n110+t126*abb86n111+t126*t126*abb86n80+t127*abb86n84+t127*t127*abb&
         &86n79+t2*abb86n76+t3*abb86n92+t4*abb86n93+t1*t123*abb86n83+t1*t124*abb&
         &86n82+t1*t125*abb86n75+t1*t126*abb86n74+t1*t127*abb86n121+t1*t3*abb86n&
         &91+t1*t4*abb86n65+t1*t5*abb86n72+t1*t8*abb86n68+t123*t2*abb86n96+t123*&
         &t4*abb86n87+t124*t125*abb86n77+t124*t126*abb86n78+t124*t127*abb86n114+&
         &t124*t4*abb86n69+t125*t126*abb86n81+t125*t127*abb86n118+t125*t2*abb86n&
         &96+t125*t3*abb86n88+t125*t4*abb86n86+t126*t127*abb86n118+t126*t2*abb86&
         &n94+t126*t3*abb86n89+t126*t4*abb86n67+t127*t2*abb86n90+t127*t3*abb86n1&
         &05+t127*t4*abb86n142+t2*t3*abb86n108+t2*t4*abb86n134+t2*t5*abb86n100+t&
         &2*t6*abb86n129+t2*t7*abb86n132+t2*t8*abb86n137+t2*t9*abb86n148+t3*t4*a&
         &bb86n85+t1*t10*t3*abb86n131+t1*t123*t4*abb86n139+t1*t124*t4*abb86n141+&
         &t1*t124*t6*abb86n128+t1*t124*t9*abb86n144+t1*t125*t3*abb86n124+t1*t125&
         &*t4*abb86n137+t1*t126*t3*abb86n123+t1*t126*t4*abb86n136+t1*t126*t6*abb&
         &86n126+t1*t126*t9*abb86n146+t1*t127*t3*abb86n73+t1*t127*t4*abb86n70+t1&
         &*t127*t6*abb86n71+t1*t127*t9*abb86n66+t1*t3*t4*abb86n147+t1*t3*t7*abb8&
         &6n107+t2*t3*t7*abb86n64)
         return
      end if
      t11 = k1(iv1)
      t12 = k2(iv1)
      t13 = k5(iv1)
      t14 = k6(iv1)
      t15 = qshift(iv1)
      t16 = spvak3k4(iv1)
      t17 = spvak5k1(iv1)
      t18 = spvak5k6(iv1)
      t19 = t15*abb86n119
      t20 = spvak2k1(iv1)
      t21 = spvak2k4(iv1)
      t22 = spvak2k5(iv1)
      t23 = spvak3k1(iv1)
      t24 = spvak6k1(iv1)
      t25 = spvak2k6(iv1)
      t26 = t18*abb86n97
      if(deg.eq.1) then
         numerator = (t11*abb86n111+t12*abb86n102+t125*t19+t126*t19+t13*abb86n11&
         &0+t14*abb86n103+t15*abb86n112+t16*abb86n92+t17*abb86n93+t18*abb86n104+&
         &t1*t11*abb86n74+t1*t12*abb86n83+t1*t123*t26+t1*t125*t26+t1*t13*abb86n7&
         &5+t1*t14*abb86n82+t1*t15*abb86n122+t1*t16*abb86n91+t1*t17*abb86n65+t1*&
         &t18*abb86n120+t1*t22*abb86n72+t1*t24*abb86n68+t11*t124*abb86n78+t11*t1&
         &25*abb86n81+t11*t126*abb86n113+t11*t127*abb86n118+t11*t2*abb86n94+t11*&
         &t3*abb86n89+t11*t4*abb86n67+t12*t2*abb86n96+t12*t4*abb86n87+t123*t17*a&
         &bb86n87+t123*t18*abb86n83+t124*t13*abb86n77+t124*t15*abb86n115+t124*t1&
         &7*abb86n69+t124*t18*abb86n82+t125*t14*abb86n77+t125*t16*abb86n88+t125*&
         &t17*abb86n86+t125*t18*abb86n75+t126*t13*abb86n81+t126*t14*abb86n78+t12&
         &6*t16*abb86n89+t126*t17*abb86n67+t126*t18*abb86n74+t127*t13*abb86n118+&
         &t127*t14*abb86n114+t127*t15*abb86n116+t127*t16*abb86n105+t127*t17*abb8&
         &6n142+t127*t18*abb86n121+t13*t2*abb86n96+t13*t3*abb86n88+t13*t4*abb86n&
         &86+t14*t4*abb86n69+t15*t2*abb86n99+t15*t3*abb86n106+t15*t4*abb86n143+t&
         &16*t2*abb86n108+t16*t4*abb86n85+t17*t2*abb86n134+t17*t3*abb86n85+t18*t&
         &3*abb86n91+t18*t4*abb86n65+t18*t5*abb86n72+t18*t8*abb86n68+t2*t20*abb8&
         &6n132+t2*t21*abb86n129+t2*t22*abb86n100+t2*t23*abb86n148+t2*t24*abb86n&
         &137+t1*t10*t16*abb86n131+t1*t11*t3*abb86n123+t1*t11*t4*abb86n136+t1*t1&
         &1*t6*abb86n126+t1*t11*t9*abb86n146+t1*t12*t4*abb86n139+t1*t123*t17*abb&
         &86n139+t1*t124*t17*abb86n141+t1*t124*t21*abb86n128+t1*t124*t23*abb86n1&
         &44+t1*t125*t16*abb86n124+t1*t125*t17*abb86n137+t1*t126*t16*abb86n123+t&
         &1*t126*t17*abb86n136+t1*t126*t18*abb86n95+t1*t126*t21*abb86n126+t1*t12&
         &6*t23*abb86n146+t1*t127*t16*abb86n73+t1*t127*t17*abb86n70+t1*t127*t18*&
         &abb86n99+t1*t127*t21*abb86n71+t1*t127*t23*abb86n66+t1*t13*t3*abb86n124&
         &+t1*t13*t4*abb86n137+t1*t14*t4*abb86n141+t1*t14*t6*abb86n128+t1*t14*t9&
         &*abb86n144+t1*t15*t3*abb86n125+t1*t15*t4*abb86n140+t1*t15*t6*abb86n127&
         &+t1*t15*t9*abb86n145+t1*t16*t4*abb86n147+t1*t16*t7*abb86n107+t1*t17*t3&
         &*abb86n147+t1*t18*t3*abb86n109+t1*t18*t4*abb86n135+t1*t18*t5*abb86n101&
         &+t1*t18*t6*abb86n130+t1*t18*t7*abb86n133+t1*t18*t8*abb86n138+t1*t18*t9&
         &*abb86n149+t1*t20*t3*abb86n107+t1*t25*t3*abb86n131+t10*t18*t3*abb86n13&
         &1+t123*t18*t4*abb86n139+t124*t18*t4*abb86n141+t124*t18*t6*abb86n128+t1&
         &24*t18*t9*abb86n144+t125*t18*t3*abb86n124+t125*t18*t4*abb86n137+t126*t&
         &18*t3*abb86n123+t126*t18*t4*abb86n136+t126*t18*t6*abb86n126+t126*t18*t&
         &9*abb86n146+t127*t18*t3*abb86n73+t127*t18*t4*abb86n70+t127*t18*t6*abb8&
         &6n71+t127*t18*t9*abb86n66+t16*t2*t7*abb86n64+t18*t3*t4*abb86n147+t18*t&
         &3*t7*abb86n107+t2*t20*t3*abb86n64+t1*t18*t3*t7*abb86n150)
         return
      end if
      t128 = d(iv1,iv2)
      t19 = k1(iv2)
      t26 = qshift(iv2)
      t27 = spvak5k6(iv2)
      t28 = t18*t27
      t29 = t128*abb86n118
      t30 = t28*abb86n96
      t31 = k5(iv2)
      t32 = k6(iv2)
      t33 = spvak3k4(iv2)
      t34 = t11*t33
      t35 = spvak5k1(iv2)
      t36 = t11*t35
      t37 = t11*t27
      t38 = t16*t19
      t39 = t17*t19
      t40 = t18*t19
      t41 = t12*t35
      t42 = t12*t27
      t43 = k2(iv2)
      t44 = t17*t43
      t45 = t18*t43
      t46 = t13*t33
      t47 = t13*t35
      t48 = t13*t27
      t49 = t16*t31
      t50 = t17*t31
      t51 = t18*t31
      t52 = t14*t35
      t53 = t14*t27
      t54 = t17*t32
      t55 = t18*t32
      t56 = t15*t33
      t57 = t15*t35
      t58 = t15*t27
      t59 = t16*t26
      t60 = t17*t26
      t61 = t18*t26
      t22 = t22*t27
      t62 = spvak2k5(iv2)*t18
      t63 = t16*t35
      t64 = t16*t27
      t65 = t17*t33
      t66 = t18*t33
      t67 = t17*t27
      t68 = t18*t35
      t69 = spvak6k1(iv2)
      t70 = t18*t69
      t71 = t24*t27
      t72 = spvak2k4(iv2)
      t73 = t11*t72
      t74 = spvak3k1(iv2)
      t75 = t11*t74
      t76 = t19*t21
      t77 = t19*t23
      t78 = t14*t72
      t79 = t14*t74
      t80 = t21*t32
      t81 = t23*t32
      t82 = t15*t72
      t83 = t15*t74
      t84 = t21*t26
      t85 = t23*t26
      t86 = t20*t33
      t87 = t20*t27
      t88 = spvak2k1(iv2)
      t89 = t16*t88
      t90 = t18*t88
      t91 = t21*t27
      t92 = t18*t72
      t93 = t25*t33
      t94 = spvak2k6(iv2)
      t95 = t16*t94
      t96 = t23*t27
      t97 = t18*t74
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t123*t30+t125*t29+t125*t30+t126*t29+t128*abb86n8&
         &4+t28*abb86n76+t1*t128*abb86n121+t11*t19*abb86n80+t124*t128*abb86n114+&
         &t126*t28*abb86n94+t127*t128*abb86n117+t127*t28*abb86n90+t128*t2*abb86n&
         &90+t128*t3*abb86n105+t128*t4*abb86n142+t15*t26*abb86n116+t28*t3*abb86n&
         &108+t28*t4*abb86n134+t28*t5*abb86n100+t28*t6*abb86n129+t28*t7*abb86n13&
         &2+t28*t8*abb86n137+t28*t9*abb86n148+t1*t128*t3*abb86n73+t1*t128*t4*abb&
         &86n70+t1*t128*t6*abb86n71+t1*t128*t9*abb86n66+t28*t3*t7*abb86n64)+t22*&
         &abb86n72+t34*abb86n89+t36*abb86n67+t37*abb86n74+t38*abb86n89+t39*abb86&
         &n67+t40*abb86n74+t41*abb86n87+t42*abb86n83+t44*abb86n87+t45*abb86n83+t&
         &46*abb86n88+t47*abb86n86+t48*abb86n75+t49*abb86n88+t50*abb86n86+t51*ab&
         &b86n75+t52*abb86n69+t53*abb86n82+t54*abb86n69+t55*abb86n82+t56*abb86n1&
         &06+t57*abb86n143+t58*abb86n122+t59*abb86n106+t60*abb86n143+t61*abb86n1&
         &22+t62*abb86n72+t63*abb86n85+t64*abb86n91+t65*abb86n85+t66*abb86n91+t6&
         &7*abb86n65+t68*abb86n65+t70*abb86n68+t71*abb86n68+t1*t22*abb86n101+t1*&
         &t34*abb86n123+t1*t36*abb86n136+t1*t37*abb86n95+t1*t38*abb86n123+t1*t39&
         &*abb86n136+t1*t40*abb86n95+t1*t41*abb86n139+t1*t42*abb86n97+t1*t44*abb&
         &86n139+t1*t45*abb86n97+t1*t46*abb86n124+t1*t47*abb86n137+t1*t48*abb86n&
         &97+t1*t49*abb86n124+t1*t50*abb86n137+t1*t51*abb86n97+t1*t52*abb86n141+&
         &t1*t54*abb86n141+t1*t56*abb86n125+t1*t57*abb86n140+t1*t58*abb86n98+t1*&
         &t59*abb86n125+t1*t60*abb86n140+t1*t61*abb86n98+t1*t62*abb86n101+t1*t63&
         &*abb86n147+t1*t64*abb86n109+t1*t65*abb86n147+t1*t66*abb86n109+t1*t67*a&
         &bb86n135+t1*t68*abb86n135+t1*t70*abb86n138+t1*t71*abb86n138+t1*t73*abb&
         &86n126+t1*t75*abb86n146+t1*t76*abb86n126+t1*t77*abb86n146+t1*t78*abb86&
         &n128+t1*t79*abb86n144+t1*t80*abb86n128+t1*t81*abb86n144+t1*t82*abb86n1&
         &27+t1*t83*abb86n145+t1*t84*abb86n127+t1*t85*abb86n145+t1*t86*abb86n107&
         &+t1*t87*abb86n133+t1*t89*abb86n107+t1*t90*abb86n133+t1*t91*abb86n130+t&
         &1*t92*abb86n130+t1*t93*abb86n131+t1*t95*abb86n131+t1*t96*abb86n149+t1*&
         &t97*abb86n149+t10*t64*abb86n131+t10*t66*abb86n131+t11*t26*abb86n119+t1&
         &1*t31*abb86n81+t11*t32*abb86n78+t123*t67*abb86n139+t123*t68*abb86n139+&
         &t124*t67*abb86n141+t124*t68*abb86n141+t124*t91*abb86n128+t124*t92*abb8&
         &6n128+t124*t96*abb86n144+t124*t97*abb86n144+t125*t64*abb86n124+t125*t6&
         &6*abb86n124+t125*t67*abb86n137+t125*t68*abb86n137+t126*t64*abb86n123+t&
         &126*t66*abb86n123+t126*t67*abb86n136+t126*t68*abb86n136+t126*t91*abb86&
         &n126+t126*t92*abb86n126+t126*t96*abb86n146+t126*t97*abb86n146+t127*t64&
         &*abb86n73+t127*t66*abb86n73+t127*t67*abb86n70+t127*t68*abb86n70+t127*t&
         &91*abb86n71+t127*t92*abb86n71+t127*t96*abb86n66+t127*t97*abb86n66+t13*&
         &t19*abb86n81+t13*t26*abb86n119+t13*t32*abb86n77+t14*t19*abb86n78+t14*t&
         &26*abb86n115+t14*t31*abb86n77+t15*t19*abb86n119+t15*t31*abb86n119+t15*&
         &t32*abb86n115+t2*t86*abb86n64+t2*t89*abb86n64+t3*t37*abb86n123+t3*t40*&
         &abb86n123+t3*t48*abb86n124+t3*t51*abb86n124+t3*t58*abb86n125+t3*t61*ab&
         &b86n125+t3*t67*abb86n147+t3*t68*abb86n147+t3*t87*abb86n107+t3*t90*abb8&
         &6n107+t37*t4*abb86n136+t37*t6*abb86n126+t37*t9*abb86n146+t4*t40*abb86n&
         &136+t4*t42*abb86n139+t4*t45*abb86n139+t4*t48*abb86n137+t4*t51*abb86n13&
         &7+t4*t53*abb86n141+t4*t55*abb86n141+t4*t58*abb86n140+t4*t61*abb86n140+&
         &t4*t64*abb86n147+t4*t66*abb86n147+t40*t6*abb86n126+t40*t9*abb86n146+t5&
         &3*t6*abb86n128+t53*t9*abb86n144+t55*t6*abb86n128+t55*t9*abb86n144+t58*&
         &t6*abb86n127+t58*t9*abb86n145+t6*t61*abb86n127+t61*t9*abb86n145+t64*t7&
         &*abb86n107+t66*t7*abb86n107+t1*t3*t87*abb86n150+t1*t3*t90*abb86n150+t1&
         &*t64*t7*abb86n150+t1*t66*t7*abb86n150+t18*t3*t94*abb86n131+t25*t27*t3*&
         &abb86n131)
         return
      end if
      t123 = d(iv2,iv3)
      t124 = d(iv1,iv3)
      t2 = k1(iv3)
      t5 = k5(iv3)
      t8 = k6(iv3)
      t10 = qshift(iv3)
      t29 = t123*t16
      t30 = t124*t33
      t53 = spvak3k4(iv3)
      t55 = t128*t53
      t70 = t123*t17
      t71 = t124*t35
      t98 = spvak5k1(iv3)
      t99 = t128*t98
      t100 = t123*t18
      t101 = t124*t27
      t102 = spvak5k6(iv3)
      t103 = t102*t128
      t104 = k2(iv3)
      t87 = t102*t87
      t90 = t102*t90
      t105 = spvak2k1(iv3)
      t106 = t105*t18*t27
      t107 = spvak2k4(iv3)
      t108 = t107*t18
      t109 = spvak3k1(iv3)
      t110 = t109*t18
      t111 = t102*t64
      t112 = t102*t66
      t113 = t18*t53
      t114 = t113*t27
      t115 = t18*t98
      t116 = t102*t18
      t117 = t102*t27
      t86 = t102*t86
      t118 = t20*t27*t53
      t89 = t102*t89
      t119 = t18*t53*t88
      t120 = t105*t16*t27
      t121 = t105*t18*t33
      t122 = spvak2k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t100*abb86n121+t101*abb86n121+t103*abb86n121+t10&
         &6*abb86n132+t111*abb86n108+t112*abb86n108+t114*abb86n108+t29*abb86n105&
         &+t30*abb86n105+t55*abb86n105+t70*abb86n142+t71*abb86n142+t87*abb86n132&
         &+t90*abb86n132+t99*abb86n142+spvak6k1(iv3)*t28*abb86n137+t1*t100*abb86&
         &n99+t1*t101*abb86n99+t1*t103*abb86n99+t1*t29*abb86n73+t1*t30*abb86n73+&
         &t1*t55*abb86n73+t1*t70*abb86n70+t1*t71*abb86n70+t1*t99*abb86n70+t10*t1&
         &28*abb86n116+t100*t3*abb86n73+t100*t4*abb86n70+t100*t6*abb86n71+t100*t&
         &9*abb86n66+t101*t3*abb86n73+t101*t4*abb86n70+t101*t6*abb86n71+t101*t9*&
         &abb86n66+t102*t22*abb86n100+t102*t37*abb86n94+t102*t40*abb86n94+t102*t&
         &42*abb86n96+t102*t45*abb86n96+t102*t48*abb86n96+t102*t51*abb86n96+t102&
         &*t58*abb86n99+t102*t61*abb86n99+t102*t62*abb86n100+t102*t67*abb86n134+&
         &t102*t68*abb86n134+t102*t91*abb86n129+t102*t92*abb86n129+t102*t96*abb8&
         &6n148+t102*t97*abb86n148+t103*t3*abb86n73+t103*t4*abb86n70+t103*t6*abb&
         &86n71+t103*t9*abb86n66+t106*t3*abb86n64+t108*t27*abb86n129+t11*t123*ab&
         &b86n118+t110*t27*abb86n148+t111*t7*abb86n64+t112*t7*abb86n64+t114*t7*a&
         &bb86n64+t115*t27*abb86n134+t116*t69*abb86n137+t117*t24*abb86n137+t123*&
         &t13*abb86n118+t123*t14*abb86n114+t123*t15*abb86n116+t124*t19*abb86n118&
         &+t124*t26*abb86n116+t124*t31*abb86n118+t124*t32*abb86n114+t128*t2*abb8&
         &6n118+t128*t5*abb86n118+t128*t8*abb86n114+t3*t87*abb86n64+t3*t90*abb86&
         &n64+spvak2k5(iv3)*t18*t27*abb86n100+t1*t107*t128*abb86n71+t1*t109*t128&
         &*abb86n66+t1*t123*t21*abb86n71+t1*t123*t23*abb86n66+t1*t124*t72*abb86n&
         &71+t1*t124*t74*abb86n66+t10*t18*t27*abb86n99+t104*t18*t27*abb86n96+t18&
         &*t2*t27*abb86n94+t18*t27*t5*abb86n96)+t118*abb86n107+t119*abb86n107+t1&
         &20*abb86n107+t121*abb86n107+t86*abb86n107+t89*abb86n107+t1*t118*abb86n&
         &150+t1*t119*abb86n150+t1*t120*abb86n150+t1*t121*abb86n150+t1*t86*abb86&
         &n150+t1*t89*abb86n150+t102*t34*abb86n123+t102*t36*abb86n136+t102*t38*a&
         &bb86n123+t102*t39*abb86n136+t102*t41*abb86n139+t102*t44*abb86n139+t102&
         &*t46*abb86n124+t102*t47*abb86n137+t102*t49*abb86n124+t102*t50*abb86n13&
         &7+t102*t52*abb86n141+t102*t54*abb86n141+t102*t56*abb86n125+t102*t57*ab&
         &b86n140+t102*t59*abb86n125+t102*t60*abb86n140+t102*t63*abb86n147+t102*&
         &t65*abb86n147+t102*t73*abb86n126+t102*t75*abb86n146+t102*t76*abb86n126&
         &+t102*t77*abb86n146+t102*t78*abb86n128+t102*t79*abb86n144+t102*t80*abb&
         &86n128+t102*t81*abb86n144+t102*t82*abb86n127+t102*t83*abb86n145+t102*t&
         &84*abb86n127+t102*t85*abb86n145+t102*t93*abb86n131+t102*t95*abb86n131+&
         &t10*t16*t27*abb86n125+t10*t17*t27*abb86n140+t10*t18*t33*abb86n125+t10*&
         &t18*t35*abb86n140+t10*t18*t72*abb86n127+t10*t18*t74*abb86n145+t10*t21*&
         &t27*abb86n127+t10*t23*t27*abb86n145+t104*t17*t27*abb86n139+t104*t18*t3&
         &5*abb86n139+t107*t11*t27*abb86n126+t107*t14*t27*abb86n128+t107*t15*t27&
         &*abb86n127+t107*t18*t19*abb86n126+t107*t18*t26*abb86n127+t107*t18*t32*&
         &abb86n128+t109*t11*t27*abb86n146+t109*t14*t27*abb86n144+t109*t15*t27*a&
         &bb86n145+t109*t18*t19*abb86n146+t109*t18*t26*abb86n145+t109*t18*t32*ab&
         &b86n144+t11*t27*t53*abb86n123+t11*t27*t98*abb86n136+t12*t27*t98*abb86n&
         &139+t122*t16*t27*abb86n131+t122*t18*t33*abb86n131+t13*t27*t53*abb86n12&
         &4+t13*t27*t98*abb86n137+t14*t27*t98*abb86n141+t15*t27*t53*abb86n125+t1&
         &5*t27*t98*abb86n140+t16*t2*t27*abb86n123+t16*t27*t5*abb86n124+t16*t27*&
         &t98*abb86n147+t17*t2*t27*abb86n136+t17*t27*t5*abb86n137+t17*t27*t53*ab&
         &b86n147+t17*t27*t8*abb86n141+t18*t19*t53*abb86n123+t18*t19*t98*abb86n1&
         &36+t18*t2*t33*abb86n123+t18*t2*t35*abb86n136+t18*t2*t72*abb86n126+t18*&
         &t2*t74*abb86n146+t18*t26*t53*abb86n125+t18*t26*t98*abb86n140+t18*t31*t&
         &53*abb86n124+t18*t31*t98*abb86n137+t18*t32*t98*abb86n141+t18*t33*t5*ab&
         &b86n124+t18*t33*t98*abb86n147+t18*t35*t5*abb86n137+t18*t35*t53*abb86n1&
         &47+t18*t35*t8*abb86n141+t18*t43*t98*abb86n139+t18*t53*t94*abb86n131+t1&
         &8*t72*t8*abb86n128+t18*t74*t8*abb86n144+t2*t21*t27*abb86n126+t2*t23*t2&
         &7*abb86n146+t21*t27*t8*abb86n128+t23*t27*t8*abb86n144+t25*t27*t53*abb8&
         &6n131)
         return
      end if
      t125 = d(iv3,iv4)
      t126 = d(iv2,iv4)
      t127 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak3k1(iv4)
      t4 = spvak3k4(iv4)
      t5 = spvak5k1(iv4)
      t6 = spvak2k1(iv4)
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t123*t127*abb86n79+t124*t126*abb86n79+t125*t128*&
         &abb86n79)+(4.0_ki)*(t116*t126*abb86n90+t117*t127*abb86n90+t125*t28*abb&
         &86n90+t1*t102*t128*abb86n90+t1*t123*t18*abb86n90+t1*t124*t27*abb86n90)&
         &+(2.0_ki)*(t1*t118*abb86n64+t1*t119*abb86n64+t1*t120*abb86n64+t1*t121*&
         &abb86n64+t1*t86*abb86n64+t1*t89*abb86n64+t108*t126*abb86n71+t110*t126*&
         &abb86n66+t113*t126*abb86n73+t115*t126*abb86n70+t125*t64*abb86n73+t125*&
         &t66*abb86n73+t125*t67*abb86n70+t125*t68*abb86n70+t125*t91*abb86n71+t12&
         &5*t92*abb86n71+t125*t96*abb86n66+t125*t97*abb86n66+t1*t107*t128*abb86n&
         &71+t1*t109*t128*abb86n66+t1*t123*t16*abb86n73+t1*t123*t17*abb86n70+t1*&
         &t123*t21*abb86n71+t1*t123*t23*abb86n66+t1*t124*t33*abb86n73+t1*t124*t3&
         &5*abb86n70+t1*t124*t72*abb86n71+t1*t124*t74*abb86n66+t1*t128*t53*abb86&
         &n73+t1*t128*t98*abb86n70+t102*t126*t16*abb86n73+t102*t126*t17*abb86n70&
         &+t102*t126*t21*abb86n71+t102*t126*t23*abb86n66+t102*t127*t33*abb86n73+&
         &t102*t127*t35*abb86n70+t102*t127*t72*abb86n71+t102*t127*t74*abb86n66+t&
         &102*t128*t2*abb86n71+t102*t128*t3*abb86n66+t102*t128*t4*abb86n73+t102*&
         &t128*t5*abb86n70+t107*t127*t27*abb86n71+t109*t127*t27*abb86n66+t123*t1&
         &8*t2*abb86n71+t123*t18*t3*abb86n66+t123*t18*t4*abb86n73+t123*t18*t5*ab&
         &b86n70+t124*t2*t27*abb86n71+t124*t27*t3*abb86n66+t124*t27*t4*abb86n73+&
         &t124*t27*t5*abb86n70+t127*t27*t53*abb86n73+t127*t27*t98*abb86n70+t102*&
         &t16*t27*t6*abb86n64+t102*t18*t33*t6*abb86n64+t102*t18*t4*t88*abb86n64+&
         &t102*t20*t27*t4*abb86n64+t105*t18*t27*t4*abb86n64+t18*t27*t53*t6*abb86&
         &n64))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d86:
   subroutine     reconstruct_d86(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_86:
      coeffs%coeffs_86%c0 = derivative(czip)
      coeffs%coeffs_86%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_86%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_86%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_86%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_86%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_86%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_86%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_86%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_86%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_86%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_86%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_86%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_86%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_86%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_86%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_86%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_86%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_86%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_86%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_86%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_86%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_86%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_86%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_86%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_86%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_86%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_86%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_86%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_86%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_86%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_86%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_86%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_86%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_86%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_86%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_86%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_86%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_86%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_86%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_86%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_86%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_86%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_86%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_86%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_86%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_86%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_86%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_86%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_86%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_86%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_86%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_86%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_86%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_86%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_86%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_86%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_86%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_86%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_86%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_86%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_86%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_86%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_86%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_86%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_86%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_86%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_86%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_86%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_86%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_86:
   end subroutine reconstruct_d86
!---#] subroutine reconstruct_d86:
end module p9_udbar_neepgg_d86h1l1d
