module     p9_udbar_neepgg_d89h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d89h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d89
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd89h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      real(ki) :: t41
      real(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      real(ki) :: t46
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t1 = 0.0_ki
      if(deg.eq.0) then
         numerator = t1
         return
      end if
      if(deg.eq.1) then
         numerator = t1
         return
      end if
      t1 = spvak5k6(iv2)
      t2 = k2(iv1)*t1
      t3 = spvak5k6(iv1)
      t4 = k2(iv2)*t3
      t5 = k5(iv1)
      t6 = k5(iv2)
      t7 = k6(iv1)
      t8 = k6(iv2)
      t9 = spvak2k1(iv1)
      t10 = t1*t9
      t11 = spvak2k1(iv2)
      t12 = t11*t3
      t13 = spvak2k6(iv1)
      t14 = t1*t13
      t15 = spvak2k6(iv2)
      t16 = t15*t3
      t17 = spvak3k1(iv1)
      t18 = t1*t17
      t19 = spvak3k1(iv2)
      t20 = t19*t3
      t21 = spvak3k4(iv1)
      t22 = spvak3k4(iv2)
      t23 = t1*t3
      if(deg.eq.2) then
         numerator = (t10*abb89n33+t12*abb89n33+t14*abb89n44+t16*abb89n44+t18*ab&
         &b89n45+t2*abb89n36+t20*abb89n45+(2.0_ki)*t23*abb89n25+t4*abb89n36+t1*t&
         &21*abb89n46+t1*t5*abb89n47+t1*t7*abb89n47+t22*t3*abb89n46+t3*t6*abb89n&
         &47+t3*t8*abb89n47)
         return
      end if
      t41 = d(iv2,iv3)
      t42 = d(iv1,iv3)
      t24 = spvak5k6(iv3)
      t43 = d(iv1,iv2)
      t25 = spvak2k1(iv3)
      t26 = spvak2k6(iv3)
      t27 = t26*t3
      t28 = spvak3k1(iv3)
      t29 = t28*t3
      t30 = spvak5k1(iv1)
      t31 = t1*t30
      t32 = spvak5k1(iv2)
      t33 = t3*t32
      t34 = spvak5k1(iv3)
      t35 = t3*t34
      t36 = t24*t3
      t37 = t1*t24
      t38 = k5(iv3)
      t39 = k6(iv3)
      t40 = spvak3k4(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak6k1(iv1)*t37*abb89n31+spvak6k1(iv2)*t36*abb&
         &89n31+spvak6k1(iv3)*t23*abb89n31+t1*t27*abb89n38+t1*t29*abb89n27+t1*t3&
         &5*abb89n32+t1*t42*abb89n37+t10*t24*abb89n34+t12*t24*abb89n34+t14*t24*a&
         &bb89n38+t16*t24*abb89n38+t18*t24*abb89n27+t2*t24*abb89n42+t20*t24*abb8&
         &9n27+t24*t31*abb89n32+t24*t33*abb89n32+t24*t4*abb89n42+t24*t43*abb89n3&
         &7+t3*t41*abb89n37+k2(iv3)*t1*t3*abb89n42+spvak2k4(iv1)*t1*t24*abb89n43&
         &+spvak2k4(iv2)*t24*t3*abb89n43+spvak2k4(iv3)*t1*t3*abb89n43+spvak2k5(i&
         &v1)*t1*t24*abb89n39+spvak2k5(iv2)*t24*t3*abb89n39+spvak2k5(iv3)*t1*t3*&
         &abb89n39+t1*t25*t3*abb89n34)+t1*t13*t38*abb89n40+t1*t13*t39*abb89n40+t&
         &1*t13*t40*abb89n35+t1*t17*t38*abb89n29+t1*t17*t39*abb89n29+t1*t21*t26*&
         &abb89n35+t1*t26*t5*abb89n40+t1*t26*t7*abb89n40+t1*t28*t5*abb89n29+t1*t&
         &28*t7*abb89n29+t1*t30*t38*abb89n30+t1*t30*t39*abb89n30+t1*t34*t5*abb89&
         &n30+t1*t34*t7*abb89n30+t13*t22*t24*abb89n35+t13*t24*t6*abb89n40+t13*t2&
         &4*t8*abb89n40+t15*t21*t24*abb89n35+t15*t24*t5*abb89n40+t15*t24*t7*abb8&
         &9n40+t15*t3*t38*abb89n40+t15*t3*t39*abb89n40+t15*t3*t40*abb89n35+t17*t&
         &24*t6*abb89n29+t17*t24*t8*abb89n29+t19*t24*t5*abb89n29+t19*t24*t7*abb8&
         &9n29+t19*t3*t38*abb89n29+t19*t3*t39*abb89n29+t22*t26*t3*abb89n35+t24*t&
         &30*t6*abb89n30+t24*t30*t8*abb89n30+t24*t32*t5*abb89n30+t24*t32*t7*abb8&
         &9n30+t26*t3*t6*abb89n40+t26*t3*t8*abb89n40+t28*t3*t6*abb89n29+t28*t3*t&
         &8*abb89n29+t3*t32*t38*abb89n30+t3*t32*t39*abb89n30+t3*t34*t6*abb89n30+&
         &t3*t34*t8*abb89n30)
         return
      end if
      t44 = d(iv3,iv4)
      t45 = d(iv2,iv4)
      t2 = spvak5k6(iv4)
      t46 = d(iv1,iv4)
      t4 = spvak2k6(iv4)
      t5 = spvak3k1(iv4)
      t6 = spvak5k1(iv4)
      t7 = spvak3k4(iv4)
      t8 = spvak2k1(iv4)
      if(deg.eq.4) then
         numerator = ((4.0_ki)*(t23*t44*abb89n41+t36*t45*abb89n41+t37*t46*abb89n&
         &41+t1*t2*t42*abb89n41+t2*t24*t43*abb89n41+t2*t3*t41*abb89n41)+(2.0_ki)&
         &*(t14*t44*abb89n39+t16*t44*abb89n39+t18*t44*abb89n28+t20*t44*abb89n28+&
         &t27*t45*abb89n39+t29*t45*abb89n28+t31*t44*abb89n31+t33*t44*abb89n31+t3&
         &5*t45*abb89n31+t1*t26*t46*abb89n39+t1*t28*t46*abb89n28+t1*t34*t46*abb8&
         &9n31+t1*t4*t42*abb89n39+t1*t42*t5*abb89n28+t1*t42*t6*abb89n31+t13*t2*t&
         &41*abb89n39+t13*t24*t45*abb89n39+t15*t2*t42*abb89n39+t15*t24*t46*abb89&
         &n39+t17*t2*t41*abb89n28+t17*t24*t45*abb89n28+t19*t2*t42*abb89n28+t19*t&
         &24*t46*abb89n28+t2*t26*t43*abb89n39+t2*t28*t43*abb89n28+t2*t30*t41*abb&
         &89n31+t2*t32*t42*abb89n31+t2*t34*t43*abb89n31+t24*t30*t45*abb89n31+t24&
         &*t32*t46*abb89n31+t24*t4*t43*abb89n39+t24*t43*t5*abb89n28+t24*t43*t6*a&
         &bb89n31+t3*t4*t41*abb89n39+t3*t41*t5*abb89n28+t3*t41*t6*abb89n31+t1*t2&
         &*t21*t25*abb89n26+t1*t2*t40*t9*abb89n26+t1*t21*t24*t8*abb89n26+t1*t24*&
         &t7*t9*abb89n26+t1*t25*t3*t7*abb89n26+t1*t3*t40*t8*abb89n26+t11*t2*t21*&
         &t24*abb89n26+t11*t2*t3*t40*abb89n26+t11*t24*t3*t7*abb89n26+t2*t22*t24*&
         &t9*abb89n26+t2*t22*t25*t3*abb89n26+t22*t24*t3*t8*abb89n26))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d89:
   subroutine     reconstruct_d89(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_89:
      coeffs%coeffs_89%c0 = derivative(czip)
      coeffs%coeffs_89%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_89%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_89%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_89%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_89%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_89%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_89%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_89%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_89%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_89%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_89%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_89%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_89%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_89%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_89%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_89%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_89%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_89%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_89%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_89%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_89%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_89%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_89%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_89%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_89%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_89%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_89%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_89%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_89%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_89%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_89%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_89%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_89%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_89%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_89%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_89%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_89%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_89%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_89%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_89%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_89%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_89%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_89%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_89%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_89%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_89%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_89%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_89%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_89%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_89%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_89%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_89%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_89%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_89%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_89%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_89%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_89%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_89%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_89%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_89%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_89%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_89%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_89%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_89%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_89%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_89%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_89:
   end subroutine reconstruct_d89
!---#] subroutine reconstruct_d89:
end module p9_udbar_neepgg_d89h1l1d
