module     p9_udbar_neepgg_d90h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d90h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d90
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd90h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      real(ki) :: t74
      real(ki) :: t75
      real(ki) :: t76
      real(ki) :: t77
      real(ki) :: t78
      real(ki) :: t79
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      if(deg.eq.0) then
         numerator = abb90n62
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k1(iv1)
      t7 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb90n104+t2*abb90n119+t3*abb90n106+t4*abb90n118+t5*abb&
         &90n121+t6*abb90n81+t7*abb90n110)
         return
      end if
      t74 = d(iv1,iv2)
      t8 = spvak5k6(iv2)
      t9 = t7*t8
      t10 = k2(iv2)
      t11 = spvak3k1(iv2)
      t12 = t1*t11
      t13 = spvak3k4(iv2)
      t14 = t1*t13
      t15 = k1(iv2)
      t16 = spvak3k1(iv1)
      t17 = t15*t16
      t18 = t15*t5
      t19 = k5(iv2)
      t20 = t13*t2
      t21 = spvak5k1(iv2)
      t22 = t2*t21
      t23 = t2*t8
      t24 = t10*t5
      t25 = t10*t6
      t26 = t10*t7
      t27 = t11*t3
      t28 = t13*t3
      t29 = t3*t8
      t30 = t16*t19
      t31 = t19*t5
      t32 = t19*t7
      t33 = t21*t4
      t34 = k6(iv2)
      t35 = t34*t6
      t36 = spvak2k1(iv1)
      t37 = t36*t8
      t38 = spvak2k1(iv2)
      t39 = t38*t7
      t40 = spvak2k6(iv1)
      t41 = t40*t8
      t42 = spvak2k6(iv2)
      t43 = t42*t7
      t44 = t16*t8
      t45 = t11*t7
      t46 = t21*t5
      t47 = t5*t8
      t48 = t13*t6
      t49 = t13*t7
      t50 = t6*t8
      t51 = t21*t7
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t74*abb90n105+t9*abb90n91)+t12*abb90n77+t14*abb9&
         &0n103+t17*abb90n77+t18*abb90n103+t20*abb90n111+t22*abb90n74+t23*abb90n&
         &101+t24*abb90n111+t25*abb90n74+t26*abb90n101+t27*abb90n79+t28*abb90n10&
         &3+t29*abb90n100+t30*abb90n79+t31*abb90n103+t32*abb90n100+t33*abb90n72+&
         &t35*abb90n72+t37*abb90n88+t39*abb90n88+t41*abb90n108+t43*abb90n108+t44&
         &*abb90n80+t45*abb90n80+t46*abb90n76+t47*abb90n120+t48*abb90n76+t49*abb&
         &90n120+t50*abb90n71+t51*abb90n71+t1*t10*abb90n92+t1*t8*abb90n98+t10*t3&
         &*abb90n96+t15*t2*abb90n92+t15*t7*abb90n98+t19*t2*abb90n96+t34*t7*abb90&
         &n99+t4*t8*abb90n99)
         return
      end if
      t75 = d(iv2,iv3)
      t76 = d(iv1,iv3)
      t52 = k1(iv3)
      t53 = k2(iv3)
      t54 = k5(iv3)
      t55 = spvak3k1(iv3)
      t56 = spvak3k4(iv3)
      t57 = spvak5k1(iv3)
      t58 = spvak5k6(iv3)
      t59 = spvak2k1(iv3)
      t60 = spvak2k6(iv3)
      t61 = t60*t7
      t62 = t55*t7
      t63 = t56*t7
      t64 = t57*t7
      t65 = t58*t7
      t66 = t58*t8
      t67 = k6(iv3)
      t68 = t13*t36*t58
      t69 = t36*t56*t8
      t70 = t38*t5*t58
      t71 = t38*t56*t7
      t72 = t5*t59*t8
      t73 = t13*t59*t7
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak6k1(iv1)*t66*abb90n84+spvak6k1(iv2)*t65*abb&
         &90n84+spvak6k1(iv3)*t9*abb90n84+t1*t75*abb90n95+t10*t76*abb90n93+t11*t&
         &76*abb90n78+t13*t76*abb90n102+t15*t76*abb90n95+t16*t75*abb90n78+t19*t7&
         &6*abb90n93+t2*t75*abb90n93+t21*t76*abb90n73+t23*t58*abb90n116+t26*t58*&
         &abb90n116+t29*t58*abb90n116+t3*t75*abb90n93+t32*t58*abb90n116+t37*t58*&
         &abb90n87+t39*t58*abb90n87+t41*t58*abb90n112+t43*t58*abb90n112+t44*t58*&
         &abb90n64+t45*t58*abb90n64+t47*t58*abb90n109+t49*t58*abb90n109+t5*t75*a&
         &bb90n102+t50*t58*abb90n86+t51*t58*abb90n86+t52*t74*abb90n95+t53*t74*ab&
         &b90n93+t54*t74*abb90n93+t55*t74*abb90n78+t56*t74*abb90n102+t57*t74*abb&
         &90n73+t58*t74*abb90n97+t6*t75*abb90n73+t61*t8*abb90n112+t62*t8*abb90n6&
         &4+t63*t8*abb90n109+t64*t8*abb90n86+t7*t75*abb90n97+t76*t8*abb90n97+spv&
         &ak2k4(iv1)*t58*t8*abb90n107+spvak2k4(iv2)*t58*t7*abb90n107+spvak2k4(iv&
         &3)*t7*t8*abb90n107+t53*t7*t8*abb90n116+t54*t7*t8*abb90n116+t59*t7*t8*a&
         &bb90n87)+t68*abb90n75+t69*abb90n75+t70*abb90n75+t71*abb90n75+t72*abb90&
         &n75+t73*abb90n75+t12*t58*abb90n68+t14*t58*abb90n90+t17*t58*abb90n68+t1&
         &8*t58*abb90n90+t20*t58*abb90n90+t22*t58*abb90n85+t24*t58*abb90n90+t25*&
         &t58*abb90n85+t27*t58*abb90n67+t28*t58*abb90n90+t30*t58*abb90n67+t31*t5&
         &8*abb90n90+t33*t58*abb90n82+t35*t58*abb90n82+t46*t58*abb90n65+t48*t58*&
         &abb90n65+t1*t55*t8*abb90n68+t1*t56*t8*abb90n90+t10*t16*t58*abb90n66+t1&
         &0*t40*t58*abb90n113+t10*t55*t7*abb90n66+t10*t56*t7*abb90n90+t10*t57*t7&
         &*abb90n85+t10*t60*t7*abb90n113+t11*t2*t58*abb90n66+t11*t4*t58*abb90n70&
         &+t11*t52*t7*abb90n68+t11*t53*t7*abb90n66+t11*t54*t7*abb90n67+t11*t67*t&
         &7*abb90n70+t13*t40*t58*abb90n89+t13*t52*t7*abb90n90+t13*t53*t7*abb90n9&
         &0+t13*t54*t7*abb90n90+t13*t57*t7*abb90n65+t13*t60*t7*abb90n89+t15*t55*&
         &t7*abb90n68+t15*t56*t7*abb90n90+t16*t34*t58*abb90n70+t16*t52*t8*abb90n&
         &68+t16*t53*t8*abb90n66+t16*t54*t8*abb90n67+t16*t67*t8*abb90n70+t19*t55&
         &*t7*abb90n67+t19*t56*t7*abb90n90+t2*t42*t58*abb90n113+t2*t55*t8*abb90n&
         &66+t2*t56*t8*abb90n90+t2*t57*t8*abb90n85+t2*t60*t8*abb90n113+t21*t53*t&
         &7*abb90n85+t21*t56*t7*abb90n65+t21*t67*t7*abb90n82+t3*t55*t8*abb90n67+&
         &t3*t56*t8*abb90n90+t34*t40*t58*abb90n115+t34*t55*t7*abb90n70+t34*t57*t&
         &7*abb90n82+t34*t60*t7*abb90n115+t4*t42*t58*abb90n115+t4*t55*t8*abb90n7&
         &0+t4*t57*t8*abb90n82+t4*t60*t8*abb90n115+t40*t53*t8*abb90n113+t40*t56*&
         &t8*abb90n89+t40*t67*t8*abb90n115+t42*t5*t58*abb90n89+t42*t53*t7*abb90n&
         &113+t42*t56*t7*abb90n89+t42*t67*t7*abb90n115+t5*t52*t8*abb90n90+t5*t53&
         &*t8*abb90n90+t5*t54*t8*abb90n90+t5*t57*t8*abb90n65+t5*t60*t8*abb90n89+&
         &t53*t6*t8*abb90n85+t56*t6*t8*abb90n65+t6*t67*t8*abb90n82)
         return
      end if
      t77 = d(iv3,iv4)
      t78 = d(iv2,iv4)
      t79 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k6(iv4)
      t3 = spvak3k1(iv4)
      t4 = spvak3k4(iv4)
      t10 = spvak5k1(iv4)
      t12 = spvak2k1(iv4)
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t74*t77*abb90n94+t75*t79*abb90n94+t76*t78*abb90n&
         &94)+(4.0_ki)*(t65*t78*abb90n117+t66*t79*abb90n117+t77*t9*abb90n117+t1*&
         &t58*t74*abb90n117+t1*t7*t75*abb90n117+t1*t76*t8*abb90n117)+(2.0_ki)*(t&
         &1*t68*abb90n63+t1*t69*abb90n63+t1*t70*abb90n63+t1*t71*abb90n63+t1*t72*&
         &abb90n63+t1*t73*abb90n63+t41*t77*abb90n114+t43*t77*abb90n114+t44*t77*a&
         &bb90n69+t45*t77*abb90n69+t47*t77*abb90n90+t49*t77*abb90n90+t50*t77*abb&
         &90n83+t51*t77*abb90n83+t61*t78*abb90n114+t62*t78*abb90n69+t63*t78*abb9&
         &0n90+t64*t78*abb90n83+t1*t11*t76*abb90n69+t1*t13*t76*abb90n90+t1*t16*t&
         &75*abb90n69+t1*t21*t76*abb90n83+t1*t40*t75*abb90n114+t1*t42*t76*abb90n&
         &114+t1*t5*t75*abb90n90+t1*t55*t74*abb90n69+t1*t56*t74*abb90n90+t1*t57*&
         &t74*abb90n83+t1*t6*t75*abb90n83+t1*t60*t74*abb90n114+t10*t58*t74*abb90&
         &n83+t10*t7*t75*abb90n83+t10*t76*t8*abb90n83+t11*t58*t79*abb90n69+t13*t&
         &58*t79*abb90n90+t16*t58*t78*abb90n69+t2*t58*t74*abb90n114+t2*t7*t75*ab&
         &b90n114+t2*t76*t8*abb90n114+t21*t58*t79*abb90n83+t3*t58*t74*abb90n69+t&
         &3*t7*t75*abb90n69+t3*t76*t8*abb90n69+t4*t58*t74*abb90n90+t4*t7*t75*abb&
         &90n90+t4*t76*t8*abb90n90+t40*t58*t78*abb90n114+t42*t58*t79*abb90n114+t&
         &5*t58*t78*abb90n90+t55*t79*t8*abb90n69+t56*t79*t8*abb90n90+t57*t79*t8*&
         &abb90n83+t58*t6*t78*abb90n83+t60*t79*t8*abb90n114+t12*t13*t58*t7*abb90&
         &n63+t12*t5*t58*t8*abb90n63+t12*t56*t7*t8*abb90n63+t36*t4*t58*t8*abb90n&
         &63+t38*t4*t58*t7*abb90n63+t4*t59*t7*t8*abb90n63))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d90:
   subroutine     reconstruct_d90(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_90:
      coeffs%coeffs_90%c0 = derivative(czip)
      coeffs%coeffs_90%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_90%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_90%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_90%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_90%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_90%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_90%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_90%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_90%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_90%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_90%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_90%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_90%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_90%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_90%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_90%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_90%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_90%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_90%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_90%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_90%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_90%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_90%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_90%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_90%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_90%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_90%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_90%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_90%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_90%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_90%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_90%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_90%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_90%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_90%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_90%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_90%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_90%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_90%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_90%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_90%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_90%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_90%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_90%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_90%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_90%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_90%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_90%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_90%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_90%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_90%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_90%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_90%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_90%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_90%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_90%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_90%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_90%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_90%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_90%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_90%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_90%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_90%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_90%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_90%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_90%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_90%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_90%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_90%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_90:
   end subroutine reconstruct_d90
!---#] subroutine reconstruct_d90:
end module p9_udbar_neepgg_d90h1l1d
