module     p9_udbar_neepgg_abbrevd6h3
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh3
   implicit none
   private
   complex(ki), public :: abb6n1
   complex(ki), public :: rat2d6
   complex(ki), public :: abb6n3
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   real(ki) :: t7
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t7 = NC*TR
      t2 = t7*c1*i_
      t3 = spbk6k5*spbk6k5
      t4 = (es34+es56-(es234+es12))*t1*t3
      t5 = t7*c2*i_
      t6 = t2*spak2k3
      t1 = es234*t1*t3
      t3 = t5*spak2k3
      abb6n1 = ((9.0_ki/2.0_ki)*(t3/t1*spak3k5*spbk4k3*spbk5k1+t6/t1*spak2k5*spb&
      &k4k2*spbk5k1+t5/t4*spak1k3*spak2k5*spbk4k1*spbk5k1+t5/t4*spak2k5*spak3k4*&
      &spbk4k1*spbk5k4-(t2/t4*spak2k5*spak3k4*spbk4k1*spbk5k4+t2/t4*spak1k3*spak&
      &2k5*spbk4k1*spbk5k1+t6/t1*spak3k5*spbk4k3*spbk5k1+t3/t1*spak2k5*spbk4k2*s&
      &pbk5k1)))
      rat2d6 = 0
      rat2 = rat2 + rat2d6
      abb6n3 = abb6n1
   end subroutine
end module p9_udbar_neepgg_abbrevd6h3
