module     p9_udbar_neepgg_d27h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d27h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d27
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd27h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      real(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      real(ki) :: t46
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k5-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t42 = dotproduct(qshift, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-sp&
      &vak6k4(4)*qshift(4))
      t43 = dotproduct(k5, qshift)
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t4 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t7 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t44 = dotproduct(k6, qshift)
      t45 = dotproduct(k1, qshift)
      t8 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t9 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t46 = dotproduct(k2, qshift)
      t10 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-s&
      &pvak3k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t42*abb27n40+t1*t2*abb27n25+t1*t3*abb27n28+t1*t4*abb27n27+&
         &t1*t44*abb27n34+t1*t45*abb27n35+t1*t46*abb27n38+t1*t5*abb27n29+t1*t6*a&
         &bb27n30+t1*t7*abb27n33+t1*t8*abb27n36+t1*t9*abb27n37+t10*t42*abb27n42+&
         &t2*t42*abb27n48+t2*t43*abb27n31+t3*t42*abb27n51+t3*t43*abb27n26+t42*t5&
         &*abb27n44+t42*t7*abb27n46+t43*t5*abb27n39+t43*t7*abb27n32+t1*t10*t4*ab&
         &b27n53+t1*t10*t6*abb27n50)
         return
      end if
      t11 = qshift(iv1)
      t12 = k1(iv1)
      t13 = k2(iv1)
      t14 = k5(iv1)
      t15 = k6(iv1)
      t16 = spvak2k1(iv1)
      t17 = spvak2k4(iv1)
      t18 = spvak2k6(iv1)
      t19 = spvak3k1(iv1)
      t20 = spvak3k4(iv1)
      t21 = spvak5k1(iv1)
      t22 = spvak5k6(iv1)
      t23 = spvak6k1(iv1)
      t24 = spvak6k2(iv1)
      t25 = spvak6k4(iv1)
      if(deg.eq.1) then
         numerator = (t11*abb27n41+t1*t12*abb27n35+t1*t13*abb27n38+t1*t15*abb27n&
         &34+t1*t16*abb27n30+t1*t17*abb27n33+t1*t18*abb27n36+t1*t19*abb27n29+t1*&
         &t21*abb27n28+t1*t23*abb27n27+t1*t24*abb27n37+t1*t25*abb27n25+t10*t11*a&
         &bb27n43+t11*t2*abb27n49+t11*t3*abb27n52+t11*t5*abb27n45+t11*t7*abb27n4&
         &7+t14*t2*abb27n31+t14*t3*abb27n26+t14*t5*abb27n39+t14*t7*abb27n32+t17*&
         &t42*abb27n46+t17*t43*abb27n32+t19*t42*abb27n44+t19*t43*abb27n39+t2*t22&
         &*abb27n25+t20*t42*abb27n42+t21*t42*abb27n51+t21*t43*abb27n26+t22*t3*ab&
         &b27n28+t22*t4*abb27n27+t22*t44*abb27n34+t22*t45*abb27n35+t22*t46*abb27&
         &n38+t22*t5*abb27n29+t22*t6*abb27n30+t22*t7*abb27n33+t22*t8*abb27n36+t2&
         &2*t9*abb27n37+t25*t42*abb27n48+t25*t43*abb27n31+t1*t10*t16*abb27n50+t1&
         &*t10*t23*abb27n53+t1*t20*t4*abb27n53+t1*t20*t6*abb27n50+t10*t22*t4*abb&
         &27n53+t10*t22*t6*abb27n50)
         return
      end if
      t42 = d(iv1,iv2)
      t8 = spvak5k6(iv2)
      t9 = spvak2k4(iv2)
      t26 = spvak3k1(iv2)
      t27 = spvak5k1(iv2)
      t28 = spvak6k4(iv2)
      t29 = k5(iv2)
      t30 = spvak3k4(iv2)
      t31 = qshift(iv2)
      t32 = t16*t8
      t33 = spvak2k1(iv2)
      t34 = t22*t33
      t35 = spvak6k1(iv2)
      t36 = t22*t35
      t37 = t23*t8
      t38 = t16*t30
      t39 = t20*t33
      t40 = t20*t8
      t41 = t22*t30
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t42*abb27n40+t10*t42*abb27n42+t2*t42*abb27n48+t3&
         &*t42*abb27n51+t42*t5*abb27n44+t42*t7*abb27n46)+t32*abb27n30+t34*abb27n&
         &30+t36*abb27n27+t37*abb27n27+k1(iv2)*t22*abb27n35+k2(iv2)*t22*abb27n38&
         &+k6(iv2)*t22*abb27n34+spvak2k6(iv2)*t22*abb27n36+spvak6k2(iv2)*t22*abb&
         &27n37+t1*t38*abb27n50+t1*t39*abb27n50+t10*t32*abb27n50+t10*t34*abb27n5&
         &0+t10*t36*abb27n53+t10*t37*abb27n53+t11*t26*abb27n45+t11*t27*abb27n52+&
         &t11*t28*abb27n49+t11*t30*abb27n43+t11*t9*abb27n47+t12*t8*abb27n35+t13*&
         &t8*abb27n38+t14*t26*abb27n39+t14*t27*abb27n26+t14*t28*abb27n31+t14*t9*&
         &abb27n32+t15*t8*abb27n34+t17*t29*abb27n32+t17*t31*abb27n47+t17*t8*abb2&
         &7n33+t18*t8*abb27n36+t19*t29*abb27n39+t19*t31*abb27n45+t19*t8*abb27n29&
         &+t20*t31*abb27n43+t21*t29*abb27n26+t21*t31*abb27n52+t21*t8*abb27n28+t2&
         &2*t26*abb27n29+t22*t27*abb27n28+t22*t28*abb27n25+t22*t9*abb27n33+t24*t&
         &8*abb27n37+t25*t29*abb27n31+t25*t31*abb27n49+t25*t8*abb27n25+t4*t40*ab&
         &b27n53+t4*t41*abb27n53+t40*t6*abb27n50+t41*t6*abb27n50+t1*t20*t35*abb2&
         &7n53+t1*t23*t30*abb27n53)
         return
      end if
      t43 = d(iv2,iv3)
      t44 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t2 = spvak5k6(iv3)
      t3 = spvak2k1(iv3)
      t4 = spvak6k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t42*abb27n46+spvak3k1(iv3)*t42*abb&
         &27n44+spvak5k1(iv3)*t42*abb27n51+spvak6k4(iv3)*t42*abb27n48+t1*t42*abb&
         &27n42+t17*t43*abb27n46+t19*t43*abb27n44+t20*t43*abb27n42+t21*t43*abb27&
         &n51+t25*t43*abb27n48+t26*t44*abb27n44+t27*t44*abb27n51+t28*t44*abb27n4&
         &8+t30*t44*abb27n42+t44*t9*abb27n46)+t2*t38*abb27n50+t2*t39*abb27n50+t4&
         &*t40*abb27n53+t4*t41*abb27n53+t1*t16*t8*abb27n50+t1*t22*t33*abb27n50+t&
         &1*t22*t35*abb27n53+t1*t23*t8*abb27n53+t2*t20*t35*abb27n53+t2*t23*t30*a&
         &bb27n53+t20*t3*t8*abb27n50+t22*t3*t30*abb27n50)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d27:
   subroutine     reconstruct_d27(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group10
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group10), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_27:
      coeffs%coeffs_27%c0 = derivative(czip)
      coeffs%coeffs_27%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_27%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_27%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_27%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_27%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_27%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_27%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_27%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_27%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_27%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_27%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_27%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_27%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_27%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_27%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_27%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_27%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_27%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_27%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_27%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_27%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_27%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_27%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_27%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_27%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_27%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_27%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_27%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_27%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_27%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_27%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_27%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_27%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_27%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_27:
   end subroutine reconstruct_d27
!---#] subroutine reconstruct_d27:
end module p9_udbar_neepgg_d27h3l1d
