module     p0_ddbar_neepdubar_abbrevd23h0
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb23n1
   complex(ki), public :: abb23n2
   complex(ki), public :: abb23n3
   complex(ki), public :: abb23n4
   complex(ki), public :: abb23n5
   complex(ki), public :: abb23n6
   complex(ki), public :: abb23n7
   complex(ki), public :: abb23n8
   complex(ki), public :: abb23n9
   complex(ki), public :: abb23n10
   complex(ki), public :: abb23n11
   complex(ki), public :: abb23n12
   complex(ki), public :: rat2d23
   complex(ki), public :: abb23n14
   complex(ki), public :: abb23n15
   complex(ki), public :: abb23n16
   complex(ki), public :: abb23n17
   complex(ki), public :: abb23n18
   complex(ki), public :: abb23n19
   complex(ki), public :: abb23n20
   complex(ki), public :: abb23n21
   complex(ki), public :: abb23n22
   complex(ki), public :: abb23n23
   complex(ki), public :: abb23n24
   complex(ki), public :: abb23n25
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   real(ki) :: t39
   real(ki) :: t40
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak1k5
      t4 = t3*spak3k4
      t5 = t4*spbk4k2*spbk6k4
      t39 = TR*mT
      t39 = t39*t39
      t6 = (es12+es34-(es56+es345))*t1
      t40 = es12*es12
      t7 = t40*t6
      t8 = t3*spak3k6
      t9 = t8*spbk6k2*spbk6k4
      t10 = t2*spak1k3*spak3k5
      t11 = t10*spbk4k3
      t12 = t11*spbk6k2
      t13 = es345*t40*t1
      t3 = t3*spak3k5
      t14 = t3*spbk5k4
      t15 = t14*spbk6k2
      t16 = c1*i_
      t17 = t16*spak1k5
      t18 = t17*spak3k4
      t19 = t18*spbk4k2*spbk6k4
      t20 = NC*t6
      t21 = t40*t20
      t22 = t17*spak3k6
      t23 = t22*spbk6k2*spbk6k4
      t24 = t16*spak1k3*spak3k5
      t25 = t24*spbk4k3
      t26 = t25*spbk6k2
      t27 = NC*t1
      t28 = es345*t40*t27
      t17 = t17*spak3k5
      t29 = t17*spbk5k4
      t30 = t29*spbk6k2
      t40 = TR*TR
      t31 = t40*t5
      t6 = es12*t6
      t32 = t40*t9
      t33 = t40*t12
      t1 = es345*es12*t1
      t34 = t40*t15
      t35 = t40*t19
      t20 = es12*t20
      t36 = t40*t23
      t37 = t40*t26
      t27 = es345*es12*t27
      t38 = t40*t30
      abb23n1 = ((4.0_ki/3.0_ki)*(t34/t1+t35/t20+t36/t20+t37/t27-(t32/t6+t31/t6+&
      &t38/t27+t33/t1))+(8.0_ki)*(t39*t12/t13+t39*t30/t28+t39*t5/t7+t39/t7*t9-(t&
      &39*t26/t28+t39*t23/t21+t39*t19/t21+t39*t15/t13)))
      abb23n2 = ((4.0_ki)*(t40*t4/t7*spbk2k1*spbk6k4-t40*t18/t21*spbk2k1*spbk6k4&
      &))
      abb23n3 = ((8.0_ki)*(t40*t2/t7*spak3k4*spbk6k4-t40*t16/t21*spak3k4*spbk6k4&
      &))
      t1 = TR*sqrt((mT*mT))
      t1 = t1*t1
      abb23n4 = ((8.0_ki)*(t1*t12/t13+t1/t28*t30+t1*t5/t7+t1/t7*t9-(t1*t26/t28+t&
      &1/t21*t23+t1*t19/t21+t1/t13*t15)))
      t1 = t2*spak1k2
      t5 = t1*spak3k5
      t6 = t16*spak1k2
      t9 = t6*spak3k5
      abb23n5 = ((4.0_ki)*(t40/t28*t9*spbk4k3*spbk6k2-t40/t13*t5*spbk4k3*spbk6k2&
      &))
      abb23n6 = ((4.0_ki)*(t40/t13*t5*spbk5k4*spbk6k2+t40/t21*t6*spak3k4*spbk4k2&
      &*spbk6k4+t40/t21*t6*spak3k6*spbk6k2*spbk6k4-(t40*t1/t7*spak3k6*spbk6k2*sp&
      &bk6k4+t40*t1/t7*spak3k4*spbk4k2*spbk6k4+t40/t28*t9*spbk5k4*spbk6k2)))
      abb23n7 = ((4.0_ki)*(t40*t10/t13*spbk2k1*spbk4k3+t40*t17/t28*spbk2k1*spbk5&
      &k4+t40/t7*t8*spbk2k1*spbk6k4-(t40*t24/t28*spbk2k1*spbk4k3+t40*t22/t21*spb&
      &k2k1*spbk6k4+t40*t3/t13*spbk2k1*spbk5k4)))
      t1 = t31/t7
      t3 = t32/t7
      t5 = t33/t13
      t6 = t34/t13
      t9 = t35/t21
      t10 = t36/t21
      t12 = t37/t28
      t15 = t38/t28
      abb23n8 = ((16.0_ki)*(t1+t15+t3+t5-(t9+t6+t12+t10)))
      abb23n9 = ((8.0_ki)*(t10+t12+t6+t9-(t5+t3+t15+t1)))
      t1 = t2*spak2k5
      t3 = t16*spak2k5
      abb23n10 = ((8.0_ki)*(t40*t14/t13*spbk6k1+t40*t25/t28*spbk6k1+t40*t18/t21*&
      &spbk4k1*spbk6k4+t40*t22/t21*spbk6k1*spbk6k4+t40*t1/t13*spak3k5*spbk5k4*sp&
      &bk6k2+t40*t3/t21*spak3k4*spbk4k2*spbk6k4+t40*t3/t21*spak3k6*spbk6k2*spbk6&
      &k4+t40*t16/t28*spak2k3*spak3k5*spbk4k3*spbk6k2-(t40*t2/t13*spak2k3*spak3k&
      &5*spbk4k3*spbk6k2+t40*t3/t28*spak3k5*spbk5k4*spbk6k2+t40*t1/t7*spak3k6*sp&
      &bk6k2*spbk6k4+t40*t1/t7*spak3k4*spbk4k2*spbk6k4+t40/t7*t8*spbk6k1*spbk6k4&
      &+t40*t4/t7*spbk4k1*spbk6k4+t40*t29/t28*spbk6k1+t40*t11/t13*spbk6k1)))
      t1 = t2*spak3k5
      t3 = t16*spak3k5
      abb23n11 = ((8.0_ki)*(t40*t1/t13*spbk4k3-t40*t3/t28*spbk4k3))
      abb23n12 = ((8.0_ki)*(t40*t3/t28*spbk5k4+t40*t2/t7*spak3k6*spbk6k4-(t40*t1&
      &6/t21*spak3k6*spbk6k4+t40*t1/t13*spbk5k4)))
      rat2d23 = abb23n1
      rat2 = rat2 + rat2d23
      abb23n14 = abb23n4
      abb23n15 = abb23n12
      abb23n16 = abb23n11
      abb23n17 = abb23n9
      abb23n18 = abb23n3
      abb23n19 = -(abb23n2)
      abb23n20 = -(abb23n5)
      abb23n21 = -(abb23n6)
      abb23n22 = -(abb23n7)
      abb23n23 = -(abb23n8)
      abb23n24 = ((2.0_ki)*abb23n9)
      abb23n25 = -(abb23n10)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd23h0
