module     p0_ddbar_neepdubar_abbrevd4h0
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb4n1
   complex(ki), public :: abb4n2
   complex(ki), public :: abb4n3
   complex(ki), public :: abb4n4
   complex(ki), public :: abb4n5
   complex(ki), public :: abb4n6
   complex(ki), public :: abb4n7
   complex(ki), public :: abb4n8
   complex(ki), public :: abb4n9
   complex(ki), public :: abb4n10
   complex(ki), public :: abb4n11
   complex(ki), public :: abb4n12
   complex(ki), public :: abb4n13
   complex(ki), public :: abb4n14
   complex(ki), public :: abb4n15
   complex(ki), public :: abb4n16
   complex(ki), public :: abb4n17
   complex(ki), public :: abb4n18
   complex(ki), public :: abb4n19
   complex(ki), public :: abb4n20
   complex(ki), public :: abb4n21
   complex(ki), public :: abb4n22
   complex(ki), public :: abb4n23
   complex(ki), public :: abb4n24
   complex(ki), public :: abb4n25
   complex(ki), public :: abb4n26
   complex(ki), public :: abb4n27
   complex(ki), public :: abb4n28
   complex(ki), public :: abb4n29
   complex(ki), public :: rat2d4
   complex(ki), public :: abb4n31
   complex(ki), public :: abb4n32
   complex(ki), public :: abb4n33
   complex(ki), public :: abb4n34
   complex(ki), public :: abb4n35
   complex(ki), public :: abb4n36
   complex(ki), public :: abb4n37
   complex(ki), public :: abb4n38
   complex(ki), public :: abb4n39
   complex(ki), public :: abb4n40
   complex(ki), public :: abb4n41
   complex(ki), public :: abb4n42
   complex(ki), public :: abb4n43
   complex(ki), public :: abb4n44
   complex(ki), public :: abb4n45
   complex(ki), public :: abb4n46
   complex(ki), public :: abb4n47
   complex(ki), public :: abb4n48
   complex(ki), public :: abb4n49
   complex(ki), public :: abb4n50
   complex(ki), public :: abb4n51
   complex(ki), public :: abb4n52
   complex(ki), public :: abb4n53
   complex(ki), public :: abb4n54
   complex(ki), public :: abb4n55
   complex(ki), public :: abb4n56
   complex(ki), public :: abb4n57
   complex(ki), public :: abb4n58
   complex(ki), public :: abb4n59
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   real(ki) :: t25
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = es56*c1*i_
      t25 = TR*TR
      t3 = es12*NC*NC*t1
      t4 = es56*c2*i_
      t1 = es12*NC*t1
      abb4n1 = ((4.0_ki)*(t25*t2/t3*spak1k2*spak3k5*spbk4k2*spbk6k2+t25*t2/t3*sp&
      &ak1k6*spak3k5*spbk6k2*spbk6k4-(t25/t1*t4*spak1k6*spak3k5*spbk6k2*spbk6k4+&
      &t25/t1*t4*spak1k2*spak3k5*spbk4k2*spbk6k2)))
      t5 = c1*i_
      t6 = t5*spak1k2
      t7 = TR*spbk6k2
      t7 = t7*t7
      t8 = c2*i_
      t9 = t8*spak1k2
      abb4n2 = ((4.0_ki)*(t6/t3*t7*spak5k6-t7/t1*t9*spak5k6))
      abb4n3 = ((4.0_ki)*(t25/t3*t6*spbk6k2-t25/t1*t9*spbk6k2))
      t7 = t5*spak1k3
      t10 = t7*spak5k6
      t11 = t25*t10/t3*spbk6k2*spbk6k4
      t12 = t8*spak1k3
      t13 = t12*spak5k6
      t14 = t25*t13/t1*spbk6k2*spbk6k4
      abb4n4 = ((8.0_ki)*(t14-t11))
      t15 = t25/t3*t7*spbk6k2
      t16 = t25*t12/t1*spbk6k2
      t17 = t15-t16
      abb4n5 = ((8.0_ki)*t17)
      abb4n6 = ((4.0_ki)*t17)
      abb4n7 = ((8.0_ki)*(t16-t15))
      t15 = t5*spak3k5
      t16 = t8*spak3k5
      abb4n8 = ((4.0_ki)*(t25*t15/t3*spbk4k1-t25*t16/t1*spbk4k1))
      t17 = t5*spak1k5
      t18 = t17*spak3k5
      t19 = t18*spbk4k2
      t20 = t8*spak1k5
      t21 = t20*spak3k5
      t22 = t21*spbk4k2
      abb4n9 = ((4.0_ki)*(t25*t22/t1*spbk5k2-t25*t19/t3*spbk5k2))
      t23 = t25*t17/t3*spbk4k2
      t24 = t25*t20/t1*spbk4k2
      abb4n10 = ((8.0_ki)*(t23-t24))
      t23 = t24-t23
      abb4n11 = ((4.0_ki)*t23)
      abb4n12 = ((8.0_ki)*t23)
      abb4n13 = ((8.0_ki)*(t11+t25*t21/t1*spbk5k2*spbk6k4-(t25*t18/t3*spbk5k2*sp&
      &bk6k4+t14)))
      abb4n14 = ((4.0_ki)*(t11+t25*t22/t1*spbk6k5+t25*t20/t1*spak3k6*spbk6k2*spb&
      &k6k4+t25/t3*t7*spak1k5*spbk2k1*spbk6k4-(t25*t17/t3*spak3k6*spbk6k2*spbk6k&
      &4+t25*t12/t1*spak1k5*spbk2k1*spbk6k4+t25*t19/t3*spbk6k5+t14)))
      t11 = t25*t17/t3*spbk6k2
      t14 = t25*t20/t1*spbk6k2
      abb4n15 = ((8.0_ki)*(t11-t14))
      abb4n16 = ((4.0_ki)*(t14-t11))
      t11 = t5*spak1k6
      t14 = t8*spak1k6
      abb4n17 = ((8.0_ki)*(t25*t11/t3*spak3k5*spbk6k2*spbk6k4+t25/t3*t6*spak3k5*&
      &spbk4k2*spbk6k2-(t25/t1*t9*spak3k5*spbk4k2*spbk6k2+t25*t14/t1*spak3k5*spb&
      &k6k2*spbk6k4)))
      abb4n18 = ((4.0_ki)*(t25*t14/t1*spbk6k2-t25*t11/t3*spbk6k2))
      t2 = t2*spak3k5
      t4 = t4*spak3k5
      t6 = t5*spak2k3
      t9 = t8*spak2k3
      abb4n19 = ((4.0_ki)*(t25*t2/t3*spbk6k4+t25*t10/t3*spbk6k1*spbk6k4+t25/t3*t&
      &6*spak5k6*spbk6k2*spbk6k4-(t25/t1*t9*spak5k6*spbk6k2*spbk6k4+t25*t13/t1*s&
      &pbk6k1*spbk6k4+t25/t1*t4*spbk6k4)))
      abb4n20 = ((4.0_ki)*(t25/t3*t6*spbk6k2+t25/t3*t7*spbk6k1-(t25/t1*t9*spbk6k&
      &2+t25*t12/t1*spbk6k1)))
      t6 = t25*t15/t3*spbk4k2
      t7 = t25*t16/t1*spbk4k2
      t9 = t6-t7
      abb4n21 = ((8.0_ki)*t9)
      abb4n22 = ((4.0_ki)*t9)
      abb4n23 = ((8.0_ki)*(t7-t6))
      abb4n24 = ((4.0_ki)*(t25*t2/t3*spbk4k2+t25*t13/t1*spbk2k1*spbk6k4+t25*t16/&
      &t1*spak5k6*spbk5k2*spbk6k4+es34*t25/t1*c2*i_*spak3k5*spbk4k2+es61*t25/t1*&
      &c2*i_*spak3k5*spbk4k2+t25/t3*t5*spak3k6*spak5k6*spbk6k2*spbk6k4+es234*t25&
      &/t3*c1*i_*spak3k5*spbk4k2+es345*t25/t3*c1*i_*spak3k5*spbk4k2-(es61*t25/t3&
      &*c1*i_*spak3k5*spbk4k2+es34*t25/t3*c1*i_*spak3k5*spbk4k2+es345*t25/t1*c2*&
      &i_*spak3k5*spbk4k2+es234*t25/t1*c2*i_*spak3k5*spbk4k2+t25/t1*t8*spak3k6*s&
      &pak5k6*spbk6k2*spbk6k4+t25*t15/t3*spak5k6*spbk5k2*spbk6k4+t25*t10/t3*spbk&
      &2k1*spbk6k4+t25/t1*t4*spbk4k2)))
      t2 = t5*spak5k6
      t4 = t8*spak5k6
      abb4n25 = ((8.0_ki)*(t25*t2/t3*spbk6k2-t25/t1*t4*spbk6k2))
      abb4n26 = ((4.0_ki)*(t25*t16/t1*spbk5k4-t25*t15/t3*spbk5k4))
      abb4n27 = ((8.0_ki)*(t25*t15/t3*spbk6k4-t25*t16/t1*spbk6k4))
      abb4n28 = ((4.0_ki)*(t25*t20/t1*spbk4k1+t25*t2/t3*spbk6k4+t25/t1*t8*spak2k&
      &5*spbk4k2-(t25/t3*t5*spak2k5*spbk4k2+t25*t17/t3*spbk4k1+t25/t1*t4*spbk6k4&
      &)))
      abb4n29 = ((4.0_ki)*(t25/t3*t5-t25/t1*t8))
      rat2d4 = 0
      rat2 = rat2 + rat2d4
      abb4n31 = abb4n1
      abb4n32 = abb4n29
      abb4n33 = abb4n28
      abb4n34 = abb4n27
      abb4n35 = abb4n26
      abb4n36 = abb4n25
      abb4n37 = abb4n24
      abb4n38 = abb4n23
      abb4n39 = abb4n22
      abb4n40 = abb4n21
      abb4n41 = abb4n20
      abb4n42 = abb4n19
      abb4n43 = abb4n18
      abb4n44 = abb4n17
      abb4n45 = abb4n16
      abb4n46 = abb4n15
      abb4n47 = abb4n14
      abb4n48 = abb4n13
      abb4n49 = abb4n12
      abb4n50 = abb4n11
      abb4n51 = abb4n10
      abb4n52 = abb4n9
      abb4n53 = abb4n8
      abb4n54 = abb4n7
      abb4n55 = abb4n6
      abb4n56 = abb4n5
      abb4n57 = abb4n4
      abb4n58 = abb4n3
      abb4n59 = abb4n2
   end subroutine
end module p0_ddbar_neepdubar_abbrevd4h0
