module     p0_ddbar_neepdubar_abbrevd2h1
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb2n1
   complex(ki), public :: abb2n2
   complex(ki), public :: abb2n3
   complex(ki), public :: abb2n4
   complex(ki), public :: abb2n5
   complex(ki), public :: abb2n6
   complex(ki), public :: abb2n7
   complex(ki), public :: abb2n8
   complex(ki), public :: abb2n9
   complex(ki), public :: abb2n10
   complex(ki), public :: abb2n11
   complex(ki), public :: abb2n12
   complex(ki), public :: abb2n13
   complex(ki), public :: abb2n14
   complex(ki), public :: abb2n15
   complex(ki), public :: abb2n16
   complex(ki), public :: abb2n17
   complex(ki), public :: abb2n18
   complex(ki), public :: abb2n19
   complex(ki), public :: abb2n20
   complex(ki), public :: abb2n21
   complex(ki), public :: abb2n22
   complex(ki), public :: abb2n23
   complex(ki), public :: abb2n24
   complex(ki), public :: abb2n25
   complex(ki), public :: abb2n26
   complex(ki), public :: abb2n27
   complex(ki), public :: abb2n28
   complex(ki), public :: abb2n29
   complex(ki), public :: rat2d2
   complex(ki), public :: abb2n31
   complex(ki), public :: abb2n32
   complex(ki), public :: abb2n33
   complex(ki), public :: abb2n34
   complex(ki), public :: abb2n35
   complex(ki), public :: abb2n36
   complex(ki), public :: abb2n37
   complex(ki), public :: abb2n38
   complex(ki), public :: abb2n39
   complex(ki), public :: abb2n40
   complex(ki), public :: abb2n41
   complex(ki), public :: abb2n42
   complex(ki), public :: abb2n43
   complex(ki), public :: abb2n44
   complex(ki), public :: abb2n45
   complex(ki), public :: abb2n46
   complex(ki), public :: abb2n47
   complex(ki), public :: abb2n48
   complex(ki), public :: abb2n49
   complex(ki), public :: abb2n50
   complex(ki), public :: abb2n51
   complex(ki), public :: abb2n52
   complex(ki), public :: abb2n53
   complex(ki), public :: abb2n54
   complex(ki), public :: abb2n55
   complex(ki), public :: abb2n56
   complex(ki), public :: abb2n57
   complex(ki), public :: abb2n58
   complex(ki), public :: abb2n59
   complex(ki), public :: abb2n60
   complex(ki), public :: abb2n61
   complex(ki), public :: abb2n62
   complex(ki), public :: abb2n63
   complex(ki), public :: abb2n64
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   complex(ki) :: t50
   complex(ki) :: t51
   complex(ki) :: t52
   complex(ki) :: t53
   complex(ki) :: t54
   real(ki) :: t55
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es12*c2*i_
      t55 = TR*TR
      t2 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t3 = t1*spak2k3
      t4 = es234*c2*i_
      t5 = t4*spak2k3
      t6 = es34*c2*i_
      t7 = t6*spak2k3
      t8 = es345*c2*i_
      t9 = t8*spak2k3
      t10 = es61*c2*i_
      t11 = t10*spak2k3
      t12 = NC*c1
      t13 = es12*t12*i_
      t14 = t13*spak2k3
      t15 = es234*t12*i_
      t16 = t15*spak2k3
      t17 = es34*t12*i_
      t18 = t17*spak2k3
      t19 = es345*t12*i_
      t20 = t19*spak2k3
      t21 = es61*t12*i_
      t22 = t21*spak2k3
      t23 = c2*i_
      t24 = t23*spak1k5*spak2k3
      t25 = t24*spak2k5*spbk2k1
      t26 = t12*i_
      t27 = t26*spak1k5*spak2k3
      t28 = t27*spak2k5*spbk2k1
      abb2n1 = ((2.0_ki)*(t55*t28/t2*spbk4k1*spbk6k5+t55*t28/t2*spbk5k4*spbk6k1+&
      &t55*t11/t2*spak2k5*spbk2k1*spbk6k4+es56*t55/t2*c2*i_*spak2k3*spak2k5*spbk&
      &2k1*spbk6k4-(es56*t55*t12/t2*i_*spak2k3*spak2k5*spbk2k1*spbk6k4+t55*t22/t&
      &2*spak2k5*spbk2k1*spbk6k4+t55*t25/t2*spbk5k4*spbk6k1+t55*t25/t2*spbk4k1*s&
      &pbk6k5))+(4.0_ki)*(t55*t14/t2*spak5k6*spbk6k1*spbk6k4+t55*t18/t2*spak5k6*&
      &spbk6k1*spbk6k4+t55*t22/t2*spak5k6*spbk6k1*spbk6k4+t55*t5/t2*spak5k6*spbk&
      &6k1*spbk6k4+t55/t2*t9*spak5k6*spbk6k1*spbk6k4+t55*t1/t2*spak1k5*spak2k3*s&
      &pbk4k1*spbk6k1+t55*t10/t2*spak1k5*spak2k3*spbk4k1*spbk6k1+t55*t15/t2*spak&
      &1k5*spak2k3*spbk4k1*spbk6k1+t55*t19/t2*spak1k5*spak2k3*spbk4k1*spbk6k1+t5&
      &5/t2*t6*spak1k5*spak2k3*spbk4k1*spbk6k1-(t55/t2*t8*spak1k5*spak2k3*spbk4k&
      &1*spbk6k1+t55*t4/t2*spak1k5*spak2k3*spbk4k1*spbk6k1+t55*t21/t2*spak1k5*sp&
      &ak2k3*spbk4k1*spbk6k1+t55*t17/t2*spak1k5*spak2k3*spbk4k1*spbk6k1+t55*t13/&
      &t2*spak1k5*spak2k3*spbk4k1*spbk6k1+t55/t2*t7*spak5k6*spbk6k1*spbk6k4+t55*&
      &t3/t2*spak5k6*spbk6k1*spbk6k4+t55*t20/t2*spak5k6*spbk6k1*spbk6k4+t55*t16/&
      &t2*spak5k6*spbk6k1*spbk6k4+t55*t11/t2*spak5k6*spbk6k1*spbk6k4)))
      t1 = t23*spak1k2
      t6 = TR*spbk6k1
      t6 = t6*t6
      t8 = t26*spak1k2
      abb2n2 = ((2.0_ki)*(t55*t15/t2*spak2k5*spbk6k1-t55*t4/t2*spak2k5*spbk6k1)+&
      &(4.0_ki)*(t6/t2*t8*spak5k6+t55*t10/t2*spak2k5*spbk6k1-(t55*t21/t2*spak2k5&
      &*spbk6k1+t1/t2*t6*spak5k6)))
      t4 = t23*spak2k3
      t6 = t4*spak2k5
      t10 = t6*spbk2k1
      t12 = t26*spak2k3
      t13 = t12*spak2k5
      t15 = t13*spbk2k1
      t17 = t23*spak2k5
      t19 = t17*spak3k5
      t21 = t19*spbk4k1
      t25 = t17*spak3k6
      t28 = t25*spbk4k1
      t29 = t26*spak2k5
      t30 = t29*spak3k5
      t31 = t30*spbk4k1
      t32 = t29*spak3k6
      t33 = t32*spbk4k1
      abb2n3 = ((4.0_ki)*(t55*t10/t2*spbk4k1-t55*t15/t2*spbk4k1)+(2.0_ki)*(t55*t&
      &21/t2*spbk5k1+t55*t28/t2*spbk6k1-(t55*t33/t2*spbk6k1+t55*t31/t2*spbk5k1))&
      &)
      t34 = t55*t4/t2*spbk4k1
      t35 = t55*t12/t2*spbk4k1
      abb2n4 = ((4.0_ki)*(t34-t35))
      abb2n5 = ((2.0_ki)*(t35-t34))
      t34 = t55*t17/t2*spbk4k1
      t35 = t55*t29/t2*spbk4k1
      t36 = t34-t35
      abb2n6 = ((4.0_ki)*t36)
      abb2n7 = ((2.0_ki)*t36)
      abb2n8 = ((4.0_ki)*(t35-t34))
      abb2n9 = ((8.0_ki)*(t55*t17/t2*spbk5k1-t55*t29/t2*spbk5k1))
      t24 = t55*t24/t2*spbk4k1*spbk6k1
      t34 = t55*t4/t2*spak5k6*spbk6k1*spbk6k4
      t27 = t55*t27/t2*spbk4k1*spbk6k1
      t35 = t55*t12/t2*spak5k6*spbk6k1*spbk6k4
      abb2n10 = ((4.0_ki)*(t24+t35-(t34+t27)))
      t36 = t1*spak3k5*spbk4k1
      t37 = t55*t36/t2*spbk6k1
      t38 = t19*spbk5k4
      t39 = t55*t38/t2*spbk6k1
      t40 = t8*spak3k5*spbk4k1
      t41 = t55*t40/t2*spbk6k1
      t42 = t30*spbk5k4
      t43 = t55*t42/t2*spbk6k1
      t44 = (8.0_ki)*(t39+t41-(t43+t37))
      t45 = t55*t10/t2*spbk6k4
      t46 = t55*t15/t2*spbk6k4
      abb2n11 = ((4.0_ki)*(t46-t45)+t44)
      t47 = t23*spak1k3
      t48 = t47*spak2k5
      t49 = t48*spbk4k1
      t50 = t55*t49/t2*spbk6k1
      t21 = t55*t21/t2*spbk6k5
      t51 = t26*spak1k3
      t52 = t51*spak2k5
      t53 = t52*spbk4k1
      t54 = t55*t53/t2*spbk6k1
      t31 = t55*t31/t2*spbk6k5
      abb2n12 = ((4.0_ki)*(t21+t45+t50-(t54+t46+t31))+t44)
      abb2n13 = ((2.0_ki)*(t27+t34+t46-(t45+t35+t24))+(4.0_ki)*(t31+t37+t43+t54-&
      &(t50+t41+t39+t21)))
      abb2n14 = ((4.0_ki)*(t45-t46)+(8.0_ki)*(t37+t43-(t41+t39)))
      abb2n15 = ((2.0_ki)*(t55*t33/t2*spbk6k5+t55*t49/t2*spbk5k1-(t55*t53/t2*spb&
      &k5k1+t55*t28/t2*spbk6k5))+(4.0_ki)*(t55*t10/t2*spbk5k4+t55*t11/t2*spbk4k1&
      &+t55*t16/t2*spbk4k1+t55*t20/t2*spbk4k1+t55*t3/t2*spbk4k1+t55*t36/t2*spbk5&
      &k1+t55/t2*t7*spbk4k1+t55*t30/t2*spbk5k1*spbk5k4+t55*t32/t2*spbk5k4*spbk6k&
      &1+t55*t1/t2*spak3k6*spbk4k1*spbk6k1-(t55/t2*t8*spak3k6*spbk4k1*spbk6k1+t5&
      &5*t25/t2*spbk5k4*spbk6k1+t55*t19/t2*spbk5k1*spbk5k4+t55/t2*t9*spbk4k1+t55&
      &*t5/t2*spbk4k1+t55*t40/t2*spbk5k1+t55*t22/t2*spbk4k1+t55*t18/t2*spbk4k1+t&
      &55*t15/t2*spbk5k4+t55*t14/t2*spbk4k1)))
      t10 = t55*t17/t2*spbk6k1
      t15 = t55*t29/t2*spbk6k1
      abb2n16 = ((4.0_ki)*(t10-t15))
      t10 = t15-t10
      abb2n17 = ((2.0_ki)*t10)
      abb2n18 = ((4.0_ki)*t10)
      abb2n19 = ((4.0_ki)*(t55*t12/t2*spbk4k2-t55*t4/t2*spbk4k2))
      abb2n20 = ((4.0_ki)*(t55*t4/t2*spbk5k4-t55*t12/t2*spbk5k4))
      t4 = t55*t4/t2*spbk6k4
      t10 = t55*t12/t2*spbk6k4
      t12 = t4-t10
      abb2n21 = ((8.0_ki)*t12)
      abb2n22 = ((2.0_ki)*t12)
      t4 = t10-t4
      abb2n23 = ((4.0_ki)*t4)
      abb2n24 = ((8.0_ki)*t4)
      abb2n25 = ((8.0_ki)*(t55*t11/t2*spbk6k4+t55*t20/t2*spbk6k4+t55*t3/t2*spbk6&
      &k4-(t55/t2*t9*spbk6k4+t55*t22/t2*spbk6k4+t55*t14/t2*spbk6k4))+(4.0_ki)*(t&
      &55*t16/t2*spbk6k4+t55*t36/t2*spbk6k5+t55*t42/t2*spbk6k5+t55/t2*t7*spbk6k4&
      &+t55*t52/t2*spbk5k4*spbk6k1+t55/t2*t6*spbk5k4*spbk6k2+t55*t1/t2*spak1k3*s&
      &pbk4k1*spbk6k1+t55/t2*t8*spak2k3*spbk4k1*spbk6k2-(t55/t2*t8*spak1k3*spbk4&
      &k1*spbk6k1+t55*t1/t2*spak2k3*spbk4k1*spbk6k2+t55*t48/t2*spbk5k4*spbk6k1+t&
      &55*t13/t2*spbk5k4*spbk6k2+t55*t5/t2*spbk6k4+t55*t40/t2*spbk6k5+t55*t38/t2&
      &*spbk6k5+t55*t18/t2*spbk6k4)))
      abb2n26 = ((8.0_ki)*(t55*t1/t2*spbk6k1+t55*t17/t2*spbk6k5-(t55/t2*t8*spbk6&
      &k1+t55*t29/t2*spbk6k5)))
      abb2n27 = ((4.0_ki)*(t55*t1/t2*spbk4k1+t55*t29/t2*spbk5k4+t55*t26/t2*spak2&
      &k6*spbk6k4-(t55*t23/t2*spak2k6*spbk6k4+t55/t2*t8*spbk4k1+t55*t17/t2*spbk5&
      &k4)))
      abb2n28 = ((4.0_ki)*(t55*t51/t2*spbk6k1+t55*t26/t2*spak3k5*spbk6k5-(t55*t2&
      &3/t2*spak3k5*spbk6k5+t55*t47/t2*spbk6k1)))
      abb2n29 = ((4.0_ki)*(t55*t23/t2-t55*t26/t2))
      rat2d2 = 0
      rat2 = rat2 + rat2d2
      abb2n31 = abb2n1
      abb2n32 = abb2n28
      abb2n33 = abb2n27
      abb2n34 = abb2n26
      abb2n35 = abb2n24
      abb2n36 = abb2n23
      abb2n37 = abb2n21
      abb2n38 = abb2n20
      abb2n39 = abb2n19
      abb2n40 = abb2n18
      abb2n41 = abb2n16
      abb2n42 = abb2n13
      abb2n43 = abb2n9
      abb2n44 = abb2n8
      abb2n45 = abb2n6
      abb2n46 = abb2n4
      abb2n47 = -(abb2n2)
      abb2n48 = -(abb2n3)
      abb2n49 = -(abb2n5)
      abb2n50 = (-2.0_ki)*abb2n5
      abb2n51 = -(abb2n7)
      abb2n52 = (-2.0_ki)*abb2n7
      abb2n53 = -(abb2n10)
      abb2n54 = -(abb2n11)
      abb2n55 = -(abb2n12)
      abb2n56 = ((2.0_ki)*abb2n13)
      abb2n57 = -(abb2n14)
      abb2n58 = -(abb2n15)
      abb2n59 = -(abb2n17)
      abb2n60 = (-2.0_ki)*abb2n17
      abb2n61 = -(abb2n22)
      abb2n62 = (-2.0_ki)*abb2n22
      abb2n63 = -(abb2n25)
      abb2n64 = -(abb2n29)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd2h1
