module     p0_ddbar_neepdubar_abbrevd60h1
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb60n1
   complex(ki), public :: abb60n2
   complex(ki), public :: abb60n3
   complex(ki), public :: abb60n4
   complex(ki), public :: rat2d60
   complex(ki), public :: abb60n6
   complex(ki), public :: abb60n7
   complex(ki), public :: abb60n8
   complex(ki), public :: abb60n9
   complex(ki), public :: abb60n10
   complex(ki), public :: abb60n11
   complex(ki), public :: abb60n12
   complex(ki), public :: abb60n13
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   real(ki) :: t10
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_*spak2k3
      t3 = t2*spak5k6
      t10 = TR*TR
      t4 = es234*t1
      t5 = NC*NC*t4
      t6 = c1*i_*spak2k3
      t7 = t6*spak5k6
      t1 = es234*NC*t1
      t8 = NC*c1*i_*spak2k3
      t9 = t8*spak5k6
      abb60n1 = ((4.0_ki)*(t10*(2.0_ki)/t1*t7*spbk4k3*spbk6k1-(t10/t4*t9*spbk4k3&
      &*spbk6k1+t10*t3/t5*spbk4k3*spbk6k1)))
      abb60n2 = ((4.0_ki)*(t10*t3/t5*spbk4k2*spbk6k1+t10/t4*t9*spbk4k2*spbk6k1-t&
      &10*(2.0_ki)/t1*t7*spbk4k2*spbk6k1))
      abb60n3 = ((4.0_ki)*(t10*t2/t5*spbk4k2+t10/t4*t8*spbk4k2-t10*(2.0_ki)/t1*t&
      &6*spbk4k2))
      abb60n4 = ((4.0_ki)*(t10*(2.0_ki)/t1*t6*spbk4k3-(t10/t4*t8*spbk4k3+t10*t2/&
      &t5*spbk4k3)))
      rat2d60 = 0
      rat2 = rat2 + rat2d60
      abb60n6 = -(abb60n1)
      abb60n7 = abb60n4
      abb60n8 = abb60n3
      abb60n9 = abb60n2
      abb60n10 = abb60n1
      abb60n11 = -(abb60n2)
      abb60n12 = -(abb60n3)
      abb60n13 = -(abb60n4)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd60h1
