module     p0_ddbar_neepdubar_abbrevd6h1
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb6n1
   complex(ki), public :: abb6n2
   complex(ki), public :: abb6n3
   complex(ki), public :: abb6n4
   complex(ki), public :: abb6n5
   complex(ki), public :: abb6n6
   complex(ki), public :: abb6n7
   complex(ki), public :: abb6n8
   complex(ki), public :: abb6n9
   complex(ki), public :: abb6n10
   complex(ki), public :: abb6n11
   complex(ki), public :: abb6n12
   complex(ki), public :: abb6n13
   complex(ki), public :: abb6n14
   complex(ki), public :: abb6n15
   complex(ki), public :: abb6n16
   complex(ki), public :: abb6n17
   complex(ki), public :: abb6n18
   complex(ki), public :: abb6n19
   complex(ki), public :: abb6n20
   complex(ki), public :: abb6n21
   complex(ki), public :: abb6n22
   complex(ki), public :: abb6n23
   complex(ki), public :: abb6n24
   complex(ki), public :: abb6n25
   complex(ki), public :: abb6n26
   complex(ki), public :: abb6n27
   complex(ki), public :: abb6n28
   complex(ki), public :: abb6n29
   complex(ki), public :: abb6n30
   complex(ki), public :: abb6n31
   complex(ki), public :: rat2d6
   complex(ki), public :: abb6n33
   complex(ki), public :: abb6n34
   complex(ki), public :: abb6n35
   complex(ki), public :: abb6n36
   complex(ki), public :: abb6n37
   complex(ki), public :: abb6n38
   complex(ki), public :: abb6n39
   complex(ki), public :: abb6n40
   complex(ki), public :: abb6n41
   complex(ki), public :: abb6n42
   complex(ki), public :: abb6n43
   complex(ki), public :: abb6n44
   complex(ki), public :: abb6n45
   complex(ki), public :: abb6n46
   complex(ki), public :: abb6n47
   complex(ki), public :: abb6n48
   complex(ki), public :: abb6n49
   complex(ki), public :: abb6n50
   complex(ki), public :: abb6n51
   complex(ki), public :: abb6n52
   complex(ki), public :: abb6n53
   complex(ki), public :: abb6n54
   complex(ki), public :: abb6n55
   complex(ki), public :: abb6n56
   complex(ki), public :: abb6n57
   complex(ki), public :: abb6n58
   complex(ki), public :: abb6n59
   complex(ki), public :: abb6n60
   complex(ki), public :: abb6n61
   complex(ki), public :: abb6n62
   complex(ki), public :: abb6n63
   complex(ki), public :: abb6n64
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   real(ki) :: t25
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p0_ddbar_neepdubar_config, only: deltaOS
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_model
      use p0_ddbar_neepdubar_color, only: TR
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      implicit none
      t1 = es12*c2*i_
      t25 = TR*TR
      t2 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t3 = NC*NC*t2
      t4 = t1*spak2k3
      t5 = es345*c2*i_
      t6 = t5*spak2k3
      t7 = es61*c2*i_
      t8 = t7*spak2k3
      t9 = es12*c1*i_
      t2 = NC*t2
      t10 = t9*spak2k3
      t11 = es345*c1*i_
      t12 = t11*spak2k3
      t13 = es61*c1*i_
      t14 = t13*spak2k3
      abb6n1 = ((4.0_ki)*(t25*t10/t2*spak5k6*spbk6k1*spbk6k4+t25*t14/t2*spak5k6*&
      &spbk6k1*spbk6k4+t25/t3*t6*spak5k6*spbk6k1*spbk6k4+t25*t1/t3*spak1k5*spak2&
      &k3*spbk4k1*spbk6k1+t25*t11/t2*spak1k5*spak2k3*spbk4k1*spbk6k1+t25/t3*t7*s&
      &pak1k5*spak2k3*spbk4k1*spbk6k1-(t25/t3*t5*spak1k5*spak2k3*spbk4k1*spbk6k1&
      &+t25/t2*t9*spak1k5*spak2k3*spbk4k1*spbk6k1+t25*t13/t2*spak1k5*spak2k3*spb&
      &k4k1*spbk6k1+t25/t3*t8*spak5k6*spbk6k1*spbk6k4+t25/t3*t4*spak5k6*spbk6k1*&
      &spbk6k4+t25*t12/t2*spak5k6*spbk6k1*spbk6k4)))
      t1 = c2*i_
      t5 = t1*spak2k3
      t7 = t5*spak2k5
      t9 = t7*spbk2k1
      t11 = c1*i_
      t13 = t11*spak2k3
      t15 = t13*spak2k5
      t16 = t15*spbk2k1
      abb6n2 = ((4.0_ki)*(t25*t16/t2*spbk4k1-t25/t3*t9*spbk4k1))
      t17 = t25/t3*t5*spbk4k1
      t18 = t25*t13/t2*spbk4k1
      t19 = t17-t18
      abb6n3 = ((8.0_ki)*t19)
      abb6n4 = ((4.0_ki)*t19)
      abb6n5 = ((8.0_ki)*(t18-t17))
      t17 = t1*spak2k5
      t18 = t25*t17/t3*spbk4k1
      t19 = t11*spak2k5
      t20 = t25*t19/t2*spbk4k1
      abb6n6 = ((8.0_ki)*(t18-t20))
      t18 = t20-t18
      abb6n7 = ((4.0_ki)*t18)
      abb6n8 = ((8.0_ki)*t18)
      t18 = t1*spak1k5
      t20 = TR*spbk6k1
      t20 = t20*t20
      t21 = t11*spak1k5
      abb6n9 = ((4.0_ki)*(t18*t20/t3*spak2k6-t20/t2*t21*spak2k6))
      abb6n10 = ((4.0_ki)*(t25*t18/t3*spbk6k1-t25*t21/t2*spbk6k1))
      abb6n11 = ((8.0_ki)*(t25*t13/t2*spak5k6*spbk6k1*spbk6k4+t25*t18/t3*spak2k3&
      &*spbk4k1*spbk6k1-(t25/t3*t5*spak5k6*spbk6k1*spbk6k4+t25*t21/t2*spak2k3*sp&
      &bk4k1*spbk6k1)))
      t18 = t25*t17/t3*spbk6k1
      t20 = t25*t19/t2*spbk6k1
      abb6n12 = ((8.0_ki)*(t18-t20))
      abb6n13 = ((4.0_ki)*(t20-t18))
      t18 = t1*spak2k6
      t20 = t18*spak3k5
      t21 = t25*t20/t3*spbk6k1*spbk6k4
      t22 = t11*spak2k6
      t23 = t22*spak3k5
      t24 = t25*t23/t2*spbk6k1*spbk6k4
      abb6n14 = ((8.0_ki)*(t21-t24))
      abb6n15 = ((8.0_ki)*(t21+t25*t16/t2*spbk6k4-(t25/t3*t9*spbk6k4+t24)))
      abb6n16 = ((4.0_ki)*(t21+t25*t15/t2*spbk4k1*spbk6k2+t25*t19/t2*spak3k5*spb&
      &k5k1*spbk6k4+t25*t19/t2*spak3k6*spbk6k1*spbk6k4-(t25*t17/t3*spak3k6*spbk6&
      &k1*spbk6k4+t25*t17/t3*spak3k5*spbk5k1*spbk6k4+t25/t3*t7*spbk4k1*spbk6k2+t&
      &24)))
      abb6n17 = ((8.0_ki)*(t24-t21))
      abb6n18 = ((8.0_ki)*(t25*t10/t2*spbk4k1-t25/t3*t4*spbk4k1)+(4.0_ki)*(t25*t&
      &14/t2*spbk4k1+t25/t3*t6*spbk4k1+t25*t23/t2*spbk5k1*spbk6k4+t25*t22/t2*spa&
      &k3k6*spbk6k1*spbk6k4+t25/t3*t5*spak2k6*spbk2k1*spbk6k4-(t25*t18/t3*spak3k&
      &6*spbk6k1*spbk6k4+t25*t13/t2*spak2k6*spbk2k1*spbk6k4+t25*t20/t3*spbk5k1*s&
      &pbk6k4+t25/t3*t8*spbk4k1+t25*t12/t2*spbk4k1)))
      abb6n19 = ((8.0_ki)*(t25*t22/t2*spbk6k1-t25*t18/t3*spbk6k1))
      t7 = t1*spak3k5
      t9 = t25/t3*t7*spbk6k1
      t15 = t11*spak3k5
      t16 = t25*t15/t2*spbk6k1
      t21 = t9-t16
      abb6n20 = ((8.0_ki)*t21)
      abb6n21 = ((4.0_ki)*t21)
      abb6n22 = ((8.0_ki)*(t16-t9))
      abb6n23 = ((4.0_ki)*(t25*t1/t3*spak5k6*spbk6k1-t25*t11/t2*spak5k6*spbk6k1)&
      &)
      abb6n24 = ((4.0_ki)*(t25*t13/t2*spbk4k2-t25/t3*t5*spbk4k2))
      abb6n25 = ((4.0_ki)*(t25/t3*t5*spbk5k4-t25*t13/t2*spbk5k4))
      t5 = t25/t3*t5*spbk6k4
      t9 = t25*t13/t2*spbk6k4
      abb6n26 = ((8.0_ki)*(t5-t9))
      abb6n27 = ((8.0_ki)*(t9-t5))
      t5 = t1*spak1k3
      t9 = t11*spak1k3
      abb6n28 = ((4.0_ki)*(t25*t10/t2*spbk6k4+t25*t14/t2*spbk6k4+t25/t3*t6*spbk6&
      &k4+t25*t23/t2*spbk6k4*spbk6k5+t25/t2*t9*spak2k6*spbk6k1*spbk6k4-(t25/t3*t&
      &5*spak2k6*spbk6k1*spbk6k4+t25*t20/t3*spbk6k4*spbk6k5+t25/t3*t8*spbk6k4+t2&
      &5/t3*t4*spbk6k4+t25*t12/t2*spbk6k4)))
      abb6n29 = ((4.0_ki)*(t25*t19/t2*spbk5k4+t25*t22/t2*spbk6k4+t25*t1/t3*spak1&
      &k2*spbk4k1-(t25*t11/t2*spak1k2*spbk4k1+t25*t18/t3*spbk6k4+t25*t17/t3*spbk&
      &5k4)))
      abb6n30 = ((4.0_ki)*(t25*t15/t2*spbk6k5+t25/t2*t9*spbk6k1-(t25/t3*t7*spbk6&
      &k5+t25/t3*t5*spbk6k1)))
      abb6n31 = ((4.0_ki)*(t25*t11/t2-t25*t1/t3))
      rat2d6 = 0
      rat2 = rat2 + rat2d6
      abb6n33 = abb6n1
      abb6n34 = abb6n30
      abb6n35 = abb6n29
      abb6n36 = abb6n27
      abb6n37 = abb6n26
      abb6n38 = abb6n25
      abb6n39 = abb6n24
      abb6n40 = abb6n23
      abb6n41 = abb6n22
      abb6n42 = abb6n20
      abb6n43 = abb6n19
      abb6n44 = abb6n16
      abb6n45 = abb6n12
      abb6n46 = abb6n10
      abb6n47 = abb6n8
      abb6n48 = abb6n6
      abb6n49 = abb6n5
      abb6n50 = abb6n4
      abb6n51 = abb6n3
      abb6n52 = -(abb6n2)
      abb6n53 = -(abb6n4)
      abb6n54 = -(abb6n7)
      abb6n55 = -(abb6n9)
      abb6n56 = -(abb6n11)
      abb6n57 = -(abb6n13)
      abb6n58 = -(abb6n14)
      abb6n59 = -(abb6n15)
      abb6n60 = -(abb6n17)
      abb6n61 = -(abb6n18)
      abb6n62 = -(abb6n21)
      abb6n63 = -(abb6n28)
      abb6n64 = -(abb6n31)
   end subroutine
end module p0_ddbar_neepdubar_abbrevd6h1
