module     p0_ddbar_neepdubar_d2h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity1/d2h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d2
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd2h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      real(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t34 = dotproduct(qshift, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak1k6(1)*qshift(1)-spvak1k6(2)*qshift(2)-spvak1k6(3)*qshift(3)-sp&
      &vak1k6(4)*qshift(4))
      t35 = dotproduct(k2, qshift)
      t36 = dotproduct(k5, qshift)
      t37 = dotproduct(k6, qshift)
      t38 = dotproduct(k1, qshift)
      t3 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t5 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t6 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t7 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb2n31+t1*abb2n47+t2*abb2n48+t3*abb2n58+t34*abb2n42+t35*a&
         &bb2n53+t36*abb2n54+t37*abb2n55+t38*abb2n57+t4*abb2n63+t1*t3*abb2n43+t1&
         &*t34*abb2n59+t1*t36*abb2n40+t1*t37*abb2n41+t1*t38*abb2n41+t1*t4*abb2n3&
         &4+t2*t4*abb2n46+t3*t34*abb2n49+t3*t35*abb2n46+t3*t4*abb2n38+t34*t4*abb&
         &2n61+t34*t6*abb2n51+t35*t4*abb2n36+t36*t4*abb2n35+t36*t6*abb2n44+t37*t&
         &6*abb2n44+t38*t4*abb2n37+t38*t6*abb2n45+t4*t5*abb2n32+t4*t6*abb2n33+t4&
         &*t7*abb2n39+t1*t4*t7*abb2n64)
         return
      end if
      t8 = k1(iv1)
      t9 = k2(iv1)
      t10 = k5(iv1)
      t11 = k6(iv1)
      t12 = qshift(iv1)
      t13 = spvak1k6(iv1)
      t14 = spvak3k4(iv1)
      t15 = spvak5k1(iv1)
      t16 = spvak5k6(iv1)
      t17 = spvak2k4(iv1)
      t18 = spvak2k6(iv1)
      t19 = t14*abb2n41
      t20 = spvak3k6(iv1)
      t21 = t20*abb2n44
      if(deg.eq.1) then
         numerator = (t10*abb2n54+t11*abb2n55+t12*abb2n56+t13*abb2n48+t14*abb2n4&
         &7+t15*abb2n63+t16*abb2n58+t19*t37+t19*t38+t21*t36+t21*t37+t8*abb2n57+t&
         &9*abb2n53+t1*t10*abb2n40+t1*t11*abb2n41+t1*t12*abb2n60+t1*t15*abb2n34+&
         &t1*t16*abb2n43+t1*t8*abb2n41+t10*t4*abb2n35+t10*t6*abb2n44+t11*t6*abb2&
         &n44+t12*t3*abb2n50+t12*t4*abb2n62+t12*t6*abb2n52+t13*t4*abb2n46+t14*t3&
         &*abb2n43+t14*t34*abb2n59+t14*t36*abb2n40+t14*t4*abb2n34+t15*t2*abb2n46&
         &+t15*t3*abb2n38+t15*t34*abb2n61+t15*t35*abb2n36+t15*t36*abb2n35+t15*t3&
         &8*abb2n37+t15*t5*abb2n32+t15*t6*abb2n33+t15*t7*abb2n39+t16*t34*abb2n49&
         &+t16*t35*abb2n46+t16*t4*abb2n38+t17*t4*abb2n32+t18*t4*abb2n39+t20*t34*&
         &abb2n51+t20*t38*abb2n45+t20*t4*abb2n33+t3*t9*abb2n46+t4*t8*abb2n37+t4*&
         &t9*abb2n36+t6*t8*abb2n45+t1*t15*t7*abb2n64+t1*t18*t4*abb2n64+t14*t4*t7&
         &*abb2n64)
         return
      end if
      t34 = d(iv1,iv2)
      t2 = spvak3k4(iv2)
      t5 = spvak3k6(iv2)
      t19 = spvak5k1(iv2)
      t21 = k1(iv2)
      t22 = spvak5k6(iv2)
      t23 = k2(iv2)
      t24 = k5(iv2)
      t25 = k6(iv2)
      t26 = qshift(iv2)
      t27 = t18*t19
      t28 = spvak2k6(iv2)
      t29 = t15*t28
      t30 = t14*t19
      t31 = t15*t2
      t32 = t18*t2
      t33 = t14*t28
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t34*abb2n42+t1*t34*abb2n59+t3*t34*abb2n49+t34*t4&
         &*abb2n61+t34*t6*abb2n51)+t27*abb2n39+t29*abb2n39+t30*abb2n34+t31*abb2n&
         &34+spvak1k6(iv2)*t15*abb2n46+spvak2k4(iv2)*t15*abb2n32+t1*t27*abb2n64+&
         &t1*t29*abb2n64+t10*t19*abb2n35+t10*t2*abb2n40+t10*t5*abb2n44+t11*t2*ab&
         &b2n41+t11*t5*abb2n44+t12*t19*abb2n62+t12*t2*abb2n60+t12*t22*abb2n50+t1&
         &2*t5*abb2n52+t13*t19*abb2n46+t14*t21*abb2n41+t14*t22*abb2n43+t14*t24*a&
         &bb2n40+t14*t25*abb2n41+t14*t26*abb2n60+t15*t21*abb2n37+t15*t22*abb2n38&
         &+t15*t23*abb2n36+t15*t24*abb2n35+t15*t26*abb2n62+t15*t5*abb2n33+t16*t1&
         &9*abb2n38+t16*t2*abb2n43+t16*t23*abb2n46+t16*t26*abb2n50+t17*t19*abb2n&
         &32+t19*t20*abb2n33+t19*t8*abb2n37+t19*t9*abb2n36+t2*t8*abb2n41+t20*t21&
         &*abb2n45+t20*t24*abb2n44+t20*t25*abb2n44+t20*t26*abb2n52+t22*t9*abb2n4&
         &6+t30*t7*abb2n64+t31*t7*abb2n64+t32*t4*abb2n64+t33*t4*abb2n64+t5*t8*ab&
         &b2n45)
         return
      end if
      t35 = d(iv2,iv3)
      t36 = d(iv1,iv3)
      t1 = spvak3k4(iv3)
      t3 = spvak5k1(iv3)
      t4 = spvak2k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k6(iv3)*t34*abb2n51+spvak5k6(iv3)*t34*abb2&
         &n49+t1*t34*abb2n59+t14*t35*abb2n59+t15*t35*abb2n61+t16*t35*abb2n49+t19&
         &*t36*abb2n61+t2*t36*abb2n59+t20*t35*abb2n51+t22*t36*abb2n49+t3*t34*abb&
         &2n61+t36*t5*abb2n51)+t3*t32*abb2n64+t3*t33*abb2n64+t1*t15*t28*abb2n64+&
         &t1*t18*t19*abb2n64+t14*t19*t4*abb2n64+t15*t2*t4*abb2n64)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d2:
   subroutine     reconstruct_d2(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_2:
      coeffs%coeffs_2%c0 = derivative(czip)
      coeffs%coeffs_2%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_2%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_2%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_2%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_2%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_2%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_2%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_2%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_2%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_2%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_2%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_2%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_2%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_2%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_2%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_2%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_2%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_2%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_2%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_2%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_2%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_2%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_2%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_2%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_2%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_2%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_2%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_2%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_2%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_2%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_2%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_2%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_2%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_2%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_2:
   end subroutine reconstruct_d2
!---#] subroutine reconstruct_d2:
end module p0_ddbar_neepdubar_d2h1l1d
