module     p0_ddbar_neepdubar_d3h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p0_ddbar_neepdubar/helicity1/d3h1l1d.f90
   ! generator: haggies (1.1)
   use p0_ddbar_neepdubar_config, only: ki
   use p0_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d3
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_ddbar_neepdubar_globalsl1, only: epspow
      use p0_ddbar_neepdubar_kinematics
      use p0_ddbar_neepdubar_abbrevd3h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t35 = dotproduct(qshift, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t3 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t36 = dotproduct(k1, qshift)
      t37 = dotproduct(k2, qshift)
      t38 = dotproduct(k5, qshift)
      t4 = (spvak3k6(1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-sp&
      &vak3k6(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t6 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t7 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t8 = (spvak1k6(1)*qshift(1)-spvak1k6(2)*qshift(2)-spvak1k6(3)*qshift(3)-sp&
      &vak1k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb3n30+t1*abb3n48+t2*abb3n49+t3*abb3n54+t35*abb3n40+t36*a&
         &bb3n55+t37*abb3n55+t38*abb3n56+t4*abb3n58+t5*abb3n59+t1*t3*abb3n41+t1*&
         &t38*abb3n39+t1*t6*abb3n34+t2*t35*abb3n52+t2*t36*abb3n44+t2*t37*abb3n44&
         &+t2*t38*abb3n42+t2*t5*abb3n35+t3*t5*abb3n33+t35*t4*abb3n50+t35*t5*abb3&
         &n62+t35*t6*abb3n60+t36*t4*abb3n45+t36*t6*abb3n36+t37*t4*abb3n45+t37*t6&
         &*abb3n36+t38*t4*abb3n46+t38*t5*abb3n32+t38*t6*abb3n38+t4*t5*abb3n31+t5&
         &*t6*abb3n47+t5*t7*abb3n37+t5*t8*abb3n43+t1*t3*t5*abb3n64)
         return
      end if
      t9 = k1(iv1)
      t10 = k2(iv1)
      t11 = k5(iv1)
      t12 = qshift(iv1)
      t13 = spvak2k1(iv1)
      t14 = spvak2k6(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak3k6(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak1k6(iv1)
      t19 = t14*abb3n44
      t20 = t16*abb3n45
      t21 = spvak5k1(iv1)
      t22 = t21*abb3n36
      t23 = spvak5k2(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb3n55+t11*abb3n56+t12*abb3n57+t13*abb3n59+t14*abb3n4&
         &9+t15*abb3n48+t16*abb3n58+t17*abb3n54+t19*t36+t19*t37+t20*t36+t20*t37+&
         &t22*t36+t22*t37+t9*abb3n55+t1*t11*abb3n39+t1*t17*abb3n41+t1*t21*abb3n3&
         &4+t10*t2*abb3n44+t10*t4*abb3n45+t10*t6*abb3n36+t11*t2*abb3n42+t11*t4*a&
         &bb3n46+t11*t5*abb3n32+t11*t6*abb3n38+t12*t2*abb3n53+t12*t4*abb3n51+t12&
         &*t5*abb3n63+t12*t6*abb3n61+t13*t2*abb3n35+t13*t3*abb3n33+t13*t35*abb3n&
         &62+t13*t38*abb3n32+t13*t4*abb3n31+t13*t6*abb3n47+t13*t7*abb3n37+t13*t8&
         &*abb3n43+t14*t35*abb3n52+t14*t38*abb3n42+t14*t5*abb3n35+t15*t3*abb3n41&
         &+t15*t38*abb3n39+t15*t6*abb3n34+t16*t35*abb3n50+t16*t38*abb3n46+t16*t5&
         &*abb3n31+t17*t5*abb3n33+t18*t5*abb3n43+t2*t9*abb3n44+t21*t35*abb3n60+t&
         &21*t38*abb3n38+t21*t5*abb3n47+t23*t5*abb3n37+t4*t9*abb3n45+t6*t9*abb3n&
         &36+t1*t13*t3*abb3n64+t1*t17*t5*abb3n64+t15*t3*t5*abb3n64)
         return
      end if
      t35 = d(iv1,iv2)
      t7 = spvak2k6(iv2)
      t8 = spvak3k6(iv2)
      t19 = spvak5k1(iv2)
      t20 = k1(iv2)
      t22 = k2(iv2)
      t24 = spvak2k1(iv2)
      t25 = spvak3k4(iv2)
      t26 = k5(iv2)
      t27 = qshift(iv2)
      t28 = spvak5k6(iv2)
      t29 = t13*t28
      t30 = t17*t24
      t31 = t15*t28
      t32 = t17*t25
      t33 = t13*t25
      t34 = t15*t24
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t35*abb3n40+t2*t35*abb3n52+t35*t4*abb3n50+t35*t5&
         &*abb3n62+t35*t6*abb3n60)+t29*abb3n33+t30*abb3n33+t31*abb3n41+t32*abb3n&
         &41+spvak1k6(iv2)*t13*abb3n43+spvak5k2(iv2)*t13*abb3n37+t1*t29*abb3n64+&
         &t1*t30*abb3n64+t10*t19*abb3n36+t10*t7*abb3n44+t10*t8*abb3n45+t11*t19*a&
         &bb3n38+t11*t24*abb3n32+t11*t25*abb3n39+t11*t7*abb3n42+t11*t8*abb3n46+t&
         &12*t19*abb3n61+t12*t24*abb3n63+t12*t7*abb3n53+t12*t8*abb3n51+t13*t19*a&
         &bb3n47+t13*t26*abb3n32+t13*t27*abb3n63+t13*t7*abb3n35+t13*t8*abb3n31+t&
         &14*t20*abb3n44+t14*t22*abb3n44+t14*t24*abb3n35+t14*t26*abb3n42+t14*t27&
         &*abb3n53+t15*t19*abb3n34+t15*t26*abb3n39+t16*t20*abb3n45+t16*t22*abb3n&
         &45+t16*t24*abb3n31+t16*t26*abb3n46+t16*t27*abb3n51+t18*t24*abb3n43+t19&
         &*t9*abb3n36+t20*t21*abb3n36+t21*t22*abb3n36+t21*t24*abb3n47+t21*t25*ab&
         &b3n34+t21*t26*abb3n38+t21*t27*abb3n61+t23*t24*abb3n37+t3*t33*abb3n64+t&
         &3*t34*abb3n64+t31*t5*abb3n64+t32*t5*abb3n64+t7*t9*abb3n44+t8*t9*abb3n4&
         &5)
         return
      end if
      t36 = d(iv2,iv3)
      t37 = d(iv1,iv3)
      t1 = spvak2k1(iv3)
      t2 = spvak5k6(iv3)
      t3 = spvak3k4(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k6(iv3)*t35*abb3n52+spvak3k6(iv3)*t35*abb3&
         &n50+spvak5k1(iv3)*t35*abb3n60+t1*t35*abb3n62+t13*t36*abb3n62+t14*t36*a&
         &bb3n52+t16*t36*abb3n50+t19*t37*abb3n60+t21*t36*abb3n60+t24*t37*abb3n62&
         &+t37*t7*abb3n52+t37*t8*abb3n50)+t2*t33*abb3n64+t2*t34*abb3n64+t1*t15*t&
         &28*abb3n64+t1*t17*t25*abb3n64+t13*t28*t3*abb3n64+t17*t24*t3*abb3n64)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d3:
   subroutine     reconstruct_d3(coeffs)
      use p0_ddbar_neepdubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_3:
      coeffs%coeffs_3%c0 = derivative(czip)
      coeffs%coeffs_3%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_3%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_3%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_3%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_3%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_3%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_3%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_3%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_3%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_3%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_3%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_3%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_3%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_3%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_3%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_3%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_3%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_3%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_3%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_3%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_3%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_3%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_3%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_3%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_3%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_3%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_3%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_3%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_3%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_3%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_3:
   end subroutine reconstruct_d3
!---#] subroutine reconstruct_d3:
end module p0_ddbar_neepdubar_d3h1l1d
