module     p1_ddbar_neepscbar_abbrevd27h0
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb27n1
   complex(ki), public :: abb27n2
   complex(ki), public :: abb27n3
   complex(ki), public :: abb27n4
   complex(ki), public :: abb27n5
   complex(ki), public :: abb27n6
   complex(ki), public :: abb27n7
   complex(ki), public :: abb27n8
   complex(ki), public :: abb27n9
   complex(ki), public :: rat2d27
   complex(ki), public :: abb27n11
   complex(ki), public :: abb27n12
   complex(ki), public :: abb27n13
   complex(ki), public :: abb27n14
   complex(ki), public :: abb27n15
   complex(ki), public :: abb27n16
   complex(ki), public :: abb27n17
   complex(ki), public :: abb27n18
   complex(ki), public :: abb27n19
   complex(ki), public :: abb27n20
   complex(ki), public :: abb27n21
   complex(ki), public :: abb27n22
   complex(ki), public :: abb27n23
   complex(ki), public :: abb27n24
   complex(ki), public :: abb27n25
   complex(ki), public :: abb27n26
   complex(ki), public :: abb27n27
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   real(ki) :: t43
   real(ki) :: t44
   real(ki) :: t45
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak1k3*spak3k5
      t4 = t3*spbk4k3
      t43 = TR*TR
      t5 = t43*t4*spbk6k2
      t44 = es345*es345
      t6 = t44*t1
      t7 = t2*spak1k5*spak3k5
      t8 = t7*spbk5k4
      t9 = t43*t8*spbk6k2
      t45 = NC*es345
      t45 = t45*t45
      t10 = t45*t1
      t11 = c2*i_
      t12 = t11*spak1k3*spak3k5
      t13 = t12*spbk4k3
      t14 = t43*t13*spbk6k2
      t15 = NC*t1
      t16 = t44*t15
      t17 = t11*spak1k5*spak3k5
      t18 = t17*spbk5k4
      t19 = t43*t18*spbk6k2
      t20 = NC*c2
      t21 = t20*i_
      t22 = t21*spak1k3*spak3k5
      t23 = t22*spbk4k3
      t24 = t43*t23*spbk6k2
      t25 = t21*spak1k5*spak3k5
      t26 = t25*spbk5k4
      t27 = t43*t26*spbk6k2
      t28 = es61*c1*i_
      t29 = t43*t28*spak1k3*spak3k5*spbk4k3*spbk6k2
      t1 = es12*t1
      t30 = t44*t1
      t28 = t43*t28*spak1k5*spak3k5*spbk5k4*spbk6k2
      t31 = t2*spak1k2*spak3k5
      t32 = TR*spbk6k2
      t32 = t32*t32
      t33 = t31*t32*spak3k6*spbk4k3
      t34 = t31*t32*spak5k6*spbk5k4
      t35 = t2*spak1k6
      t36 = t32*t35*spak2k3*spak3k5*spbk4k3
      t37 = t32*t35*spak2k5*spak3k5*spbk5k4
      t1 = t45*t1
      t38 = es61*c2*i_
      t15 = es12*t44*t15
      t39 = t11*spak1k2*spak3k5
      t40 = t11*spak1k6
      t20 = es61*t20*i_
      t41 = t21*spak1k2*spak3k5
      t42 = t21*spak1k6
      abb27n1 = ((4.0_ki)*(t29/t1+t34/t1+t37/t1+t5/t10+t19/t16+t24/t6+t28/t30+t3&
      &3/t30+t36/t30+t9/t6+t32/t15*t39*spak3k6*spbk4k3+t32/t30*t41*spak5k6*spbk5&
      &k4+t32/t15*t40*spak2k3*spak3k5*spbk4k3+t32/t30*t42*spak2k5*spak3k5*spbk5k&
      &4+t43*t38/t15*spak1k5*spak3k5*spbk5k4*spbk6k2+t43*t20/t30*spak1k3*spak3k5&
      &*spbk4k3*spbk6k2-(t43*t20/t30*spak1k5*spak3k5*spbk5k4*spbk6k2+t43*t38/t15&
      &*spak1k3*spak3k5*spbk4k3*spbk6k2+t32/t30*t42*spak2k3*spak3k5*spbk4k3+t32/&
      &t15*t40*spak2k5*spak3k5*spbk5k4+t32/t30*t41*spak3k6*spbk4k3+t32/t15*t39*s&
      &pak5k6*spbk5k4+t5/t6+t37/t30+t34/t30+t29/t30+t27/t6+t14/t16+t9/t10+t36/t1&
      &+t33/t1+t28/t1)))
      t6 = t43*t31*spbk4k3*spbk6k2
      abb27n2 = ((4.0_ki)*(t6/t1+t43*t41/t30*spbk4k3*spbk6k2-(t43*t39/t15*spbk4k&
      &3*spbk6k2+t6/t30)))
      t6 = t43*t31*spbk5k4*spbk6k2
      abb27n3 = ((4.0_ki)*(t6/t30+t43*t39/t15*spbk5k4*spbk6k2-(t43*t41/t30*spbk5&
      &k4*spbk6k2+t6/t1)))
      t6 = t5/t30
      t10 = t9/t30
      t5 = t5/t1
      t9 = t9/t1
      t14 = t14/t15
      t16 = t19/t15
      t19 = t24/t30
      t20 = t27/t30
      abb27n4 = ((16.0_ki)*(t14+t20+t6+t9-(t5+t19+t16+t10)))
      abb27n5 = ((16.0_ki)*(t10+t16+t19+t5-(t9+t6+t20+t14)))
      t5 = t35*spak3k5
      t6 = t43*t5*spbk4k3*spbk6k2
      t9 = t40*spak3k5
      t10 = t42*spak3k5
      abb27n6 = ((4.0_ki)*(t6/t30+t43/t15*t9*spbk4k3*spbk6k2-(t43*t10/t30*spbk4k&
      &3*spbk6k2+t6/t1)))
      t5 = t43*t5*spbk5k4*spbk6k2
      abb27n7 = ((4.0_ki)*(t5/t1+t43*t10/t30*spbk5k4*spbk6k2-(t43/t15*t9*spbk5k4&
      &*spbk6k2+t5/t30)))
      t4 = t43*t4*spbk6k1
      t5 = t43*t8*spbk6k1
      t6 = t43*t2*spak2k3*spak3k5*spbk4k3*spbk6k2
      t8 = t43*t2*spak2k5*spak3k5*spbk5k4*spbk6k2
      abb27n8 = ((8.0_ki)*(t4/t1+t6/t1+t5/t30+t8/t30+t43*t18/t15*spbk6k1+t43*t23&
      &/t30*spbk6k1+t43*t11/t15*spak2k5*spak3k5*spbk5k4*spbk6k2+t43*t21/t30*spak&
      &2k3*spak3k5*spbk4k3*spbk6k2-(t43*t21/t30*spak2k5*spak3k5*spbk5k4*spbk6k2+&
      &t43*t11/t15*spak2k3*spak3k5*spbk4k3*spbk6k2+t43*t26/t30*spbk6k1+t43*t13/t&
      &15*spbk6k1+t6/t30+t4/t30+t8/t1+t5/t1)))
      t3 = t43*t3*spbk2k1*spbk4k3
      t4 = t43*t7*spbk2k1*spbk5k4
      t2 = t2*spak3k5
      t5 = t43*t2*spak3k6*spbk4k3*spbk6k2
      t2 = t43*t2*spak5k6*spbk5k4*spbk6k2
      t6 = t11*spak3k5
      t7 = t21*spak3k5
      abb27n9 = ((8.0_ki)*(t4/t1+t5/t1+t2/t30+t3/t30+t43*t12/t15*spbk2k1*spbk4k3&
      &+t43*t25/t30*spbk2k1*spbk5k4+t43/t15*t6*spak5k6*spbk5k4*spbk6k2+t43/t30*t&
      &7*spak3k6*spbk4k3*spbk6k2-(t43/t30*t7*spak5k6*spbk5k4*spbk6k2+t43/t15*t6*&
      &spak3k6*spbk4k3*spbk6k2+t43*t22/t30*spbk2k1*spbk4k3+t43*t17/t15*spbk2k1*s&
      &pbk5k4+t5/t30+t4/t30+t3/t1+t2/t1)))
      rat2d27 = 0
      rat2 = rat2 + rat2d27
      abb27n11 = abb27n1
      abb27n12 = abb27n9
      abb27n13 = abb27n8
      abb27n14 = abb27n7
      abb27n15 = abb27n6
      abb27n16 = abb27n5
      abb27n17 = abb27n4
      abb27n18 = abb27n3
      abb27n19 = abb27n2
      abb27n20 = -(abb27n2)
      abb27n21 = -(abb27n3)
      abb27n22 = -(abb27n4)
      abb27n23 = -(abb27n5)
      abb27n24 = -(abb27n6)
      abb27n25 = -(abb27n7)
      abb27n26 = -(abb27n8)
      abb27n27 = -(abb27n9)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd27h0
