module     p1_ddbar_neepscbar_abbrevd28h0
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb28n1
   complex(ki), public :: abb28n2
   complex(ki), public :: abb28n3
   complex(ki), public :: abb28n4
   complex(ki), public :: abb28n5
   complex(ki), public :: abb28n6
   complex(ki), public :: abb28n7
   complex(ki), public :: abb28n8
   complex(ki), public :: abb28n9
   complex(ki), public :: abb28n10
   complex(ki), public :: abb28n11
   complex(ki), public :: abb28n12
   complex(ki), public :: abb28n13
   complex(ki), public :: abb28n14
   complex(ki), public :: abb28n15
   complex(ki), public :: abb28n16
   complex(ki), public :: abb28n17
   complex(ki), public :: abb28n18
   complex(ki), public :: abb28n19
   complex(ki), public :: abb28n20
   complex(ki), public :: abb28n21
   complex(ki), public :: abb28n22
   complex(ki), public :: abb28n23
   complex(ki), public :: abb28n24
   complex(ki), public :: abb28n25
   complex(ki), public :: abb28n26
   complex(ki), public :: abb28n27
   complex(ki), public :: abb28n28
   complex(ki), public :: rat2d28
   complex(ki), public :: abb28n30
   complex(ki), public :: abb28n31
   complex(ki), public :: abb28n32
   complex(ki), public :: abb28n33
   complex(ki), public :: abb28n34
   complex(ki), public :: abb28n35
   complex(ki), public :: abb28n36
   complex(ki), public :: abb28n37
   complex(ki), public :: abb28n38
   complex(ki), public :: abb28n39
   complex(ki), public :: abb28n40
   complex(ki), public :: abb28n41
   complex(ki), public :: abb28n42
   complex(ki), public :: abb28n43
   complex(ki), public :: abb28n44
   complex(ki), public :: abb28n45
   complex(ki), public :: abb28n46
   complex(ki), public :: abb28n47
   complex(ki), public :: abb28n48
   complex(ki), public :: abb28n49
   complex(ki), public :: abb28n50
   complex(ki), public :: abb28n51
   complex(ki), public :: abb28n52
   complex(ki), public :: abb28n53
   complex(ki), public :: abb28n54
   complex(ki), public :: abb28n55
   complex(ki), public :: abb28n56
   complex(ki), public :: abb28n57
   complex(ki), public :: abb28n58
   complex(ki), public :: abb28n59
   complex(ki), public :: abb28n60
   complex(ki), public :: abb28n61
   complex(ki), public :: abb28n62
   complex(ki), public :: abb28n63
   complex(ki), public :: abb28n64
   complex(ki), public :: abb28n65
   complex(ki), public :: abb28n66
   complex(ki), public :: abb28n67
   complex(ki), public :: abb28n68
   complex(ki), public :: abb28n69
   complex(ki), public :: abb28n70
   complex(ki), public :: abb28n71
   complex(ki), public :: abb28n72
   complex(ki), public :: abb28n73
   complex(ki), public :: abb28n74
   complex(ki), public :: abb28n75
   complex(ki), public :: abb28n76
   complex(ki), public :: abb28n77
   complex(ki), public :: abb28n78
   complex(ki), public :: abb28n79
   complex(ki), public :: abb28n80
   complex(ki), public :: abb28n81
   complex(ki), public :: abb28n82
   complex(ki), public :: abb28n83
   complex(ki), public :: abb28n84
   complex(ki), public :: abb28n85
   complex(ki), public :: abb28n86
   complex(ki), public :: abb28n87
   complex(ki), public :: abb28n88
   complex(ki), public :: abb28n89
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   real(ki) :: t16
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak1k2
      t16 = TR*TR
      t4 = NC*t1
      t5 = t2*spak1k3
      t6 = c1*i_
      t7 = t6*spak1k2
      t8 = NC*NC*t1
      t9 = t6*spak1k3
      t10 = NC*c2*i_
      t11 = t10*spak1k2
      t12 = t10*spak1k3
      abb28n1 = ((8.0_ki)*(t16*t3/t4*spak1k3*spbk4k2*spbk6k2+t16/t4*t5*spak1k6*s&
      &pbk6k2*spbk6k4)+(4.0_ki)*(-(t16/t8*t9*spak1k6*spbk6k2*spbk6k4+t16*t7/t8*s&
      &pak1k3*spbk4k2*spbk6k2+t16*t12/t1*spak1k6*spbk6k2*spbk6k4+t16*t11/t1*spak&
      &1k3*spbk4k2*spbk6k2)))
      abb28n2 = ((4.0_ki)*(t16*t11/t1*spbk6k2+t16*t7/t8*spbk6k2-(2.0_ki)*t16*t3/&
      &t4*spbk6k2))
      t13 = t16/t8*t9*spbk4k2
      t14 = (2.0_ki)*t16/t4*t5*spbk4k2
      t15 = t16*t12/t1*spbk4k2
      abb28n3 = ((4.0_ki)*(t13+t15-t14))
      abb28n4 = ((8.0_ki)*(t14-(t15+t13)))
      abb28n5 = ((16.0_ki)*(t16/t4*t5*spak2k5*spbk4k2*spbk6k2-t16/t4*t5*spak5k6*&
      &spbk6k2*spbk6k4)+(8.0_ki)*(t16*t12/t1*spak5k6*spbk6k2*spbk6k4+t16/t8*t9*s&
      &pak5k6*spbk6k2*spbk6k4-(t16/t8*t9*spak2k5*spbk4k2*spbk6k2+t16*t12/t1*spak&
      &2k5*spbk4k2*spbk6k2)))
      t13 = t16/t8*t9*spbk6k2
      t14 = (2.0_ki)*t16/t4*t5*spbk6k2
      t15 = t16*t12/t1*spbk6k2
      abb28n6 = ((8.0_ki)*(t13+t15-t14))
      t13 = t14-(t15+t13)
      abb28n7 = ((4.0_ki)*t13)
      abb28n8 = ((8.0_ki)*t13)
      t9 = t16/t8*t9*spbk6k4
      t5 = (2.0_ki)*t16/t4*t5*spbk6k4
      t12 = t16*t12/t1*spbk6k4
      abb28n9 = ((4.0_ki)*(t12+t9-t5))
      abb28n10 = ((8.0_ki)*(t5-(t9+t12)))
      t5 = t2*spak1k6
      t9 = t6*spak1k6
      t12 = t10*spak1k6
      abb28n11 = ((16.0_ki)*(t16*t3/t4*spak3k5*spbk4k2*spbk6k2+t16/t4*t5*spak3k5&
      &*spbk6k2*spbk6k4)+(8.0_ki)*(-(t16/t8*t9*spak3k5*spbk6k2*spbk6k4+t16*t7/t8&
      &*spak3k5*spbk4k2*spbk6k2+t16*t12/t1*spak3k5*spbk6k2*spbk6k4+t16*t11/t1*sp&
      &ak3k5*spbk4k2*spbk6k2)))
      abb28n12 = ((4.0_ki)*((2.0_ki)*t16/t4*t5*spbk6k2-(t16/t8*t9*spbk6k2+t16*t1&
      &2/t1*spbk6k2)))
      t3 = t16*t6/t8*spak2k3*spbk6k2
      t5 = (2.0_ki)*t16*t2/t4*spak2k3*spbk6k2
      t7 = t16*t10/t1*spak2k3*spbk6k2
      abb28n13 = ((4.0_ki)*(t3+t7-t5))
      abb28n14 = ((4.0_ki)*(t5-(t7+t3)))
      t3 = t6*spak3k5
      t5 = t16*t3/t8*spbk4k2
      t7 = t2*spak3k5
      t9 = (2.0_ki)*t16/t4*t7*spbk4k2
      t11 = t10*spak3k5
      t12 = t16*t11/t1*spbk4k2
      abb28n15 = ((8.0_ki)*(t12+t5-t9))
      abb28n16 = ((4.0_ki)*(t9-(t5+t12)))
      t5 = t6*spak2k5
      t9 = t2*spak2k5
      t12 = t10*spak2k5
      abb28n17 = ((4.0_ki)*(t16*t12/t1*spbk6k2+t16*t5/t8*spbk6k2-(2.0_ki)*t16/t4&
      &*t9*spbk6k2))
      abb28n18 = ((8.0_ki)*(t16/t4*t9*spak3k5*spbk4k2*spbk6k2-t16/t4*t7*spak5k6*&
      &spbk6k2*spbk6k4)+(4.0_ki)*(t16*t11/t1*spak5k6*spbk6k2*spbk6k4+t16*t3/t8*s&
      &pak5k6*spbk6k2*spbk6k4-(t16*t5/t8*spak3k5*spbk4k2*spbk6k2+t16*t12/t1*spak&
      &3k5*spbk4k2*spbk6k2)))
      t5 = t16*t3/t8*spbk6k2
      t9 = (2.0_ki)*t16/t4*t7*spbk6k2
      t12 = t16*t11/t1*spbk6k2
      abb28n19 = ((8.0_ki)*(t12+t5-t9))
      t5 = t9-(t5+t12)
      abb28n20 = ((4.0_ki)*t5)
      abb28n21 = ((8.0_ki)*t5)
      t5 = t16*t6/t8*spak3k6*spbk6k2
      t9 = (2.0_ki)*t16*t2/t4*spak3k6*spbk6k2
      t12 = t16*t10/t1*spak3k6*spbk6k2
      abb28n22 = ((4.0_ki)*(t12+t5-t9))
      abb28n23 = ((4.0_ki)*(t9-(t5+t12)))
      abb28n24 = ((4.0_ki)*(t16*t10/t1*spak5k6*spbk6k2+t16*t6/t8*spak5k6*spbk6k2&
      &-(2.0_ki)*t16*t2/t4*spak5k6*spbk6k2))
      t3 = t16*t3/t8*spbk6k4
      t5 = (2.0_ki)*t16/t4*t7*spbk6k4
      t7 = t16*t11/t1*spbk6k4
      abb28n25 = ((8.0_ki)*(t3+t7-t5))
      abb28n26 = ((4.0_ki)*(t5-(t7+t3)))
      t3 = t16*t6/t8
      t2 = (2.0_ki)*t16*t2/t4
      t1 = t16*t10/t1
      abb28n27 = ((8.0_ki)*(t1+t3-t2))
      abb28n28 = ((8.0_ki)*(t2-(t3+t1)))
      rat2d28 = 0
      rat2 = rat2 + rat2d28
      abb28n30 = -(abb28n1)
      abb28n31 = abb28n28
      abb28n32 = abb28n27
      abb28n33 = abb28n26
      abb28n34 = abb28n25
      abb28n35 = abb28n24
      abb28n36 = abb28n23
      abb28n37 = abb28n22
      abb28n38 = abb28n21
      abb28n39 = abb28n20
      abb28n40 = abb28n19
      abb28n41 = abb28n18
      abb28n42 = abb28n17
      abb28n43 = abb28n16
      abb28n44 = abb28n15
      abb28n45 = abb28n14
      abb28n46 = abb28n13
      abb28n47 = abb28n12
      abb28n48 = abb28n11
      abb28n49 = abb28n10
      abb28n50 = abb28n9
      abb28n51 = abb28n8
      abb28n52 = abb28n7
      abb28n53 = abb28n6
      abb28n54 = abb28n5
      abb28n55 = abb28n4
      abb28n56 = abb28n3
      abb28n57 = abb28n2
      abb28n58 = abb28n1
      abb28n59 = -(abb28n2)
      abb28n60 = -(abb28n3)
      abb28n61 = -(abb28n4)
      abb28n62 = -(abb28n5)
      abb28n63 = -(abb28n6)
      t1 = (2.0_ki)*abb28n7
      abb28n64 = t1
      abb28n65 = -(abb28n7)
      abb28n66 = -(t1)
      abb28n67 = -(abb28n8)
      abb28n68 = -(abb28n9)
      abb28n69 = -(abb28n10)
      abb28n70 = -(abb28n11)
      abb28n71 = -(abb28n12)
      abb28n72 = -(abb28n13)
      abb28n73 = -(abb28n14)
      abb28n74 = -(abb28n15)
      abb28n75 = -(abb28n16)
      abb28n76 = -(abb28n17)
      abb28n77 = -(abb28n18)
      abb28n78 = -(abb28n19)
      t1 = (2.0_ki)*abb28n20
      abb28n79 = t1
      abb28n80 = -(abb28n20)
      abb28n81 = -(t1)
      abb28n82 = -(abb28n21)
      abb28n83 = -(abb28n22)
      abb28n84 = -(abb28n23)
      abb28n85 = -(abb28n24)
      abb28n86 = -(abb28n25)
      abb28n87 = -(abb28n26)
      abb28n88 = -(abb28n27)
      abb28n89 = -(abb28n28)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd28h0
