module     p1_ddbar_neepscbar_abbrevd34h1
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb34n1
   complex(ki), public :: abb34n2
   complex(ki), public :: abb34n3
   complex(ki), public :: abb34n4
   complex(ki), public :: abb34n5
   complex(ki), public :: abb34n6
   complex(ki), public :: abb34n7
   complex(ki), public :: abb34n8
   complex(ki), public :: abb34n9
   complex(ki), public :: abb34n10
   complex(ki), public :: abb34n11
   complex(ki), public :: abb34n12
   complex(ki), public :: rat2d34
   complex(ki), public :: abb34n14
   complex(ki), public :: abb34n15
   complex(ki), public :: abb34n16
   complex(ki), public :: abb34n17
   complex(ki), public :: abb34n18
   complex(ki), public :: abb34n19
   complex(ki), public :: abb34n20
   complex(ki), public :: abb34n21
   complex(ki), public :: abb34n22
   complex(ki), public :: abb34n23
   complex(ki), public :: abb34n24
   complex(ki), public :: abb34n25
   complex(ki), public :: abb34n26
   complex(ki), public :: abb34n27
   complex(ki), public :: abb34n28
   complex(ki), public :: abb34n29
   complex(ki), public :: abb34n30
   complex(ki), public :: abb34n31
   complex(ki), public :: abb34n32
   complex(ki), public :: abb34n33
   complex(ki), public :: abb34n34
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   complex(ki) :: t41
   complex(ki) :: t42
   complex(ki) :: t43
   complex(ki) :: t44
   complex(ki) :: t45
   complex(ki) :: t46
   complex(ki) :: t47
   complex(ki) :: t48
   complex(ki) :: t49
   complex(ki) :: t50
   complex(ki) :: t51
   real(ki) :: t52
   real(ki) :: t53
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak2k5
      t4 = t3*spak3k4
      t52 = TR*TR
      t5 = t52*t4*spbk4k1*spbk6k4
      t6 = (es12+es34-(es56+es345))*t1
      t7 = es12*t6
      t8 = t5/t7
      t9 = t3*spak3k6
      t10 = t52*t9*spbk6k1*spbk6k4
      t11 = t10/t7
      t12 = t2*spak2k3*spak3k5*spbk4k3
      t13 = t52*t12*spbk6k1
      t14 = es345*es12*t1
      t15 = t13/t14
      t3 = t3*spak3k5*spbk5k4
      t16 = t52*t3*spbk6k1
      t17 = t16/t14
      t53 = NC*NC
      t18 = t53*t7
      t19 = t5/t18
      t20 = t10/t18
      t21 = c2*i_
      t22 = t21*spak2k5
      t23 = t22*spak3k4
      t24 = t52*t23*spbk4k1*spbk6k4
      t25 = NC*t6
      t26 = es12*t25
      t27 = t24/t26
      t28 = t22*spak3k6
      t29 = t52*t28*spbk6k1*spbk6k4
      t30 = t29/t26
      t31 = NC*c2*i_
      t32 = t31*spak2k5
      t33 = t32*spak3k4
      t34 = t52*t33/t7*spbk4k1*spbk6k4
      t35 = t32*spak3k6
      t36 = t52*t35/t7*spbk6k1*spbk6k4
      t37 = t53*t14
      t38 = t13/t37
      t39 = t16/t37
      t40 = t21*spak2k3*spak3k5*spbk4k3
      t41 = t52*t40*spbk6k1
      t42 = NC*t1
      t43 = es345*es12*t42
      t44 = t41/t43
      t22 = t22*spak3k5*spbk5k4
      t45 = t52*t22*spbk6k1
      t46 = t45/t43
      t47 = t31*spak2k3*spak3k5*spbk4k3
      t48 = t52*t47/t14*spbk6k1
      t32 = t32*spak3k5*spbk5k4
      t49 = t52*t32/t14*spbk6k1
      abb34n1 = ((2.0_ki)*(t17+t19+t20+t34+t36+t38+t46+t48-(t8+t49+t44+t39+t30+t&
      &27+t15+t11)))
      t50 = t2*spak3k5
      t51 = t31*spak3k5
      abb34n2 = ((8.0_ki)*(t52*t50/t7*spbk6k4-t52*t51/t7*spbk6k4))
      abb34n3 = ((4.0_ki)*(t52*t51/t7*spbk6k3+t52*t31/t7*spak4k5*spbk6k4-(t52*t2&
      &/t7*spak4k5*spbk6k4+t52*t50/t7*spbk6k3)))
      abb34n4 = ((4.0_ki)*(t52*t2/t18*spak3k4*spbk6k4-t52*t21/t26*spak3k4*spbk6k&
      &4))
      t6 = t53*t6
      t1 = es345*t53*t1
      t42 = es345*t42
      abb34n5 = ((4.0_ki)*(t13/t1+t10/t6+t45/t42+t5/t6-(t41/t42+t29/t25+t24/t25+&
      &t16/t1)))
      t1 = t2*spak1k2
      t5 = t1*spak3k5
      t6 = t52*t5*spbk4k3*spbk6k1
      t10 = t21*spak1k2
      t13 = t10*spak3k5
      t16 = t31*spak1k2
      t24 = t16*spak3k5
      abb34n6 = ((4.0_ki)*(t6/t14+t52*t13/t43*spbk4k3*spbk6k1-(t52*t24/t14*spbk4&
      &k3*spbk6k1+t6/t37)))
      t6 = t52*t1*spak3k4*spbk4k1*spbk6k4
      t1 = t52*t1*spak3k6*spbk6k1*spbk6k4
      t5 = t52*t5*spbk5k4*spbk6k1
      abb34n7 = ((4.0_ki)*(t1/t7+t5/t37+t6/t7+t52*t24/t14*spbk5k4*spbk6k1+t52*t1&
      &0/t26*spak3k4*spbk4k1*spbk6k4+t52*t10/t26*spak3k6*spbk6k1*spbk6k4-(t52*t1&
      &6/t7*spak3k6*spbk6k1*spbk6k4+t52*t16/t7*spak3k4*spbk4k1*spbk6k4+t52*t13/t&
      &43*spbk5k4*spbk6k1+t6/t18+t5/t14+t1/t18)))
      t1 = t11+t15+t27+t30+t39+t44+t49+t8-(t48+t46+t38+t36+t34+t20+t19+t17)
      abb34n8 = ((8.0_ki)*t1)
      abb34n9 = ((4.0_ki)*t1)
      t1 = t52*t4*spbk4k2*spbk6k4
      t4 = t52*t9*spbk6k2*spbk6k4
      t5 = t52*t12*spbk6k2
      t3 = t52*t3*spbk6k2
      t6 = t2*spak1k5
      t8 = t31*spak1k5
      abb34n10 = ((4.0_ki)*(t1/t18+t4/t18+t5/t37+t52*t22/t43*spbk6k2-(t52*t28/t2&
      &6*spbk6k2*spbk6k4+t52*t23/t26*spbk4k2*spbk6k4+t52*t40/t43*spbk6k2+t3/t37)&
      &)+(2.0_ki)*(t3/t14+t52*t47/t14*spbk6k2+t52*t33/t7*spbk4k2*spbk6k4+t52*t35&
      &/t7*spbk6k2*spbk6k4+t52/t14*t6*spak3k5*spbk5k4*spbk6k1+t52/t7*t8*spak3k4*&
      &spbk4k1*spbk6k4+t52/t7*t8*spak3k6*spbk6k1*spbk6k4+t52*t31/t14*spak1k3*spa&
      &k3k5*spbk4k3*spbk6k1-(t52*t2/t14*spak1k3*spak3k5*spbk4k3*spbk6k1+t52*t6/t&
      &7*spak3k6*spbk6k1*spbk6k4+t52*t6/t7*spak3k4*spbk4k1*spbk6k4+t52/t14*t8*sp&
      &ak3k5*spbk5k4*spbk6k1+t52*t32/t14*spbk6k2+t4/t7+t5/t14+t1/t7)))
      t1 = t52*t50*spbk4k3
      t3 = t52*t51*spbk4k3
      t4 = t21*spak3k5
      abb34n11 = ((4.0_ki)*(t1/t14+t1/t37+t1/t7+t52*t2/t7*spak5k6*spbk6k4-(t52*t&
      &31/t7*spak5k6*spbk6k4+t52*t4/t43*spbk4k3+t3/t7+t3/t14)))
      t1 = t52*t50*spbk5k4
      abb34n12 = ((4.0_ki)*(t52*t51/t14*spbk5k4+t52*t4/t43*spbk5k4+t52*t2/t18*sp&
      &ak3k6*spbk6k4-(t52*t21/t26*spak3k6*spbk6k4+t1/t37+t1/t14)))
      rat2d34 = abb34n1
      rat2 = rat2 + rat2d34
      abb34n14 = abb34n5
      abb34n15 = abb34n12
      abb34n16 = abb34n11
      abb34n17 = abb34n10
      abb34n18 = abb34n9
      abb34n19 = abb34n8
      abb34n20 = abb34n7
      abb34n21 = abb34n6
      abb34n22 = abb34n4
      abb34n23 = abb34n3
      abb34n24 = abb34n2
      abb34n25 = -(abb34n2)
      abb34n26 = -(abb34n3)
      abb34n27 = -(abb34n4)
      abb34n28 = -(abb34n6)
      abb34n29 = -(abb34n7)
      abb34n30 = -(abb34n8)
      abb34n31 = (-2.0_ki)*abb34n9
      abb34n32 = -(abb34n10)
      abb34n33 = -(abb34n11)
      abb34n34 = -(abb34n12)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd34h1
