module     p1_ddbar_neepscbar_abbrevd4h1
   use p1_ddbar_neepscbar_config, only: ki
   use p1_ddbar_neepscbar_globalsh1
   implicit none
   private
   complex(ki), public :: abb4n1
   complex(ki), public :: abb4n2
   complex(ki), public :: abb4n3
   complex(ki), public :: abb4n4
   complex(ki), public :: abb4n5
   complex(ki), public :: abb4n6
   complex(ki), public :: rat2d4
   complex(ki), public :: abb4n8
   complex(ki), public :: abb4n9
   complex(ki), public :: abb4n10
   complex(ki), public :: abb4n11
   complex(ki), public :: abb4n12
   complex(ki), public :: abb4n13
   complex(ki), public :: abb4n14
   complex(ki), public :: abb4n15
   complex(ki), public :: abb4n16
   complex(ki), public :: abb4n17
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   real(ki) :: t19
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p1_ddbar_neepscbar_config, only: deltaOS
      use p1_ddbar_neepscbar_kinematics
      use p1_ddbar_neepscbar_model
      use p1_ddbar_neepscbar_color, only: TR
      use p1_ddbar_neepscbar_globalsl1, only: epspow
      implicit none
      t1 = c1*i_
      t19 = TR*TR
      t2 = t19*t1*spak2k3*spak2k5*spbk2k1*spbk6k4
      t3 = (es12+es34-(es56+es345))*(es34+wW*mW*i_-mW*mW)
      t4 = es12*t3
      t5 = t2/t4
      t1 = t1*spak2k5
      t6 = t19*t1*spak3k5*spbk5k1*spbk6k4
      t7 = t6/t4
      t8 = NC*NC*t4
      t2 = t2/t8
      t6 = t6/t8
      t9 = c2*i_
      t3 = es12*NC*t3
      t10 = t19/t3*t9*spak2k3*spak2k5*spbk2k1*spbk6k4
      t9 = t9*spak2k5
      t11 = t19/t3*t9*spak3k5*spbk5k1*spbk6k4
      t12 = NC*c2*i_
      t13 = t19*t12/t4*spak2k3*spak2k5*spbk2k1*spbk6k4
      t12 = t12*spak2k5
      t14 = t19*t12/t4*spak3k5*spbk5k1*spbk6k4
      abb4n1 = ((2.0_ki)*(t10+t11+t5+t7-(t6+t2+t14+t13)))
      t15 = t1*spak3k4
      t16 = t19*t15*spbk2k1*spbk6k4
      t17 = t9*spak3k4
      t18 = t12*spak3k4
      abb4n2 = ((4.0_ki)*(t16/t8+t19*t18/t4*spbk2k1*spbk6k4-(t19*t17/t3*spbk2k1*&
      &spbk6k4+t16/t4)))
      t16 = t19*t1*spbk2k1
      abb4n3 = ((4.0_ki)*(t16/t8+t19*t12/t4*spbk2k1-(t19/t3*t9*spbk2k1+t16/t4)))
      t15 = t19*t15*spbk5k1*spbk6k4
      abb4n4 = ((4.0_ki)*(t15/t4+t19*t17/t3*spbk5k1*spbk6k4-(t19*t18/t4*spbk5k1*&
      &spbk6k4+t15/t8)))
      abb4n5 = ((4.0_ki)*(t13+t14+t2+t6-(t7+t5+t11+t10)))
      t1 = t19*t1*spbk5k1
      abb4n6 = ((4.0_ki)*(t1/t4+t19/t3*t9*spbk5k1-(t19*t12/t4*spbk5k1+t1/t8)))
      rat2d4 = abb4n1
      rat2 = rat2 + rat2d4
      abb4n8 = -(abb4n4)
      abb4n9 = abb4n6
      abb4n10 = abb4n5
      abb4n11 = abb4n4
      abb4n12 = abb4n3
      abb4n13 = abb4n2
      abb4n14 = -(abb4n2)
      abb4n15 = -(abb4n3)
      abb4n16 = (-2.0_ki)*abb4n5
      abb4n17 = -(abb4n6)
   end subroutine
end module p1_ddbar_neepscbar_abbrevd4h1
