module     p7_udbar_neepuubar_abbrevd39h0
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_globalsh0
   implicit none
   private
   complex(ki), public :: abb39n1
   complex(ki), public :: abb39n2
   complex(ki), public :: abb39n3
   complex(ki), public :: abb39n4
   complex(ki), public :: abb39n5
   complex(ki), public :: abb39n6
   complex(ki), public :: abb39n7
   complex(ki), public :: abb39n8
   complex(ki), public :: abb39n9
   complex(ki), public :: abb39n10
   complex(ki), public :: abb39n11
   complex(ki), public :: abb39n12
   complex(ki), public :: rat2d39
   complex(ki), public :: abb39n14
   complex(ki), public :: abb39n15
   complex(ki), public :: abb39n16
   complex(ki), public :: abb39n17
   complex(ki), public :: abb39n18
   complex(ki), public :: abb39n19
   complex(ki), public :: abb39n20
   complex(ki), public :: abb39n21
   complex(ki), public :: abb39n22
   complex(ki), public :: abb39n23
   complex(ki), public :: abb39n24
   complex(ki), public :: abb39n25
   complex(ki), public :: abb39n26
   complex(ki), public :: abb39n27
   complex(ki), public :: abb39n28
   complex(ki), public :: abb39n29
   complex(ki), public :: abb39n30
   complex(ki), public :: abb39n31
   complex(ki), public :: abb39n32
   complex(ki), public :: abb39n33
   complex(ki), public :: abb39n34
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   real(ki) :: t39
   real(ki) :: t40
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_udbar_neepuubar_config, only: deltaOS
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_model
      use p7_udbar_neepuubar_color, only: TR
      use p7_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak1k3
      t4 = t3*spak2k6*spbk4k1
      t5 = t4*spbk5k1
      t39 = TR*mT
      t39 = t39*t39
      t6 = (es34+es56-(es234+es12))*t1
      t40 = es56*es56
      t7 = t40*t6
      t8 = t2*spak2k6*spak3k4*spbk4k1
      t9 = t8*spbk5k4
      t10 = t2*spak2k3
      t11 = t10*spak2k6*spbk4k2
      t12 = t11*spbk5k1
      t13 = es234*t1
      t14 = t40*t13
      t15 = t10*spak3k6*spbk4k3
      t16 = t15*spbk5k1
      t17 = c1*i_
      t18 = t17*spak1k3
      t19 = t18*spak2k6*spbk4k1
      t20 = t19*spbk5k1
      t21 = NC*t6
      t22 = t40*t21
      t23 = t17*spak2k6*spak3k4*spbk4k1
      t24 = t23*spbk5k4
      t25 = t17*spak2k3
      t26 = t25*spak2k6*spbk4k2
      t27 = t26*spbk5k1
      t1 = es234*NC*t1
      t28 = t40*t1
      t29 = t25*spak3k6*spbk4k3
      t30 = t29*spbk5k1
      t40 = TR*TR
      t31 = t40*t5
      t6 = es56*t6
      t32 = t40*t9
      t33 = t40*t12
      t13 = es56*t13
      t34 = t40*t16
      t35 = t40*t20
      t21 = es56*t21
      t36 = t40*t24
      t37 = t40*t27
      t1 = es56*t1
      t38 = t40*t30
      abb39n1 = ((4.0_ki/3.0_ki)*(t37/t1+t34/t13+t31/t6+t32/t6-(t36/t21+t35/t21+&
      &t33/t13+t38/t1))+(8.0_ki)*(t39*t12/t14+t39*t20/t22+t39*t24/t22+t39*t30/t2&
      &8-(t39/t7*t9+t39*t5/t7+t39*t27/t28+t39*t16/t14)))
      abb39n2 = ((4.0_ki)*(t40/t7*t8*spbk6k5-t40*t23/t22*spbk6k5))
      t1 = t2*spak3k4
      t6 = t17*spak3k4
      abb39n3 = ((8.0_ki)*(t40/t22*t6*spbk4k1-t40*t1/t7*spbk4k1))
      t13 = TR*sqrt((mT*mT))
      t13 = t13*t13
      abb39n4 = ((8.0_ki)*(t12*t13/t14+t13*t20/t22+t13/t22*t24+t13/t28*t30-(t13/&
      &t7*t9+t13*t5/t7+t13*t27/t28+t13/t14*t16)))
      t5 = t10*spak5k6
      t9 = t25*spak5k6
      abb39n5 = ((4.0_ki)*(t40/t14*t5*spbk4k2*spbk5k1+t40*t18/t22*spak5k6*spbk4k&
      &1*spbk5k1+t40/t22*t6*spak5k6*spbk4k1*spbk5k4-(t40*t3/t7*spak5k6*spbk4k1*s&
      &pbk5k1+t40*t1/t7*spak5k6*spbk4k1*spbk5k4+t40/t28*t9*spbk4k2*spbk5k1)))
      t1 = t34/t14+t37/t28+t31/t7+t32/t7-(t38/t28+t36/t22+t35/t22+t33/t14)
      abb39n6 = ((8.0_ki)*t1)
      abb39n7 = ((16.0_ki)*t1)
      abb39n8 = ((4.0_ki)*(t40/t28*t9*spbk4k3*spbk5k1-t40/t14*t5*spbk4k3*spbk5k1&
      &))
      abb39n9 = ((8.0_ki)*(t40*t11/t14*spbk6k1+t40*t19/t22*spbk6k1+t40*t23/t22*s&
      &pbk6k4+t40*t29/t28*spbk6k1+t40*t10/t14*spak2k5*spbk4k2*spbk5k1+t40*t18/t2&
      &2*spak2k5*spbk4k1*spbk5k1+t40*t25/t28*spak3k5*spbk4k3*spbk5k1+t40*t17/t22&
      &*spak2k5*spak3k4*spbk4k1*spbk5k4-(t40*t2/t7*spak2k5*spak3k4*spbk4k1*spbk5&
      &k4+t40*t3/t7*spak2k5*spbk4k1*spbk5k1+t40*t25/t28*spak2k5*spbk4k2*spbk5k1+&
      &t40*t10/t14*spak3k5*spbk4k3*spbk5k1+t40/t7*t8*spbk6k4+t40*t4/t7*spbk6k1+t&
      &40*t26/t28*spbk6k1+t40*t15/t14*spbk6k1)))
      abb39n10 = ((8.0_ki)*(t40*t10/t14*spbk4k2+t40*t18/t22*spbk4k1-(t40*t3/t7*s&
      &pbk4k1+t40*t25/t28*spbk4k2)))
      abb39n11 = ((4.0_ki)*(t40*t15/t14*spbk6k5+t40*t26/t28*spbk6k5+t40*t4/t7*sp&
      &bk6k5-(t40*t29/t28*spbk6k5+t40*t19/t22*spbk6k5+t40*t11/t14*spbk6k5)))
      abb39n12 = ((8.0_ki)*(t40*t25/t28*spbk4k3-t40*t10/t14*spbk4k3))
      rat2d39 = abb39n1
      rat2 = rat2 + rat2d39
      abb39n14 = abb39n4
      abb39n15 = abb39n12
      abb39n16 = abb39n11
      abb39n17 = abb39n10
      abb39n18 = abb39n9
      abb39n19 = abb39n8
      abb39n20 = abb39n7
      abb39n21 = abb39n6
      abb39n22 = abb39n5
      abb39n23 = abb39n3
      abb39n24 = abb39n2
      abb39n25 = -(abb39n2)
      abb39n26 = -(abb39n3)
      abb39n27 = -(abb39n5)
      abb39n28 = (-2.0_ki)*abb39n6
      abb39n29 = -(abb39n7)
      abb39n30 = -(abb39n8)
      abb39n31 = -(abb39n9)
      abb39n32 = -(abb39n10)
      abb39n33 = -(abb39n11)
      abb39n34 = -(abb39n12)
   end subroutine
end module p7_udbar_neepuubar_abbrevd39h0
