module     p7_udbar_neepuubar_abbrevd51h1
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb51n1
   complex(ki), public :: abb51n2
   complex(ki), public :: abb51n3
   complex(ki), public :: abb51n4
   complex(ki), public :: abb51n5
   complex(ki), public :: abb51n6
   complex(ki), public :: abb51n7
   complex(ki), public :: abb51n8
   complex(ki), public :: rat2d51
   complex(ki), public :: abb51n10
   complex(ki), public :: abb51n11
   complex(ki), public :: abb51n12
   complex(ki), public :: abb51n13
   complex(ki), public :: abb51n14
   complex(ki), public :: abb51n15
   complex(ki), public :: abb51n16
   complex(ki), public :: abb51n17
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   real(ki) :: t32
   real(ki) :: t33
   real(ki) :: t34
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_udbar_neepuubar_config, only: deltaOS
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_model
      use p7_udbar_neepuubar_color, only: TR
      use p7_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t32 = es12+es34-(es56+es345)
      t1 = es12*c2*i_*spak2k5
      t33 = TR*TR
      t2 = t33*t1*spak3k4*spbk4k1*spbk6k4
      t3 = (es234-(es61+es56))*(es34+wW*mW*i_-mW*mW)
      t34 = t32*t32
      t4 = t34*t3
      t1 = t33*t1*spak3k6*spbk6k1*spbk6k4
      t5 = es234*c2*i_*spak2k5
      t6 = t33*t5*spak3k4*spbk4k1*spbk6k4
      t5 = t33*t5*spak3k6*spbk6k1*spbk6k4
      t7 = es56*c2*i_*spak2k5
      t8 = t33*t7*spak3k4*spbk4k1*spbk6k4
      t7 = t33*t7*spak3k6*spbk6k1*spbk6k4
      t9 = es61*c2*i_*spak2k5
      t10 = t33*t9*spak3k4*spbk4k1*spbk6k4
      t9 = t33*t9*spak3k6*spbk6k1*spbk6k4
      t11 = c2*i_
      t12 = t11*spak3k4
      t13 = TR*spak2k5
      t13 = t13*t13
      t14 = t12*t13*spbk2k1*spbk5k4*spbk6k4
      t12 = t12*t13*spbk4k2*spbk5k1*spbk6k4
      t15 = t11*spak3k6
      t16 = t13*t15*spbk2k1*spbk6k4*spbk6k5
      t15 = t13*t15*spbk5k1*spbk6k2*spbk6k4
      t32 = t32*NC
      t17 = t32*t32*t3
      t18 = es12*c1*i_*spak2k5
      t3 = NC*t34*t3
      t19 = es234*c1*i_*spak2k5
      t20 = es56*c1*i_*spak2k5
      t21 = es61*c1*i_*spak2k5
      t22 = c1*i_
      t23 = t22*spak3k4
      t24 = t22*spak3k6
      t25 = NC*c1
      t26 = es12*t25*i_*spak2k5
      t27 = es234*t25*i_*spak2k5
      t28 = es56*t25*i_*spak2k5
      t29 = es61*t25*i_*spak2k5
      t25 = t25*i_
      t30 = t25*spak3k4
      t31 = t25*spak3k6
      abb51n1 = ((4.0_ki)*(t1/t17+t10/t4+t12/t4+t14/t4+t15/t4+t16/t17+t2/t17+t5/&
      &t17+t6/t17+t7/t4+t8/t4+t9/t4+t13*t23/t3*spbk2k1*spbk5k4*spbk6k4+t13*t23/t&
      &3*spbk4k2*spbk5k1*spbk6k4+t13*t24/t3*spbk5k1*spbk6k2*spbk6k4+t13*t31/t4*s&
      &pbk2k1*spbk6k4*spbk6k5+t33*t20/t3*spak3k4*spbk4k1*spbk6k4+t33*t20/t3*spak&
      &3k6*spbk6k1*spbk6k4+t33*t21/t3*spak3k4*spbk4k1*spbk6k4+t33*t21/t3*spak3k6&
      &*spbk6k1*spbk6k4+t33*t26/t4*spak3k4*spbk4k1*spbk6k4+t33*t26/t4*spak3k6*sp&
      &bk6k1*spbk6k4+t33*t27/t4*spak3k4*spbk4k1*spbk6k4+t33*t27/t4*spak3k6*spbk6&
      &k1*spbk6k4-(t33*t29/t4*spak3k6*spbk6k1*spbk6k4+t33*t29/t4*spak3k4*spbk4k1&
      &*spbk6k4+t33*t28/t4*spak3k6*spbk6k1*spbk6k4+t33*t28/t4*spak3k4*spbk4k1*sp&
      &bk6k4+t33*t19/t3*spak3k6*spbk6k1*spbk6k4+t33*t19/t3*spak3k4*spbk4k1*spbk6&
      &k4+t33*t18/t3*spak3k6*spbk6k1*spbk6k4+t33*t18/t3*spak3k4*spbk4k1*spbk6k4+&
      &t13*t31/t4*spbk5k1*spbk6k2*spbk6k4+t13*t30/t4*spbk4k2*spbk5k1*spbk6k4+t13&
      &*t30/t4*spbk2k1*spbk5k4*spbk6k4+t13*t24/t3*spbk2k1*spbk6k4*spbk6k5+t6/t4+&
      &t5/t4+t2/t4+t9/t17+t8/t17+t7/t17+t16/t4+t15/t17+t14/t17+t12/t17+t10/t17+t&
      &1/t4)))
      t1 = t11*spak2k5
      t2 = t1*spak3k4
      t5 = t33*t2*spbk2k1*spbk6k4
      t6 = t22*spak2k5
      t7 = t6*spak3k4
      t8 = t25*spak2k5
      t9 = t8*spak3k4
      abb51n2 = ((4.0_ki)*(t5/t17+t33/t4*t9*spbk2k1*spbk6k4-(t33/t3*t7*spbk2k1*s&
      &pbk6k4+t5/t4)))
      t5 = t1*spak3k6
      t10 = t33*t5*spbk2k1*spbk6k4
      t12 = t6*spak3k6
      t13 = t8*spak3k6
      abb51n3 = ((4.0_ki)*(t10/t17+t33*t13/t4*spbk2k1*spbk6k4-(t33*t12/t3*spbk2k&
      &1*spbk6k4+t10/t4)))
      t2 = t33*t2*spbk5k1*spbk6k4
      abb51n4 = ((4.0_ki)*(t2/t4+t33/t3*t7*spbk5k1*spbk6k4-(t33/t4*t9*spbk5k1*sp&
      &bk6k4+t2/t17)))
      t2 = t11*spak2k3*spak2k5*spbk2k1
      t7 = t33*t2*spbk6k4
      t9 = t1*spak3k5
      t10 = t9*spbk5k1
      t14 = t33*t10*spbk6k4
      t15 = t22*spak2k3*spak2k5*spbk2k1
      t16 = t6*spak3k5
      t18 = t16*spbk5k1
      t19 = t25*spak2k3*spak2k5*spbk2k1
      t20 = t8*spak3k5
      t21 = t20*spbk5k1
      abb51n5 = ((16.0_ki)*(t14/t17+t7/t17+t33*t19/t4*spbk6k4+t33*t21/t4*spbk6k4&
      &-(t33*t18/t3*spbk6k4+t33*t15/t3*spbk6k4+t7/t4+t14/t4)))
      t5 = t33*t5*spbk5k1*spbk6k4
      abb51n6 = ((4.0_ki)*(t5/t4+t33*t12/t3*spbk5k1*spbk6k4-(t33*t13/t4*spbk5k1*&
      &spbk6k4+t5/t17)))
      t5 = t33*t2*spbk6k3
      t7 = t33*t11*spak2k4*spak2k5*spbk2k1*spbk6k4
      t10 = t33*t10*spbk6k3
      t11 = t33*t1*spak4k5*spbk5k1*spbk6k4
      abb51n7 = ((8.0_ki)*(t10/t4+t11/t4+t5/t4+t7/t4+t33*t15/t3*spbk6k3+t33*t18/&
      &t3*spbk6k3+t33/t3*t6*spak4k5*spbk5k1*spbk6k4+t33*t22/t3*spak2k4*spak2k5*s&
      &pbk2k1*spbk6k4-(t33*t25/t4*spak2k4*spak2k5*spbk2k1*spbk6k4+t33/t4*t8*spak&
      &4k5*spbk5k1*spbk6k4+t33*t21/t4*spbk6k3+t33*t19/t4*spbk6k3+t7/t17+t5/t17+t&
      &11/t17+t10/t17)))
      t2 = t33*t2*spbk4k3
      t5 = t33*t1*spak2k6*spbk2k1*spbk6k4
      t7 = t33*t9*spbk4k3*spbk5k1
      t1 = t33*t1*spak5k6*spbk5k1*spbk6k4
      abb51n8 = ((8.0_ki)*(t1/t17+t2/t17+t7/t17+t5/t4+t33*t19/t4*spbk4k3+t33*t20&
      &/t4*spbk4k3*spbk5k1+t33/t3*t6*spak2k6*spbk2k1*spbk6k4+t33/t4*t8*spak5k6*s&
      &pbk5k1*spbk6k4-(t33/t4*t8*spak2k6*spbk2k1*spbk6k4+t33/t3*t6*spak5k6*spbk5&
      &k1*spbk6k4+t33*t16/t3*spbk4k3*spbk5k1+t33*t15/t3*spbk4k3+t7/t4+t2/t4+t5/t&
      &17+t1/t4)))
      rat2d51 = 0
      rat2 = rat2 + rat2d51
      abb51n10 = abb51n1
      abb51n11 = -(abb51n2)
      abb51n12 = -(abb51n3)
      abb51n13 = -(abb51n4)
      abb51n14 = -(abb51n5)
      abb51n15 = -(abb51n6)
      abb51n16 = -(abb51n7)
      abb51n17 = -(abb51n8)
   end subroutine
end module p7_udbar_neepuubar_abbrevd51h1
