module     p7_udbar_neepuubar_abbrevd59h1
   use p7_udbar_neepuubar_config, only: ki
   use p7_udbar_neepuubar_globalsh1
   implicit none
   private
   complex(ki), public :: abb59n1
   complex(ki), public :: abb59n2
   complex(ki), public :: abb59n3
   complex(ki), public :: abb59n4
   complex(ki), public :: abb59n5
   complex(ki), public :: abb59n6
   complex(ki), public :: abb59n7
   complex(ki), public :: abb59n8
   complex(ki), public :: abb59n9
   complex(ki), public :: abb59n10
   complex(ki), public :: abb59n11
   complex(ki), public :: abb59n12
   complex(ki), public :: abb59n13
   complex(ki), public :: abb59n14
   complex(ki), public :: abb59n15
   complex(ki), public :: abb59n16
   complex(ki), public :: rat2d59
   complex(ki), public :: abb59n18
   complex(ki), public :: abb59n19
   complex(ki), public :: abb59n20
   complex(ki), public :: abb59n21
   complex(ki), public :: abb59n22
   complex(ki), public :: abb59n23
   complex(ki), public :: abb59n24
   complex(ki), public :: abb59n25
   complex(ki), public :: abb59n26
   complex(ki), public :: abb59n27
   complex(ki), public :: abb59n28
   complex(ki), public :: abb59n29
   complex(ki), public :: abb59n30
   complex(ki), public :: abb59n31
   complex(ki), public :: abb59n32
   complex(ki), public :: abb59n33
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   real(ki) :: t16
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p7_udbar_neepuubar_config, only: deltaOS
      use p7_udbar_neepuubar_kinematics
      use p7_udbar_neepuubar_model
      use p7_udbar_neepuubar_color, only: TR
      use p7_udbar_neepuubar_globalsl1, only: epspow
      implicit none
      t1 = es234*c2*i_
      t16 = TR*TR
      t2 = (es34+es56-(es234+es12))*(es34+wW*mW*i_-mW*mW)
      t3 = NC*t2
      t4 = es34*c2*i_
      t5 = es345*c2*i_
      t6 = es61*c2*i_
      t7 = es234*c1*i_
      t8 = t16*t7*spak1k3*spak2k5*spbk4k1*spbk6k1
      t7 = t16*t7*spak2k5*spak3k4*spbk4k1*spbk6k4
      t9 = es34*c1*i_
      t10 = t16*t9*spak1k3*spak2k5*spbk4k1*spbk6k1
      t9 = t16*t9*spak2k5*spak3k4*spbk4k1*spbk6k4
      t11 = es345*c1*i_
      t12 = t16*t11*spak1k3*spak2k5*spbk4k1*spbk6k1
      t11 = t16*t11*spak2k5*spak3k4*spbk4k1*spbk6k4
      t13 = es61*c1*i_
      t14 = t16*t13*spak1k3*spak2k5*spbk4k1*spbk6k1
      t13 = t16*t13*spak2k5*spak3k4*spbk4k1*spbk6k4
      t15 = NC*NC*t2
      abb59n1 = ((8.0_ki)*(t16*t1/t3*spak1k3*spak2k5*spbk4k1*spbk6k1+t16*t1/t3*s&
      &pak2k5*spak3k4*spbk4k1*spbk6k4+t16/t3*t5*spak1k3*spak2k5*spbk4k1*spbk6k1+&
      &t16/t3*t5*spak2k5*spak3k4*spbk4k1*spbk6k4-(t16/t3*t6*spak2k5*spak3k4*spbk&
      &4k1*spbk6k4+t16/t3*t6*spak1k3*spak2k5*spbk4k1*spbk6k1+t16/t3*t4*spak2k5*s&
      &pak3k4*spbk4k1*spbk6k4+t16/t3*t4*spak1k3*spak2k5*spbk4k1*spbk6k1))+(4.0_k&
      &i)*(t10/t15+t10/t2+t13/t15+t13/t2+t14/t15+t14/t2+t9/t15+t9/t2-(t8/t2+t7/t&
      &2+t8/t15+t7/t15+t12/t2+t12/t15+t11/t2+t11/t15)))
      t1 = c1*i_
      t4 = t1*spak1k3*spak2k5
      t5 = t4*spbk4k1
      t6 = t16*t5*spbk6k2
      t7 = c2*i_
      t8 = t7*spak1k3*spak2k5
      t9 = t8*spbk4k1
      abb59n2 = ((4.0_ki)*((2.0_ki)*t16/t3*t9*spbk6k2-(t6/t2+t6/t15)))
      t6 = t1*spak2k5
      t10 = t16*t6*spbk3k1
      t11 = t7*spak2k5
      abb59n3 = ((4.0_ki)*(t16*(2.0_ki)*t11/t3*spbk3k1-(t10/t2+t10/t15)))
      t10 = t11*spak3k4*spbk4k1
      t4 = t16*t4*spbk2k1*spbk4k1
      t12 = t6*spak3k4*spbk4k1
      t13 = t16*t12*spbk4k2
      abb59n4 = ((8.0_ki)*(t16/t3*t8*spbk2k1*spbk4k1-t16*t10/t3*spbk4k2)+(4.0_ki&
      &)*(t13/t15+t13/t2-(t4/t2+t4/t15)))
      t4 = t16*t12*spbk6k2
      abb59n5 = ((4.0_ki)*(t16*(2.0_ki)*t10/t3*spbk6k2-(t4/t2+t4/t15)))
      t4 = t16*t5*spbk5k1
      t8 = t16*t12*spbk5k4
      abb59n6 = ((8.0_ki)*(t16*t10/t3*spbk5k4+t16/t3*t9*spbk5k1)+(4.0_ki)*(-(t8/&
      &t2+t4/t2+t8/t15+t4/t15)))
      t4 = t16*t5*spbk6k1
      t5 = t16*t12*spbk6k4
      abb59n7 = ((8.0_ki)*(t16*t10/t3*spbk6k4+t16/t3*t9*spbk6k1)+(4.0_ki)*(-(t5/&
      &t2+t4/t2+t5/t15+t4/t15)))
      t4 = t6*spak3k5
      t5 = t16*t4*spbk4k1*spbk6k5
      t8 = t5/t2
      t5 = t5/t15
      t9 = t11*spak3k5
      t10 = (2.0_ki)*t16/t3*t9*spbk4k1*spbk6k5
      abb59n8 = ((8.0_ki)*(t5+t8-t10))
      abb59n9 = ((8.0_ki)*(t10-(t8+t5)))
      t5 = t16*t4*spbk3k1*spbk6k5
      t8 = t16*t6*spak4k5*spbk4k1*spbk6k5
      abb59n10 = ((8.0_ki)*(-(t16*t11/t3*spak4k5*spbk4k1*spbk6k5+t16/t3*t9*spbk3&
      &k1*spbk6k5))+(4.0_ki)*(t5/t15+t8/t15+t5/t2+t8/t2))
      t5 = t16*t6*spbk4k1
      t8 = t5/t2
      t5 = t5/t15
      t10 = t16*(2.0_ki)*t11/t3*spbk4k1
      t12 = t5+t8-t10
      abb59n11 = ((8.0_ki)*t12)
      abb59n12 = ((4.0_ki)*t12)
      t5 = t10-(t8+t5)
      abb59n13 = ((4.0_ki)*t5)
      abb59n14 = ((8.0_ki)*t5)
      t1 = t16*t1*spak1k5*spak2k5*spbk4k1*spbk6k5
      t4 = t16*t4*spbk4k3*spbk6k5
      abb59n15 = ((8.0_ki)*(t16/t3*t7*spak1k5*spak2k5*spbk4k1*spbk6k5-t16/t3*t9*&
      &spbk4k3*spbk6k5)+(4.0_ki)*(t4/t15+t4/t2-(t1/t2+t1/t15)))
      t1 = t16*t6*spbk4k3
      abb59n16 = ((4.0_ki)*(t16*(2.0_ki)*t11/t3*spbk4k3-(t1/t2+t1/t15)))
      rat2d59 = 0
      rat2 = rat2 + rat2d59
      abb59n18 = abb59n1
      abb59n19 = abb59n16
      abb59n20 = abb59n14
      abb59n21 = abb59n13
      abb59n22 = abb59n12
      abb59n23 = abb59n11
      abb59n24 = abb59n7
      abb59n25 = abb59n3
      abb59n26 = -(abb59n2)
      abb59n27 = -(abb59n4)
      abb59n28 = -(abb59n5)
      abb59n29 = -(abb59n6)
      abb59n30 = -(abb59n8)
      abb59n31 = -(abb59n9)
      abb59n32 = -(abb59n10)
      abb59n33 = -(abb59n15)
   end subroutine
end module p7_udbar_neepuubar_abbrevd59h1
