module     p8_udbar_neepssbar_abbrevd28h0
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb28n1
   complex(ki), public :: abb28n2
   complex(ki), public :: abb28n3
   complex(ki), public :: abb28n4
   complex(ki), public :: abb28n5
   complex(ki), public :: abb28n6
   complex(ki), public :: abb28n7
   complex(ki), public :: abb28n8
   complex(ki), public :: abb28n9
   complex(ki), public :: abb28n10
   complex(ki), public :: abb28n11
   complex(ki), public :: abb28n12
   complex(ki), public :: abb28n13
   complex(ki), public :: abb28n14
   complex(ki), public :: abb28n15
   complex(ki), public :: abb28n16
   complex(ki), public :: abb28n17
   complex(ki), public :: abb28n18
   complex(ki), public :: abb28n19
   complex(ki), public :: abb28n20
   complex(ki), public :: abb28n21
   complex(ki), public :: abb28n22
   complex(ki), public :: abb28n23
   complex(ki), public :: abb28n24
   complex(ki), public :: abb28n25
   complex(ki), public :: abb28n26
   complex(ki), public :: abb28n27
   complex(ki), public :: abb28n28
   complex(ki), public :: rat2d28
   complex(ki), public :: abb28n30
   complex(ki), public :: abb28n31
   complex(ki), public :: abb28n32
   complex(ki), public :: abb28n33
   complex(ki), public :: abb28n34
   complex(ki), public :: abb28n35
   complex(ki), public :: abb28n36
   complex(ki), public :: abb28n37
   complex(ki), public :: abb28n38
   complex(ki), public :: abb28n39
   complex(ki), public :: abb28n40
   complex(ki), public :: abb28n41
   complex(ki), public :: abb28n42
   complex(ki), public :: abb28n43
   complex(ki), public :: abb28n44
   complex(ki), public :: abb28n45
   complex(ki), public :: abb28n46
   complex(ki), public :: abb28n47
   complex(ki), public :: abb28n48
   complex(ki), public :: abb28n49
   complex(ki), public :: abb28n50
   complex(ki), public :: abb28n51
   complex(ki), public :: abb28n52
   complex(ki), public :: abb28n53
   complex(ki), public :: abb28n54
   complex(ki), public :: abb28n55
   complex(ki), public :: abb28n56
   complex(ki), public :: abb28n57
   complex(ki), public :: abb28n58
   complex(ki), public :: abb28n59
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   real(ki) :: t23
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p8_udbar_neepssbar_config, only: deltaOS
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_model
      use p8_udbar_neepssbar_color, only: TR
      use p8_udbar_neepssbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c2*i_
      t3 = t2*spak1k2
      t23 = TR*TR
      t4 = NC*t1
      t5 = t2*spak2k3
      t6 = c1*i_
      t7 = t6*spak1k2
      t8 = NC*NC*t1
      t9 = t6*spak2k3
      t10 = NC*c2*i_
      t11 = t10*spak1k2
      t12 = t10*spak2k3
      abb28n1 = ((8.0_ki)*(t23*t3/t4*spak2k3*spbk4k1*spbk5k1-t23/t4*t5*spak2k5*s&
      &pbk5k1*spbk5k4)+(4.0_ki)*(t23*t12/t1*spak2k5*spbk5k1*spbk5k4+t23/t8*t9*sp&
      &ak2k5*spbk5k1*spbk5k4-(t23*t7/t8*spak2k3*spbk4k1*spbk5k1+t23*t11/t1*spak2&
      &k3*spbk4k1*spbk5k1)))
      abb28n2 = ((4.0_ki)*((2.0_ki)*t23*t3/t4*spbk5k1-(t23*t7/t8*spbk5k1+t23*t11&
      &/t1*spbk5k1)))
      t13 = t23*t6/t8*spak1k3*spbk5k1
      t14 = t23*(2.0_ki)*t2/t4*spak1k3*spbk5k1
      t15 = t23*t10/t1*spak1k3*spbk5k1
      abb28n3 = ((4.0_ki)*(t13+t15-t14))
      abb28n4 = ((4.0_ki)*(t14-(t15+t13)))
      t13 = t23/t8*t9*spbk4k1
      t14 = (2.0_ki)*t23/t4*t5*spbk4k1
      t15 = t23*t12/t1*spbk4k1
      abb28n5 = ((4.0_ki)*(t13+t15-t14))
      abb28n6 = ((8.0_ki)*(t14-(t15+t13)))
      t13 = t6*spak3k6
      t14 = t23*t13/t8*spbk4k1
      t15 = t2*spak3k6
      t16 = t23*(2.0_ki)*t15/t4*spbk4k1
      t17 = t10*spak3k6
      t18 = t23*t17/t1*spbk4k1
      abb28n7 = ((8.0_ki)*(t14+t18-t16))
      abb28n8 = ((4.0_ki)*(t16-(t18+t14)))
      t14 = t6*spak1k6
      t16 = t2*spak1k6
      t18 = t10*spak1k6
      abb28n9 = ((4.0_ki)*(t23*t18/t1*spbk5k1+t23*t14/t8*spbk5k1-t23*(2.0_ki)*t1&
      &6/t4*spbk5k1))
      abb28n10 = ((16.0_ki)*(-(t23/t4*t5*spak5k6*spbk5k1*spbk5k4+t23*t16/t4*spak&
      &2k3*spbk4k1*spbk5k1))+(8.0_ki)*(t23*t12/t1*spak5k6*spbk5k1*spbk5k4+t23*t1&
      &8/t1*spak2k3*spbk4k1*spbk5k1+t23*t14/t8*spak2k3*spbk4k1*spbk5k1+t23/t8*t9&
      &*spak5k6*spbk5k1*spbk5k4))
      t19 = t23/t8*t9*spbk5k1
      t20 = (2.0_ki)*t23/t4*t5*spbk5k1
      t21 = t23*t12/t1*spbk5k1
      t22 = t19+t21-t20
      abb28n11 = ((8.0_ki)*t22)
      abb28n12 = ((4.0_ki)*t22)
      abb28n13 = ((8.0_ki)*(t20-(t21+t19)))
      t19 = t2*spak2k5
      t20 = t6*spak2k5
      t21 = t10*spak2k5
      abb28n14 = ((16.0_ki)*(t23*t3/t4*spak3k6*spbk4k1*spbk5k1-t23*t19/t4*spak3k&
      &6*spbk5k1*spbk5k4)+(8.0_ki)*(t23*t21/t1*spak3k6*spbk5k1*spbk5k4+t23*t20/t&
      &8*spak3k6*spbk5k1*spbk5k4-(t23*t7/t8*spak3k6*spbk4k1*spbk5k1+t23*t11/t1*s&
      &pak3k6*spbk4k1*spbk5k1)))
      abb28n15 = ((4.0_ki)*(t23*(2.0_ki)*t19/t4*spbk5k1-(t23*t20/t8*spbk5k1+t23*&
      &t21/t1*spbk5k1)))
      t3 = t23*t6/t8*spak3k5*spbk5k1
      t7 = t23*(2.0_ki)*t2/t4*spak3k5*spbk5k1
      t11 = t23*t10/t1*spak3k5*spbk5k1
      abb28n16 = ((4.0_ki)*(t11+t3-t7))
      abb28n17 = ((4.0_ki)*(t7-(t3+t11)))
      abb28n18 = ((8.0_ki)*(-(t23*t16/t4*spak3k6*spbk4k1*spbk5k1+t23*t15/t4*spak&
      &5k6*spbk5k1*spbk5k4))+(4.0_ki)*(t23*t17/t1*spak5k6*spbk5k1*spbk5k4+t23*t1&
      &8/t1*spak3k6*spbk4k1*spbk5k1+t23*t13/t8*spak5k6*spbk5k1*spbk5k4+t23*t14/t&
      &8*spak3k6*spbk4k1*spbk5k1))
      t3 = t23*t13/t8*spbk5k1
      t7 = t23*(2.0_ki)*t15/t4*spbk5k1
      t11 = t23*t17/t1*spbk5k1
      t14 = t11+t3-t7
      abb28n19 = ((8.0_ki)*t14)
      abb28n20 = ((4.0_ki)*t14)
      abb28n21 = ((8.0_ki)*(t7-(t3+t11)))
      abb28n22 = ((4.0_ki)*(t23*(2.0_ki)*t2/t4*spak5k6*spbk5k1-(t23*t6/t8*spak5k&
      &6*spbk5k1+t23*t10/t1*spak5k6*spbk5k1)))
      t3 = t23/t8*t9*spbk5k4
      t5 = (2.0_ki)*t23/t4*t5*spbk5k4
      t7 = t23*t12/t1*spbk5k4
      abb28n23 = ((4.0_ki)*(t3+t7-t5))
      abb28n24 = ((8.0_ki)*(t5-(t7+t3)))
      t3 = t23*t13/t8*spbk5k4
      t5 = t23*(2.0_ki)*t15/t4*spbk5k4
      t7 = t23*t17/t1*spbk5k4
      abb28n25 = ((8.0_ki)*(t3+t7-t5))
      abb28n26 = ((4.0_ki)*(t5-(t7+t3)))
      t3 = t23*t6/t8
      t2 = t23*(2.0_ki)*t2/t4
      t1 = t23*t10/t1
      abb28n27 = ((8.0_ki)*(t1+t3-t2))
      abb28n28 = ((8.0_ki)*(t2-(t3+t1)))
      rat2d28 = 0
      rat2 = rat2 + rat2d28
      abb28n30 = -(abb28n1)
      abb28n31 = abb28n26
      abb28n32 = abb28n25
      abb28n33 = abb28n24
      abb28n34 = abb28n23
      abb28n35 = abb28n22
      abb28n36 = abb28n21
      abb28n37 = abb28n19
      abb28n38 = abb28n17
      abb28n39 = abb28n16
      abb28n40 = abb28n15
      abb28n41 = abb28n13
      abb28n42 = abb28n11
      abb28n43 = abb28n9
      abb28n44 = abb28n8
      abb28n45 = abb28n7
      abb28n46 = abb28n6
      abb28n47 = abb28n5
      abb28n48 = abb28n4
      abb28n49 = abb28n3
      abb28n50 = abb28n2
      abb28n51 = -(abb28n10)
      abb28n52 = -(abb28n12)
      abb28n53 = (-2.0_ki)*abb28n12
      abb28n54 = -(abb28n14)
      abb28n55 = -(abb28n18)
      abb28n56 = -(abb28n20)
      abb28n57 = (-2.0_ki)*abb28n20
      abb28n58 = -(abb28n27)
      abb28n59 = -(abb28n28)
   end subroutine
end module p8_udbar_neepssbar_abbrevd28h0
