module     p8_udbar_neepssbar_abbrevd29h0
   use p8_udbar_neepssbar_config, only: ki
   use p8_udbar_neepssbar_globalsh0
   implicit none
   private
   complex(ki), public :: abb29n1
   complex(ki), public :: abb29n2
   complex(ki), public :: abb29n3
   complex(ki), public :: abb29n4
   complex(ki), public :: abb29n5
   complex(ki), public :: abb29n6
   complex(ki), public :: abb29n7
   complex(ki), public :: abb29n8
   complex(ki), public :: abb29n9
   complex(ki), public :: abb29n10
   complex(ki), public :: abb29n11
   complex(ki), public :: abb29n12
   complex(ki), public :: abb29n13
   complex(ki), public :: abb29n14
   complex(ki), public :: rat2d29
   complex(ki), public :: abb29n16
   complex(ki), public :: abb29n17
   complex(ki), public :: abb29n18
   complex(ki), public :: abb29n19
   complex(ki), public :: abb29n20
   complex(ki), public :: abb29n21
   complex(ki), public :: abb29n22
   complex(ki), public :: abb29n23
   complex(ki), public :: abb29n24
   complex(ki), public :: abb29n25
   complex(ki), public :: abb29n26
   complex(ki), public :: abb29n27
   complex(ki), public :: abb29n28
   complex(ki), public :: abb29n29
   complex(ki), public :: abb29n30
   complex(ki), public :: abb29n31
   complex(ki), public :: abb29n32
   complex(ki), public :: abb29n33
   complex(ki), public :: abb29n34
   complex(ki), public :: abb29n35
   complex(ki), public :: abb29n36
   complex(ki), public :: abb29n37
   complex(ki), public :: abb29n38
   complex(ki), public :: abb29n39
   complex(ki), public :: abb29n40
   complex(ki), public :: abb29n41
   complex(ki), public :: abb29n42
   complex(ki), public :: abb29n43
   complex(ki), public :: abb29n44
   complex(ki), public :: abb29n45
   complex(ki), public :: abb29n46
   complex(ki), public :: abb29n47
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   real(ki) :: t11
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p8_udbar_neepssbar_config, only: deltaOS
      use p8_udbar_neepssbar_kinematics
      use p8_udbar_neepssbar_model
      use p8_udbar_neepssbar_color, only: TR
      use p8_udbar_neepssbar_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = c1*i_
      t3 = t2*spak1k2
      t11 = TR*TR
      t4 = t11*t3*spak2k3*spbk4k1*spbk5k2
      t5 = NC*NC*t1
      t6 = c2*i_
      t7 = t6*spak1k2
      t8 = NC*t1
      abb29n1 = ((4.0_ki)*(t4/t1+t4/t5-(2.0_ki)*t11*t7/t8*spak2k3*spbk4k1*spbk5k&
      &2))
      t3 = t11*t3*spbk5k1
      abb29n2 = ((4.0_ki)*((2.0_ki)*t11*t7/t8*spbk5k1-(t3/t5+t3/t1)))
      t3 = t11*t2*spak1k3*spbk5k4
      abb29n3 = ((4.0_ki)*(t3/t1+t3/t5-(2.0_ki)*t11*t6/t8*spak1k3*spbk5k4))
      t3 = t2*spak2k3
      t4 = t11*t3*spak2k6*spbk4k1*spbk5k2
      t7 = t6*spak2k3
      abb29n4 = ((8.0_ki)*(t4/t1+t4/t5-(2.0_ki)*t11*t7/t8*spak2k6*spbk4k1*spbk5k&
      &2))
      t4 = t2*spak2k6
      t9 = t11*t4*spbk5k1
      t10 = t6*spak2k6
      abb29n5 = ((8.0_ki)*(t11*(2.0_ki)*t10/t8*spbk5k1-(t9/t5+t9/t1)))
      t9 = t11*t3*spbk5k2
      abb29n6 = ((4.0_ki)*(t9/t1+t9/t5-(2.0_ki)*t11*t7/t8*spbk5k2))
      t3 = t11*t3*spbk5k4
      t9 = t3/t1
      t3 = t3/t5
      t7 = (2.0_ki)*t11*t7/t8*spbk5k4
      abb29n7 = ((8.0_ki)*(t3+t9-t7))
      t3 = t7-(t9+t3)
      abb29n8 = ((4.0_ki)*t3)
      abb29n9 = ((8.0_ki)*t3)
      t3 = t11*t4*spbk5k4
      t4 = t3/t1
      t3 = t3/t5
      t7 = t11*(2.0_ki)*t10/t8*spbk5k4
      t9 = t3+t4-t7
      abb29n10 = ((8.0_ki)*t9)
      abb29n11 = ((4.0_ki)*t9)
      abb29n12 = ((8.0_ki)*(t7-(t4+t3)))
      t3 = t11*t2*spak3k6*spbk5k4
      abb29n13 = ((8.0_ki)*(t3/t1+t3/t5-(2.0_ki)*t11*t6/t8*spak3k6*spbk5k4))
      t2 = t11*t2
      abb29n14 = ((4.0_ki)*((2.0_ki)*t11*t6/t8-(t2/t5+t2/t1)))
      rat2d29 = 0
      rat2 = rat2 + rat2d29
      abb29n16 = -(abb29n1)
      abb29n17 = abb29n14
      abb29n18 = abb29n13
      abb29n19 = abb29n12
      abb29n20 = abb29n11
      abb29n21 = abb29n10
      abb29n22 = abb29n9
      abb29n23 = abb29n8
      abb29n24 = abb29n7
      abb29n25 = abb29n6
      abb29n26 = abb29n5
      abb29n27 = abb29n4
      abb29n28 = abb29n3
      abb29n29 = abb29n2
      abb29n30 = abb29n1
      abb29n31 = -(abb29n2)
      abb29n32 = -(abb29n3)
      abb29n33 = -(abb29n4)
      abb29n34 = -(abb29n5)
      abb29n35 = -(abb29n6)
      abb29n36 = -(abb29n7)
      t1 = (2.0_ki)*abb29n8
      abb29n37 = t1
      abb29n38 = -(abb29n8)
      abb29n39 = -(t1)
      abb29n40 = -(abb29n9)
      abb29n41 = -(abb29n10)
      t1 = (2.0_ki)*abb29n11
      abb29n42 = t1
      abb29n43 = -(abb29n11)
      abb29n44 = -(t1)
      abb29n45 = -(abb29n12)
      abb29n46 = -(abb29n13)
      abb29n47 = -(abb29n14)
   end subroutine
end module p8_udbar_neepssbar_abbrevd29h0
