module     p9_udbar_neepgg_abbrevd23h0
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh0
   implicit none
   private
   complex(ki), public :: abb23n1
   complex(ki), public :: abb23n2
   complex(ki), public :: abb23n3
   complex(ki), public :: abb23n4
   complex(ki), public :: abb23n5
   complex(ki), public :: abb23n6
   complex(ki), public :: abb23n7
   complex(ki), public :: abb23n8
   complex(ki), public :: abb23n9
   complex(ki), public :: abb23n10
   complex(ki), public :: abb23n11
   complex(ki), public :: abb23n12
   complex(ki), public :: abb23n13
   complex(ki), public :: abb23n14
   complex(ki), public :: abb23n15
   complex(ki), public :: abb23n16
   complex(ki), public :: abb23n17
   complex(ki), public :: abb23n18
   complex(ki), public :: abb23n19
   complex(ki), public :: abb23n20
   complex(ki), public :: abb23n21
   complex(ki), public :: abb23n22
   complex(ki), public :: abb23n23
   complex(ki), public :: abb23n24
   complex(ki), public :: abb23n25
   complex(ki), public :: abb23n26
   complex(ki), public :: abb23n27
   complex(ki), public :: abb23n28
   complex(ki), public :: abb23n29
   complex(ki), public :: abb23n30
   complex(ki), public :: abb23n31
   complex(ki), public :: abb23n32
   complex(ki), public :: abb23n33
   complex(ki), public :: abb23n34
   complex(ki), public :: abb23n35
   complex(ki), public :: abb23n36
   complex(ki), public :: rat2d23
   complex(ki), public :: abb23n38
   complex(ki), public :: abb23n39
   complex(ki), public :: abb23n40
   complex(ki), public :: abb23n41
   complex(ki), public :: abb23n42
   complex(ki), public :: abb23n43
   complex(ki), public :: abb23n44
   complex(ki), public :: abb23n45
   complex(ki), public :: abb23n46
   complex(ki), public :: abb23n47
   complex(ki), public :: abb23n48
   complex(ki), public :: abb23n49
   complex(ki), public :: abb23n50
   complex(ki), public :: abb23n51
   complex(ki), public :: abb23n52
   complex(ki), public :: abb23n53
   complex(ki), public :: abb23n54
   complex(ki), public :: abb23n55
   complex(ki), public :: abb23n56
   complex(ki), public :: abb23n57
   complex(ki), public :: abb23n58
   complex(ki), public :: abb23n59
   complex(ki), public :: abb23n60
   complex(ki), public :: abb23n61
   complex(ki), public :: abb23n62
   complex(ki), public :: abb23n63
   complex(ki), public :: abb23n64
   complex(ki), public :: abb23n65
   complex(ki), public :: abb23n66
   complex(ki), public :: abb23n67
   complex(ki), public :: abb23n68
   complex(ki), public :: abb23n69
   complex(ki), public :: abb23n70
   complex(ki), public :: abb23n71
   complex(ki), public :: abb23n72
   complex(ki), public :: abb23n73
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = TR*c1
      t2 = t1*i_
      t3 = t2*spak1k2
      t4 = t3*spak3k5
      t5 = t4*spbk4k1*spbk6k1
      t6 = NC*(es34+wW*mW*i_-mW*mW)
      t7 = spak5k6*spak5k6
      t8 = t6*t7
      t9 = t2*spak2k6
      t10 = t9*spak3k5
      t11 = t10*spbk6k1*spbk6k4
      t12 = es234*t1
      t13 = t12*i_
      t14 = t13*spak1k2
      t15 = es61*t6
      t7 = t15*t7
      t16 = t13*spak2k6
      abb23n1 = ((4.0_ki)*(t11/t8+t14/t7*spak3k5*spbk4k1*spbk6k1-(t16/t7*spak3k5&
      &*spbk6k1*spbk6k4+t5/t8)))
      t17 = es56*t1*i_
      t18 = t17*spak2k6
      t6 = t6*spak5k6
      t19 = t15*spak5k6
      abb23n2 = ((4.0_ki)*(t18/t8*spbk6k1+t14/t19*spbk5k1*spbk6k1-(es56*t12/t7*i&
      &_*spak2k6*spbk6k1+t3/t6*spbk5k1*spbk6k1)))
      t12 = t2*spak2k3
      t20 = t12*spbk5k4
      t21 = t20*spbk6k1
      t22 = t21/t6
      t23 = t13/t19*spak2k3*spbk5k4*spbk6k1
      t24 = t23-t22
      abb23n3 = ((8.0_ki)*t24)
      t25 = t3*spak3k6
      t26 = t25*spbk4k1*spbk6k1
      t27 = t26/t8
      t28 = t9*spak3k6
      t29 = t28*spbk6k1*spbk6k4
      t30 = t29/t8
      t14 = t14/t7*spak3k6*spbk4k1*spbk6k1
      t16 = t16/t7*spak3k6*spbk6k1*spbk6k4
      abb23n4 = ((4.0_ki)*(t14+t22+t30-(t27+t23+t16)))
      abb23n5 = ((8.0_ki)*(t16+t27-(t30+t14)))
      t14 = t2*spbk6k1
      abb23n6 = ((4.0_ki)*(t14/t6-t13/t19*spbk6k1))
      t13 = es34*t1/t19*i_*spak2k3*spbk5k4*spbk6k1
      t1 = es345*t1/t19*i_*spak2k3*spbk5k4*spbk6k1
      t16 = t18/t7*spak3k5*spbk5k4*spbk6k1
      t4 = t4/t19*spbk5k1*spbk5k4*spbk6k1
      abb23n7 = ((8.0_ki)*(t1+t24+t4-(t16+t13)))
      abb23n8 = ((8.0_ki)*(t13+t16+t22-(t4+t23+t1)))
      t1 = t3*spak1k3
      t4 = t3*spak2k3
      abb23n9 = ((4.0_ki)*(t1/t19*spbk5k1*spbk5k4*spbk6k1+t4/t19*spbk5k2*spbk5k4&
      &*spbk6k1-(t17/t7*spak1k3*spak2k6*spbk5k4*spbk6k1+t17/t8*spak2k3*spbk5k4))&
      &)
      abb23n10 = (-8.0_ki)*t3/t7*spbk6k1
      t13 = t20/t8
      t16 = t2*spak1k3
      t17 = t16*spak2k6
      t20 = t17/t7*spbk5k4*spbk6k1
      abb23n11 = ((4.0_ki)*(t13+t20))
      abb23n12 = ((8.0_ki)*(-(t20+t13)))
      t13 = spbk6k1*spbk6k1
      t20 = t2*spak1k5
      abb23n13 = ((4.0_ki)*(t13/t19*t3-t13*t20/t7*spak2k6))
      t3 = t20*spak2k3
      abb23n14 = ((4.0_ki)*(t1/t7*spbk4k1*spbk6k1+t4/t7*spbk4k2*spbk6k1+t16/t7*s&
      &pak2k5*spbk5k4*spbk6k1-(t3/t7*spbk5k4*spbk6k1+t17/t7*spbk6k1*spbk6k4+t12/&
      &t8*spbk6k4)))
      abb23n15 = ((4.0_ki)*t20/t7*spbk6k1)
      t1 = t12*spak2k6
      abb23n16 = ((4.0_ki)*(t1/t19*spbk5k2*spbk5k4*spbk6k1+t25/t19*spbk5k1*spbk5&
      &k4*spbk6k1-(t18/t7*spak3k6*spbk5k4*spbk6k1+t12/t6*spbk5k1*spbk5k4)))
      t4 = t20*spak3k6
      t6 = t3*spbk2k1
      abb23n17 = ((4.0_ki)*(t13/t19*t4*spbk5k4+t6/t19*spbk5k4*spbk6k1-(t13/t15*t&
      &16*spbk5k4+t21/t15*spbk6k2)))
      t15 = t12*spbk6k1
      abb23n18 = ((4.0_ki)*(t13*t4/t7+t6/t7*spbk6k1-(t15/t19*spbk6k2+t13*t16/t19&
      &)))
      t6 = t15/t19*spbk6k4
      t3 = t3/t7*spbk4k1*spbk6k1
      abb23n19 = ((8.0_ki)*(t6-t3))
      abb23n20 = ((4.0_ki)*(t3-t6))
      t3 = t2*spak2k5
      t6 = (16.0_ki)*t3/t7*spbk6k1
      abb23n21 = t6
      abb23n22 = -(t6)
      t6 = t21/t19
      t10 = t10/t7*spbk5k4*spbk6k1
      t13 = t10+t6
      abb23n23 = ((16.0_ki)*t13)
      abb23n24 = ((8.0_ki)*t13)
      t10 = -(t6+t10)
      abb23n25 = ((8.0_ki)*t10)
      abb23n26 = ((16.0_ki)*t10)
      t5 = t5/t7
      t10 = t12/t7*spak2k5*spbk4k2*spbk6k1
      t13 = t3/t7*spak3k5*spbk5k4*spbk6k1
      t11 = t11/t7
      abb23n27 = ((8.0_ki)*(t11-(t5+t13+t10)))
      abb23n28 = ((8.0_ki)*(t10+t13+t5-t11))
      t5 = t28/t7*spbk5k4*spbk6k1
      abb23n29 = ((4.0_ki)*t5)
      abb23n30 = (-8.0_ki)*t5
      abb23n31 = ((4.0_ki)*(t26/t7+t1/t7*spbk4k2*spbk6k1+t3/t7*spak3k6*spbk5k4*s&
      &pbk6k1-(t12/t8*spbk4k1+t29/t7+t6)))
      abb23n32 = (-8.0_ki)/t7*t9*spbk6k1
      abb23n33 = ((4.0_ki)*(t20/t7*spak3k5*spbk4k1*spbk6k1-t2/t19*spak3k5*spbk6k&
      &1*spbk6k4))
      t1 = t2/t19*spak3k6*spbk6k1*spbk6k4
      t2 = t4/t7*spbk4k1*spbk6k1
      abb23n34 = ((8.0_ki)*(t1-t2))
      abb23n35 = ((4.0_ki)*(t2-t1))
      abb23n36 = ((4.0_ki)*t14/t19)
      rat2d23 = 0
      rat2 = rat2 + rat2d23
      abb23n38 = abb23n1
      abb23n39 = abb23n36
      abb23n40 = abb23n35
      abb23n41 = abb23n34
      abb23n42 = abb23n33
      abb23n43 = abb23n32
      abb23n44 = abb23n31
      abb23n45 = abb23n30
      abb23n46 = abb23n29
      abb23n47 = abb23n28
      abb23n48 = abb23n27
      abb23n49 = abb23n26
      abb23n50 = abb23n25
      abb23n51 = abb23n24
      abb23n52 = abb23n23
      abb23n53 = abb23n22
      abb23n54 = abb23n21
      abb23n55 = abb23n20
      abb23n56 = abb23n19
      abb23n57 = abb23n18
      abb23n58 = abb23n17
      abb23n59 = abb23n16
      abb23n60 = abb23n15
      abb23n61 = abb23n14
      abb23n62 = abb23n13
      abb23n63 = abb23n12
      abb23n64 = abb23n11
      abb23n65 = abb23n10
      abb23n66 = abb23n9
      abb23n67 = abb23n8
      abb23n68 = abb23n7
      abb23n69 = abb23n6
      abb23n70 = abb23n5
      abb23n71 = abb23n4
      abb23n72 = abb23n3
      abb23n73 = abb23n2
   end subroutine
end module p9_udbar_neepgg_abbrevd23h0
