module     p9_udbar_neepgg_d115h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d115h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d115
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd115h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      real(ki) :: t18
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb115n31
         return
      end if
      t1 = k5(iv1)
      t2 = k6(iv1)
      t3 = spvak2k1(iv1)
      t4 = spvak2k4(iv1)
      t5 = spvak2k5(iv1)
      t6 = spvak2k6(iv1)
      t7 = spvak3k1(iv1)
      t8 = spvak3k5(iv1)
      t9 = spvak3k6(iv1)
      t10 = spvak5k6(iv1)
      t11 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb115n57+t10*abb115n53+t11*abb115n56+t2*abb115n52+t3*a&
         &bb115n43+t4*abb115n40+t5*abb115n55+t6*abb115n51+t7*abb115n44+t8*abb115&
         &n58+t9*abb115n54)
         return
      end if
      t16 = d(iv1,iv2)
      t12 = spvak5k6(iv2)
      t13 = spvak6k5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*t16*abb115n39+k5(iv2)*t10*abb115n37+k6(iv2)*t11*a&
         &bb115n34+spvak2k5(iv2)*t10*abb115n38+spvak2k6(iv2)*t11*abb115n35+spvak&
         &3k5(iv2)*t10*abb115n36+spvak3k6(iv2)*t11*abb115n32+t1*t12*abb115n37+t1&
         &0*t13*abb115n33+t11*t12*abb115n33+t12*t5*abb115n38+t12*t8*abb115n36+t1&
         &3*t2*abb115n34+t13*t6*abb115n35+t13*t9*abb115n32)
         return
      end if
      t17 = d(iv2,iv3)
      t1 = spvak2k1(iv2)
      t18 = d(iv1,iv3)
      t2 = spvak2k1(iv3)
      t5 = spvak2k4(iv2)
      t6 = spvak2k4(iv3)
      t8 = spvak3k1(iv2)
      t9 = spvak3k1(iv3)
      t14 = spvak5k6(iv3)
      t15 = spvak6k5(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t18*abb115n45+t10*t17*abb115n47+t11*t17*abb11&
         &5n48+t12*t18*abb115n47+t13*t18*abb115n48+t14*t16*abb115n47+t15*t16*abb&
         &115n48+t16*t2*abb115n45+t16*t6*abb115n41+t16*t9*abb115n46+t17*t3*abb11&
         &5n45+t17*t4*abb115n41+t17*t7*abb115n46+t18*t5*abb115n41+t18*t8*abb115n&
         &46)+t1*t10*t15*abb115n49+t1*t11*t14*abb115n49+t10*t13*t2*abb115n49+t10&
         &*t13*t6*abb115n42+t10*t13*t9*abb115n50+t10*t15*t5*abb115n42+t10*t15*t8&
         &*abb115n50+t11*t12*t2*abb115n49+t11*t12*t6*abb115n42+t11*t12*t9*abb115&
         &n50+t11*t14*t5*abb115n42+t11*t14*t8*abb115n50+t12*t15*t3*abb115n49+t12&
         &*t15*t4*abb115n42+t12*t15*t7*abb115n50+t13*t14*t3*abb115n49+t13*t14*t4&
         &*abb115n42+t13*t14*t7*abb115n50)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d115:
   subroutine     reconstruct_d115(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group0
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group0), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_115:
      coeffs%coeffs_115%c0 = derivative(czip)
      coeffs%coeffs_115%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_115%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_115%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_115%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_115%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_115%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_115%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_115%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_115%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_115%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_115%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_115%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_115%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_115%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_115%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_115%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_115%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_115%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_115%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_115%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_115%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_115%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_115%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_115%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_115%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_115%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_115%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_115%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_115%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_115%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_115%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_115%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_115%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_115%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_115:
   end subroutine reconstruct_d115
!---#] subroutine reconstruct_d115:
end module p9_udbar_neepgg_d115h0l1d
