module     p9_udbar_neepgg_d17h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d17h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d17
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd17h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      real(ki) :: t54
      real(ki) :: t55
      real(ki) :: t56
      real(ki) :: t57
      real(ki) :: t58
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t54 = dotproduct(k1, qshift)
      t55 = dotproduct(k6, qshift)
      t56 = dotproduct(qshift, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t57 = dotproduct(k2, qshift)
      t3 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t58 = dotproduct(k5, qshift)
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t5 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t6 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t8 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb17n47+t1*abb17n71+t2*abb17n72+t3*abb17n82+t4*abb17n86+t&
         &5*abb17n88+t54*abb17n85+t54*t54*abb17n53+t55*abb17n84+t55*t55*abb17n53&
         &+t56*abb17n62+t57*abb17n73+t58*abb17n83+t1*t3*abb17n59+t1*t4*abb17n69+&
         &t1*t5*abb17n68+t1*t54*abb17n63+t1*t55*abb17n64+t1*t56*abb17n74+t1*t6*a&
         &bb17n65+t1*t7*abb17n70+t2*t3*abb17n58+t2*t54*abb17n67+t2*t55*abb17n66+&
         &t2*t56*abb17n76+t2*t58*abb17n66+t3*t4*abb17n57+t3*t5*abb17n48+t3*t54*a&
         &bb17n51+t3*t55*abb17n52+t3*t57*abb17n56+t4*t54*abb17n60+t4*t55*abb17n6&
         &1+t4*t56*abb17n80+t4*t58*abb17n61+t5*t54*abb17n49+t5*t55*abb17n50+t5*t&
         &56*abb17n96+t5*t58*abb17n50+t54*t55*abb17n55+t54*t56*abb17n93+t54*t58*&
         &abb17n54+t55*t56*abb17n91+t55*t58*abb17n53+t1*t3*t4*abb17n78+t1*t3*t5*&
         &abb17n98+t1*t3*t54*abb17n89+t1*t3*t55*abb17n90+t1*t3*t7*abb17n87+t1*t3&
         &*t8*abb17n99)
         return
      end if
      t9 = k1(iv1)
      t10 = k2(iv1)
      t11 = k5(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak2k4(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak6k5(iv1)
      t19 = spvak2k1(iv1)
      t20 = t14*abb17n66
      t21 = spvak2k5(iv1)
      t22 = t16*abb17n61
      t23 = t17*abb17n50
      t24 = spvak2k6(iv1)
      if(deg.eq.1) then
         numerator = (t10*abb17n73+t11*abb17n83+t12*abb17n84+t13*abb17n79+t14*ab&
         &b17n72+t15*abb17n71+t16*abb17n86+t17*abb17n88+t18*abb17n82+t20*t55+t20&
         &*t58+t22*t55+t22*t58+t23*t55+t23*t58+t9*abb17n85+t1*t12*abb17n64+t1*t1&
         &3*abb17n75+t1*t16*abb17n69+t1*t17*abb17n68+t1*t18*abb17n59+t1*t19*abb1&
         &7n70+t1*t21*abb17n65+t1*t9*abb17n63+t10*t3*abb17n56+t11*t2*abb17n66+t1&
         &1*t4*abb17n61+t11*t5*abb17n50+t11*t54*abb17n54+t11*t55*abb17n53+t12*t2&
         &*abb17n66+t12*t3*abb17n52+t12*t4*abb17n61+t12*t5*abb17n50+t12*t54*abb1&
         &7n55+t12*t55*abb17n95+t12*t56*abb17n91+t12*t58*abb17n53+t13*t2*abb17n7&
         &7+t13*t4*abb17n81+t13*t5*abb17n97+t13*t54*abb17n94+t13*t55*abb17n92+t1&
         &4*t3*abb17n58+t14*t54*abb17n67+t14*t56*abb17n76+t15*t3*abb17n59+t15*t4&
         &*abb17n69+t15*t5*abb17n68+t15*t54*abb17n63+t15*t55*abb17n64+t15*t56*ab&
         &b17n74+t15*t6*abb17n65+t15*t7*abb17n70+t16*t3*abb17n57+t16*t54*abb17n6&
         &0+t16*t56*abb17n80+t17*t3*abb17n48+t17*t54*abb17n49+t17*t56*abb17n96+t&
         &18*t2*abb17n58+t18*t4*abb17n57+t18*t5*abb17n48+t18*t54*abb17n51+t18*t5&
         &5*abb17n52+t18*t57*abb17n56+t2*t9*abb17n67+t3*t9*abb17n51+t4*t9*abb17n&
         &60+t5*t9*abb17n49+t54*t9*abb17n95+t55*t9*abb17n55+t56*t9*abb17n93+t58*&
         &t9*abb17n54+t1*t12*t3*abb17n90+t1*t16*t3*abb17n78+t1*t17*t3*abb17n98+t&
         &1*t18*t4*abb17n78+t1*t18*t5*abb17n98+t1*t18*t54*abb17n89+t1*t18*t55*ab&
         &b17n90+t1*t18*t7*abb17n87+t1*t18*t8*abb17n99+t1*t19*t3*abb17n87+t1*t24&
         &*t3*abb17n99+t1*t3*t9*abb17n89+t15*t3*t4*abb17n78+t15*t3*t5*abb17n98+t&
         &15*t3*t54*abb17n89+t15*t3*t55*abb17n90+t15*t3*t7*abb17n87+t15*t3*t8*ab&
         &b17n99)
         return
      end if
      t56 = d(iv1,iv2)
      t6 = k1(iv2)
      t20 = k6(iv2)
      t22 = k5(iv2)
      t23 = qshift(iv2)
      t25 = spvak2k4(iv2)
      t26 = spvak3k4(iv2)
      t27 = t26*t9
      t28 = spvak5k1(iv2)
      t29 = spvak5k6(iv2)
      t30 = spvak6k5(iv2)
      t31 = t30*t9
      t32 = t15*t6
      t33 = t18*t6
      t34 = t12*t26
      t35 = t12*t30
      t36 = t15*t20
      t37 = t18*t20
      t38 = t19*t26
      t39 = spvak2k1(iv2)
      t40 = t15*t39
      t41 = t15*t28
      t42 = t15*t29
      t43 = t15*t30
      t44 = t16*t26
      t45 = t17*t26
      t46 = t18*t26
      t47 = t16*t30
      t48 = t18*t28
      t49 = t17*t30
      t50 = t18*t29
      t51 = t24*t26
      t52 = spvak2k6(iv2)
      t53 = t15*t52
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t56*abb17n62+t1*t56*abb17n74+t12*t20*abb17n53+t2&
         &*t56*abb17n76+t4*t56*abb17n80+t5*t56*abb17n96+t54*t56*abb17n93+t55*t56&
         &*abb17n91+t6*t9*abb17n53)+t27*abb17n63+t31*abb17n51+t32*abb17n63+t33*a&
         &bb17n51+t34*abb17n64+t35*abb17n52+t36*abb17n64+t37*abb17n52+t38*abb17n&
         &70+t40*abb17n70+t41*abb17n69+t42*abb17n68+t43*abb17n59+t44*abb17n69+t4&
         &5*abb17n68+t46*abb17n59+t47*abb17n57+t48*abb17n57+t49*abb17n48+t50*abb&
         &17n48+k2(iv2)*t18*abb17n56+spvak2k5(iv2)*t15*abb17n65+t1*t31*abb17n89+&
         &t1*t33*abb17n89+t1*t35*abb17n90+t1*t37*abb17n90+t1*t47*abb17n78+t1*t48&
         &*abb17n78+t1*t49*abb17n98+t1*t50*abb17n98+t10*t30*abb17n56+t11*t20*abb&
         &17n53+t11*t25*abb17n66+t11*t28*abb17n61+t11*t29*abb17n50+t11*t6*abb17n&
         &54+t12*t22*abb17n53+t12*t23*abb17n92+t12*t25*abb17n66+t12*t28*abb17n61&
         &+t12*t29*abb17n50+t12*t6*abb17n55+t13*t20*abb17n92+t13*t25*abb17n77+t1&
         &3*t26*abb17n75+t13*t28*abb17n81+t13*t29*abb17n97+t13*t6*abb17n94+t14*t&
         &20*abb17n66+t14*t22*abb17n66+t14*t23*abb17n77+t14*t30*abb17n58+t14*t6*&
         &abb17n67+t15*t23*abb17n75+t16*t20*abb17n61+t16*t22*abb17n61+t16*t23*ab&
         &b17n81+t16*t6*abb17n60+t17*t20*abb17n50+t17*t22*abb17n50+t17*t23*abb17&
         &n97+t17*t6*abb17n49+t18*t25*abb17n58+t20*t9*abb17n55+t21*t26*abb17n65+&
         &t22*t9*abb17n54+t23*t9*abb17n94+t25*t9*abb17n67+t27*t3*abb17n89+t28*t9&
         &*abb17n60+t29*t9*abb17n49+t3*t32*abb17n89+t3*t34*abb17n90+t3*t36*abb17&
         &n90+t3*t38*abb17n87+t3*t40*abb17n87+t3*t41*abb17n78+t3*t42*abb17n98+t3&
         &*t44*abb17n78+t3*t45*abb17n98+t3*t51*abb17n99+t3*t53*abb17n99+t4*t43*a&
         &bb17n78+t4*t46*abb17n78+t43*t5*abb17n98+t43*t54*abb17n89+t43*t55*abb17&
         &n90+t43*t7*abb17n87+t43*t8*abb17n99+t46*t5*abb17n98+t46*t54*abb17n89+t&
         &46*t55*abb17n90+t46*t7*abb17n87+t46*t8*abb17n99+t1*t18*t39*abb17n87+t1&
         &*t18*t52*abb17n99+t1*t19*t30*abb17n87+t1*t24*t30*abb17n99)
         return
      end if
      t54 = d(iv2,iv3)
      t55 = d(iv1,iv3)
      t1 = k1(iv3)
      t2 = k6(iv3)
      t3 = spvak3k4(iv3)
      t4 = spvak5k1(iv3)
      t5 = spvak5k6(iv3)
      t7 = spvak6k5(iv3)
      t8 = spvak2k1(iv3)
      t10 = spvak2k6(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t56*abb17n76+t1*t56*abb17n93+t12*t&
         &54*abb17n91+t14*t54*abb17n76+t15*t54*abb17n74+t16*t54*abb17n80+t17*t54&
         &*abb17n96+t2*t56*abb17n91+t20*t55*abb17n91+t25*t55*abb17n76+t26*t55*ab&
         &b17n74+t28*t55*abb17n80+t29*t55*abb17n96+t3*t56*abb17n74+t4*t56*abb17n&
         &80+t5*t56*abb17n96+t54*t9*abb17n93+t55*t6*abb17n93)+t27*t7*abb17n89+t3&
         &2*t7*abb17n89+t34*t7*abb17n90+t36*t7*abb17n90+t38*t7*abb17n87+t40*t7*a&
         &bb17n87+t41*t7*abb17n78+t42*t7*abb17n98+t44*t7*abb17n78+t45*t7*abb17n9&
         &8+t51*t7*abb17n99+t53*t7*abb17n99+t1*t15*t30*abb17n89+t1*t18*t26*abb17&
         &n89+t10*t15*t30*abb17n99+t10*t18*t26*abb17n99+t12*t3*t30*abb17n90+t15*&
         &t2*t30*abb17n90+t15*t30*t4*abb17n78+t15*t30*t5*abb17n98+t15*t30*t8*abb&
         &17n87+t16*t3*t30*abb17n78+t17*t3*t30*abb17n98+t18*t2*t26*abb17n90+t18*&
         &t20*t3*abb17n90+t18*t26*t4*abb17n78+t18*t26*t5*abb17n98+t18*t26*t8*abb&
         &17n87+t18*t28*t3*abb17n78+t18*t29*t3*abb17n98+t18*t3*t39*abb17n87+t18*&
         &t3*t52*abb17n99+t18*t3*t6*abb17n89+t19*t3*t30*abb17n87+t24*t3*t30*abb1&
         &7n99+t3*t30*t9*abb17n89)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d17:
   subroutine     reconstruct_d17(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group11
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group11), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_17:
      coeffs%coeffs_17%c0 = derivative(czip)
      coeffs%coeffs_17%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_17%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_17%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_17%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_17%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_17%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_17%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_17%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_17%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_17%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_17%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_17%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_17%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_17%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_17%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_17%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_17%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_17%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_17%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_17%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_17%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_17%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_17%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_17%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_17%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_17%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_17%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_17%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_17%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_17%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_17%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_17%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_17%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_17%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_17:
   end subroutine reconstruct_d17
!---#] subroutine reconstruct_d17:
end module p9_udbar_neepgg_d17h0l1d
