module     p9_udbar_neepgg_d28h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d28h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d28
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd28h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      real(ki) :: t35
      real(ki) :: t36
      real(ki) :: t37
      real(ki) :: t38
      real(ki) :: t39
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t35 = dotproduct(qshift, qshift)
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t36 = dotproduct(k2, qshift)
      t37 = dotproduct(k5, qshift)
      t38 = dotproduct(k6, qshift)
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t3 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t39 = dotproduct(k1, qshift)
      t4 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t7 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t8 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb28n30+t1*abb28n63+t2*abb28n76+t3*abb28n79+t35*abb28n41+&
         &t36*abb28n69+t37*abb28n70+t38*abb28n71+t39*abb28n81+t4*abb28n90+t1*t2*&
         &abb28n37+t2*t3*abb28n39+t2*t35*abb28n73+t2*t36*abb28n46+t2*t37*abb28n4&
         &6+t2*t38*abb28n46+t2*t4*abb28n34+t2*t5*abb28n32+t2*t6*abb28n38+t2*t7*a&
         &bb28n43+t2*t8*abb28n44+t3*t35*abb28n59+t3*t37*abb28n55+t3*t39*abb28n56&
         &+t3*t4*abb28n51+t35*t4*abb28n86+t35*t5*abb28n66+t36*t4*abb28n37+t37*t4&
         &*abb28n35+t38*t4*abb28n35+t39*t5*abb28n53+t2*t3*t6*abb28n92)
         return
      end if
      t9 = k1(iv1)
      t10 = k2(iv1)
      t11 = k5(iv1)
      t12 = k6(iv1)
      t13 = qshift(iv1)
      t14 = spvak3k4(iv1)
      t15 = spvak5k1(iv1)
      t16 = spvak6k1(iv1)
      t17 = spvak6k5(iv1)
      t18 = spvak2k1(iv1)
      t19 = spvak2k5(iv1)
      t20 = spvak2k6(iv1)
      t21 = spvak3k1(iv1)
      t22 = t16*abb28n88
      t23 = t17*abb28n75
      if(deg.eq.1) then
         numerator = (t10*abb28n50+t11*abb28n49+t12*abb28n48+t13*abb28n80+t14*ab&
         &b28n42+t15*abb28n54+t16*abb28n33+t17*abb28n45+t22*t37+t22*t38+t23*t36+&
         &t23*t37+t23*t38+t9*abb28n40+t1*t17*abb28n84+t10*t2*abb28n75+t10*t4*abb&
         &28n84+t11*t2*abb28n75+t11*t3*abb28n62+t11*t4*abb28n88+t12*t2*abb28n75+&
         &t12*t4*abb28n88+t13*t2*abb28n72+t13*t3*abb28n58+t13*t4*abb28n85+t13*t5&
         &*abb28n65+t14*t2*abb28n82+t14*t35*abb28n57+t14*t37*abb28n62+t14*t39*ab&
         &b28n61+t14*t4*abb28n68+t15*t2*abb28n84+t16*t2*abb28n89+t16*t3*abb28n68&
         &+t16*t35*abb28n36+t16*t36*abb28n84+t17*t3*abb28n82+t17*t35*abb28n47+t1&
         &7*t4*abb28n89+t17*t5*abb28n91+t17*t6*abb28n83+t17*t7*abb28n78+t17*t8*a&
         &bb28n77+t18*t2*abb28n83+t19*t2*abb28n77+t2*t20*abb28n78+t2*t21*abb28n9&
         &1+t21*t35*abb28n52+t21*t39*abb28n64+t3*t9*abb28n61+t5*t9*abb28n64+t14*&
         &t2*t6*abb28n31+t17*t3*t6*abb28n31+t18*t2*t3*abb28n31)
         return
      end if
      t35 = d(iv1,iv2)
      t1 = spvak3k1(iv2)
      t7 = spvak3k4(iv2)
      t8 = k1(iv2)
      t22 = spvak6k1(iv2)
      t23 = spvak6k5(iv2)
      t24 = k2(iv2)
      t25 = k5(iv2)
      t26 = k6(iv2)
      t27 = qshift(iv2)
      t28 = t18*t23
      t29 = spvak2k1(iv2)
      t30 = t17*t29
      t31 = t14*t23
      t32 = t17*t7
      t33 = t18*t7
      t34 = t14*t29
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t35*abb28n41+t2*t35*abb28n73+t3*t35*abb28n59+t35&
         &*t4*abb28n86+t35*t5*abb28n66)+t28*abb28n38+t30*abb28n38+t31*abb28n39+t&
         &32*abb28n39+spvak2k5(iv2)*t17*abb28n44+spvak2k6(iv2)*t17*abb28n43+spva&
         &k5k1(iv2)*t17*abb28n37+t1*t13*abb28n67+t1*t17*abb28n32+t1*t9*abb28n53+&
         &t10*t22*abb28n37+t10*t23*abb28n46+t11*t22*abb28n35+t11*t23*abb28n46+t1&
         &1*t7*abb28n55+t12*t22*abb28n35+t12*t23*abb28n46+t13*t22*abb28n87+t13*t&
         &23*abb28n74+t13*t7*abb28n60+t14*t22*abb28n51+t14*t25*abb28n55+t14*t27*&
         &abb28n60+t14*t8*abb28n56+t15*t23*abb28n37+t16*t23*abb28n34+t16*t24*abb&
         &28n37+t16*t25*abb28n35+t16*t26*abb28n35+t16*t27*abb28n87+t16*t7*abb28n&
         &51+t17*t22*abb28n34+t17*t24*abb28n46+t17*t25*abb28n46+t17*t26*abb28n46&
         &+t17*t27*abb28n74+t19*t23*abb28n44+t2*t33*abb28n92+t2*t34*abb28n92+t20&
         &*t23*abb28n43+t21*t23*abb28n32+t21*t27*abb28n67+t21*t8*abb28n53+t28*t3&
         &*abb28n92+t3*t30*abb28n92+t31*t6*abb28n92+t32*t6*abb28n92+t7*t9*abb28n&
         &56)
         return
      end if
      t36 = d(iv2,iv3)
      t37 = d(iv1,iv3)
      t2 = spvak3k4(iv3)
      t3 = spvak6k5(iv3)
      t4 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak3k1(iv3)*t35*abb28n52+spvak6k1(iv3)*t35*abb&
         &28n36+t1*t37*abb28n52+t14*t36*abb28n57+t16*t36*abb28n36+t17*t36*abb28n&
         &47+t2*t35*abb28n57+t21*t36*abb28n52+t22*t37*abb28n36+t23*t37*abb28n47+&
         &t3*t35*abb28n47+t37*t7*abb28n57)+t3*t33*abb28n31+t3*t34*abb28n31+t14*t&
         &23*t4*abb28n31+t17*t2*t29*abb28n31+t17*t4*t7*abb28n31+t18*t2*t23*abb28&
         &n31)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d28:
   subroutine     reconstruct_d28(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_28:
      coeffs%coeffs_28%c0 = derivative(czip)
      coeffs%coeffs_28%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_28%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_28%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_28%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_28%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_28%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_28%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_28%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_28%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_28%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_28%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_28%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_28%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_28%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_28%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_28%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_28%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_28%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_28%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_28%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_28%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_28%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_28%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_28%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_28%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_28%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_28%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_28%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_28%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_28%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_28%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_28%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_28%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_28%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_28:
   end subroutine reconstruct_d28
!---#] subroutine reconstruct_d28:
end module p9_udbar_neepgg_d28h0l1d
