module     p9_udbar_neepgg_d61h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d61h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d61
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd61h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      real(ki) :: t19
      real(ki) :: t20
      real(ki) :: t21
      real(ki) :: t22
      real(ki) :: t23
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t19 = dotproduct(k6, qshift)
      t20 = dotproduct(k5, qshift)
      t1 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t2 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t3 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t4 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t21 = dotproduct(k1, qshift)
      t22 = dotproduct(k3, qshift)
      t23 = dotproduct(k4, qshift)
      if(deg.eq.0) then
         numerator = (abb61n25+t19*abb61n56+t20*abb61n59+abb61n33*dotproduct(qsh&
         &ift, qshift)+abb61n51*(spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spv&
         &ak6k4(3)*qshift(3)-spvak6k4(4)*qshift(4))+abb61n52*(spvak5k4(1)*qshift&
         &(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshift(3)-spvak5k4(4)*qshift(4))&
         &+abb61n55*(spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qsh&
         &ift(3)-spvak2k6(4)*qshift(4))+abb61n57*(spvak3k6(1)*qshift(1)-spvak3k6&
         &(2)*qshift(2)-spvak3k6(3)*qshift(3)-spvak3k6(4)*qshift(4))+abb61n58*(s&
         &pvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-spvak&
         &2k5(4)*qshift(4))+abb61n61*(spvak3k5(1)*qshift(1)-spvak3k5(2)*qshift(2&
         &)-spvak3k5(3)*qshift(3)-spvak3k5(4)*qshift(4))+abb61n64*(spvak6k1(1)*q&
         &shift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*qshif&
         &t(4))+abb61n65*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3&
         &)*qshift(3)-spvak5k1(4)*qshift(4))+t1*t19*abb61n26+t1*t20*abb61n27+t19&
         &*t2*abb61n31+t19*t21*abb61n46+t19*t22*abb61n45+t19*t23*abb61n45+t19*t3&
         &*abb61n39+t19*t4*abb61n44+t2*t20*abb61n30+t20*t21*abb61n45+t20*t22*abb&
         &61n46+t20*t23*abb61n46+t20*t3*abb61n40+t20*t4*abb61n43)
         return
      end if
      t5 = k5(iv1)
      t6 = k6(iv1)
      t7 = k1(iv1)
      t8 = k3(iv1)
      t9 = k4(iv1)
      t10 = t5*abb61n47
      t11 = t6*abb61n48
      t12 = spvak2k1(iv1)
      t13 = spvak2k4(iv1)
      t14 = spvak3k1(iv1)
      t15 = spvak3k4(iv1)
      if(deg.eq.1) then
         numerator = (qshift(iv1)*abb61n60+spvak2k5(iv1)*abb61n35+spvak2k6(iv1)*&
         &abb61n38+spvak3k5(iv1)*abb61n32+spvak3k6(iv1)*abb61n36+spvak5k1(iv1)*a&
         &bb61n28+spvak5k4(iv1)*abb61n41+spvak6k1(iv1)*abb61n29+spvak6k4(iv1)*ab&
         &b61n42+t10*t22+t10*t23+t11*t22+t11*t23+t5*abb61n34+t6*abb61n37+t1*t5*a&
         &bb61n66+t1*t6*abb61n67+t12*t19*abb61n62+t12*t20*abb61n63+t13*t19*abb61&
         &n54+t13*t20*abb61n53+t14*t19*abb61n67+t14*t20*abb61n66+t15*t19*abb61n4&
         &9+t15*t20*abb61n50+t19*t7*abb61n47+t19*t8*abb61n48+t19*t9*abb61n48+t2*&
         &t5*abb61n63+t2*t6*abb61n62+t20*t7*abb61n48+t20*t8*abb61n47+t20*t9*abb6&
         &1n47+t21*t5*abb61n48+t21*t6*abb61n47+t3*t5*abb61n53+t3*t6*abb61n54+t4*&
         &t5*abb61n50+t4*t6*abb61n49)
         return
      end if
      t1 = k5(iv2)
      t2 = k6(iv2)
      t3 = k1(iv2)
      t4 = k3(iv2)
      t10 = k4(iv2)
      t11 = spvak2k1(iv2)
      t16 = spvak2k4(iv2)
      t17 = spvak3k1(iv2)
      t18 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb61n33+t1*t12*abb61n30+t1*t13*abb61n&
         &40+t1*t14*abb61n27+t1*t15*abb61n43+t1*t7*abb61n45+t1*t8*abb61n46+t1*t9&
         &*abb61n46+t10*t5*abb61n46+t10*t6*abb61n45+t11*t5*abb61n30+t11*t6*abb61&
         &n31+t12*t2*abb61n31+t13*t2*abb61n39+t14*t2*abb61n26+t15*t2*abb61n44+t1&
         &6*t5*abb61n40+t16*t6*abb61n39+t17*t5*abb61n27+t17*t6*abb61n26+t18*t5*a&
         &bb61n43+t18*t6*abb61n44+t2*t7*abb61n46+t2*t8*abb61n45+t2*t9*abb61n45+t&
         &3*t5*abb61n45+t3*t6*abb61n46+t4*t5*abb61n46+t4*t6*abb61n45)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d61:
   subroutine     reconstruct_d61(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_61:
      coeffs%coeffs_61%c0 = derivative(czip)
      coeffs%coeffs_61%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_61%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_61%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_61%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_61%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_61%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_61%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_61%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_61%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_61%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_61%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_61%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_61%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_61%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_61:
   end subroutine reconstruct_d61
!---#] subroutine reconstruct_d61:
end module p9_udbar_neepgg_d61h0l1d
