module     p9_udbar_neepgg_d88h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d88h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d88
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd88h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      complex(ki) :: t158
      complex(ki) :: t159
      complex(ki) :: t160
      complex(ki) :: t161
      complex(ki) :: t162
      complex(ki) :: t163
      complex(ki) :: t164
      complex(ki) :: t165
      complex(ki) :: t166
      complex(ki) :: t167
      complex(ki) :: t168
      complex(ki) :: t169
      complex(ki) :: t170
      complex(ki) :: t171
      complex(ki) :: t172
      complex(ki) :: t173
      complex(ki) :: t174
      complex(ki) :: t175
      complex(ki) :: t176
      complex(ki) :: t177
      complex(ki) :: t178
      complex(ki) :: t179
      complex(ki) :: t180
      real(ki) :: t181
      real(ki) :: t182
      real(ki) :: t183
      real(ki) :: t184
      real(ki) :: t185
      real(ki) :: t186
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t181 = dotproduct(k1, qshift)
      t182 = dotproduct(qshift, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t183 = dotproduct(k2, qshift)
      t3 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t184 = dotproduct(k5, qshift)
      t4 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t5 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t185 = dotproduct(k6, qshift)
      t6 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t7 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t8 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t9 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t10 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-s&
      &pvak3k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb88n83+t1*abb88n124+t181*abb88n140+t181*t181*abb88n109+t&
         &182*abb88n113+t182*t182*abb88n99+t183*abb88n128+t184*abb88n130+t185*ab&
         &b88n141+t2*abb88n125+t3*abb88n129+t4*abb88n131+t5*abb88n133+t1*t181*ab&
         &b88n120+t1*t182*abb88n126+t1*t185*abb88n121+t1*t2*abb88n122+t1*t3*abb8&
         &8n114+t1*t4*abb88n119+t1*t5*abb88n123+t181*t182*abb88n158+t181*t183*ab&
         &b88n98+t181*t184*abb88n108+t181*t185*abb88n100+t181*t2*abb88n86+t181*t&
         &3*abb88n110+t181*t4*abb88n104+t181*t5*abb88n92+t182*t183*abb88n154+t18&
         &2*t184*abb88n145+t182*t185*abb88n158+t182*t2*abb88n178+t182*t3*abb88n1&
         &42+t182*t4*abb88n163+t182*t5*abb88n174+t183*t2*abb88n117+t183*t3*abb88&
         &n118+t183*t4*abb88n112+t184*t185*abb88n107+t184*t2*abb88n87+t184*t4*ab&
         &b88n105+t184*t5*abb88n91+t185*t2*abb88n116+t185*t3*abb88n111+t185*t4*a&
         &bb88n112+t2*t3*abb88n89+t2*t4*abb88n88+t3*t4*abb88n106+t3*t5*abb88n94+&
         &t4*t5*abb88n93+t4*t6*abb88n102+t1*t181*t3*abb88n161+t1*t181*t4*abb88n1&
         &47+t1*t181*t5*abb88n177+t1*t182*t3*abb88n97+t1*t182*t4*abb88n103+t1*t1&
         &82*t5*abb88n90+t1*t185*t3*abb88n160+t1*t3*t4*abb88n165+t1*t4*t5*abb88n&
         &132+t1*t4*t8*abb88n138+t1*t4*t9*abb88n153+t10*t181*t4*abb88n182+t10*t1&
         &82*t4*abb88n85+t10*t184*t4*abb88n180+t10*t3*t4*abb88n183+t181*t3*t4*ab&
         &b88n134+t181*t4*t5*abb88n167+t181*t4*t7*abb88n150+t182*t2*t3*abb88n95+&
         &t182*t3*t4*abb88n115+t182*t4*t5*abb88n96+t182*t4*t7*abb88n101+t183*t2*&
         &t3*abb88n173+t183*t3*t4*abb88n135+t184*t4*t5*abb88n170+t184*t4*t7*abb8&
         &8n152+t185*t2*t3*abb88n171+t185*t3*t4*abb88n135+t2*t3*t4*abb88n168+t3*&
         &t4*t5*abb88n173+t3*t4*t6*abb88n137+t3*t4*t7*abb88n149+t3*t4*t8*abb88n1&
         &66+t1*t3*t4*t8*abb88n84)
         return
      end if
      t11 = k1(iv1)
      t12 = k2(iv1)
      t13 = k5(iv1)
      t14 = k6(iv1)
      t15 = qshift(iv1)
      t16 = spvak3k4(iv1)
      t17 = spvak5k1(iv1)
      t18 = spvak5k6(iv1)
      t19 = spvak6k1(iv1)
      t20 = spvak6k5(iv1)
      t21 = t15*abb88n159
      t22 = spvak2k6(iv1)
      t23 = t18*abb88n112
      t24 = spvak2k1(iv1)
      t25 = spvak2k4(iv1)
      t26 = spvak2k5(iv1)
      t27 = spvak3k1(iv1)
      t28 = t18*abb88n135
      t29 = t20*abb88n135
      t30 = t20*abb88n173
      if(deg.eq.1) then
         numerator = (t11*abb88n140+t12*abb88n128+t13*abb88n130+t14*abb88n141+t1&
         &5*abb88n139+t16*abb88n124+t17*abb88n125+t18*abb88n131+t181*t21+t183*t2&
         &3+t185*t21+t185*t23+t19*abb88n133+t20*abb88n129+t1*t11*abb88n120+t1*t1&
         &4*abb88n121+t1*t15*abb88n127+t1*t17*abb88n122+t1*t18*abb88n119+t1*t19*&
         &abb88n123+t1*t20*abb88n114+t11*t181*abb88n144+t11*t182*abb88n158+t11*t&
         &183*abb88n98+t11*t184*abb88n108+t11*t185*abb88n100+t11*t2*abb88n86+t11&
         &*t3*abb88n110+t11*t4*abb88n104+t11*t5*abb88n92+t12*t181*abb88n98+t12*t&
         &182*abb88n154+t12*t2*abb88n117+t12*t3*abb88n118+t12*t4*abb88n112+t13*t&
         &181*abb88n108+t13*t182*abb88n145+t13*t185*abb88n107+t13*t2*abb88n87+t1&
         &3*t4*abb88n105+t13*t5*abb88n91+t14*t181*abb88n100+t14*t182*abb88n158+t&
         &14*t184*abb88n107+t14*t2*abb88n116+t14*t3*abb88n111+t14*t4*abb88n112+t&
         &15*t182*abb88n156+t15*t183*abb88n155+t15*t184*abb88n146+t15*t2*abb88n1&
         &79+t15*t3*abb88n143+t15*t4*abb88n164+t15*t5*abb88n175+t16*t181*abb88n1&
         &20+t16*t182*abb88n126+t16*t185*abb88n121+t16*t2*abb88n122+t16*t3*abb88&
         &n114+t16*t4*abb88n119+t16*t5*abb88n123+t17*t181*abb88n86+t17*t182*abb8&
         &8n178+t17*t183*abb88n117+t17*t184*abb88n87+t17*t185*abb88n116+t17*t3*a&
         &bb88n89+t17*t4*abb88n88+t18*t181*abb88n104+t18*t182*abb88n163+t18*t184&
         &*abb88n105+t18*t2*abb88n88+t18*t3*abb88n106+t18*t5*abb88n93+t18*t6*abb&
         &88n102+t181*t19*abb88n92+t181*t20*abb88n110+t182*t19*abb88n174+t182*t2&
         &0*abb88n142+t183*t2*t30+t183*t20*abb88n118+t183*t28*t3+t183*t29*t4+t18&
         &4*t19*abb88n91+t185*t20*abb88n111+t185*t28*t3+t185*t29*t4+t19*t3*abb88&
         &n94+t19*t4*abb88n93+t2*t20*abb88n89+t20*t4*abb88n106+t20*t5*abb88n94+t&
         &22*t4*abb88n102+t30*t4*t5+t1*t11*t3*abb88n161+t1*t11*t4*abb88n147+t1*t&
         &11*t5*abb88n177+t1*t14*t3*abb88n160+t1*t15*t3*abb88n162+t1*t15*t4*abb8&
         &8n148+t1*t15*t5*abb88n176+t1*t18*t181*abb88n147+t1*t18*t182*abb88n103+&
         &t1*t18*t3*abb88n165+t1*t18*t5*abb88n132+t1*t18*t8*abb88n138+t1*t18*t9*&
         &abb88n153+t1*t181*t19*abb88n177+t1*t181*t20*abb88n161+t1*t182*t19*abb8&
         &8n90+t1*t182*t20*abb88n97+t1*t185*t20*abb88n160+t1*t19*t4*abb88n132+t1&
         &*t20*t4*abb88n165+t1*t24*t4*abb88n138+t1*t26*t4*abb88n153+t10*t11*t4*a&
         &bb88n182+t10*t13*t4*abb88n180+t10*t15*t4*abb88n181+t10*t18*t181*abb88n&
         &182+t10*t18*t182*abb88n85+t10*t18*t184*abb88n180+t10*t18*t3*abb88n183+&
         &t10*t20*t4*abb88n183+t11*t3*t4*abb88n134+t11*t4*t5*abb88n167+t11*t4*t7&
         &*abb88n150+t12*t2*t3*abb88n173+t12*t3*t4*abb88n135+t13*t4*t5*abb88n170&
         &+t13*t4*t7*abb88n152+t14*t2*t3*abb88n171+t14*t3*t4*abb88n135+t15*t2*t3&
         &*abb88n172+t15*t3*t4*abb88n136+t15*t4*t5*abb88n169+t15*t4*t7*abb88n151&
         &+t16*t181*t3*abb88n161+t16*t181*t4*abb88n147+t16*t181*t5*abb88n177+t16&
         &*t182*t3*abb88n97+t16*t182*t4*abb88n103+t16*t182*t5*abb88n90+t16*t185*&
         &t3*abb88n160+t16*t3*t4*abb88n165+t16*t4*t5*abb88n132+t16*t4*t8*abb88n1&
         &38+t16*t4*t9*abb88n153+t17*t182*t3*abb88n95+t17*t183*t3*abb88n173+t17*&
         &t185*t3*abb88n171+t17*t3*t4*abb88n168+t18*t181*t3*abb88n134+t18*t181*t&
         &5*abb88n167+t18*t181*t7*abb88n150+t18*t182*t3*abb88n115+t18*t182*t5*ab&
         &b88n96+t18*t182*t7*abb88n101+t18*t184*t5*abb88n170+t18*t184*t7*abb88n1&
         &52+t18*t2*t3*abb88n168+t18*t3*t5*abb88n173+t18*t3*t6*abb88n137+t18*t3*&
         &t7*abb88n149+t18*t3*t8*abb88n166+t181*t19*t4*abb88n167+t181*t20*t4*abb&
         &88n134+t181*t25*t4*abb88n150+t181*t27*t4*abb88n182+t182*t19*t4*abb88n9&
         &6+t182*t2*t20*abb88n95+t182*t20*t4*abb88n115+t182*t25*t4*abb88n101+t18&
         &2*t27*t4*abb88n85+t184*t19*t4*abb88n170+t184*t25*t4*abb88n152+t184*t27&
         &*t4*abb88n180+t185*t2*t20*abb88n171+t19*t3*t4*abb88n173+t2*t20*t4*abb8&
         &8n168+t20*t4*t6*abb88n137+t20*t4*t7*abb88n149+t20*t4*t8*abb88n166+t22*&
         &t3*t4*abb88n137+t24*t3*t4*abb88n166+t25*t3*t4*abb88n149+t27*t3*t4*abb8&
         &8n183+t1*t18*t3*t8*abb88n84+t1*t20*t4*t8*abb88n84+t1*t24*t3*t4*abb88n8&
         &4+t16*t3*t4*t8*abb88n84)
         return
      end if
      t186 = d(iv1,iv2)
      t21 = k1(iv2)
      t23 = qshift(iv2)
      t28 = t186*abb88n158
      t29 = k2(iv2)
      t30 = k5(iv2)
      t31 = k6(iv2)
      t32 = spvak3k4(iv2)
      t33 = t11*t32
      t34 = spvak5k1(iv2)
      t35 = spvak5k6(iv2)
      t36 = t11*t35
      t37 = spvak6k1(iv2)
      t38 = t11*t37
      t39 = spvak6k5(iv2)
      t40 = t11*t39
      t41 = t16*t21
      t42 = t18*t21
      t43 = t19*t21
      t44 = t20*t21
      t45 = t12*t34
      t46 = t12*t35
      t47 = t12*t39
      t48 = t17*t29
      t49 = t18*t29
      t50 = t20*t29
      t51 = t13*t35
      t52 = t13*t37
      t53 = t18*t30
      t54 = t19*t30
      t55 = t14*t32
      t56 = t14*t34
      t57 = t14*t35
      t58 = t14*t39
      t59 = t16*t31
      t60 = t17*t31
      t61 = t18*t31
      t62 = t20*t31
      t63 = t15*t32
      t64 = t15*t34
      t65 = t15*t35
      t66 = t15*t37
      t67 = t15*t39
      t68 = t16*t23
      t69 = t17*t23
      t70 = t18*t23
      t71 = t19*t23
      t72 = t20*t23
      t73 = t22*t35
      t74 = spvak2k6(iv2)
      t75 = t18*t74
      t76 = t16*t35
      t77 = t16*t37
      t78 = t16*t39
      t79 = t18*t32
      t80 = t19*t32
      t81 = t20*t32
      t82 = t17*t35
      t83 = t17*t39
      t84 = t18*t34
      t85 = t20*t34
      t86 = t18*t37
      t87 = t18*t39
      t88 = t19*t35
      t89 = t20*t35
      t90 = t19*t39
      t91 = t20*t37
      t92 = spvak2k4(iv2)
      t93 = t11*t92
      t94 = spvak3k1(iv2)
      t95 = t11*t94
      t96 = t21*t25
      t97 = t21*t27
      t98 = t13*t92
      t99 = t13*t94
      t100 = t25*t30
      t101 = t27*t30
      t102 = t15*t92
      t103 = t15*t94
      t104 = t23*t25
      t105 = t23*t27
      t106 = t24*t32
      t107 = t24*t35
      t108 = t24*t39
      t109 = spvak2k1(iv2)
      t110 = t109*t16
      t111 = t109*t18
      t112 = t109*t20
      t113 = t25*t35
      t114 = t18*t92
      t115 = t26*t32
      t116 = spvak2k5(iv2)
      t117 = t116*t16
      t118 = t27*t35
      t119 = t18*t94
      t120 = t87*abb88n135
      t121 = t89*abb88n135
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t181*t28+t185*t28+t186*abb88n113+t1*t186*abb88n1&
         &26+t11*t21*abb88n109+t15*t23*abb88n156+t182*t186*abb88n157+t183*t186*a&
         &bb88n154+t184*t186*abb88n145+t186*t2*abb88n178+t186*t3*abb88n142+t186*&
         &t4*abb88n163+t186*t5*abb88n174+t1*t186*t3*abb88n97+t1*t186*t4*abb88n10&
         &3+t1*t186*t5*abb88n90+t10*t186*t4*abb88n85+t186*t2*t3*abb88n95+t186*t3&
         &*t4*abb88n115+t186*t4*t5*abb88n96+t186*t4*t7*abb88n101)+t120*t183+t120&
         &*t185+t121*t183+t121*t185+t33*abb88n120+t36*abb88n104+t38*abb88n92+t40&
         &*abb88n110+t41*abb88n120+t42*abb88n104+t43*abb88n92+t44*abb88n110+t45*&
         &abb88n117+t46*abb88n112+t47*abb88n118+t48*abb88n117+t49*abb88n112+t50*&
         &abb88n118+t51*abb88n105+t52*abb88n91+t53*abb88n105+t54*abb88n91+t55*ab&
         &b88n121+t56*abb88n116+t57*abb88n112+t58*abb88n111+t59*abb88n121+t60*ab&
         &b88n116+t61*abb88n112+t62*abb88n111+t63*abb88n127+t64*abb88n179+t65*ab&
         &b88n164+t66*abb88n175+t67*abb88n143+t68*abb88n127+t69*abb88n179+t70*ab&
         &b88n164+t71*abb88n175+t72*abb88n143+t73*abb88n102+t75*abb88n102+t76*ab&
         &b88n119+t77*abb88n123+t78*abb88n114+t79*abb88n119+t80*abb88n123+t81*ab&
         &b88n114+t82*abb88n88+t83*abb88n89+t84*abb88n88+t85*abb88n89+t86*abb88n&
         &93+t87*abb88n106+t88*abb88n93+t89*abb88n106+t90*abb88n94+t91*abb88n94+&
         &t1*t107*abb88n138+t1*t111*abb88n138+t1*t36*abb88n147+t1*t38*abb88n177+&
         &t1*t40*abb88n161+t1*t42*abb88n147+t1*t43*abb88n177+t1*t44*abb88n161+t1&
         &*t58*abb88n160+t1*t62*abb88n160+t1*t65*abb88n148+t1*t66*abb88n176+t1*t&
         &67*abb88n162+t1*t70*abb88n148+t1*t71*abb88n176+t1*t72*abb88n162+t1*t86&
         &*abb88n132+t1*t87*abb88n165+t1*t88*abb88n132+t1*t89*abb88n165+t10*t36*&
         &abb88n182+t10*t42*abb88n182+t10*t51*abb88n180+t10*t53*abb88n180+t10*t6&
         &5*abb88n181+t10*t70*abb88n181+t10*t87*abb88n183+t10*t89*abb88n183+t100&
         &*t4*abb88n152+t101*t4*abb88n180+t102*t4*abb88n151+t103*t4*abb88n181+t1&
         &04*t4*abb88n151+t105*t4*abb88n181+t106*t4*abb88n138+t107*t3*abb88n166+&
         &t108*t4*abb88n166+t11*t23*abb88n159+t11*t29*abb88n98+t11*t30*abb88n108&
         &+t11*t31*abb88n100+t11*t34*abb88n86+t110*t4*abb88n138+t111*t3*abb88n16&
         &6+t112*t4*abb88n166+t113*t181*abb88n150+t113*t182*abb88n101+t113*t184*&
         &abb88n152+t113*t3*abb88n149+t114*t181*abb88n150+t114*t182*abb88n101+t1&
         &14*t184*abb88n152+t114*t3*abb88n149+t115*t4*abb88n153+t117*t4*abb88n15&
         &3+t118*t181*abb88n182+t118*t182*abb88n85+t118*t184*abb88n180+t118*t3*a&
         &bb88n183+t119*t181*abb88n182+t119*t182*abb88n85+t119*t184*abb88n180+t1&
         &19*t3*abb88n183+t12*t21*abb88n98+t12*t23*abb88n155+t13*t21*abb88n108+t&
         &13*t23*abb88n146+t13*t31*abb88n107+t13*t34*abb88n87+t14*t21*abb88n100+&
         &t14*t23*abb88n159+t14*t30*abb88n107+t15*t21*abb88n159+t15*t29*abb88n15&
         &5+t15*t30*abb88n146+t15*t31*abb88n159+t16*t34*abb88n122+t17*t21*abb88n&
         &86+t17*t30*abb88n87+t17*t32*abb88n122+t181*t76*abb88n147+t181*t77*abb8&
         &8n177+t181*t78*abb88n161+t181*t79*abb88n147+t181*t80*abb88n177+t181*t8&
         &1*abb88n161+t181*t86*abb88n167+t181*t87*abb88n134+t181*t88*abb88n167+t&
         &181*t89*abb88n134+t182*t76*abb88n103+t182*t77*abb88n90+t182*t78*abb88n&
         &97+t182*t79*abb88n103+t182*t80*abb88n90+t182*t81*abb88n97+t182*t83*abb&
         &88n95+t182*t85*abb88n95+t182*t86*abb88n96+t182*t87*abb88n115+t182*t88*&
         &abb88n96+t182*t89*abb88n115+t183*t83*abb88n173+t183*t85*abb88n173+t184&
         &*t86*abb88n170+t184*t88*abb88n170+t185*t78*abb88n160+t185*t81*abb88n16&
         &0+t185*t83*abb88n171+t185*t85*abb88n171+t2*t47*abb88n173+t2*t50*abb88n&
         &173+t2*t58*abb88n171+t2*t62*abb88n171+t2*t67*abb88n172+t2*t72*abb88n17&
         &2+t2*t87*abb88n168+t2*t89*abb88n168+t3*t33*abb88n161+t3*t36*abb88n134+&
         &t3*t41*abb88n161+t3*t42*abb88n134+t3*t45*abb88n173+t3*t46*abb88n135+t3&
         &*t48*abb88n173+t3*t49*abb88n135+t3*t55*abb88n160+t3*t56*abb88n171+t3*t&
         &57*abb88n135+t3*t59*abb88n160+t3*t60*abb88n171+t3*t61*abb88n135+t3*t63&
         &*abb88n162+t3*t64*abb88n172+t3*t65*abb88n136+t3*t68*abb88n162+t3*t69*a&
         &bb88n172+t3*t70*abb88n136+t3*t73*abb88n137+t3*t75*abb88n137+t3*t76*abb&
         &88n165+t3*t79*abb88n165+t3*t82*abb88n168+t3*t84*abb88n168+t3*t86*abb88&
         &n173+t3*t88*abb88n173+t33*t4*abb88n147+t33*t5*abb88n177+t36*t5*abb88n1&
         &67+t36*t7*abb88n150+t38*t4*abb88n167+t4*t40*abb88n134+t4*t41*abb88n147&
         &+t4*t43*abb88n167+t4*t44*abb88n134+t4*t47*abb88n135+t4*t50*abb88n135+t&
         &4*t52*abb88n170+t4*t54*abb88n170+t4*t58*abb88n135+t4*t62*abb88n135+t4*&
         &t63*abb88n148+t4*t66*abb88n169+t4*t67*abb88n136+t4*t68*abb88n148+t4*t7&
         &1*abb88n169+t4*t72*abb88n136+t4*t77*abb88n132+t4*t78*abb88n165+t4*t80*&
         &abb88n132+t4*t81*abb88n165+t4*t83*abb88n168+t4*t85*abb88n168+t4*t90*ab&
         &b88n173+t4*t91*abb88n173+t4*t93*abb88n150+t4*t95*abb88n182+t4*t96*abb8&
         &8n150+t4*t97*abb88n182+t4*t98*abb88n152+t4*t99*abb88n180+t41*t5*abb88n&
         &177+t42*t5*abb88n167+t42*t7*abb88n150+t5*t51*abb88n170+t5*t53*abb88n17&
         &0+t5*t63*abb88n176+t5*t65*abb88n169+t5*t68*abb88n176+t5*t70*abb88n169+&
         &t5*t76*abb88n132+t5*t79*abb88n132+t5*t87*abb88n173+t5*t89*abb88n173+t5&
         &1*t7*abb88n152+t53*t7*abb88n152+t6*t87*abb88n137+t6*t89*abb88n137+t65*&
         &t7*abb88n151+t7*t70*abb88n151+t7*t87*abb88n149+t7*t89*abb88n149+t76*t8&
         &*abb88n138+t76*t9*abb88n153+t79*t8*abb88n138+t79*t9*abb88n153+t8*t87*a&
         &bb88n166+t8*t89*abb88n166+t1*t107*t3*abb88n84+t1*t108*t4*abb88n84+t1*t&
         &111*t3*abb88n84+t1*t112*t4*abb88n84+t1*t116*t18*abb88n153+t1*t26*t35*a&
         &bb88n153+t1*t8*t87*abb88n84+t1*t8*t89*abb88n84+t106*t3*t4*abb88n84+t11&
         &0*t3*t4*abb88n84+t20*t4*t74*abb88n137+t20*t4*t92*abb88n149+t20*t4*t94*&
         &abb88n183+t22*t39*t4*abb88n137+t25*t39*t4*abb88n149+t27*t39*t4*abb88n1&
         &83+t3*t76*t8*abb88n84+t3*t79*t8*abb88n84+t4*t78*t8*abb88n84+t4*t8*t81*&
         &abb88n84)
         return
      end if
      t181 = d(iv2,iv3)
      t182 = d(iv1,iv3)
      t6 = k1(iv3)
      t9 = k2(iv3)
      t28 = k5(iv3)
      t38 = k6(iv3)
      t40 = qshift(iv3)
      t43 = t16*t181
      t44 = t182*t32
      t47 = spvak3k4(iv3)
      t50 = t186*t47
      t52 = t17*t181
      t54 = t182*t34
      t58 = spvak5k1(iv3)
      t62 = t186*t58
      t66 = t18*t181
      t67 = t182*t35
      t71 = spvak5k6(iv3)
      t72 = t186*t71
      t90 = t181*t19
      t91 = t182*t37
      t108 = spvak6k1(iv3)
      t112 = t108*t186
      t120 = t181*t20
      t121 = t182*t39
      t122 = spvak6k5(iv3)
      t123 = t122*t186
      t124 = spvak2k4(iv3)
      t125 = spvak3k1(iv3)
      t126 = t11*t47
      t127 = t11*t71
      t128 = t21*t47
      t129 = t21*t71
      t130 = t16*t6
      t131 = t32*t6
      t132 = t18*t6
      t133 = t35*t6
      t134 = t15*t47
      t135 = t15*t71
      t136 = t23*t47
      t137 = t23*t71
      t138 = t16*t40
      t139 = t32*t40
      t140 = t18*t40
      t141 = t35*t40
      t142 = t106*t71
      t143 = t24*t47
      t144 = t143*t35
      t107 = t107*t122
      t145 = t24*t39*t71
      t146 = t110*t71
      t147 = t109*t47
      t148 = t147*t18
      t111 = t111*t122
      t149 = t109*t20*t71
      t150 = spvak2k1(iv3)
      t151 = t150*t16
      t152 = t151*t35
      t153 = t150*t32
      t154 = t153*t18
      t155 = t150*t18*t39
      t156 = t150*t20*t35
      t157 = t25*t71
      t158 = t71*t92
      t159 = t124*t18
      t160 = t124*t35
      t161 = spvak2k5(iv3)
      t162 = spvak2k6(iv3)
      t163 = t27*t71
      t164 = t71*t94
      t165 = t125*t18
      t166 = t125*t35
      t167 = t122*t76
      t168 = t16*t71
      t169 = t168*t39
      t170 = t122*t79
      t171 = t32*t71
      t172 = t171*t20
      t173 = t18*t47
      t174 = t173*t39
      t175 = t35*t47
      t176 = t175*t20
      t177 = t108*t18
      t178 = t108*t35
      t179 = t19*t71
      t180 = t37*t71
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t112*abb88n174+t120*abb88n142+t121*abb88n142+t12&
         &3*abb88n142+t43*abb88n126+t44*abb88n126+t50*abb88n126+t52*abb88n178+t5&
         &4*abb88n178+t62*abb88n178+t66*abb88n163+t67*abb88n163+t72*abb88n163+t9&
         &0*abb88n174+t91*abb88n174+t1*t112*abb88n90+t1*t120*abb88n97+t1*t121*ab&
         &b88n97+t1*t123*abb88n97+t1*t66*abb88n103+t1*t67*abb88n103+t1*t72*abb88&
         &n103+t1*t90*abb88n90+t1*t91*abb88n90+t10*t66*abb88n85+t10*t67*abb88n85&
         &+t10*t72*abb88n85+t11*t181*abb88n158+t112*t4*abb88n96+t12*t181*abb88n1&
         &54+t120*t2*abb88n95+t120*t4*abb88n115+t121*t2*abb88n95+t121*t4*abb88n1&
         &15+t123*t2*abb88n95+t123*t4*abb88n115+t13*t181*abb88n145+t14*t181*abb8&
         &8n158+t15*t181*abb88n156+t182*t21*abb88n158+t182*t23*abb88n156+t182*t2&
         &9*abb88n154+t182*t30*abb88n145+t182*t31*abb88n158+t186*t28*abb88n145+t&
         &186*t38*abb88n158+t186*t40*abb88n156+t186*t6*abb88n158+t186*t9*abb88n1&
         &54+t3*t43*abb88n97+t3*t44*abb88n97+t3*t50*abb88n97+t3*t52*abb88n95+t3*&
         &t54*abb88n95+t3*t62*abb88n95+t3*t66*abb88n115+t3*t67*abb88n115+t3*t72*&
         &abb88n115+t4*t43*abb88n103+t4*t44*abb88n103+t4*t50*abb88n103+t4*t90*ab&
         &b88n96+t4*t91*abb88n96+t43*t5*abb88n90+t44*t5*abb88n90+t5*t50*abb88n90&
         &+t5*t66*abb88n96+t5*t67*abb88n96+t5*t72*abb88n96+t66*t7*abb88n101+t67*&
         &t7*abb88n101+t7*t72*abb88n101+t124*t186*t4*abb88n101+t125*t186*t4*abb8&
         &8n85+t181*t25*t4*abb88n101+t181*t27*t4*abb88n85+t182*t4*t92*abb88n101+&
         &t182*t4*t94*abb88n85)+t107*abb88n166+t111*abb88n166+t142*abb88n138+t14&
         &4*abb88n138+t145*abb88n166+t146*abb88n138+t148*abb88n138+t149*abb88n16&
         &6+t152*abb88n138+t154*abb88n138+t155*abb88n166+t156*abb88n166+t167*abb&
         &88n165+t169*abb88n165+t170*abb88n165+t172*abb88n165+t174*abb88n165+t17&
         &6*abb88n165+t1*t107*abb88n84+t1*t111*abb88n84+t1*t145*abb88n84+t1*t149&
         &*abb88n84+t1*t155*abb88n84+t1*t156*abb88n84+t100*t71*abb88n152+t101*t7&
         &1*abb88n180+t102*t71*abb88n151+t103*t71*abb88n181+t104*t71*abb88n151+t&
         &105*t71*abb88n181+t108*t33*abb88n177+t108*t36*abb88n167+t108*t41*abb88&
         &n177+t108*t42*abb88n167+t108*t51*abb88n170+t108*t53*abb88n170+t108*t63&
         &*abb88n176+t108*t65*abb88n169+t108*t68*abb88n176+t108*t70*abb88n169+t1&
         &08*t76*abb88n132+t108*t79*abb88n132+t113*t122*abb88n149+t114*t122*abb8&
         &8n149+t115*t71*abb88n153+t117*t71*abb88n153+t118*t122*abb88n183+t119*t&
         &122*abb88n183+t122*t33*abb88n161+t122*t36*abb88n134+t122*t41*abb88n161&
         &+t122*t42*abb88n134+t122*t45*abb88n173+t122*t46*abb88n135+t122*t48*abb&
         &88n173+t122*t49*abb88n135+t122*t55*abb88n160+t122*t56*abb88n171+t122*t&
         &57*abb88n135+t122*t59*abb88n160+t122*t60*abb88n171+t122*t61*abb88n135+&
         &t122*t63*abb88n162+t122*t64*abb88n172+t122*t65*abb88n136+t122*t68*abb8&
         &8n162+t122*t69*abb88n172+t122*t70*abb88n136+t122*t73*abb88n137+t122*t7&
         &5*abb88n137+t122*t82*abb88n168+t122*t84*abb88n168+t122*t86*abb88n173+t&
         &122*t88*abb88n173+t126*t35*abb88n147+t126*t37*abb88n177+t126*t39*abb88&
         &n161+t127*t37*abb88n167+t127*t39*abb88n134+t128*t18*abb88n147+t128*t19&
         &*abb88n177+t128*t20*abb88n161+t129*t19*abb88n167+t129*t20*abb88n134+t1&
         &30*t35*abb88n147+t130*t37*abb88n177+t130*t39*abb88n161+t131*t18*abb88n&
         &147+t131*t19*abb88n177+t131*t20*abb88n161+t132*t37*abb88n167+t132*t39*&
         &abb88n134+t133*t19*abb88n167+t133*t20*abb88n134+t134*t35*abb88n148+t13&
         &4*t37*abb88n176+t134*t39*abb88n162+t135*t37*abb88n169+t135*t39*abb88n1&
         &36+t136*t18*abb88n148+t136*t19*abb88n176+t136*t20*abb88n162+t137*t19*a&
         &bb88n169+t137*t20*abb88n136+t138*t35*abb88n148+t138*t37*abb88n176+t138&
         &*t39*abb88n162+t139*t18*abb88n148+t139*t19*abb88n176+t139*t20*abb88n16&
         &2+t140*t37*abb88n169+t140*t39*abb88n136+t141*t19*abb88n169+t141*t20*ab&
         &b88n136+t142*t3*abb88n84+t144*t3*abb88n84+t146*t3*abb88n84+t148*t3*abb&
         &88n84+t152*t3*abb88n84+t154*t3*abb88n84+t157*t39*abb88n149+t158*t20*ab&
         &b88n149+t159*t39*abb88n149+t160*t20*abb88n149+t163*t39*abb88n183+t164*&
         &t20*abb88n183+t165*t39*abb88n183+t166*t20*abb88n183+t167*t8*abb88n84+t&
         &168*t37*abb88n132+t169*t8*abb88n84+t170*t8*abb88n84+t171*t19*abb88n132&
         &+t172*t8*abb88n84+t173*t37*abb88n132+t174*t8*abb88n84+t175*t19*abb88n1&
         &32+t176*t8*abb88n84+t177*t39*abb88n173+t178*t20*abb88n173+t179*t39*abb&
         &88n173+t180*t20*abb88n173+t33*t71*abb88n147+t41*t71*abb88n147+t63*t71*&
         &abb88n148+t68*t71*abb88n148+t71*t93*abb88n150+t71*t95*abb88n182+t71*t9&
         &6*abb88n150+t71*t97*abb88n182+t71*t98*abb88n152+t71*t99*abb88n180+t106&
         &*t122*t4*abb88n84+t11*t124*t35*abb88n150+t11*t125*t35*abb88n182+t110*t&
         &122*t4*abb88n84+t116*t18*t47*abb88n153+t12*t39*t58*abb88n173+t12*t39*t&
         &71*abb88n135+t124*t13*t35*abb88n152+t124*t15*t35*abb88n151+t124*t18*t2&
         &1*abb88n150+t124*t18*t23*abb88n151+t124*t18*t30*abb88n152+t125*t13*t35&
         &*abb88n180+t125*t15*t35*abb88n181+t125*t18*t21*abb88n182+t125*t18*t23*&
         &abb88n181+t125*t18*t30*abb88n180+t13*t37*t71*abb88n170+t14*t39*t47*abb&
         &88n160+t14*t39*t58*abb88n171+t14*t39*t71*abb88n135+t143*t39*t4*abb88n8&
         &4+t147*t20*t4*abb88n84+t15*t39*t58*abb88n172+t151*t39*t4*abb88n84+t153&
         &*t20*t4*abb88n84+t16*t161*t35*abb88n153+t16*t38*t39*abb88n160+t161*t18&
         &*t32*abb88n153+t162*t18*t39*abb88n137+t162*t20*t35*abb88n137+t17*t38*t&
         &39*abb88n171+t17*t39*t40*abb88n172+t17*t39*t71*abb88n168+t17*t39*t9*ab&
         &b88n173+t18*t28*t37*abb88n170+t18*t28*t92*abb88n152+t18*t28*t94*abb88n&
         &180+t18*t38*t39*abb88n135+t18*t39*t58*abb88n168+t18*t39*t9*abb88n135+t&
         &18*t40*t92*abb88n151+t18*t40*t94*abb88n181+t18*t6*t92*abb88n150+t18*t6&
         &*t94*abb88n182+t19*t28*t35*abb88n170+t19*t30*t71*abb88n170+t20*t23*t58&
         &*abb88n172+t20*t29*t58*abb88n173+t20*t29*t71*abb88n135+t20*t31*t47*abb&
         &88n160+t20*t31*t58*abb88n171+t20*t31*t71*abb88n135+t20*t32*t38*abb88n1&
         &60+t20*t34*t38*abb88n171+t20*t34*t40*abb88n172+t20*t34*t71*abb88n168+t&
         &20*t34*t9*abb88n173+t20*t35*t38*abb88n135+t20*t35*t58*abb88n168+t20*t3&
         &5*t9*abb88n135+t20*t71*t74*abb88n137+t22*t39*t71*abb88n137+t25*t28*t35&
         &*abb88n152+t25*t35*t40*abb88n151+t25*t35*t6*abb88n150+t26*t35*t47*abb8&
         &8n153+t27*t28*t35*abb88n180+t27*t35*t40*abb88n181+t27*t35*t6*abb88n182&
         &)
         return
      end if
      t183 = d(iv3,iv4)
      t184 = d(iv2,iv4)
      t185 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak3k1(iv4)
      t4 = spvak6k1(iv4)
      t5 = spvak6k5(iv4)
      t6 = spvak3k4(iv4)
      t7 = spvak5k1(iv4)
      t8 = t24*t6
      t9 = t109*t6
      t10 = t150*t6
      t11 = spvak2k1(iv4)
      t12 = t11*t16
      t13 = t11*t32
      t11 = t11*t47
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t181*t185*abb88n99+t182*t184*abb88n99+t183*t186*&
         &abb88n99)+(2.0_ki)*(t113*t183*abb88n101+t114*t183*abb88n101+t118*t183*&
         &abb88n85+t119*t183*abb88n85+t157*t184*abb88n101+t158*t185*abb88n101+t1&
         &59*t184*abb88n101+t160*t185*abb88n101+t163*t184*abb88n85+t164*t185*abb&
         &88n85+t165*t184*abb88n85+t166*t185*abb88n85+t168*t184*abb88n103+t171*t&
         &185*abb88n103+t173*t184*abb88n103+t175*t185*abb88n103+t177*t184*abb88n&
         &96+t178*t185*abb88n96+t179*t184*abb88n96+t180*t185*abb88n96+t183*t76*a&
         &bb88n103+t183*t77*abb88n90+t183*t78*abb88n97+t183*t79*abb88n103+t183*t&
         &80*abb88n90+t183*t81*abb88n97+t183*t83*abb88n95+t183*t85*abb88n95+t183&
         &*t86*abb88n96+t183*t87*abb88n115+t183*t88*abb88n96+t183*t89*abb88n115+&
         &t1*t108*t186*abb88n96+t1*t122*t186*abb88n115+t1*t124*t186*abb88n101+t1&
         &*t125*t186*abb88n85+t1*t16*t181*abb88n103+t1*t181*t19*abb88n96+t1*t181&
         &*t20*abb88n115+t1*t181*t25*abb88n101+t1*t181*t27*abb88n85+t1*t182*t32*&
         &abb88n103+t1*t182*t37*abb88n96+t1*t182*t39*abb88n115+t1*t182*t92*abb88&
         &n101+t1*t182*t94*abb88n85+t1*t186*t47*abb88n103+t108*t16*t184*abb88n90&
         &+t108*t185*t32*abb88n90+t108*t186*t6*abb88n90+t122*t16*t184*abb88n97+t&
         &122*t17*t184*abb88n95+t122*t18*t184*abb88n115+t122*t185*t32*abb88n97+t&
         &122*t185*t34*abb88n95+t122*t185*t35*abb88n115+t122*t186*t6*abb88n97+t1&
         &22*t186*t7*abb88n95+t16*t181*t4*abb88n90+t16*t181*t5*abb88n97+t17*t181&
         &*t5*abb88n95+t18*t181*t2*abb88n101+t18*t181*t3*abb88n85+t18*t181*t4*ab&
         &b88n96+t18*t181*t5*abb88n115+t18*t181*t6*abb88n103+t181*t19*t6*abb88n9&
         &0+t181*t20*t6*abb88n97+t181*t20*t7*abb88n95+t182*t2*t35*abb88n101+t182&
         &*t3*t35*abb88n85+t182*t32*t4*abb88n90+t182*t32*t5*abb88n97+t182*t34*t5&
         &*abb88n95+t182*t35*t4*abb88n96+t182*t35*t5*abb88n115+t182*t35*t6*abb88&
         &n103+t182*t37*t6*abb88n90+t182*t39*t6*abb88n97+t182*t39*t7*abb88n95+t1&
         &84*t19*t47*abb88n90+t184*t20*t47*abb88n97+t184*t20*t58*abb88n95+t184*t&
         &20*t71*abb88n115+t185*t37*t47*abb88n90+t185*t39*t47*abb88n97+t185*t39*&
         &t58*abb88n95+t185*t39*t71*abb88n115+t186*t2*t71*abb88n101+t186*t3*t71*&
         &abb88n85+t186*t4*t47*abb88n90+t186*t4*t71*abb88n96+t186*t47*t5*abb88n9&
         &7+t186*t5*t58*abb88n95+t186*t5*t71*abb88n115+t186*t6*t71*abb88n103)+t1&
         &42*t5*abb88n84+t144*t5*abb88n84+t146*t5*abb88n84+t148*t5*abb88n84+t152&
         &*t5*abb88n84+t154*t5*abb88n84+t1*t106*t122*abb88n84+t1*t110*t122*abb88&
         &n84+t1*t143*t39*abb88n84+t1*t147*t20*abb88n84+t1*t151*t39*abb88n84+t1*&
         &t153*t20*abb88n84+t10*t18*t39*abb88n84+t10*t20*t35*abb88n84+t11*t18*t3&
         &9*abb88n84+t11*t20*t35*abb88n84+t12*t122*t35*abb88n84+t12*t39*t71*abb8&
         &8n84+t122*t13*t18*abb88n84+t122*t18*t9*abb88n84+t122*t35*t8*abb88n84+t&
         &13*t20*t71*abb88n84+t20*t71*t9*abb88n84+t39*t71*t8*abb88n84)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d88:
   subroutine     reconstruct_d88(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group9
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group9), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_88:
      coeffs%coeffs_88%c0 = derivative(czip)
      coeffs%coeffs_88%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_88%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_88%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_88%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_88%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_88%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_88%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_88%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_88%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_88%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_88%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_88%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_88%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_88%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_88%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_88%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_88%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_88%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_88%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_88%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_88%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_88%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_88%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_88%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_88%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_88%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_88%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_88%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_88%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_88%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_88%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_88%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_88%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_88%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_88%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_88%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_88%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_88%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_88%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_88%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_88%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_88%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_88%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_88%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_88%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_88%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_88%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_88%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_88%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_88%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_88%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_88%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_88%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_88%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_88%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_88%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_88%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_88%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_88%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_88%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_88%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_88%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_88%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_88%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_88%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_88%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_88%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_88%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_88%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_88:
   end subroutine reconstruct_d88
!---#] subroutine reconstruct_d88:
end module p9_udbar_neepgg_d88h0l1d
