module     p9_udbar_neepgg_d91h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity0/d91h0l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d91
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd91h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      real(ki) :: t90
      real(ki) :: t91
      real(ki) :: t92
      real(ki) :: t93
      real(ki) :: t94
      real(ki) :: t95
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = k2(iv1)
      t2 = k5(iv1)
      t3 = spvak2k1(iv1)
      t4 = spvak2k6(iv1)
      t5 = spvak3k1(iv1)
      t6 = spvak3k4(iv1)
      t7 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb91n118+t2*abb91n125+t3*abb91n117+t4*abb91n122+t5*abb&
         &91n123+t6*abb91n124+t7*abb91n64)
         return
      end if
      t90 = d(iv1,iv2)
      t8 = k6(iv2)
      t9 = spvak5k6(iv2)
      t10 = t1*t9
      t11 = spvak6k5(iv2)
      t12 = k2(iv2)
      t13 = k6(iv1)
      t14 = spvak5k6(iv1)
      t15 = t12*t14
      t16 = spvak2k6(iv2)
      t17 = spvak3k1(iv2)
      t18 = t17*t2
      t19 = t2*t9
      t20 = spvak6k1(iv2)
      t21 = k5(iv2)
      t22 = t21*t5
      t23 = t14*t21
      t24 = spvak6k1(iv1)
      t25 = spvak2k1(iv2)
      t26 = t13*t16
      t27 = t13*t17
      t28 = spvak3k4(iv2)
      t29 = t13*t28
      t30 = t13*t9
      t31 = t4*t8
      t32 = t5*t8
      t33 = t6*t8
      t34 = t14*t8
      t35 = t3*t9
      t36 = t14*t25
      t37 = spvak2k5(iv1)
      t38 = t37*t9
      t39 = spvak2k5(iv2)
      t40 = t14*t39
      t41 = t28*t4
      t42 = t16*t6
      t43 = t5*t9
      t44 = t14*t17
      t45 = spvak5k1(iv2)
      t46 = t45*t6
      t47 = t20*t6
      t48 = spvak5k1(iv1)
      t49 = t28*t48
      t50 = t24*t28
      t51 = t11*t14
      t52 = t7*t9
      if(deg.eq.2) then
         numerator = (t10*abb91n91+t15*abb91n91+t18*abb91n113+t19*abb91n111+t22*&
         &abb91n113+t23*abb91n111+t26*abb91n99+t27*abb91n103+t29*abb91n108+t30*a&
         &bb91n111+t31*abb91n99+t32*abb91n103+t33*abb91n108+t34*abb91n111+t35*ab&
         &b91n79+t36*abb91n79+t38*abb91n100+t40*abb91n100+t41*abb91n120+t42*abb9&
         &1n120+t43*abb91n106+t44*abb91n106+t46*abb91n112+t47*abb91n114+t49*abb9&
         &1n112+t50*abb91n114+t51*abb91n110+t52*abb91n110+(2.0_ki)*t90*abb91n119&
         &+t1*t11*abb91n82+t1*t8*abb91n86+t11*t3*abb91n76+t11*t4*abb91n98+t11*t4&
         &8*abb91n115+t11*t5*abb91n102+t11*t6*abb91n105+t12*t13*abb91n86+t12*t7*&
         &abb91n82+t13*t25*abb91n77+t14*t28*abb91n109+t16*t2*abb91n121+t16*t7*ab&
         &b91n98+t17*t7*abb91n102+t2*t20*abb91n116+t21*t24*abb91n116+t21*t4*abb9&
         &1n121+t25*t7*abb91n76+t28*t7*abb91n105+t3*t8*abb91n77+t45*t7*abb91n115&
         &+t6*t9*abb91n109)
         return
      end if
      t91 = d(iv2,iv3)
      t92 = d(iv1,iv3)
      t53 = k2(iv3)
      t54 = k6(iv3)
      t55 = spvak2k1(iv3)
      t56 = spvak2k6(iv3)
      t57 = spvak3k1(iv3)
      t58 = spvak3k4(iv3)
      t59 = spvak5k6(iv3)
      t60 = spvak6k5(iv3)
      t61 = spvak2k5(iv3)
      t62 = spvak6k1(iv3)
      t63 = k5(iv3)
      t64 = spvak5k1(iv3)
      t65 = t13*t58
      t66 = t58*t8
      t67 = t54*t6
      t68 = t28*t54
      t69 = spvak2k4(iv1)
      t70 = spvak2k4(iv2)
      t71 = spvak2k4(iv3)
      t72 = t37*t59
      t73 = t39*t59
      t74 = t14*t61
      t75 = t61*t9
      t76 = t4*t58
      t77 = t16*t58
      t78 = t56*t6
      t79 = t28*t56
      t80 = t5*t59
      t81 = t17*t59
      t82 = t14*t57
      t83 = t57*t9
      t84 = t14*t20
      t85 = t14*t62
      t86 = t24*t9
      t87 = t62*t9
      t88 = t24*t59
      t89 = t20*t59
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t91*abb91n84+t11*t92*abb91n83+t12*t92*abb91n8&
         &4+t13*t91*abb91n84+t14*t91*abb91n90+t16*t92*abb91n101+t17*t92*abb91n10&
         &4+t25*t92*abb91n78+t28*t92*abb91n107+t3*t91*abb91n78+t4*t91*abb91n101+&
         &t5*t91*abb91n104+t53*t90*abb91n84+t54*t90*abb91n84+t55*t90*abb91n78+t5&
         &6*t90*abb91n101+t57*t90*abb91n104+t58*t90*abb91n107+t59*t90*abb91n90+t&
         &6*t91*abb91n107+t60*t90*abb91n83+t7*t91*abb91n83+t8*t92*abb91n84+t9*t9&
         &2*abb91n90)+t10*t60*abb91n96+t11*t72*abb91n94+t11*t74*abb91n94+t11*t76&
         &*abb91n81+t11*t78*abb91n81+t11*t80*abb91n68+t11*t82*abb91n68+t11*t85*a&
         &bb91n73+t11*t88*abb91n73+t15*t60*abb91n96+t18*t59*abb91n70+t19*t62*abb&
         &91n74+t20*t65*abb91n72+t20*t67*abb91n72+t22*t59*abb91n70+t23*t62*abb91&
         &n74+t24*t66*abb91n72+t24*t68*abb91n72+t26*t58*abb91n87+t27*t59*abb91n7&
         &0+t29*t62*abb91n72+t29*t64*abb91n66+t30*t62*abb91n74+t31*t58*abb91n87+&
         &t32*t59*abb91n70+t33*t62*abb91n72+t33*t64*abb91n66+t34*t62*abb91n74+t3&
         &5*t60*abb91n80+t36*t60*abb91n80+t38*t60*abb91n94+t40*t60*abb91n94+t41*&
         &t60*abb91n81+t42*t60*abb91n81+t43*t60*abb91n68+t44*t60*abb91n68+t45*t6&
         &5*abb91n66+t45*t67*abb91n66+t48*t66*abb91n66+t48*t68*abb91n66+t60*t84*&
         &abb91n73+t60*t86*abb91n73+t7*t73*abb91n94+t7*t75*abb91n94+t7*t77*abb91&
         &n81+t7*t79*abb91n81+t7*t81*abb91n68+t7*t83*abb91n68+t7*t87*abb91n73+t7&
         &*t89*abb91n73+t1*t11*t59*abb91n96+t11*t14*t53*abb91n96+t11*t14*t55*abb&
         &91n80+t11*t14*t56*abb91n92+t11*t14*t64*abb91n75+t11*t14*t71*abb91n97+t&
         &11*t3*t59*abb91n80+t11*t4*t59*abb91n92+t11*t48*t59*abb91n75+t11*t59*t6&
         &9*abb91n97+t12*t59*t7*abb91n96+t13*t20*t59*abb91n74+t13*t28*t56*abb91n&
         &87+t13*t39*t59*abb91n93+t13*t57*t9*abb91n70+t13*t61*t9*abb91n93+t14*t1&
         &6*t60*abb91n92+t14*t17*t54*abb91n70+t14*t17*t63*abb91n70+t14*t20*t54*a&
         &bb91n74+t14*t20*t63*abb91n74+t14*t21*t57*abb91n70+t14*t21*t61*abb91n93&
         &+t14*t28*t61*abb91n88+t14*t39*t54*abb91n93+t14*t39*t58*abb91n88+t14*t3&
         &9*t63*abb91n93+t14*t45*t60*abb91n75+t14*t57*t8*abb91n70+t14*t60*t70*ab&
         &b91n97+t14*t61*t8*abb91n93+t16*t54*t6*abb91n87+t16*t59*t7*abb91n92+t2*&
         &t20*t59*abb91n74+t2*t39*t59*abb91n93+t2*t57*t9*abb91n70+t2*t61*t9*abb9&
         &1n93+t21*t24*t59*abb91n74+t21*t37*t59*abb91n93+t24*t54*t9*abb91n74+t24&
         &*t59*t8*abb91n74+t24*t63*t9*abb91n74+t25*t59*t7*abb91n80+t28*t37*t59*a&
         &bb91n88+t28*t4*t54*abb91n87+t37*t54*t9*abb91n93+t37*t58*t9*abb91n88+t3&
         &7*t59*t8*abb91n93+t37*t63*t9*abb91n93+t39*t59*t6*abb91n88+t4*t60*t9*ab&
         &b91n92+t45*t59*t7*abb91n75+t48*t60*t9*abb91n75+t5*t54*t9*abb91n70+t5*t&
         &63*t9*abb91n70+t53*t7*t9*abb91n96+t55*t7*t9*abb91n80+t56*t6*t8*abb91n8&
         &7+t56*t7*t9*abb91n92+t59*t7*t70*abb91n97+t6*t61*t9*abb91n88+t60*t69*t9&
         &*abb91n97+t64*t7*t9*abb91n75+t7*t71*t9*abb91n97)
         return
      end if
      t93 = d(iv3,iv4)
      t94 = d(iv2,iv4)
      t95 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k5(iv4)
      t8 = spvak3k4(iv4)
      t10 = spvak2k6(iv4)
      t12 = spvak3k1(iv4)
      t13 = spvak5k1(iv4)
      t15 = spvak6k1(iv4)
      t18 = spvak6k5(iv4)
      t19 = t28*t3
      t21 = t3*t58
      t3 = t3*t8
      t22 = t25*t6
      t23 = t25*t58
      t25 = t25*t8
      t26 = t55*t6
      t27 = t28*t55
      t29 = t55*t8
      t30 = spvak2k1(iv4)
      t31 = t30*t6
      t32 = t28*t30
      t30 = t30*t58
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t90*t93*abb91n85+t91*t95*abb91n85+t92*t94*abb91n&
         &85)+(2.0_ki)*(t38*t93*abb91n92+t40*t93*abb91n92+t41*t93*abb91n89+t42*t&
         &93*abb91n89+t43*t93*abb91n69+t44*t93*abb91n69+t46*t93*abb91n67+t47*t93&
         &*abb91n71+t49*t93*abb91n67+t50*t93*abb91n71+t51*t93*abb91n95+t52*t93*a&
         &bb91n95+t72*t94*abb91n92+t73*t95*abb91n92+t74*t94*abb91n92+t75*t95*abb&
         &91n92+t76*t94*abb91n89+t77*t95*abb91n89+t78*t94*abb91n89+t79*t95*abb91&
         &n89+t80*t94*abb91n69+t81*t95*abb91n69+t82*t94*abb91n69+t83*t95*abb91n6&
         &9+t84*t93*abb91n75+t85*t94*abb91n75+t86*t93*abb91n75+t87*t95*abb91n75+&
         &t88*t94*abb91n75+t89*t95*abb91n75+t1*t11*t92*abb91n95+t1*t17*t92*abb91&
         &n69+t1*t20*t92*abb91n75+t1*t24*t91*abb91n75+t1*t37*t91*abb91n92+t1*t39&
         &*t92*abb91n92+t1*t5*t91*abb91n69+t1*t57*t90*abb91n69+t1*t60*t90*abb91n&
         &95+t1*t61*t90*abb91n92+t1*t62*t90*abb91n75+t1*t7*t91*abb91n95+t10*t28*&
         &t92*abb91n89+t10*t58*t90*abb91n89+t10*t6*t91*abb91n89+t11*t59*t95*abb9&
         &1n95+t12*t14*t91*abb91n69+t12*t59*t90*abb91n69+t12*t9*t92*abb91n69+t13&
         &*t28*t92*abb91n67+t13*t58*t90*abb91n67+t13*t6*t91*abb91n67+t14*t15*t91&
         &*abb91n75+t14*t18*t91*abb91n95+t14*t2*t91*abb91n92+t14*t60*t94*abb91n9&
         &5+t15*t28*t92*abb91n71+t15*t58*t90*abb91n71+t15*t59*t90*abb91n75+t15*t&
         &6*t91*abb91n71+t15*t9*t92*abb91n75+t16*t8*t92*abb91n89+t18*t59*t90*abb&
         &91n95+t18*t9*t92*abb91n95+t2*t59*t90*abb91n92+t2*t9*t92*abb91n92+t20*t&
         &58*t95*abb91n71+t20*t8*t92*abb91n71+t24*t58*t94*abb91n71+t24*t8*t91*ab&
         &b91n71+t28*t62*t95*abb91n71+t28*t64*t95*abb91n67+t4*t8*t91*abb91n89+t4&
         &5*t58*t95*abb91n67+t45*t8*t92*abb91n67+t48*t58*t94*abb91n67+t48*t8*t91&
         &*abb91n67+t56*t8*t90*abb91n89+t59*t7*t94*abb91n95+t6*t62*t94*abb91n71+&
         &t6*t64*t94*abb91n67+t60*t9*t95*abb91n95+t62*t8*t90*abb91n71+t64*t8*t90&
         &*abb91n67)+t1*t11*t21*abb91n65+t1*t11*t26*abb91n65+t1*t19*t60*abb91n65&
         &+t1*t22*t60*abb91n65+t1*t23*t7*abb91n65+t1*t27*t7*abb91n65+t11*t14*t29&
         &*abb91n65+t11*t14*t30*abb91n65+t11*t3*t59*abb91n65+t11*t31*t59*abb91n6&
         &5+t14*t18*t23*abb91n65+t14*t18*t27*abb91n65+t14*t25*t60*abb91n65+t14*t&
         &32*t60*abb91n65+t18*t19*t59*abb91n65+t18*t21*t9*abb91n65+t18*t22*t59*a&
         &bb91n65+t18*t26*t9*abb91n65+t25*t59*t7*abb91n65+t29*t7*t9*abb91n65+t3*&
         &t60*t9*abb91n65+t30*t7*t9*abb91n65+t31*t60*t9*abb91n65+t32*t59*t7*abb9&
         &1n65)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d91:
   subroutine     reconstruct_d91(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group8
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group8), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_91:
      coeffs%coeffs_91%c0 = derivative(czip)
      coeffs%coeffs_91%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_91%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_91%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_91%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_91%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_91%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_91%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_91%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_91%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_91%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_91%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_91%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_91%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_91%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_91%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_91%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_91%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_91%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_91%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_91%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_91%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_91%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_91%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_91%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_91%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_91%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_91%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_91%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_91%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_91%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_91%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_91%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_91%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_91%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_91%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_91%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_91%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_91%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_91%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_91%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_91%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_91%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_91%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_91%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_91%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_91%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_91%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_91%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_91%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_91%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_91%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_91%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_91%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_91%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_91%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_91%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_91%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_91%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_91%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_91%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_91%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_91%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_91%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_91%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_91%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_91%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_91%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_91%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_91%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_91:
   end subroutine reconstruct_d91
!---#] subroutine reconstruct_d91:
end module p9_udbar_neepgg_d91h0l1d
