module     p9_udbar_neepgg_abbrevd35h1
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh1
   implicit none
   private
   complex(ki), public :: abb35n1
   complex(ki), public :: abb35n2
   complex(ki), public :: abb35n3
   complex(ki), public :: abb35n4
   complex(ki), public :: abb35n5
   complex(ki), public :: abb35n6
   complex(ki), public :: abb35n7
   complex(ki), public :: abb35n8
   complex(ki), public :: abb35n9
   complex(ki), public :: abb35n10
   complex(ki), public :: rat2d35
   complex(ki), public :: abb35n12
   complex(ki), public :: abb35n13
   complex(ki), public :: abb35n14
   complex(ki), public :: abb35n15
   complex(ki), public :: abb35n16
   complex(ki), public :: abb35n17
   complex(ki), public :: abb35n18
   complex(ki), public :: abb35n19
   complex(ki), public :: abb35n20
   complex(ki), public :: abb35n21
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   complex(ki) :: t18
   complex(ki) :: t19
   complex(ki) :: t20
   complex(ki) :: t21
   complex(ki) :: t22
   complex(ki) :: t23
   complex(ki) :: t24
   complex(ki) :: t25
   complex(ki) :: t26
   complex(ki) :: t27
   complex(ki) :: t28
   complex(ki) :: t29
   complex(ki) :: t30
   complex(ki) :: t31
   complex(ki) :: t32
   complex(ki) :: t33
   complex(ki) :: t34
   complex(ki) :: t35
   complex(ki) :: t36
   complex(ki) :: t37
   complex(ki) :: t38
   complex(ki) :: t39
   complex(ki) :: t40
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c1
      t3 = t2*i_
      t4 = t3*spak1k5
      t5 = (es34+es61-(es345+es234))*t1
      t6 = es61*NC*t5
      t7 = t6*spak5k6
      t8 = t4/t7*spak2k5*spak3k5*spbk4k1*spbk6k1
      t9 = t3*spak2k3
      t10 = t9*spak2k5
      t6 = t6*spbk6k5
      t11 = t10/t6*spbk6k1*spbk6k2*spbk6k4
      t12 = NC*TR*c1
      t13 = t12*i_
      t14 = t13*spak1k5
      t15 = t14*spak2k5*spak3k5*spbk4k1*spbk6k1
      t16 = es61*t5
      t17 = t16*spak5k6
      t18 = t15/t17
      t19 = t13*spak2k3
      t20 = t19*spak2k5
      t21 = t20*spbk6k1*spbk6k2*spbk6k4
      t16 = t21/(t16*spbk6k5)
      t2 = es56*t2*i_*spak2k5*spak3k5
      t22 = t7*spbk6k5
      t23 = t2/t22*spbk6k1*spbk6k4
      t12 = es56*t12*i_*spak2k5*spak3k5*spbk6k1*spbk6k4
      t24 = t17*spbk6k5
      t25 = t12/t24
      t4 = t4*spak2k3
      t26 = t4*spak2k5
      t27 = spbk6k1*spbk6k1
      t28 = es61*es234*NC*t1
      t29 = t28*spak5k6*spbk6k5
      t30 = t26*t27/t29*spbk4k2
      t4 = t27/t29*t4*spak3k5*spbk4k3
      t14 = t14*spak2k3
      t31 = t14*spak2k5
      t32 = t27*t31*spbk4k2
      t1 = es234*t1
      t33 = es61*t1*spak5k6*spbk6k5
      t34 = t32/t33
      t14 = t14*t27*spak3k5*spbk4k3
      t35 = t14/t33
      t26 = t26/t22*spbk4k1*spbk6k1*spbk6k2
      t31 = t31*spbk4k1*spbk6k1*spbk6k2
      t36 = t31/t24
      abb35n1 = ((2.0_ki)*(t11+t18+t23+t34+t36+t4-(t8+t35+t30+t26+t25+t16)))
      t13 = t13*spak2k5*spak3k5
      t37 = t13*spbk6k4
      t38 = t5*spak5k6
      t39 = t20*spbk6k2*spbk6k4
      t40 = t38*spbk6k5
      abb35n2 = ((2.0_ki)*(-(t39/t40+t37/t38)))
      t3 = t3*spak2k5*spak3k5
      abb35n3 = ((4.0_ki)*(-(t10/t22*spbk6k2*spbk6k4+t3/t7*spbk6k4+t39/t24+t37/t&
      &17)))
      t1 = t1*spak5k6*spbk6k5
      abb35n4 = ((4.0_ki)*(-(t12/t40+t21/(t5*spbk6k5)))+(2.0_ki)*(t32/t1+t15/t38&
      &+t31/t40-t14/t1))
      t5 = t13*spbk4k1
      t12 = t20*spbk4k1*spbk6k2
      t13 = t20*spbk4k2*spbk6k1
      t14 = t19*spak3k5*spbk4k3*spbk6k1
      abb35n5 = ((2.0_ki)*(t13/t1+t12/t40+t5/t38-t14/t1))
      abb35n6 = ((8.0_ki)*(t18+t34+t36-(t35+t25+t16)))
      abb35n7 = ((8.0_ki)*(t11+t18+t23+t34+t36-(t35+t25+t16)))
      abb35n8 = ((4.0_ki)*(t16+t25+t26+t30+t35+t8-(t4+t36+t34+t23+t18+t11)))
      t1 = t10*spbk4k2
      t4 = t28*spbk6k5
      t8 = t9*spak3k5*spbk4k3
      t9 = t10*spbk4k1
      abb35n9 = ((4.0_ki)*(t1*t27/t4+t2/t22*spbk4k1*spbk6k1+t9/t6*spbk6k1*spbk6k&
      &2-t27/t4*t8))
      abb35n10 = ((8.0_ki)*(t14/t33+t8/t29*spbk6k1-(t3/t7*spbk4k1+t9/t22*spbk6k2&
      &+t1/t29*spbk6k1+t5/t17+t13/t33+t12/t24)))
      rat2d35 = abb35n1
      rat2 = rat2 + rat2d35
      abb35n12 = abb35n4
      abb35n13 = abb35n10
      abb35n14 = abb35n8
      abb35n15 = abb35n3
      abb35n16 = -(abb35n2)
      abb35n17 = -(abb35n5)
      abb35n18 = -(abb35n6)
      abb35n19 = -(abb35n7)
      abb35n20 = ((2.0_ki)*abb35n8)
      abb35n21 = -(abb35n9)
   end subroutine
end module p9_udbar_neepgg_abbrevd35h1
