module     p9_udbar_neepgg_d92h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity1/d92h1l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d92
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd92h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      real(ki) :: t122
      real(ki) :: t123
      real(ki) :: t124
      real(ki) :: t125
      real(ki) :: t126
      real(ki) :: t127
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t122 = dotproduct(k2, qshift)
      t123 = dotproduct(k1, qshift)
      t1 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t2 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t3 = t2*t2
      t124 = dotproduct(qshift, qshift)
      t4 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t5 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t125 = dotproduct(k6, qshift)
      t6 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t8 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t126 = dotproduct(k5, qshift)
      t9 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t10 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-s&
      &pvak2k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb92n59+t1*abb92n129+t122*abb92n100+t123*abb92n101+t124*a&
         &bb92n80+t124*t124*abb92n77+t125*abb92n94+t2*abb92n89+t3*abb92n70+t4*ab&
         &b92n86+t5*abb92n87+t1*t2*abb92n64+t1*t3*abb92n126+t10*t3*abb92n97+t122&
         &*t123*abb92n76+t122*t124*abb92n109+t122*t125*abb92n78+t122*t2*abb92n73&
         &+t122*t3*abb92n92+t122*t4*abb92n83+t122*t5*abb92n63+t123*t124*abb92n10&
         &5+t123*t2*abb92n71+t123*t4*abb92n79+t123*t8*abb92n65+t124*t125*abb92n1&
         &09+t124*t2*abb92n113+t124*t3*abb92n85+t124*t4*abb92n103+t124*t5*abb92n&
         &133+t124*t8*abb92n130+t125*t2*abb92n74+t125*t3*abb92n92+t125*t4*abb92n&
         &79+t125*t8*abb92n66+t126*t2*abb92n72+t2*t4*abb92n82+t2*t5*abb92n61+t2*&
         &t7*abb92n69+t2*t8*abb92n67+t2*t9*abb92n81+t3*t4*abb92n116+t3*t5*abb92n&
         &122+t3*t6*abb92n118+t3*t7*abb92n120+t3*t8*abb92n140+t122*t2*t4*abb92n1&
         &12+t122*t2*t5*abb92n124+t122*t2*t8*abb92n139+t122*t2*t9*abb92n99+t123*&
         &t2*t4*abb92n112+t123*t2*t8*abb92n137+t124*t2*t4*abb92n75+t124*t2*t5*ab&
         &b92n68+t124*t2*t8*abb92n62+t124*t2*t9*abb92n84+t125*t2*t4*abb92n112+t1&
         &25*t2*t8*abb92n138+t126*t2*t5*abb92n128+t126*t2*t8*abb92n135+t126*t2*t&
         &9*abb92n95+t2*t4*t7*abb92n132+t2*t4*t9*abb92n88+t3*t4*t7*abb92n60)
         return
      end if
      t11 = k1(iv1)
      t12 = k2(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak3k4(iv1)
      t16 = spvak5k1(iv1)
      t17 = spvak5k6(iv1)
      t18 = spvak6k1(iv1)
      t19 = k5(iv1)
      t20 = t14*abb92n110
      t21 = spvak2k1(iv1)
      t22 = spvak2k4(iv1)
      t23 = spvak2k5(iv1)
      t24 = spvak2k6(iv1)
      t25 = spvak3k1(iv1)
      t26 = t15*abb92n79
      t27 = t15*abb92n112
      t28 = t17*abb92n112
      t29 = t17*abb92n93
      if(deg.eq.1) then
         numerator = (t11*abb92n101+t12*abb92n100+t122*t20+t123*t26+t125*t20+t12&
         &5*t26+t13*abb92n94+t14*abb92n102+t15*abb92n86+t16*abb92n87+t17*abb92n8&
         &9+t18*abb92n129+t1*t17*abb92n64+t11*t122*abb92n76+t11*t124*abb92n105+t&
         &11*t2*abb92n71+t11*t4*abb92n79+t11*t8*abb92n65+t12*t123*abb92n76+t12*t&
         &124*abb92n109+t12*t125*abb92n78+t12*t2*abb92n73+t12*t3*abb92n92+t12*t4&
         &*abb92n83+t12*t5*abb92n63+t122*t13*abb92n78+t122*t15*abb92n83+t122*t16&
         &*abb92n63+t122*t17*abb92n73+t122*t2*t27+t122*t2*t29+t122*t28*t4+t123*t&
         &14*abb92n106+t123*t17*abb92n71+t123*t2*t27+t123*t25*abb92n65+t123*t28*&
         &t4+t124*t13*abb92n109+t124*t14*abb92n107+t124*t15*abb92n103+t124*t16*a&
         &bb92n133+t124*t17*abb92n113+t124*t25*abb92n130+t125*t17*abb92n74+t125*&
         &t2*t27+t125*t2*t29+t125*t25*abb92n66+t125*t28*t4+t126*t17*abb92n72+t13&
         &*t2*abb92n74+t13*t3*abb92n92+t13*t4*abb92n79+t13*t8*abb92n66+t14*t2*ab&
         &b92n114+t14*t3*abb92n91+t14*t4*abb92n104+t14*t5*abb92n134+t14*t8*abb92&
         &n131+t15*t2*abb92n82+t15*t3*abb92n116+t16*t2*abb92n61+t16*t3*abb92n122&
         &+t17*t2*abb92n115+t17*t4*abb92n82+t17*t5*abb92n61+t17*t7*abb92n69+t17*&
         &t8*abb92n67+t17*t9*abb92n81+t18*t2*abb92n64+t18*t3*abb92n126+t19*t2*ab&
         &b92n72+t2*t21*abb92n69+t2*t24*abb92n81+t2*t25*abb92n67+t21*t3*abb92n12&
         &0+t22*t3*abb92n118+t23*t3*abb92n97+t25*t3*abb92n140+t1*t17*t2*abb92n12&
         &7+t10*t17*t2*abb92n98+t11*t2*t4*abb92n112+t11*t2*t8*abb92n137+t12*t2*t&
         &4*abb92n112+t12*t2*t5*abb92n124+t12*t2*t8*abb92n139+t12*t2*t9*abb92n99&
         &+t122*t16*t2*abb92n124+t122*t17*t5*abb92n124+t122*t17*t8*abb92n139+t12&
         &2*t17*t9*abb92n99+t122*t2*t24*abb92n99+t122*t2*t25*abb92n139+t123*t17*&
         &t8*abb92n137+t123*t2*t25*abb92n137+t124*t15*t2*abb92n75+t124*t16*t2*ab&
         &b92n68+t124*t17*t2*abb92n91+t124*t17*t4*abb92n75+t124*t17*t5*abb92n68+&
         &t124*t17*t8*abb92n62+t124*t17*t9*abb92n84+t124*t2*t24*abb92n84+t124*t2&
         &*t25*abb92n62+t125*t17*t8*abb92n138+t125*t2*t25*abb92n138+t126*t16*t2*&
         &abb92n128+t126*t17*t5*abb92n128+t126*t17*t8*abb92n135+t126*t17*t9*abb9&
         &2n95+t126*t2*t24*abb92n95+t126*t2*t25*abb92n135+t13*t2*t4*abb92n112+t1&
         &3*t2*t8*abb92n138+t14*t2*t4*abb92n111+t14*t2*t5*abb92n125+t14*t2*t8*ab&
         &b92n136+t14*t2*t9*abb92n96+t15*t2*t7*abb92n132+t15*t2*t9*abb92n88+t15*&
         &t3*t7*abb92n60+t17*t2*t4*abb92n117+t17*t2*t5*abb92n123+t17*t2*t6*abb92&
         &n119+t17*t2*t7*abb92n121+t17*t2*t8*abb92n141+t17*t4*t7*abb92n132+t17*t&
         &4*t9*abb92n88+t19*t2*t5*abb92n128+t19*t2*t8*abb92n135+t19*t2*t9*abb92n&
         &95+t2*t21*t4*abb92n132+t2*t24*t4*abb92n88+t21*t3*t4*abb92n60+t17*t2*t4&
         &*t7*abb92n142)
         return
      end if
      t127 = d(iv1,iv2)
      t20 = qshift(iv2)
      t26 = spvak5k6(iv2)
      t27 = t17*t26
      t28 = t127*abb92n109
      t29 = t27*abb92n92
      t30 = k2(iv2)
      t31 = spvak3k1(iv2)
      t32 = t11*t31
      t33 = spvak3k4(iv2)
      t34 = t11*t33
      t35 = t11*t26
      t36 = k1(iv2)
      t37 = t25*t36
      t38 = t15*t36
      t39 = t17*t36
      t40 = k6(iv2)
      t41 = t12*t33
      t42 = spvak5k1(iv2)
      t43 = t12*t42
      t44 = t12*t26
      t45 = t15*t30
      t46 = t16*t30
      t47 = t17*t30
      t48 = t19*t26
      t49 = k5(iv2)
      t50 = t17*t49
      t51 = t13*t31
      t52 = t13*t33
      t53 = t13*t26
      t54 = t25*t40
      t55 = t15*t40
      t56 = t17*t40
      t57 = t14*t31
      t58 = t14*t33
      t59 = t14*t42
      t60 = t14*t26
      t61 = t20*t25
      t62 = t15*t20
      t63 = t16*t20
      t64 = t17*t20
      t65 = t21*t26
      t66 = spvak2k1(iv2)
      t67 = t17*t66
      t68 = t24*t26
      t69 = spvak2k6(iv2)
      t70 = t17*t69
      t71 = t25*t26
      t72 = t17*t31
      t73 = t15*t26
      t74 = t17*t33
      t75 = t16*t26
      t76 = t17*t42
      t77 = spvak6k1(iv2)
      t78 = t17*t77
      t79 = t18*t26
      t80 = t12*t69
      t81 = t12*t31
      t82 = t24*t30
      t83 = t25*t30
      t84 = t19*t69
      t85 = t19*t31
      t86 = t19*t42
      t87 = t24*t49
      t88 = t25*t49
      t89 = t16*t49
      t90 = t14*t69
      t91 = t20*t24
      t92 = t21*t33
      t93 = t15*t66
      t22 = t22*t26
      t94 = spvak2k4(iv2)*t17
      t23 = t23*t26
      t95 = spvak2k5(iv2)*t17
      t96 = t24*t33
      t97 = t15*t69
      t98 = t73*abb92n112
      t99 = t74*abb92n112
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t122*t28+t122*t29+t125*t28+t125*t29+t127*abb92n8&
         &0+t27*abb92n70+t1*t27*abb92n126+t10*t27*abb92n97+t123*t127*abb92n105+t&
         &124*t127*abb92n108+t124*t27*abb92n85+t127*t2*abb92n113+t127*t3*abb92n8&
         &5+t127*t4*abb92n103+t127*t5*abb92n133+t127*t8*abb92n130+t14*t20*abb92n&
         &107+t27*t4*abb92n116+t27*t5*abb92n122+t27*t6*abb92n118+t27*t7*abb92n12&
         &0+t27*t8*abb92n140+t127*t2*t4*abb92n75+t127*t2*t5*abb92n68+t127*t2*t8*&
         &abb92n62+t127*t2*t9*abb92n84+t27*t4*t7*abb92n60)+t122*t98+t122*t99+t12&
         &3*t98+t123*t99+t125*t98+t125*t99+t32*abb92n65+t34*abb92n79+t35*abb92n7&
         &1+t37*abb92n65+t38*abb92n79+t39*abb92n71+t41*abb92n83+t43*abb92n63+t44&
         &*abb92n73+t45*abb92n83+t46*abb92n63+t47*abb92n73+t48*abb92n72+t50*abb9&
         &2n72+t51*abb92n66+t52*abb92n79+t53*abb92n74+t54*abb92n66+t55*abb92n79+&
         &t56*abb92n74+t57*abb92n131+t58*abb92n104+t59*abb92n134+t60*abb92n114+t&
         &61*abb92n131+t62*abb92n104+t63*abb92n134+t64*abb92n114+t65*abb92n69+t6&
         &7*abb92n69+t68*abb92n81+t70*abb92n81+t71*abb92n67+t72*abb92n67+t73*abb&
         &92n82+t74*abb92n82+t75*abb92n61+t76*abb92n61+t78*abb92n64+t79*abb92n64&
         &+t11*t20*abb92n106+t11*t30*abb92n76+t12*t20*abb92n110+t12*t36*abb92n76&
         &+t12*t40*abb92n78+t122*t68*abb92n99+t122*t70*abb92n99+t122*t71*abb92n1&
         &39+t122*t72*abb92n139+t122*t75*abb92n124+t122*t76*abb92n124+t123*t71*a&
         &bb92n137+t123*t72*abb92n137+t124*t68*abb92n84+t124*t70*abb92n84+t124*t&
         &71*abb92n62+t124*t72*abb92n62+t124*t73*abb92n75+t124*t74*abb92n75+t124&
         &*t75*abb92n68+t124*t76*abb92n68+t125*t71*abb92n138+t125*t72*abb92n138+&
         &t126*t68*abb92n95+t126*t70*abb92n95+t126*t71*abb92n135+t126*t72*abb92n&
         &135+t126*t75*abb92n128+t126*t76*abb92n128+t13*t20*abb92n110+t13*t30*ab&
         &b92n78+t14*t30*abb92n110+t14*t36*abb92n106+t14*t40*abb92n110+t2*t22*ab&
         &b92n119+t2*t23*abb92n98+t2*t32*abb92n137+t2*t34*abb92n112+t2*t37*abb92&
         &n137+t2*t38*abb92n112+t2*t41*abb92n112+t2*t43*abb92n124+t2*t44*abb92n9&
         &3+t2*t45*abb92n112+t2*t46*abb92n124+t2*t47*abb92n93+t2*t51*abb92n138+t&
         &2*t52*abb92n112+t2*t53*abb92n93+t2*t54*abb92n138+t2*t55*abb92n112+t2*t&
         &56*abb92n93+t2*t57*abb92n136+t2*t58*abb92n111+t2*t59*abb92n125+t2*t60*&
         &abb92n90+t2*t61*abb92n136+t2*t62*abb92n111+t2*t63*abb92n125+t2*t64*abb&
         &92n90+t2*t65*abb92n121+t2*t67*abb92n121+t2*t71*abb92n141+t2*t72*abb92n&
         &141+t2*t73*abb92n117+t2*t74*abb92n117+t2*t75*abb92n123+t2*t76*abb92n12&
         &3+t2*t78*abb92n127+t2*t79*abb92n127+t2*t80*abb92n99+t2*t81*abb92n139+t&
         &2*t82*abb92n99+t2*t83*abb92n139+t2*t84*abb92n95+t2*t85*abb92n135+t2*t8&
         &6*abb92n128+t2*t87*abb92n95+t2*t88*abb92n135+t2*t89*abb92n128+t2*t90*a&
         &bb92n96+t2*t91*abb92n96+t2*t92*abb92n132+t2*t93*abb92n132+t2*t94*abb92&
         &n119+t2*t95*abb92n98+t2*t96*abb92n88+t2*t97*abb92n88+t3*t92*abb92n60+t&
         &3*t93*abb92n60+t35*t4*abb92n112+t35*t8*abb92n137+t39*t4*abb92n112+t39*&
         &t8*abb92n137+t4*t44*abb92n112+t4*t47*abb92n112+t4*t53*abb92n112+t4*t56&
         &*abb92n112+t4*t60*abb92n111+t4*t64*abb92n111+t4*t65*abb92n132+t4*t67*a&
         &bb92n132+t4*t68*abb92n88+t4*t70*abb92n88+t44*t5*abb92n124+t44*t8*abb92&
         &n139+t44*t9*abb92n99+t47*t5*abb92n124+t47*t8*abb92n139+t47*t9*abb92n99&
         &+t48*t5*abb92n128+t48*t8*abb92n135+t48*t9*abb92n95+t5*t50*abb92n128+t5&
         &*t60*abb92n125+t5*t64*abb92n125+t50*t8*abb92n135+t50*t9*abb92n95+t53*t&
         &8*abb92n138+t56*t8*abb92n138+t60*t8*abb92n136+t60*t9*abb92n96+t64*t8*a&
         &bb92n136+t64*t9*abb92n96+t7*t73*abb92n132+t7*t74*abb92n132+t73*t9*abb9&
         &2n88+t74*t9*abb92n88+t2*t4*t65*abb92n142+t2*t4*t67*abb92n142+t2*t7*t73&
         &*abb92n142+t2*t7*t74*abb92n142)
         return
      end if
      t122 = d(iv2,iv3)
      t123 = d(iv1,iv3)
      t1 = k1(iv3)
      t3 = k2(iv3)
      t6 = k6(iv3)
      t10 = qshift(iv3)
      t28 = t122*t25
      t29 = t123*t31
      t35 = spvak3k1(iv3)
      t39 = t127*t35
      t48 = t122*t15
      t50 = t123*t33
      t78 = spvak3k4(iv3)
      t79 = t127*t78
      t98 = t122*t16
      t99 = t123*t42
      t100 = spvak5k1(iv3)
      t101 = t100*t127
      t102 = t122*t17
      t103 = t123*t26
      t104 = spvak5k6(iv3)
      t105 = t104*t127
      t65 = t104*t65
      t67 = t104*t67
      t106 = spvak2k1(iv3)
      t107 = t106*t17*t26
      t108 = spvak2k6(iv3)
      t109 = t17*t35
      t110 = t104*t73
      t111 = t104*t74
      t112 = t17*t78
      t113 = t112*t26
      t114 = t100*t17
      t115 = t104*t17
      t116 = t104*t26
      t117 = k5(iv3)
      t92 = t104*t92
      t118 = t21*t26*t78
      t93 = t104*t93
      t119 = t17*t66*t78
      t120 = t106*t15*t26
      t121 = t106*t17*t33
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t101*abb92n133+t102*abb92n113+t103*abb92n113+t10&
         &5*abb92n113+t107*abb92n120+t110*abb92n116+t111*abb92n116+t113*abb92n11&
         &6+t28*abb92n130+t29*abb92n130+t39*abb92n130+t48*abb92n103+t50*abb92n10&
         &3+t65*abb92n120+t67*abb92n120+t79*abb92n103+t98*abb92n133+t99*abb92n13&
         &3+spvak6k1(iv3)*t27*abb92n126+t1*t127*abb92n105+t10*t127*abb92n107+t10&
         &1*t2*abb92n68+t102*t2*abb92n91+t102*t4*abb92n75+t102*t5*abb92n68+t102*&
         &t8*abb92n62+t102*t9*abb92n84+t103*t2*abb92n91+t103*t4*abb92n75+t103*t5&
         &*abb92n68+t103*t8*abb92n62+t103*t9*abb92n84+t104*t22*abb92n118+t104*t2&
         &3*abb92n97+t104*t44*abb92n92+t104*t47*abb92n92+t104*t53*abb92n92+t104*&
         &t56*abb92n92+t104*t60*abb92n91+t104*t64*abb92n91+t104*t71*abb92n140+t1&
         &04*t72*abb92n140+t104*t75*abb92n122+t104*t76*abb92n122+t104*t94*abb92n&
         &118+t104*t95*abb92n97+t105*t2*abb92n91+t105*t4*abb92n75+t105*t5*abb92n&
         &68+t105*t8*abb92n62+t105*t9*abb92n84+t107*t4*abb92n60+t109*t26*abb92n1&
         &40+t11*t122*abb92n105+t110*t7*abb92n60+t111*t7*abb92n60+t113*t7*abb92n&
         &60+t114*t26*abb92n122+t115*t77*abb92n126+t116*t18*abb92n126+t12*t122*a&
         &bb92n109+t122*t13*abb92n109+t122*t14*abb92n107+t123*t20*abb92n107+t123&
         &*t30*abb92n109+t123*t36*abb92n105+t123*t40*abb92n109+t127*t3*abb92n109&
         &+t127*t6*abb92n109+t2*t28*abb92n62+t2*t29*abb92n62+t2*t39*abb92n62+t2*&
         &t48*abb92n75+t2*t50*abb92n75+t2*t79*abb92n75+t2*t98*abb92n68+t2*t99*ab&
         &b92n68+t4*t65*abb92n60+t4*t67*abb92n60+spvak2k4(iv3)*t17*t26*abb92n118&
         &+spvak2k5(iv3)*t17*t26*abb92n97+t10*t17*t26*abb92n91+t108*t127*t2*abb9&
         &2n84+t122*t2*t24*abb92n84+t123*t2*t69*abb92n84+t17*t26*t3*abb92n92+t17&
         &*t26*t6*abb92n92)+t118*abb92n132+t119*abb92n132+t120*abb92n132+t121*ab&
         &b92n132+t92*abb92n132+t93*abb92n132+t104*t32*abb92n137+t104*t34*abb92n&
         &112+t104*t37*abb92n137+t104*t38*abb92n112+t104*t41*abb92n112+t104*t43*&
         &abb92n124+t104*t45*abb92n112+t104*t46*abb92n124+t104*t51*abb92n138+t10&
         &4*t52*abb92n112+t104*t54*abb92n138+t104*t55*abb92n112+t104*t57*abb92n1&
         &36+t104*t58*abb92n111+t104*t59*abb92n125+t104*t61*abb92n136+t104*t62*a&
         &bb92n111+t104*t63*abb92n125+t104*t80*abb92n99+t104*t81*abb92n139+t104*&
         &t82*abb92n99+t104*t83*abb92n139+t104*t84*abb92n95+t104*t85*abb92n135+t&
         &104*t86*abb92n128+t104*t87*abb92n95+t104*t88*abb92n135+t104*t89*abb92n&
         &128+t104*t90*abb92n96+t104*t91*abb92n96+t104*t96*abb92n88+t104*t97*abb&
         &92n88+t118*t2*abb92n142+t119*t2*abb92n142+t120*t2*abb92n142+t121*t2*ab&
         &b92n142+t2*t92*abb92n142+t2*t93*abb92n142+t1*t15*t26*abb92n112+t1*t17*&
         &t31*abb92n137+t1*t17*t33*abb92n112+t1*t25*t26*abb92n137+t10*t15*t26*ab&
         &b92n111+t10*t16*t26*abb92n125+t10*t17*t31*abb92n136+t10*t17*t33*abb92n&
         &111+t10*t17*t42*abb92n125+t10*t17*t69*abb92n96+t10*t24*t26*abb92n96+t1&
         &0*t25*t26*abb92n136+t100*t12*t26*abb92n124+t100*t14*t26*abb92n125+t100&
         &*t17*t20*abb92n125+t100*t17*t30*abb92n124+t100*t17*t49*abb92n128+t100*&
         &t19*t26*abb92n128+t108*t12*t26*abb92n99+t108*t14*t26*abb92n96+t108*t15&
         &*t26*abb92n88+t108*t17*t20*abb92n96+t108*t17*t30*abb92n99+t108*t17*t33&
         &*abb92n88+t108*t17*t49*abb92n95+t108*t19*t26*abb92n95+t11*t26*t35*abb9&
         &2n137+t11*t26*t78*abb92n112+t117*t16*t26*abb92n128+t117*t17*t31*abb92n&
         &135+t117*t17*t42*abb92n128+t117*t17*t69*abb92n95+t117*t24*t26*abb92n95&
         &+t117*t25*t26*abb92n135+t12*t26*t35*abb92n139+t12*t26*t78*abb92n112+t1&
         &3*t26*t35*abb92n138+t13*t26*t78*abb92n112+t14*t26*t35*abb92n136+t14*t2&
         &6*t78*abb92n111+t15*t26*t3*abb92n112+t15*t26*t6*abb92n112+t16*t26*t3*a&
         &bb92n124+t17*t20*t35*abb92n136+t17*t20*t78*abb92n111+t17*t3*t31*abb92n&
         &139+t17*t3*t33*abb92n112+t17*t3*t42*abb92n124+t17*t3*t69*abb92n99+t17*&
         &t30*t35*abb92n139+t17*t30*t78*abb92n112+t17*t31*t6*abb92n138+t17*t33*t&
         &6*abb92n112+t17*t35*t36*abb92n137+t17*t35*t40*abb92n138+t17*t35*t49*ab&
         &b92n135+t17*t36*t78*abb92n112+t17*t40*t78*abb92n112+t17*t69*t78*abb92n&
         &88+t19*t26*t35*abb92n135+t24*t26*t3*abb92n99+t24*t26*t78*abb92n88+t25*&
         &t26*t3*abb92n139+t25*t26*t6*abb92n138)
         return
      end if
      t124 = d(iv3,iv4)
      t125 = d(iv2,iv4)
      t126 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k6(iv4)
      t3 = spvak3k1(iv4)
      t4 = spvak3k4(iv4)
      t5 = spvak5k1(iv4)
      t6 = spvak2k1(iv4)
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t122*t126*abb92n77+t123*t125*abb92n77+t124*t127*&
         &abb92n77)+(4.0_ki)*(t115*t125*abb92n85+t116*t126*abb92n85+t124*t27*abb&
         &92n85+t1*t104*t127*abb92n85+t1*t122*t17*abb92n85+t1*t123*t26*abb92n85)&
         &+(2.0_ki)*(t1*t118*abb92n60+t1*t119*abb92n60+t1*t120*abb92n60+t1*t121*&
         &abb92n60+t1*t92*abb92n60+t1*t93*abb92n60+t109*t125*abb92n62+t112*t125*&
         &abb92n75+t114*t125*abb92n68+t124*t68*abb92n84+t124*t70*abb92n84+t124*t&
         &71*abb92n62+t124*t72*abb92n62+t124*t73*abb92n75+t124*t74*abb92n75+t124&
         &*t75*abb92n68+t124*t76*abb92n68+t1*t100*t127*abb92n68+t1*t108*t127*abb&
         &92n84+t1*t122*t15*abb92n75+t1*t122*t16*abb92n68+t1*t122*t24*abb92n84+t&
         &1*t122*t25*abb92n62+t1*t123*t31*abb92n62+t1*t123*t33*abb92n75+t1*t123*&
         &t42*abb92n68+t1*t123*t69*abb92n84+t1*t127*t35*abb92n62+t1*t127*t78*abb&
         &92n75+t100*t126*t26*abb92n68+t104*t125*t15*abb92n75+t104*t125*t16*abb9&
         &2n68+t104*t125*t24*abb92n84+t104*t125*t25*abb92n62+t104*t126*t31*abb92&
         &n62+t104*t126*t33*abb92n75+t104*t126*t42*abb92n68+t104*t126*t69*abb92n&
         &84+t104*t127*t2*abb92n84+t104*t127*t3*abb92n62+t104*t127*t4*abb92n75+t&
         &104*t127*t5*abb92n68+t108*t125*t17*abb92n84+t108*t126*t26*abb92n84+t12&
         &2*t17*t2*abb92n84+t122*t17*t3*abb92n62+t122*t17*t4*abb92n75+t122*t17*t&
         &5*abb92n68+t123*t2*t26*abb92n84+t123*t26*t3*abb92n62+t123*t26*t4*abb92&
         &n75+t123*t26*t5*abb92n68+t126*t26*t35*abb92n62+t126*t26*t78*abb92n75+t&
         &104*t15*t26*t6*abb92n60+t104*t17*t33*t6*abb92n60+t104*t17*t4*t66*abb92&
         &n60+t104*t21*t26*t4*abb92n60+t106*t17*t26*t4*abb92n60+t17*t26*t6*t78*a&
         &bb92n60))
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d92:
   subroutine     reconstruct_d92(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group1
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group1), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_92:
      coeffs%coeffs_92%c0 = derivative(czip)
      coeffs%coeffs_92%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_92%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_92%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_92%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_92%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_92%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_92%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_92%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_92%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_92%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_92%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_92%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_92%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_92%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_92%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_92%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_92%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_92%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_92%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_92%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_92%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_92%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_92%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_92%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_92%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_92%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_92%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_92%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_92%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_92%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_92%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_92%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_92%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_92%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_92%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_92%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_92%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_92%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_92%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_92%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_92%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_92%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_92%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_92%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_92%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_92%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_92%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_92%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_92%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_92%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_92%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_92%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_92%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_92%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_92%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_92%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_92%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_92%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_92%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_92%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_92%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_92%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_92%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_92%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_92%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_92%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_92%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_92%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_92%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_92:
   end subroutine reconstruct_d92
!---#] subroutine reconstruct_d92:
end module p9_udbar_neepgg_d92h1l1d
