module     p9_udbar_neepgg_abbrevd91h3
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_globalsh3
   implicit none
   private
   complex(ki), public :: abb91n1
   complex(ki), public :: abb91n2
   complex(ki), public :: abb91n3
   complex(ki), public :: abb91n4
   complex(ki), public :: abb91n5
   complex(ki), public :: abb91n6
   complex(ki), public :: abb91n7
   complex(ki), public :: abb91n8
   complex(ki), public :: abb91n9
   complex(ki), public :: abb91n10
   complex(ki), public :: abb91n11
   complex(ki), public :: abb91n12
   complex(ki), public :: abb91n13
   complex(ki), public :: abb91n14
   complex(ki), public :: abb91n15
   complex(ki), public :: abb91n16
   complex(ki), public :: abb91n17
   complex(ki), public :: abb91n18
   complex(ki), public :: abb91n19
   complex(ki), public :: abb91n20
   complex(ki), public :: abb91n21
   complex(ki), public :: abb91n22
   complex(ki), public :: abb91n23
   complex(ki), public :: abb91n24
   complex(ki), public :: abb91n25
   complex(ki), public :: abb91n26
   complex(ki), public :: abb91n27
   complex(ki), public :: abb91n28
   complex(ki), public :: abb91n29
   complex(ki), public :: abb91n30
   complex(ki), public :: abb91n31
   complex(ki), public :: abb91n32
   complex(ki), public :: abb91n33
   complex(ki), public :: abb91n34
   complex(ki), public :: abb91n35
   complex(ki), public :: abb91n36
   complex(ki), public :: abb91n37
   complex(ki), public :: abb91n38
   complex(ki), public :: abb91n39
   complex(ki), public :: abb91n40
   complex(ki), public :: abb91n41
   complex(ki), public :: abb91n42
   complex(ki), public :: rat2d91
   complex(ki), public :: abb91n44
   complex(ki), public :: abb91n45
   complex(ki), public :: abb91n46
   complex(ki), public :: abb91n47
   complex(ki), public :: abb91n48
   complex(ki), public :: abb91n49
   complex(ki), public :: abb91n50
   complex(ki), public :: abb91n51
   complex(ki), public :: abb91n52
   complex(ki), public :: abb91n53
   complex(ki), public :: abb91n54
   complex(ki), public :: abb91n55
   complex(ki), public :: abb91n56
   complex(ki), public :: abb91n57
   complex(ki), public :: abb91n58
   complex(ki), public :: abb91n59
   complex(ki), public :: abb91n60
   complex(ki), public :: abb91n61
   complex(ki), public :: abb91n62
   complex(ki), public :: abb91n63
   complex(ki), public :: abb91n64
   complex(ki), public :: abb91n65
   complex(ki), public :: abb91n66
   complex(ki), public :: abb91n67
   complex(ki), public :: abb91n68
   complex(ki), public :: abb91n69
   complex(ki), public :: abb91n70
   complex(ki), public :: abb91n71
   complex(ki), public :: abb91n72
   complex(ki), public :: abb91n73
   complex(ki), public :: abb91n74
   complex(ki), public :: abb91n75
   complex(ki), public :: abb91n76
   complex(ki), public :: abb91n77
   complex(ki), public :: abb91n78
   complex(ki), public :: abb91n79
   complex(ki), public :: abb91n80
   complex(ki), public :: abb91n81
   complex(ki), public :: abb91n82
   complex(ki), public :: abb91n83
   complex(ki), public :: abb91n84
   complex(ki), public :: abb91n85
   complex(ki) :: t1
   complex(ki) :: t2
   complex(ki) :: t3
   complex(ki) :: t4
   complex(ki) :: t5
   complex(ki) :: t6
   complex(ki) :: t7
   complex(ki) :: t8
   complex(ki) :: t9
   complex(ki) :: t10
   complex(ki) :: t11
   complex(ki) :: t12
   complex(ki) :: t13
   complex(ki) :: t14
   complex(ki) :: t15
   complex(ki) :: t16
   complex(ki) :: t17
   public :: init_abbrev

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)

contains
   subroutine     init_abbrev()
      use p9_udbar_neepgg_config, only: deltaOS
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_model
      use p9_udbar_neepgg_color, only: TR
      use p9_udbar_neepgg_globalsl1, only: epspow
      implicit none
      t1 = es34+wW*mW*i_-mW*mW
      t2 = TR*c3
      t3 = es56*t2*i_
      t4 = t3*spak1k2*spak3k5*spbk4k1
      t5 = spbk6k5*spbk6k5
      t6 = t1*t5
      t7 = TR*c2
      t8 = es56*t7*i_
      t9 = t8*spak1k2*spak3k5*spbk4k1
      t10 = NC*t1
      t5 = t10*t5
      abb91n1 = ((4.0_ki)*(t9/t5*spbk6k1-t4/t6*spbk6k1))
      t4 = t4/t6*spbk5k1
      t9 = t9/t5*spbk5k1
      abb91n2 = ((4.0_ki)*(t9-t4))
      abb91n3 = ((8.0_ki)*(t4-t9))
      t4 = t3/t6*spak3k5*spbk4k1
      t9 = t8/t5*spak3k5*spbk4k1
      t11 = t4-t9
      abb91n4 = ((4.0_ki)*t11)
      t12 = t3*spak2k3
      t13 = t12/t6*spbk5k4
      t14 = t8*spak2k3
      t15 = t14/t5*spbk5k4
      abb91n5 = ((4.0_ki)*(t15-t13))
      abb91n6 = ((8.0_ki)*(t13-t15))
      abb91n7 = ((4.0_ki)*(t14/t5*spbk6k4-t12/t6*spbk6k4))
      t3 = t3*spak2k5
      t8 = t8*spak2k5
      abb91n8 = ((4.0_ki)*(t3/t6*spbk6k4-t8/t5*spbk6k4))
      t2 = t2*i_
      t12 = t2*spak1k2
      t13 = t12*spak3k5*spbk4k1
      t14 = t13/t6*spbk6k1
      t7 = t7*i_
      t15 = t7*spak1k2
      t16 = t15*spak3k5*spbk4k1
      t17 = t16/t5*spbk6k1
      abb91n9 = ((4.0_ki)*(t17-t14))
      abb91n10 = ((8.0_ki)*(t14-t17))
      abb91n11 = ((4.0_ki)*(t16/t5*spbk5k1+t15/t5*spak3k6*spbk4k1*spbk6k1-(t12/t&
      &6*spak3k6*spbk4k1*spbk6k1+t13/t6*spbk5k1)))
      t13 = t12*spak5k6*spbk5k1
      t14 = t13/t6*spbk6k1
      t16 = t15*spak5k6*spbk5k1
      t17 = t16/t5*spbk6k1
      abb91n12 = ((4.0_ki)*(t17-t14))
      abb91n13 = ((8.0_ki)*(t14-t17))
      t3 = t3/t6*spbk5k4
      t8 = t8/t5*spbk5k4
      t13 = t13/t6*spbk6k4
      t14 = t16/t5*spbk6k4
      abb91n14 = ((8.0_ki)*(t14+t8-(t3+t13)))
      abb91n15 = ((4.0_ki)*(t13+t3-(t8+t14)))
      t3 = t2*spak2k3
      t8 = t3*spak5k6
      t13 = t8/t6*spbk2k1*spbk6k4
      t14 = t7*spak2k3
      t16 = t14*spak5k6
      t17 = t16/t5*spbk2k1*spbk6k4
      abb91n16 = ((8.0_ki)*(t17+t9-(t4+t13)))
      abb91n17 = ((4.0_ki)*(t11+t13-t17))
      abb91n18 = ((4.0_ki)*(t3/t6*spbk2k1-t14/t5*spbk2k1))
      t4 = t3/t6*spbk4k1
      t9 = t14/t5*spbk4k1
      abb91n19 = ((8.0_ki)*(t9-t4))
      abb91n20 = ((4.0_ki)*(t4-t9))
      t4 = t2/t6*spak3k5*spbk4k1
      t9 = t7/t5*spak3k5*spbk4k1
      abb91n21 = ((8.0_ki)*(t9-t4))
      abb91n22 = ((4.0_ki)*(t4-t9))
      abb91n23 = ((4.0_ki)*(t2/t6*spak3k6*spbk4k1-t7/t5*spak3k6*spbk4k1))
      t4 = t8/t6*spbk5k1*spbk6k4
      t9 = t16/t5*spbk5k1*spbk6k4
      abb91n24 = ((8.0_ki)*(t9-t4))
      t4 = t4-t9
      abb91n25 = ((4.0_ki)*t4)
      abb91n26 = ((16.0_ki)*t4)
      t4 = t2/t6*spak5k6*spbk6k1
      t9 = t7/t5*spak5k6*spbk6k1
      abb91n27 = ((8.0_ki)*(t9-t4))
      abb91n28 = ((4.0_ki)*(t4-t9))
      abb91n29 = ((4.0_ki)*(t3/t6*spbk4k2-t14/t5*spbk4k2))
      t4 = t8/t6*spbk5k2*spbk6k4
      t8 = t16/t5*spbk5k2*spbk6k4
      abb91n30 = ((8.0_ki)*(t8-t4))
      abb91n31 = ((4.0_ki)*(t4-t8))
      abb91n32 = ((4.0_ki)*(t14/t5*spbk5k4-t3/t6*spbk5k4))
      t3 = t3/t6*spbk6k4
      t4 = t14/t5*spbk6k4
      abb91n33 = ((4.0_ki)*(t4-t3))
      abb91n34 = ((8.0_ki)*(t3-t4))
      t3 = t2*spak2k5
      t4 = t3/t6*spbk6k4
      t8 = t7*spak2k5
      t9 = t8/t5*spbk6k4
      abb91n35 = ((8.0_ki)*(t9-t4))
      abb91n36 = ((4.0_ki)*(t4-t9))
      t1 = t1*spbk6k5
      t4 = t3/t1
      t9 = t10*spbk6k5
      t10 = t8/t9
      abb91n37 = ((8.0_ki)*(t10-t4))
      abb91n38 = ((4.0_ki)*(t4-t10))
      t4 = t2*spak2k6
      t10 = t7*spak2k6
      abb91n39 = ((4.0_ki)*(t12/t6*spbk4k1+t3/t6*spbk5k4+t4/t6*spbk6k4-(t8/t5*sp&
      &bk5k4+t15/t5*spbk4k1+t10/t5*spbk6k4)))
      t1 = t4/t1
      t3 = t10/t9
      abb91n40 = ((4.0_ki)*(t3-t1))
      abb91n41 = ((8.0_ki)*(t1-t3))
      abb91n42 = ((4.0_ki)*(t7/t5-t2/t6))
      rat2d91 = 0
      rat2 = rat2 + rat2d91
      abb91n44 = abb91n1
      abb91n45 = abb91n42
      abb91n46 = abb91n41
      abb91n47 = abb91n40
      abb91n48 = abb91n39
      abb91n49 = abb91n38
      abb91n50 = abb91n37
      abb91n51 = abb91n36
      abb91n52 = abb91n35
      abb91n53 = abb91n34
      abb91n54 = abb91n33
      abb91n55 = abb91n32
      abb91n56 = abb91n31
      abb91n57 = abb91n30
      abb91n58 = abb91n29
      abb91n59 = abb91n28
      abb91n60 = abb91n27
      abb91n61 = abb91n26
      abb91n62 = abb91n25
      abb91n63 = abb91n24
      abb91n64 = abb91n23
      abb91n65 = abb91n22
      abb91n66 = abb91n21
      abb91n67 = abb91n20
      abb91n68 = abb91n19
      abb91n69 = abb91n18
      abb91n70 = abb91n17
      abb91n71 = abb91n16
      abb91n72 = abb91n15
      abb91n73 = abb91n14
      abb91n74 = abb91n13
      abb91n75 = abb91n12
      abb91n76 = abb91n11
      abb91n77 = abb91n10
      abb91n78 = abb91n9
      abb91n79 = abb91n8
      abb91n80 = abb91n7
      abb91n81 = abb91n6
      abb91n82 = abb91n5
      abb91n83 = abb91n4
      abb91n84 = abb91n3
      abb91n85 = abb91n2
   end subroutine
end module p9_udbar_neepgg_abbrevd91h3
