module     p9_udbar_neepgg_d17h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d17h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d17
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd17h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      real(ki) :: t48
      real(ki) :: t49
      real(ki) :: t50
      real(ki) :: t51
      real(ki) :: t52
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t48 = dotproduct(k1, qshift)
      t49 = dotproduct(k6, qshift)
      t50 = dotproduct(qshift, qshift)
      t51 = dotproduct(k2, qshift)
      t52 = dotproduct(k5, qshift)
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t3 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t4 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t5 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t6 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb17n45+t1*abb17n70+t2*abb17n71+t3*abb17n76+t4*abb17n80+t&
         &48*abb17n78+t48*t48*abb17n54+t49*abb17n77+t49*t49*abb17n54+t5*abb17n81&
         &+t50*abb17n58+t51*abb17n68+t52*abb17n69+t1*t3*abb17n60+t1*t4*abb17n66+&
         &t1*t48*abb17n62+t1*t49*abb17n61+t1*t5*abb17n63+t1*t50*abb17n72+t1*t6*a&
         &bb17n67+t2*t4*abb17n57+t2*t48*abb17n64+t2*t49*abb17n65+t2*t50*abb17n74&
         &+t2*t52*abb17n65+t3*t4*abb17n49+t3*t48*abb17n50+t3*t49*abb17n51+t3*t50&
         &*abb17n90+t3*t52*abb17n51+t4*t48*abb17n52+t4*t49*abb17n53+t4*t5*abb17n&
         &46+t4*t51*abb17n59+t48*t49*abb17n56+t48*t5*abb17n48+t48*t50*abb17n85+t&
         &48*t52*abb17n55+t49*t5*abb17n47+t49*t50*abb17n83+t49*t52*abb17n54+t5*t&
         &50*abb17n93+t5*t52*abb17n47+t1*t3*t4*abb17n92+t1*t4*t48*abb17n88+t1*t4&
         &*t49*abb17n89+t1*t4*t5*abb17n95+t1*t4*t6*abb17n82)
         return
      end if
      t7 = k1(iv1)
      t8 = k2(iv1)
      t9 = k5(iv1)
      t10 = k6(iv1)
      t11 = qshift(iv1)
      t12 = spvak2k4(iv1)
      t13 = spvak3k4(iv1)
      t14 = spvak5k6(iv1)
      t15 = spvak6k1(iv1)
      t16 = spvak6k5(iv1)
      t17 = spvak2k1(iv1)
      t18 = t12*abb17n65
      t19 = t15*abb17n47
      t20 = t16*abb17n51
      if(deg.eq.1) then
         numerator = (t10*abb17n77+t11*abb17n79+t12*abb17n71+t13*abb17n70+t14*ab&
         &b17n80+t15*abb17n81+t16*abb17n76+t18*t49+t18*t52+t19*t49+t19*t52+t20*t&
         &49+t20*t52+t7*abb17n78+t8*abb17n68+t9*abb17n69+t1*t10*abb17n61+t1*t11*&
         &abb17n73+t1*t14*abb17n66+t1*t15*abb17n63+t1*t16*abb17n60+t1*t17*abb17n&
         &67+t1*t7*abb17n62+t10*t2*abb17n65+t10*t3*abb17n51+t10*t4*abb17n53+t10*&
         &t48*abb17n56+t10*t49*abb17n87+t10*t5*abb17n47+t10*t50*abb17n83+t10*t52&
         &*abb17n54+t11*t2*abb17n75+t11*t3*abb17n91+t11*t48*abb17n86+t11*t49*abb&
         &17n84+t11*t5*abb17n94+t12*t4*abb17n57+t12*t48*abb17n64+t12*t50*abb17n7&
         &4+t13*t3*abb17n60+t13*t4*abb17n66+t13*t48*abb17n62+t13*t49*abb17n61+t1&
         &3*t5*abb17n63+t13*t50*abb17n72+t13*t6*abb17n67+t14*t2*abb17n57+t14*t3*&
         &abb17n49+t14*t48*abb17n52+t14*t49*abb17n53+t14*t5*abb17n46+t14*t51*abb&
         &17n59+t15*t4*abb17n46+t15*t48*abb17n48+t15*t50*abb17n93+t16*t4*abb17n4&
         &9+t16*t48*abb17n50+t16*t50*abb17n90+t2*t7*abb17n64+t2*t9*abb17n65+t3*t&
         &7*abb17n50+t3*t9*abb17n51+t4*t7*abb17n52+t4*t8*abb17n59+t48*t7*abb17n8&
         &7+t48*t9*abb17n55+t49*t7*abb17n56+t49*t9*abb17n54+t5*t7*abb17n48+t5*t9&
         &*abb17n47+t50*t7*abb17n85+t52*t7*abb17n55+t1*t10*t4*abb17n89+t1*t14*t3&
         &*abb17n92+t1*t14*t48*abb17n88+t1*t14*t49*abb17n89+t1*t14*t5*abb17n95+t&
         &1*t14*t6*abb17n82+t1*t15*t4*abb17n95+t1*t16*t4*abb17n92+t1*t17*t4*abb1&
         &7n82+t1*t4*t7*abb17n88+t13*t3*t4*abb17n92+t13*t4*t48*abb17n88+t13*t4*t&
         &49*abb17n89+t13*t4*t5*abb17n95+t13*t4*t6*abb17n82)
         return
      end if
      t50 = d(iv1,iv2)
      t18 = k1(iv2)
      t19 = k6(iv2)
      t20 = k5(iv2)
      t21 = qshift(iv2)
      t22 = spvak2k4(iv2)
      t23 = spvak3k4(iv2)
      t24 = t23*t7
      t25 = spvak5k6(iv2)
      t26 = t25*t7
      t27 = spvak6k1(iv2)
      t28 = spvak6k5(iv2)
      t29 = t13*t18
      t30 = t14*t18
      t31 = t10*t23
      t32 = t10*t25
      t33 = t13*t19
      t34 = t14*t19
      t35 = t17*t23
      t36 = spvak2k1(iv2)
      t37 = t13*t36
      t38 = t13*t25
      t39 = t13*t27
      t40 = t13*t28
      t41 = t14*t23
      t42 = t15*t23
      t43 = t16*t23
      t44 = t14*t27
      t45 = t14*t28
      t46 = t15*t25
      t47 = t16*t25
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t50*abb17n58+t1*t50*abb17n72+t10*t19*abb17n54+t1&
         &8*t7*abb17n54+t2*t50*abb17n74+t3*t50*abb17n90+t48*t50*abb17n85+t49*t50&
         &*abb17n83+t5*t50*abb17n93)+t24*abb17n62+t26*abb17n52+t29*abb17n62+t30*&
         &abb17n52+t31*abb17n61+t32*abb17n53+t33*abb17n61+t34*abb17n53+t35*abb17&
         &n67+t37*abb17n67+t38*abb17n66+t39*abb17n63+t40*abb17n60+t41*abb17n66+t&
         &42*abb17n63+t43*abb17n60+t44*abb17n46+t45*abb17n49+t46*abb17n46+t47*ab&
         &b17n49+k2(iv2)*t14*abb17n59+t1*t26*abb17n88+t1*t30*abb17n88+t1*t32*abb&
         &17n89+t1*t34*abb17n89+t1*t44*abb17n95+t1*t45*abb17n92+t1*t46*abb17n95+&
         &t1*t47*abb17n92+t10*t18*abb17n56+t10*t20*abb17n54+t10*t21*abb17n84+t10&
         &*t22*abb17n65+t10*t27*abb17n47+t10*t28*abb17n51+t11*t18*abb17n86+t11*t&
         &19*abb17n84+t11*t22*abb17n75+t11*t23*abb17n73+t11*t27*abb17n94+t11*t28&
         &*abb17n91+t12*t18*abb17n64+t12*t19*abb17n65+t12*t20*abb17n65+t12*t21*a&
         &bb17n75+t12*t25*abb17n57+t13*t21*abb17n73+t14*t22*abb17n57+t15*t18*abb&
         &17n48+t15*t19*abb17n47+t15*t20*abb17n47+t15*t21*abb17n94+t16*t18*abb17&
         &n50+t16*t19*abb17n51+t16*t20*abb17n51+t16*t21*abb17n91+t18*t9*abb17n55&
         &+t19*t7*abb17n56+t19*t9*abb17n54+t20*t7*abb17n55+t21*t7*abb17n86+t22*t&
         &7*abb17n64+t22*t9*abb17n65+t24*t4*abb17n88+t25*t8*abb17n59+t27*t7*abb1&
         &7n48+t27*t9*abb17n47+t28*t7*abb17n50+t28*t9*abb17n51+t29*t4*abb17n88+t&
         &3*t38*abb17n92+t3*t41*abb17n92+t31*t4*abb17n89+t33*t4*abb17n89+t35*t4*&
         &abb17n82+t37*t4*abb17n82+t38*t48*abb17n88+t38*t49*abb17n89+t38*t5*abb1&
         &7n95+t38*t6*abb17n82+t39*t4*abb17n95+t4*t40*abb17n92+t4*t42*abb17n95+t&
         &4*t43*abb17n92+t41*t48*abb17n88+t41*t49*abb17n89+t41*t5*abb17n95+t41*t&
         &6*abb17n82+t1*t14*t36*abb17n82+t1*t17*t25*abb17n82)
         return
      end if
      t48 = d(iv2,iv3)
      t49 = d(iv1,iv3)
      t1 = k1(iv3)
      t2 = k6(iv3)
      t3 = spvak3k4(iv3)
      t4 = spvak6k1(iv3)
      t5 = spvak6k5(iv3)
      t6 = spvak5k6(iv3)
      t8 = spvak2k1(iv3)
      t9 = t13*t6
      t11 = t23*t6
      t20 = t14*t3
      t21 = t25*t3
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k4(iv3)*t50*abb17n74+t1*t50*abb17n85+t10*t&
         &48*abb17n83+t12*t48*abb17n74+t13*t48*abb17n72+t15*t48*abb17n93+t16*t48&
         &*abb17n90+t18*t49*abb17n85+t19*t49*abb17n83+t2*t50*abb17n83+t22*t49*ab&
         &b17n74+t23*t49*abb17n72+t27*t49*abb17n93+t28*t49*abb17n90+t3*t50*abb17&
         &n72+t4*t50*abb17n93+t48*t7*abb17n85+t5*t50*abb17n90)+t11*t15*abb17n95+&
         &t11*t16*abb17n92+t15*t21*abb17n95+t16*t21*abb17n92+t20*t27*abb17n95+t2&
         &0*t28*abb17n92+t24*t6*abb17n88+t27*t9*abb17n95+t28*t9*abb17n92+t29*t6*&
         &abb17n88+t31*t6*abb17n89+t33*t6*abb17n89+t35*t6*abb17n82+t37*t6*abb17n&
         &82+t38*t4*abb17n95+t38*t5*abb17n92+t4*t41*abb17n95+t41*t5*abb17n92+t1*&
         &t13*t25*abb17n88+t1*t14*t23*abb17n88+t10*t25*t3*abb17n89+t13*t2*t25*ab&
         &b17n89+t13*t25*t8*abb17n82+t14*t18*t3*abb17n88+t14*t19*t3*abb17n89+t14&
         &*t2*t23*abb17n89+t14*t23*t8*abb17n82+t14*t3*t36*abb17n82+t17*t25*t3*ab&
         &b17n82+t25*t3*t7*abb17n88)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d17:
   subroutine     reconstruct_d17(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group11
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group11), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_17:
      coeffs%coeffs_17%c0 = derivative(czip)
      coeffs%coeffs_17%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_17%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_17%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_17%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_17%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_17%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_17%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_17%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_17%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_17%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_17%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_17%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_17%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_17%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_17%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_17%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_17%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_17%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_17%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_17%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_17%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_17%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_17%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_17%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_17%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_17%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_17%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_17%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_17%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_17%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_17%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_17%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_17%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_17%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_17:
   end subroutine reconstruct_d17
!---#] subroutine reconstruct_d17:
end module p9_udbar_neepgg_d17h3l1d
