module     p9_udbar_neepgg_d84h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d84h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d84
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd84h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      complex(ki) :: t158
      complex(ki) :: t159
      complex(ki) :: t160
      complex(ki) :: t161
      complex(ki) :: t162
      complex(ki) :: t163
      complex(ki) :: t164
      complex(ki) :: t165
      complex(ki) :: t166
      complex(ki) :: t167
      complex(ki) :: t168
      complex(ki) :: t169
      complex(ki) :: t170
      complex(ki) :: t171
      complex(ki) :: t172
      complex(ki) :: t173
      complex(ki) :: t174
      complex(ki) :: t175
      complex(ki) :: t176
      complex(ki) :: t177
      complex(ki) :: t178
      complex(ki) :: t179
      complex(ki) :: t180
      complex(ki) :: t181
      complex(ki) :: t182
      real(ki) :: t183
      real(ki) :: t184
      real(ki) :: t185
      real(ki) :: t186
      real(ki) :: t187
      real(ki) :: t188
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t183 = dotproduct(qshift, qshift)
      t184 = dotproduct(k5, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t185 = dotproduct(k1, qshift)
      t186 = dotproduct(k6, qshift)
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t3 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t187 = dotproduct(k2, qshift)
      t4 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t6 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t7 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t8 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t9 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t10 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-s&
      &pvak2k4(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb84n83+t1*abb84n167+t183*abb84n118+t183*t183*abb84n113+t&
         &184*abb84n164+t185*abb84n174+t186*abb84n175+t187*abb84n189+t2*abb84n17&
         &8+t3*abb84n179+t1*t183*abb84n213+t1*t185*abb84n138+t1*t186*abb84n159+t&
         &1*t187*abb84n143+t1*t2*abb84n156+t1*t3*abb84n153+t1*t7*abb84n140+t183*&
         &t184*abb84n236+t183*t185*abb84n196+t183*t187*abb84n230+t183*t2*abb84n1&
         &70+t183*t3*abb84n243+t183*t6*abb84n207+t183*t8*abb84n184+t183*t9*abb84&
         &n262+t184*t185*abb84n135+t184*t2*abb84n157+t184*t3*abb84n148+t184*t6*a&
         &bb84n139+t185*t187*abb84n126+t185*t2*abb84n119+t185*t3*abb84n109+t185*&
         &t6*abb84n128+t185*t8*abb84n145+t185*t9*abb84n93+t186*t187*abb84n127+t1&
         &86*t3*abb84n106+t186*t6*abb84n130+t186*t9*abb84n95+t187*t2*abb84n116+t&
         &187*t3*abb84n149+t187*t6*abb84n141+t187*t8*abb84n162+t2*t3*abb84n104+t&
         &2*t4*abb84n108+t2*t5*abb84n110+t2*t6*abb84n117+t2*t9*abb84n96+t3*t8*ab&
         &b84n161+t6*t8*abb84n147+t1*t10*t183*abb84n121+t1*t10*t185*abb84n223+t1&
         &*t10*t186*abb84n219+t1*t10*t2*abb84n238+t1*t183*t3*abb84n102+t1*t183*t&
         &8*abb84n124+t1*t183*t9*abb84n87+t1*t185*t2*abb84n194+t1*t185*t3*abb84n&
         &252+t1*t185*t8*abb84n218+t1*t185*t9*abb84n271+t1*t186*t3*abb84n248+t1*&
         &t186*t9*abb84n275+t1*t187*t2*abb84n194+t1*t2*t3*abb84n257+t1*t2*t4*abb&
         &84n250+t1*t2*t5*abb84n246+t1*t2*t7*abb84n201+t1*t2*t9*abb84n276+t1*t3*&
         &t8*abb84n177+t1*t5*t8*abb84n204+t183*t2*t4*abb84n99+t183*t2*t6*abb84n1&
         &33+t183*t2*t9*abb84n90+t184*t2*t4*abb84n258+t184*t2*t6*abb84n199+t184*&
         &t2*t9*abb84n266+t187*t2*t4*abb84n253+t187*t2*t6*abb84n203+t187*t2*t8*a&
         &bb84n228+t187*t2*t9*abb84n270+t2*t5*t8*abb84n265+t2*t6*t8*abb84n187+t1&
         &*t2*t5*t8*abb84n84)
         return
      end if
      t11 = k1(iv1)
      t12 = k2(iv1)
      t13 = k5(iv1)
      t14 = k6(iv1)
      t15 = qshift(iv1)
      t16 = spvak5k6(iv1)
      t17 = spvak6k1(iv1)
      t18 = spvak6k5(iv1)
      t19 = spvak2k1(iv1)
      t20 = spvak2k5(iv1)
      t21 = spvak2k6(iv1)
      t22 = spvak3k1(iv1)
      t23 = spvak3k4(iv1)
      t24 = spvak5k1(iv1)
      t25 = spvak2k4(iv1)
      t26 = t16*abb84n137
      t27 = t18*abb84n137
      if(deg.eq.1) then
         numerator = (t11*abb84n155+t12*abb84n142+t13*abb84n163+t14*abb84n154+t1&
         &5*abb84n225+t16*abb84n160+t17*abb84n150+t18*abb84n151+t1*t11*abb84n193&
         &+t1*t12*abb84n188+t1*t14*abb84n168+t1*t15*abb84n212+t1*t17*abb84n176+t&
         &1*t18*abb84n173+t1*t185*t27+t1*t187*t27+t1*t20*abb84n191+t11*t183*abb8&
         &4n136+t11*t184*abb84n198+t11*t187*abb84n211+t11*t2*abb84n224+t11*t3*ab&
         &b84n240+t11*t6*abb84n209+t11*t8*abb84n186+t11*t9*abb84n264+t12*t183*ab&
         &b84n114+t12*t185*abb84n211+t12*t186*abb84n210+t12*t2*abb84n227+t12*t3*&
         &abb84n180+t12*t6*abb84n190+t12*t8*abb84n165+t13*t183*abb84n112+t13*t18&
         &5*abb84n198+t13*t2*abb84n172+t13*t3*abb84n181+t13*t6*abb84n192+t14*t18&
         &7*abb84n210+t14*t3*abb84n245+t14*t6*abb84n205+t14*t9*abb84n260+t15*t18&
         &3*abb84n234+t15*t184*abb84n235+t15*t185*abb84n195+t15*t187*abb84n229+t&
         &15*t2*abb84n169+t15*t3*abb84n242+t15*t6*abb84n206+t15*t8*abb84n183+t15&
         &*t9*abb84n261+t16*t183*abb84n125+t16*t185*abb84n193+t16*t186*abb84n168&
         &+t16*t187*abb84n188+t16*t2*abb84n173+t16*t3*abb84n176+t16*t7*abb84n191&
         &+t17*t183*abb84n107+t17*t184*abb84n181+t17*t185*abb84n240+t17*t186*abb&
         &84n245+t17*t187*abb84n180+t17*t2*abb84n247+t17*t8*abb84n166+t18*t183*a&
         &bb84n158+t18*t184*abb84n172+t18*t185*abb84n224+t18*t187*abb84n227+t18*&
         &t3*abb84n247+t18*t4*abb84n241+t18*t5*abb84n239+t18*t6*abb84n226+t18*t9&
         &*abb84n259+t183*t21*abb84n129+t183*t22*abb84n94+t183*t23*abb84n146+t18&
         &4*t21*abb84n192+t185*t2*t26+t185*t21*abb84n209+t185*t22*abb84n264+t185&
         &*t23*abb84n186+t186*t21*abb84n205+t186*t22*abb84n260+t187*t2*t26+t187*&
         &t21*abb84n190+t187*t23*abb84n165+t19*t2*abb84n239+t2*t21*abb84n226+t2*&
         &t22*abb84n259+t2*t24*abb84n241+t21*t8*abb84n182+t23*t3*abb84n166+t23*t&
         &6*abb84n182+t1*t10*t11*abb84n120+t1*t10*t14*abb84n122+t1*t10*t15*abb84&
         &n222+t1*t10*t18*abb84n111+t1*t11*t2*abb84n137+t1*t11*t3*abb84n101+t1*t&
         &11*t8*abb84n123+t1*t11*t9*abb84n88+t1*t12*t2*abb84n137+t1*t14*t3*abb84&
         &n103+t1*t14*t9*abb84n86+t1*t15*t3*abb84n251+t1*t15*t8*abb84n217+t1*t15&
         &*t9*abb84n274+t1*t17*t183*abb84n250+t1*t17*t185*abb84n101+t1*t17*t186*&
         &abb84n103+t1*t17*t2*abb84n98+t1*t17*t8*abb84n152+t1*t18*t3*abb84n98+t1&
         &*t18*t4*abb84n102+t1*t18*t5*abb84n105+t1*t18*t7*abb84n133+t1*t18*t9*ab&
         &b84n85+t1*t183*t22*abb84n273+t1*t183*t23*abb84n216+t1*t183*t25*abb84n2&
         &21+t1*t185*t22*abb84n88+t1*t185*t23*abb84n123+t1*t185*t25*abb84n120+t1&
         &*t186*t22*abb84n86+t1*t186*t25*abb84n122+t1*t19*t2*abb84n105+t1*t19*t8&
         &*abb84n131+t1*t2*t20*abb84n133+t1*t2*t22*abb84n85+t1*t2*t24*abb84n102+&
         &t1*t2*t25*abb84n111+t1*t23*t3*abb84n152+t1*t23*t5*abb84n131+t10*t16*t1&
         &83*abb84n221+t10*t16*t185*abb84n120+t10*t16*t186*abb84n122+t10*t16*t2*&
         &abb84n111+t12*t2*t4*abb84n100+t12*t2*t6*abb84n132+t12*t2*t8*abb84n115+&
         &t12*t2*t9*abb84n89+t13*t2*t4*abb84n97+t13*t2*t6*abb84n134+t13*t2*t9*ab&
         &b84n91+t15*t2*t4*abb84n256+t15*t2*t6*abb84n202+t15*t2*t9*abb84n269+t16&
         &*t183*t3*abb84n250+t16*t183*t8*abb84n216+t16*t183*t9*abb84n273+t16*t18&
         &5*t3*abb84n101+t16*t185*t8*abb84n123+t16*t185*t9*abb84n88+t16*t186*t3*&
         &abb84n103+t16*t186*t9*abb84n86+t16*t2*t3*abb84n98+t16*t2*t4*abb84n102+&
         &t16*t2*t5*abb84n105+t16*t2*t7*abb84n133+t16*t2*t9*abb84n85+t16*t3*t8*a&
         &bb84n152+t16*t5*t8*abb84n131+t18*t183*t4*abb84n255+t18*t183*t6*abb84n2&
         &01+t18*t183*t9*abb84n268+t18*t184*t4*abb84n97+t18*t184*t6*abb84n134+t1&
         &8*t184*t9*abb84n91+t18*t187*t4*abb84n100+t18*t187*t6*abb84n132+t18*t18&
         &7*t8*abb84n115+t18*t187*t9*abb84n89+t18*t5*t8*abb84n92+t18*t6*t8*abb84&
         &n144+t183*t2*t21*abb84n201+t183*t2*t22*abb84n268+t183*t2*t24*abb84n255&
         &+t184*t2*t21*abb84n134+t184*t2*t22*abb84n91+t184*t2*t24*abb84n97+t187*&
         &t2*t21*abb84n132+t187*t2*t22*abb84n89+t187*t2*t23*abb84n115+t187*t2*t2&
         &4*abb84n100+t19*t2*t8*abb84n92+t2*t21*t8*abb84n144+t2*t23*t5*abb84n92+&
         &t2*t23*t6*abb84n144+t1*t18*t5*t8*abb84n277+t1*t19*t2*t8*abb84n277+t1*t&
         &2*t23*t5*abb84n277+t16*t2*t5*t8*abb84n277)
         return
      end if
      t188 = d(iv1,iv2)
      t26 = qshift(iv2)
      t27 = k2(iv2)
      t28 = k5(iv2)
      t29 = spvak2k6(iv2)
      t30 = spvak3k1(iv2)
      t31 = t11*t30
      t32 = spvak3k4(iv2)
      t33 = t11*t32
      t34 = spvak5k6(iv2)
      t35 = t11*t34
      t36 = spvak6k1(iv2)
      t37 = t11*t36
      t38 = spvak6k5(iv2)
      t39 = t11*t38
      t40 = k1(iv2)
      t41 = t22*t40
      t42 = t23*t40
      t43 = t16*t40
      t44 = t17*t40
      t45 = t18*t40
      t46 = k6(iv2)
      t47 = t12*t29
      t48 = t12*t32
      t49 = t12*t34
      t50 = t12*t38
      t51 = t21*t27
      t52 = t23*t27
      t53 = t16*t27
      t54 = t18*t27
      t55 = t13*t29
      t56 = t13*t38
      t57 = t21*t28
      t58 = t18*t28
      t59 = t14*t30
      t60 = t14*t34
      t61 = t14*t36
      t62 = t22*t46
      t63 = t16*t46
      t64 = t17*t46
      t65 = t15*t29
      t66 = t15*t30
      t67 = t15*t32
      t68 = t15*t34
      t69 = t15*t36
      t70 = t15*t38
      t71 = t21*t26
      t72 = t22*t26
      t73 = t23*t26
      t74 = t16*t26
      t75 = t17*t26
      t76 = t18*t26
      t77 = t19*t38
      t78 = spvak2k1(iv2)
      t79 = t18*t78
      t80 = t20*t34
      t81 = spvak2k5(iv2)
      t82 = t16*t81
      t83 = t21*t32
      t84 = t21*t38
      t85 = t23*t29
      t86 = t18*t29
      t87 = t22*t38
      t88 = t18*t30
      t89 = t23*t36
      t90 = t17*t32
      t91 = t24*t38
      t92 = spvak5k1(iv2)
      t93 = t18*t92
      t94 = t16*t36
      t95 = t16*t38
      t96 = t17*t34
      t97 = t18*t34
      t98 = t17*t38
      t99 = t18*t36
      t100 = spvak2k4(iv2)
      t101 = t100*t11
      t102 = t25*t40
      t103 = t12*t30
      t104 = t12*t92
      t105 = t22*t27
      t106 = t24*t27
      t107 = t13*t30
      t108 = t13*t92
      t109 = t22*t28
      t110 = t24*t28
      t111 = t100*t14
      t112 = t25*t46
      t113 = t100*t15
      t114 = t15*t92
      t115 = t25*t26
      t116 = t24*t26
      t117 = t19*t32
      t118 = t19*t34
      t119 = t23*t78
      t120 = t16*t78
      t121 = t25*t34
      t122 = t100*t16
      t123 = t22*t34
      t124 = t16*t30
      t125 = t23*t34
      t126 = t23*t38
      t127 = t16*t32
      t128 = t18*t32
      t129 = t24*t34
      t130 = t16*t92
      t131 = t95*abb84n194
      t132 = t97*abb84n194
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t188*abb84n118+t1*t188*abb84n213+t15*t26*abb84n2&
         &32+t183*t188*abb84n233+t184*t188*abb84n236+t185*t188*abb84n196+t187*t1&
         &88*abb84n230+t188*t2*abb84n170+t188*t3*abb84n243+t188*t6*abb84n207+t18&
         &8*t8*abb84n184+t188*t9*abb84n262+t1*t10*t188*abb84n121+t1*t188*t3*abb8&
         &4n102+t1*t188*t8*abb84n124+t1*t188*t9*abb84n87+t188*t2*t4*abb84n99+t18&
         &8*t2*t6*abb84n133+t188*t2*t9*abb84n90)+t131*t185+t131*t187+t132*t185+t&
         &132*t187+t31*abb84n93+t33*abb84n145+t35*abb84n138+t37*abb84n109+t39*ab&
         &b84n119+t41*abb84n93+t42*abb84n145+t43*abb84n138+t44*abb84n109+t45*abb&
         &84n119+t47*abb84n141+t48*abb84n162+t49*abb84n143+t50*abb84n116+t51*abb&
         &84n141+t52*abb84n162+t53*abb84n143+t54*abb84n116+t55*abb84n139+t56*abb&
         &84n157+t57*abb84n139+t58*abb84n157+t59*abb84n95+t60*abb84n159+t61*abb8&
         &4n106+t62*abb84n95+t63*abb84n159+t64*abb84n106+t65*abb84n208+t66*abb84&
         &n263+t67*abb84n185+t68*abb84n214+t69*abb84n244+t70*abb84n171+t71*abb84&
         &n208+t72*abb84n263+t73*abb84n185+t74*abb84n214+t75*abb84n244+t76*abb84&
         &n171+t77*abb84n110+t79*abb84n110+t80*abb84n140+t82*abb84n140+t83*abb84&
         &n147+t84*abb84n117+t85*abb84n147+t86*abb84n117+t87*abb84n96+t88*abb84n&
         &96+t89*abb84n161+t90*abb84n161+t91*abb84n108+t93*abb84n108+t94*abb84n1&
         &53+t95*abb84n156+t96*abb84n153+t97*abb84n156+t98*abb84n104+t99*abb84n1&
         &04+t1*t101*abb84n223+t1*t102*abb84n223+t1*t111*abb84n219+t1*t112*abb84&
         &n219+t1*t113*abb84n220+t1*t115*abb84n220+t1*t117*abb84n204+t1*t119*abb&
         &84n204+t1*t31*abb84n271+t1*t33*abb84n218+t1*t37*abb84n252+t1*t39*abb84&
         &n194+t1*t41*abb84n271+t1*t42*abb84n218+t1*t44*abb84n252+t1*t45*abb84n1&
         &94+t1*t50*abb84n194+t1*t54*abb84n194+t1*t59*abb84n275+t1*t61*abb84n248&
         &+t1*t62*abb84n275+t1*t64*abb84n248+t1*t66*abb84n272+t1*t67*abb84n215+t&
         &1*t69*abb84n249+t1*t72*abb84n272+t1*t73*abb84n215+t1*t75*abb84n249+t1*&
         &t77*abb84n246+t1*t79*abb84n246+t1*t87*abb84n276+t1*t88*abb84n276+t1*t8&
         &9*abb84n177+t1*t90*abb84n177+t1*t91*abb84n250+t1*t93*abb84n250+t1*t98*&
         &abb84n257+t1*t99*abb84n257+t10*t35*abb84n223+t10*t43*abb84n223+t10*t60&
         &*abb84n219+t10*t63*abb84n219+t10*t68*abb84n220+t10*t74*abb84n220+t10*t&
         &95*abb84n238+t10*t97*abb84n238+t103*t2*abb84n270+t104*t2*abb84n253+t10&
         &5*t2*abb84n270+t106*t2*abb84n253+t107*t2*abb84n266+t108*t2*abb84n258+t&
         &109*t2*abb84n266+t11*t26*abb84n197+t11*t27*abb84n126+t11*t28*abb84n135&
         &+t11*t29*abb84n128+t110*t2*abb84n258+t114*t2*abb84n254+t116*t2*abb84n2&
         &54+t117*t2*abb84n265+t118*t2*abb84n246+t118*t8*abb84n204+t119*t2*abb84&
         &n265+t12*t26*abb84n231+t12*t36*abb84n149+t12*t40*abb84n126+t12*t46*abb&
         &84n127+t120*t2*abb84n246+t120*t8*abb84n204+t121*t183*abb84n121+t121*t1&
         &85*abb84n223+t121*t186*abb84n219+t121*t2*abb84n238+t122*t183*abb84n121&
         &+t122*t185*abb84n223+t122*t186*abb84n219+t122*t2*abb84n238+t123*t183*a&
         &bb84n87+t123*t185*abb84n271+t123*t186*abb84n275+t123*t2*abb84n276+t124&
         &*t183*abb84n87+t124*t185*abb84n271+t124*t186*abb84n275+t124*t2*abb84n2&
         &76+t125*t183*abb84n124+t125*t185*abb84n218+t125*t3*abb84n177+t125*t5*a&
         &bb84n204+t126*t187*abb84n228+t126*t5*abb84n265+t126*t6*abb84n187+t127*&
         &t183*abb84n124+t127*t185*abb84n218+t127*t3*abb84n177+t127*t5*abb84n204&
         &+t128*t187*abb84n228+t128*t5*abb84n265+t128*t6*abb84n187+t129*t2*abb84&
         &n250+t13*t26*abb84n237+t13*t36*abb84n148+t13*t40*abb84n135+t130*t2*abb&
         &84n250+t14*t27*abb84n127+t14*t29*abb84n130+t15*t27*abb84n231+t15*t28*a&
         &bb84n237+t15*t40*abb84n197+t17*t27*abb84n149+t17*t28*abb84n148+t183*t8&
         &4*abb84n133+t183*t86*abb84n133+t183*t87*abb84n90+t183*t88*abb84n90+t18&
         &3*t91*abb84n99+t183*t93*abb84n99+t183*t94*abb84n102+t183*t96*abb84n102&
         &+t184*t84*abb84n199+t184*t86*abb84n199+t184*t87*abb84n266+t184*t88*abb&
         &84n266+t184*t91*abb84n258+t184*t93*abb84n258+t185*t94*abb84n252+t185*t&
         &96*abb84n252+t186*t94*abb84n248+t186*t96*abb84n248+t187*t84*abb84n203+&
         &t187*t86*abb84n203+t187*t87*abb84n270+t187*t88*abb84n270+t187*t91*abb8&
         &4n253+t187*t93*abb84n253+t2*t35*abb84n194+t2*t43*abb84n194+t2*t47*abb8&
         &4n203+t2*t48*abb84n228+t2*t49*abb84n194+t2*t51*abb84n203+t2*t52*abb84n&
         &228+t2*t53*abb84n194+t2*t55*abb84n199+t2*t57*abb84n199+t2*t65*abb84n20&
         &0+t2*t66*abb84n267+t2*t71*abb84n200+t2*t72*abb84n267+t2*t80*abb84n201+&
         &t2*t82*abb84n201+t2*t83*abb84n187+t2*t85*abb84n187+t2*t94*abb84n257+t2&
         &*t96*abb84n257+t21*t40*abb84n128+t21*t46*abb84n130+t3*t35*abb84n252+t3&
         &*t43*abb84n252+t3*t60*abb84n248+t3*t63*abb84n248+t3*t68*abb84n249+t3*t&
         &74*abb84n249+t3*t95*abb84n257+t3*t97*abb84n257+t35*t8*abb84n218+t35*t9&
         &*abb84n271+t4*t50*abb84n253+t4*t54*abb84n253+t4*t56*abb84n258+t4*t58*a&
         &bb84n258+t4*t70*abb84n254+t4*t76*abb84n254+t4*t95*abb84n250+t4*t97*abb&
         &84n250+t43*t8*abb84n218+t43*t9*abb84n271+t5*t95*abb84n246+t5*t97*abb84&
         &n246+t50*t6*abb84n203+t50*t8*abb84n228+t50*t9*abb84n270+t54*t6*abb84n2&
         &03+t54*t8*abb84n228+t54*t9*abb84n270+t56*t6*abb84n199+t56*t9*abb84n266&
         &+t58*t6*abb84n199+t58*t9*abb84n266+t6*t70*abb84n200+t6*t76*abb84n200+t&
         &60*t9*abb84n275+t63*t9*abb84n275+t68*t8*abb84n215+t68*t9*abb84n272+t7*&
         &t95*abb84n201+t7*t97*abb84n201+t70*t9*abb84n267+t74*t8*abb84n215+t74*t&
         &9*abb84n272+t76*t9*abb84n267+t77*t8*abb84n265+t79*t8*abb84n265+t8*t84*&
         &abb84n187+t8*t86*abb84n187+t8*t94*abb84n177+t8*t96*abb84n177+t9*t95*ab&
         &b84n276+t9*t97*abb84n276+t1*t100*t18*abb84n238+t1*t117*t2*abb84n84+t1*&
         &t119*t2*abb84n84+t1*t126*t5*abb84n84+t1*t128*t5*abb84n84+t1*t18*t81*ab&
         &b84n201+t1*t20*t38*abb84n201+t1*t25*t38*abb84n238+t1*t77*t8*abb84n84+t&
         &1*t79*t8*abb84n84+t118*t2*t8*abb84n84+t120*t2*t8*abb84n84+t125*t2*t5*a&
         &bb84n84+t127*t2*t5*abb84n84+t5*t8*t95*abb84n84+t5*t8*t97*abb84n84)
         return
      end if
      t183 = d(iv2,iv3)
      t184 = d(iv1,iv3)
      t7 = k1(iv3)
      t37 = k2(iv3)
      t39 = k5(iv3)
      t44 = qshift(iv3)
      t45 = t183*t21
      t50 = t184*t29
      t54 = spvak2k6(iv3)
      t56 = t188*t54
      t58 = t183*t22
      t61 = t184*t30
      t64 = spvak3k1(iv3)
      t69 = t188*t64
      t70 = t183*t23
      t75 = t184*t32
      t76 = spvak3k4(iv3)
      t77 = t188*t76
      t79 = t16*t183
      t89 = t184*t34
      t90 = spvak5k6(iv3)
      t95 = t188*t90
      t97 = t17*t183
      t98 = t184*t36
      t99 = spvak6k1(iv3)
      t126 = t188*t99
      t128 = t18*t183
      t131 = t184*t38
      t132 = spvak6k5(iv3)
      t133 = t132*t188
      t134 = spvak2k4(iv3)
      t135 = spvak5k1(iv3)
      t136 = t11*t90
      t137 = t40*t90
      t138 = t16*t7
      t139 = t34*t7
      t140 = k6(iv3)
      t141 = t15*t64
      t142 = t26*t64
      t143 = t22*t44
      t144 = t30*t44
      t145 = t117*t90
      t146 = t117*t132
      t147 = t19*t76
      t148 = t147*t34
      t149 = t147*t38
      t118 = t118*t132
      t150 = t19*t38*t90
      t151 = t119*t90
      t152 = t119*t132
      t153 = t76*t78
      t154 = t153*t16
      t155 = t153*t18
      t120 = t120*t132
      t156 = t18*t78*t90
      t157 = spvak2k1(iv3)
      t158 = t157*t23
      t159 = t158*t34
      t160 = t158*t38
      t161 = t157*t32
      t162 = t16*t161
      t163 = t161*t18
      t164 = t157*t16*t38
      t165 = t157*t18*t34
      t166 = t25*t90
      t167 = t100*t90
      t168 = t134*t16
      t169 = t134*t34
      t170 = spvak2k5(iv3)
      t171 = t22*t90
      t172 = t30*t90
      t173 = t16*t64
      t174 = t34*t64
      t175 = t23*t90
      t176 = t32*t90
      t177 = t16*t76
      t178 = t34*t76
      t179 = t16*t99
      t180 = t34*t99
      t181 = t17*t90
      t182 = t36*t90
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t126*abb84n107+t128*abb84n158+t131*abb84n158+t13&
         &3*abb84n158+t45*abb84n129+t50*abb84n129+t56*abb84n129+t58*abb84n94+t61&
         &*abb84n94+t69*abb84n94+t70*abb84n146+t75*abb84n146+t77*abb84n146+t79*a&
         &bb84n125+t89*abb84n125+t95*abb84n125+t97*abb84n107+t98*abb84n107+t1*t1&
         &26*abb84n250+t1*t58*abb84n273+t1*t61*abb84n273+t1*t69*abb84n273+t1*t70&
         &*abb84n216+t1*t75*abb84n216+t1*t77*abb84n216+t1*t97*abb84n250+t1*t98*a&
         &bb84n250+t10*t79*abb84n221+t10*t89*abb84n221+t10*t95*abb84n221+t11*t18&
         &3*abb84n136+t12*t183*abb84n114+t128*t4*abb84n255+t128*t6*abb84n201+t12&
         &8*t9*abb84n268+t13*t183*abb84n112+t131*t4*abb84n255+t131*t6*abb84n201+&
         &t131*t9*abb84n268+t133*t4*abb84n255+t133*t6*abb84n201+t133*t9*abb84n26&
         &8+t15*t183*abb84n234+t184*t26*abb84n234+t184*t27*abb84n114+t184*t28*ab&
         &b84n112+t184*t40*abb84n136+t188*t37*abb84n114+t188*t39*abb84n112+t188*&
         &t44*abb84n234+t188*t7*abb84n136+t2*t45*abb84n201+t2*t50*abb84n201+t2*t&
         &56*abb84n201+t2*t58*abb84n268+t2*t61*abb84n268+t2*t69*abb84n268+t3*t79&
         &*abb84n250+t3*t89*abb84n250+t3*t95*abb84n250+t79*t8*abb84n216+t79*t9*a&
         &bb84n273+t8*t89*abb84n216+t8*t95*abb84n216+t89*t9*abb84n273+t9*t95*abb&
         &84n273+t1*t100*t184*abb84n221+t1*t134*t188*abb84n221+t1*t183*t25*abb84&
         &n221+t135*t188*t2*abb84n255+t183*t2*t24*abb84n255+t184*t2*t92*abb84n25&
         &5)+t118*abb84n105+t120*abb84n105+t145*abb84n131+t146*abb84n92+t148*abb&
         &84n131+t149*abb84n92+t150*abb84n105+t151*abb84n131+t152*abb84n92+t154*&
         &abb84n131+t155*abb84n92+t156*abb84n105+t159*abb84n131+t160*abb84n92+t1&
         &62*abb84n131+t163*abb84n92+t164*abb84n105+t165*abb84n105+t1*t146*abb84&
         &n277+t1*t149*abb84n277+t1*t152*abb84n277+t1*t155*abb84n277+t1*t160*abb&
         &84n277+t1*t163*abb84n277+t101*t90*abb84n120+t102*t90*abb84n120+t103*t1&
         &32*abb84n89+t104*t132*abb84n100+t105*t132*abb84n89+t106*t132*abb84n100&
         &+t107*t132*abb84n91+t108*t132*abb84n97+t109*t132*abb84n91+t110*t132*ab&
         &b84n97+t111*t90*abb84n122+t112*t90*abb84n122+t113*t90*abb84n222+t114*t&
         &132*abb84n256+t115*t90*abb84n222+t116*t132*abb84n256+t118*t8*abb84n277&
         &+t120*t8*abb84n277+t121*t132*abb84n111+t122*t132*abb84n111+t123*t132*a&
         &bb84n85+t124*t132*abb84n85+t125*t99*abb84n152+t127*t99*abb84n152+t129*&
         &t132*abb84n102+t130*t132*abb84n102+t132*t35*abb84n137+t132*t43*abb84n1&
         &37+t132*t47*abb84n132+t132*t48*abb84n115+t132*t49*abb84n137+t132*t51*a&
         &bb84n132+t132*t52*abb84n115+t132*t53*abb84n137+t132*t55*abb84n134+t132&
         &*t57*abb84n134+t132*t65*abb84n202+t132*t66*abb84n269+t132*t71*abb84n20&
         &2+t132*t72*abb84n269+t132*t80*abb84n133+t132*t82*abb84n133+t132*t83*ab&
         &b84n144+t132*t85*abb84n144+t132*t94*abb84n98+t132*t96*abb84n98+t136*t3&
         &6*abb84n101+t136*t38*abb84n137+t137*t17*abb84n101+t137*t18*abb84n137+t&
         &138*t36*abb84n101+t138*t38*abb84n137+t139*t17*abb84n101+t139*t18*abb84&
         &n137+t141*t34*abb84n274+t141*t38*abb84n269+t142*t16*abb84n274+t142*t18&
         &*abb84n269+t143*t34*abb84n274+t143*t38*abb84n269+t144*t16*abb84n274+t1&
         &44*t18*abb84n269+t145*t2*abb84n277+t148*t2*abb84n277+t150*t8*abb84n277&
         &+t151*t2*abb84n277+t154*t2*abb84n277+t156*t8*abb84n277+t159*t2*abb84n2&
         &77+t162*t2*abb84n277+t164*t8*abb84n277+t165*t8*abb84n277+t166*t38*abb8&
         &4n111+t167*t18*abb84n111+t168*t38*abb84n111+t169*t18*abb84n111+t17*t17&
         &6*abb84n152+t17*t178*abb84n152+t171*t38*abb84n85+t172*t18*abb84n85+t17&
         &3*t38*abb84n85+t174*t18*abb84n85+t175*t36*abb84n152+t177*t36*abb84n152&
         &+t179*t38*abb84n98+t18*t180*abb84n98+t18*t182*abb84n98+t181*t38*abb84n&
         &98+t31*t90*abb84n88+t33*t90*abb84n123+t35*t99*abb84n101+t41*t90*abb84n&
         &88+t42*t90*abb84n123+t43*t99*abb84n101+t59*t90*abb84n86+t60*t99*abb84n&
         &103+t62*t90*abb84n86+t63*t99*abb84n103+t66*t90*abb84n274+t67*t90*abb84&
         &n217+t68*t99*abb84n251+t72*t90*abb84n274+t73*t90*abb84n217+t74*t99*abb&
         &84n251+t100*t140*t16*abb84n122+t100*t16*t44*abb84n222+t100*t16*t7*abb8&
         &4n120+t11*t134*t34*abb84n120+t11*t34*t64*abb84n88+t11*t34*t76*abb84n12&
         &3+t12*t135*t38*abb84n100+t12*t38*t54*abb84n132+t12*t38*t64*abb84n89+t1&
         &2*t38*t76*abb84n115+t12*t38*t90*abb84n137+t125*t132*t5*abb84n277+t127*&
         &t132*t5*abb84n277+t13*t135*t38*abb84n97+t13*t38*t54*abb84n134+t13*t38*&
         &t64*abb84n91+t134*t14*t34*abb84n122+t134*t15*t34*abb84n222+t134*t16*t2&
         &6*abb84n222+t134*t16*t40*abb84n120+t134*t16*t46*abb84n122+t135*t15*t38&
         &*abb84n256+t135*t16*t38*abb84n102+t135*t18*t26*abb84n256+t135*t18*t27*&
         &abb84n100+t135*t18*t28*abb84n97+t135*t18*t34*abb84n102+t14*t34*t64*abb&
         &84n86+t14*t36*t90*abb84n103+t140*t16*t30*abb84n86+t140*t16*t36*abb84n1&
         &03+t140*t17*t34*abb84n103+t140*t22*t34*abb84n86+t140*t25*t34*abb84n122&
         &+t15*t34*t76*abb84n217+t15*t36*t90*abb84n251+t15*t38*t54*abb84n202+t16&
         &*t170*t38*abb84n133+t16*t26*t76*abb84n217+t16*t30*t7*abb84n88+t16*t32*&
         &t44*abb84n217+t16*t32*t7*abb84n123+t16*t36*t44*abb84n251+t16*t37*t38*a&
         &bb84n137+t16*t40*t64*abb84n88+t16*t40*t76*abb84n123+t16*t46*t64*abb84n&
         &86+t17*t26*t90*abb84n251+t17*t34*t44*abb84n251+t17*t46*t90*abb84n103+t&
         &170*t18*t34*abb84n133+t175*t38*t5*abb84n277+t176*t18*t5*abb84n277+t177&
         &*t38*t5*abb84n277+t178*t18*t5*abb84n277+t18*t26*t54*abb84n202+t18*t27*&
         &t54*abb84n132+t18*t27*t64*abb84n89+t18*t27*t76*abb84n115+t18*t27*t90*a&
         &bb84n137+t18*t28*t54*abb84n134+t18*t28*t64*abb84n91+t18*t29*t37*abb84n&
         &132+t18*t29*t39*abb84n134+t18*t29*t44*abb84n202+t18*t29*t76*abb84n144+&
         &t18*t30*t37*abb84n89+t18*t30*t39*abb84n91+t18*t32*t37*abb84n115+t18*t3&
         &2*t54*abb84n144+t18*t34*t37*abb84n137+t18*t37*t92*abb84n100+t18*t39*t9&
         &2*abb84n97+t18*t44*t92*abb84n256+t18*t81*t90*abb84n133+t18*t90*t92*abb&
         &84n102+t20*t38*t90*abb84n133+t21*t37*t38*abb84n132+t21*t38*t39*abb84n1&
         &34+t21*t38*t44*abb84n202+t21*t38*t76*abb84n144+t22*t34*t7*abb84n88+t22&
         &*t37*t38*abb84n89+t22*t38*t39*abb84n91+t23*t34*t44*abb84n217+t23*t34*t&
         &7*abb84n123+t23*t37*t38*abb84n115+t23*t38*t54*abb84n144+t24*t37*t38*ab&
         &b84n100+t24*t38*t39*abb84n97+t24*t38*t44*abb84n256+t24*t38*t90*abb84n1&
         &02+t25*t34*t44*abb84n222+t25*t34*t7*abb84n120)
         return
      end if
      t185 = d(iv3,iv4)
      t186 = d(iv2,iv4)
      t187 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak6k5(iv4)
      t4 = spvak2k6(iv4)
      t5 = spvak3k1(iv4)
      t6 = spvak3k4(iv4)
      t7 = spvak5k1(iv4)
      t8 = spvak6k1(iv4)
      t9 = t19*t6
      t10 = t6*t78
      t11 = t157*t6
      t12 = spvak2k1(iv4)
      t13 = t12*t23
      t14 = t12*t32
      t12 = t12*t76
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t183*t187*abb84n113+t184*t186*abb84n113+t185*t18&
         &8*abb84n113)+(2.0_ki)*(t121*t185*abb84n121+t122*t185*abb84n121+t123*t1&
         &85*abb84n87+t124*t185*abb84n87+t125*t185*abb84n124+t127*t185*abb84n124&
         &+t166*t186*abb84n121+t167*t187*abb84n121+t168*t186*abb84n121+t169*t187&
         &*abb84n121+t171*t186*abb84n87+t172*t187*abb84n87+t173*t186*abb84n87+t1&
         &74*t187*abb84n87+t175*t186*abb84n124+t176*t187*abb84n124+t177*t186*abb&
         &84n124+t178*t187*abb84n124+t179*t186*abb84n102+t180*t187*abb84n102+t18&
         &1*t186*abb84n102+t182*t187*abb84n102+t185*t84*abb84n133+t185*t86*abb84&
         &n133+t185*t87*abb84n90+t185*t88*abb84n90+t185*t91*abb84n99+t185*t93*ab&
         &b84n99+t185*t94*abb84n102+t185*t96*abb84n102+t1*t100*t184*abb84n121+t1&
         &*t134*t188*abb84n121+t1*t17*t183*abb84n102+t1*t183*t22*abb84n87+t1*t18&
         &3*t23*abb84n124+t1*t183*t25*abb84n121+t1*t184*t30*abb84n87+t1*t184*t32&
         &*abb84n124+t1*t184*t36*abb84n102+t1*t188*t64*abb84n87+t1*t188*t76*abb8&
         &4n124+t1*t188*t99*abb84n102+t132*t186*t21*abb84n133+t132*t186*t22*abb8&
         &4n90+t132*t186*t24*abb84n99+t132*t187*t29*abb84n133+t132*t187*t30*abb8&
         &4n90+t132*t187*t92*abb84n99+t132*t188*t4*abb84n133+t132*t188*t5*abb84n&
         &90+t132*t188*t7*abb84n99+t135*t18*t186*abb84n99+t135*t187*t38*abb84n99&
         &+t135*t188*t3*abb84n99+t16*t183*t2*abb84n121+t16*t183*t5*abb84n87+t16*&
         &t183*t6*abb84n124+t16*t183*t8*abb84n102+t18*t183*t4*abb84n133+t18*t183&
         &*t5*abb84n90+t18*t183*t7*abb84n99+t18*t186*t54*abb84n133+t18*t186*t64*&
         &abb84n90+t183*t21*t3*abb84n133+t183*t22*t3*abb84n90+t183*t24*t3*abb84n&
         &99+t184*t2*t34*abb84n121+t184*t29*t3*abb84n133+t184*t3*t30*abb84n90+t1&
         &84*t3*t92*abb84n99+t184*t34*t5*abb84n87+t184*t34*t6*abb84n124+t184*t34&
         &*t8*abb84n102+t184*t38*t4*abb84n133+t184*t38*t5*abb84n90+t184*t38*t7*a&
         &bb84n99+t187*t38*t54*abb84n133+t187*t38*t64*abb84n90+t188*t2*t90*abb84&
         &n121+t188*t3*t54*abb84n133+t188*t3*t64*abb84n90+t188*t5*t90*abb84n87+t&
         &188*t6*t90*abb84n124+t188*t8*t90*abb84n102)+t145*t3*abb84n84+t148*t3*a&
         &bb84n84+t151*t3*abb84n84+t154*t3*abb84n84+t159*t3*abb84n84+t162*t3*abb&
         &84n84+t1*t117*t132*abb84n84+t1*t119*t132*abb84n84+t1*t147*t38*abb84n84&
         &+t1*t153*t18*abb84n84+t1*t158*t38*abb84n84+t1*t161*t18*abb84n84+t10*t1&
         &32*t16*abb84n84+t10*t18*t90*abb84n84+t11*t16*t38*abb84n84+t11*t18*t34*&
         &abb84n84+t12*t16*t38*abb84n84+t12*t18*t34*abb84n84+t13*t132*t34*abb84n&
         &84+t13*t38*t90*abb84n84+t132*t14*t16*abb84n84+t132*t34*t9*abb84n84+t14&
         &*t18*t90*abb84n84+t38*t9*t90*abb84n84)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d84:
   subroutine     reconstruct_d84(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_84:
      coeffs%coeffs_84%c0 = derivative(czip)
      coeffs%coeffs_84%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_84%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_84%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_84%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_84%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_84%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_84%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_84%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_84%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_84%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_84%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_84%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_84%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_84%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_84%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_84%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_84%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_84%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_84%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_84%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_84%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_84%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_84%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_84%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_84%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_84%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_84%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_84%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_84%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_84%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_84%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_84%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_84%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_84%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_84%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_84%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_84%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_84%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_84%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_84%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_84%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_84%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_84%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_84%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_84%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_84%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_84%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_84%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_84%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_84%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_84%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_84%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_84%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_84%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_84%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_84%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_84%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_84%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_84%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_84%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_84%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_84%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_84%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_84%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_84%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_84%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_84%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_84%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_84%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_84:
   end subroutine reconstruct_d84
!---#] subroutine reconstruct_d84:
end module p9_udbar_neepgg_d84h3l1d
