module     p9_udbar_neepgg_d86h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d86h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d86
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd86h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      complex(ki) :: t158
      complex(ki) :: t159
      complex(ki) :: t160
      complex(ki) :: t161
      complex(ki) :: t162
      complex(ki) :: t163
      complex(ki) :: t164
      complex(ki) :: t165
      complex(ki) :: t166
      complex(ki) :: t167
      complex(ki) :: t168
      complex(ki) :: t169
      complex(ki) :: t170
      complex(ki) :: t171
      complex(ki) :: t172
      complex(ki) :: t173
      complex(ki) :: t174
      complex(ki) :: t175
      complex(ki) :: t176
      complex(ki) :: t177
      real(ki) :: t178
      real(ki) :: t179
      real(ki) :: t180
      real(ki) :: t181
      real(ki) :: t182
      real(ki) :: t183
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t178 = dotproduct(k2, qshift)
      t179 = dotproduct(k6, qshift)
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t180 = dotproduct(k5, qshift)
      t2 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t3 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t181 = dotproduct(k1, qshift)
      t182 = dotproduct(qshift, qshift)
      t4 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t5 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-sp&
      &vak2k5(4)*qshift(4))
      t6 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t9 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb86n75+t1*abb86n115+t178*abb86n111+t179*abb86n114+t180*a&
         &bb86n117+t181*abb86n125+t181*t181*abb86n96+t182*abb86n99+t182*t182*abb&
         &86n90+t2*abb86n122+t3*abb86n123+t1*t178*abb86n106+t1*t179*abb86n98+t1*&
         &t180*abb86n106+t1*t181*abb86n97+t1*t182*abb86n131+t1*t2*abb86n88+t1*t4&
         &*abb86n101+t1*t5*abb86n105+t1*t6*abb86n108+t178*t181*abb86n89+t178*t18&
         &2*abb86n138+t178*t2*abb86n107+t178*t3*abb86n104+t179*t180*abb86n94+t17&
         &9*t181*abb86n95+t179*t182*abb86n128+t179*t3*abb86n82+t180*t181*abb86n9&
         &1+t180*t182*abb86n142+t180*t2*abb86n87+t180*t3*abb86n103+t180*t4*abb86&
         &n110+t181*t182*abb86n142+t181*t2*abb86n86+t181*t3*abb86n81+t181*t4*abb&
         &86n109+t181*t6*abb86n80+t182*t2*abb86n144+t182*t3*abb86n158+t182*t4*ab&
         &b86n112+t182*t6*abb86n160+t2*t3*abb86n79+t3*t4*abb86n100+t1*t178*t2*ab&
         &b86n119+t1*t179*t6*abb86n154+t1*t179*t8*abb86n137+t1*t179*t9*abb86n165&
         &+t1*t180*t2*abb86n119+t1*t181*t2*abb86n118+t1*t181*t4*abb86n133+t1*t18&
         &1*t6*abb86n151+t1*t181*t8*abb86n135+t1*t181*t9*abb86n167+t1*t182*t2*ab&
         &b86n102+t1*t182*t4*abb86n93+t1*t182*t6*abb86n84+t1*t182*t8*abb86n92+t1&
         &*t182*t9*abb86n77+t1*t2*t3*abb86n153+t1*t2*t4*abb86n130+t1*t2*t5*abb86&
         &n121+t1*t2*t6*abb86n155+t1*t2*t7*abb86n150+t1*t2*t8*abb86n149+t1*t2*t9&
         &*abb86n168+t1*t4*t6*abb86n116+t1*t4*t7*abb86n124+t178*t2*t3*abb86n157+&
         &t180*t2*t3*abb86n155+t180*t2*t4*abb86n146+t181*t2*t4*abb86n147+t181*t4&
         &*t6*abb86n163+t182*t2*t3*abb86n83+t182*t2*t4*abb86n85+t182*t4*t6*abb86&
         &n78+t2*t3*t4*abb86n164+t1*t2*t4*t7*abb86n76)
         return
      end if
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak5k1(iv1)
      t16 = spvak5k6(iv1)
      t17 = spvak6k5(iv1)
      t18 = t14*abb86n143
      t19 = spvak2k5(iv1)
      t20 = spvak3k4(iv1)
      t21 = t16*abb86n106
      t22 = spvak6k1(iv1)
      t23 = spvak2k1(iv1)
      t24 = spvak2k4(iv1)
      t25 = spvak3k1(iv1)
      t26 = t16*abb86n119
      t27 = t17*abb86n119
      t28 = t17*abb86n155
      if(deg.eq.1) then
         numerator = (t10*abb86n125+t11*abb86n111+t12*abb86n117+t13*abb86n114+t1&
         &4*abb86n126+t15*abb86n123+t16*abb86n115+t17*abb86n122+t178*t21+t18*t18&
         &0+t18*t181+t180*t21+t1*t10*abb86n97+t1*t11*abb86n106+t1*t12*abb86n106+&
         &t1*t13*abb86n98+t1*t14*abb86n132+t1*t17*abb86n88+t1*t178*t27+t1*t180*t&
         &27+t1*t19*abb86n105+t1*t20*abb86n101+t1*t22*abb86n108+t1*t28*t6+t10*t1&
         &78*abb86n89+t10*t179*abb86n95+t10*t180*abb86n91+t10*t181*abb86n127+t10&
         &*t182*abb86n142+t10*t2*abb86n86+t10*t3*abb86n81+t10*t4*abb86n109+t10*t&
         &6*abb86n80+t11*t181*abb86n89+t11*t182*abb86n138+t11*t2*abb86n107+t11*t&
         &3*abb86n104+t12*t179*abb86n94+t12*t181*abb86n91+t12*t182*abb86n142+t12&
         &*t2*abb86n87+t12*t3*abb86n103+t12*t4*abb86n110+t13*t180*abb86n94+t13*t&
         &181*abb86n95+t13*t182*abb86n128+t13*t3*abb86n82+t14*t178*abb86n139+t14&
         &*t179*abb86n129+t14*t182*abb86n140+t14*t2*abb86n145+t14*t3*abb86n159+t&
         &14*t4*abb86n113+t14*t6*abb86n161+t15*t178*abb86n104+t15*t179*abb86n82+&
         &t15*t180*abb86n103+t15*t181*abb86n81+t15*t182*abb86n158+t15*t2*abb86n7&
         &9+t15*t4*abb86n100+t16*t179*abb86n98+t16*t181*abb86n97+t16*t182*abb86n&
         &131+t16*t2*abb86n88+t16*t4*abb86n101+t16*t5*abb86n105+t16*t6*abb86n108&
         &+t17*t178*abb86n107+t17*t180*abb86n87+t17*t181*abb86n86+t17*t182*abb86&
         &n144+t17*t3*abb86n79+t178*t2*t26+t180*t2*t26+t180*t20*abb86n110+t180*t&
         &28*t3+t181*t20*abb86n109+t181*t22*abb86n80+t182*t20*abb86n112+t182*t22&
         &*abb86n160+t20*t3*abb86n100+t1*t10*t2*abb86n118+t1*t10*t4*abb86n133+t1&
         &*t10*t6*abb86n151+t1*t10*t8*abb86n135+t1*t10*t9*abb86n167+t1*t11*t2*ab&
         &b86n119+t1*t12*t2*abb86n119+t1*t13*t6*abb86n154+t1*t13*t8*abb86n137+t1&
         &*t13*t9*abb86n165+t1*t14*t2*abb86n120+t1*t14*t4*abb86n134+t1*t14*t6*ab&
         &b86n152+t1*t14*t8*abb86n136+t1*t14*t9*abb86n166+t1*t15*t2*abb86n153+t1&
         &*t17*t181*abb86n118+t1*t17*t182*abb86n102+t1*t17*t3*abb86n153+t1*t17*t&
         &4*abb86n130+t1*t17*t5*abb86n121+t1*t17*t7*abb86n150+t1*t17*t8*abb86n14&
         &9+t1*t17*t9*abb86n168+t1*t179*t22*abb86n154+t1*t179*t24*abb86n137+t1*t&
         &179*t25*abb86n165+t1*t181*t20*abb86n133+t1*t181*t22*abb86n151+t1*t181*&
         &t24*abb86n135+t1*t181*t25*abb86n167+t1*t182*t20*abb86n93+t1*t182*t22*a&
         &bb86n84+t1*t182*t24*abb86n92+t1*t182*t25*abb86n77+t1*t19*t2*abb86n121+&
         &t1*t2*t20*abb86n130+t1*t2*t22*abb86n155+t1*t2*t23*abb86n150+t1*t2*t24*&
         &abb86n149+t1*t2*t25*abb86n168+t1*t20*t6*abb86n116+t1*t20*t7*abb86n124+&
         &t1*t22*t4*abb86n116+t1*t23*t4*abb86n124+t10*t2*t4*abb86n147+t10*t4*t6*&
         &abb86n163+t11*t2*t3*abb86n157+t12*t2*t3*abb86n155+t12*t2*t4*abb86n146+&
         &t14*t2*t3*abb86n156+t14*t2*t4*abb86n148+t14*t4*t6*abb86n162+t15*t178*t&
         &2*abb86n157+t15*t180*t2*abb86n155+t15*t182*t2*abb86n83+t15*t2*t4*abb86&
         &n164+t16*t179*t6*abb86n154+t16*t179*t8*abb86n137+t16*t179*t9*abb86n165&
         &+t16*t181*t2*abb86n118+t16*t181*t4*abb86n133+t16*t181*t6*abb86n151+t16&
         &*t181*t8*abb86n135+t16*t181*t9*abb86n167+t16*t182*t2*abb86n102+t16*t18&
         &2*t4*abb86n93+t16*t182*t6*abb86n84+t16*t182*t8*abb86n92+t16*t182*t9*ab&
         &b86n77+t16*t2*t3*abb86n153+t16*t2*t4*abb86n130+t16*t2*t5*abb86n121+t16&
         &*t2*t6*abb86n155+t16*t2*t7*abb86n150+t16*t2*t8*abb86n149+t16*t2*t9*abb&
         &86n168+t16*t4*t6*abb86n116+t16*t4*t7*abb86n124+t17*t178*t3*abb86n157+t&
         &17*t180*t4*abb86n146+t17*t181*t4*abb86n147+t17*t182*t3*abb86n83+t17*t1&
         &82*t4*abb86n85+t17*t3*t4*abb86n164+t180*t2*t20*abb86n146+t181*t2*t20*a&
         &bb86n147+t181*t20*t6*abb86n163+t181*t22*t4*abb86n163+t182*t2*t20*abb86&
         &n85+t182*t20*t6*abb86n78+t182*t22*t4*abb86n78+t2*t20*t3*abb86n164+t1*t&
         &17*t4*t7*abb86n76+t1*t2*t20*t7*abb86n76+t1*t2*t23*t4*abb86n76+t16*t2*t&
         &4*t7*abb86n76)
         return
      end if
      t183 = d(iv1,iv2)
      t18 = k1(iv2)
      t21 = qshift(iv2)
      t26 = t183*abb86n142
      t27 = k2(iv2)
      t28 = k5(iv2)
      t29 = k6(iv2)
      t30 = spvak3k4(iv2)
      t31 = t10*t30
      t32 = spvak5k1(iv2)
      t33 = spvak5k6(iv2)
      t34 = t10*t33
      t35 = spvak6k1(iv2)
      t36 = t10*t35
      t37 = spvak6k5(iv2)
      t38 = t10*t37
      t39 = t18*t20
      t40 = t16*t18
      t41 = t18*t22
      t42 = t17*t18
      t43 = t11*t32
      t44 = t11*t33
      t45 = t11*t37
      t46 = t15*t27
      t47 = t16*t27
      t48 = t17*t27
      t49 = t12*t30
      t50 = t12*t32
      t51 = t12*t33
      t52 = t12*t37
      t53 = t20*t28
      t54 = t15*t28
      t55 = t16*t28
      t56 = t17*t28
      t57 = t13*t33
      t58 = t16*t29
      t59 = t14*t30
      t60 = t14*t32
      t61 = t14*t33
      t62 = t14*t35
      t63 = t14*t37
      t64 = t20*t21
      t65 = t15*t21
      t66 = t16*t21
      t67 = t21*t22
      t68 = t17*t21
      t69 = t19*t33
      t70 = spvak2k5(iv2)
      t71 = t16*t70
      t72 = t20*t32
      t73 = t20*t33
      t74 = t15*t30
      t75 = t16*t30
      t76 = t15*t37
      t77 = t17*t32
      t78 = t16*t35
      t79 = t16*t37
      t80 = t22*t33
      t81 = t17*t33
      t82 = spvak2k4(iv2)
      t83 = t10*t82
      t84 = spvak3k1(iv2)
      t85 = t10*t84
      t86 = t18*t24
      t87 = t18*t25
      t88 = t13*t82
      t89 = t13*t84
      t90 = t24*t29
      t91 = t25*t29
      t92 = t14*t82
      t93 = t14*t84
      t94 = t21*t24
      t95 = t21*t25
      t96 = t23*t30
      t97 = t23*t33
      t98 = t23*t37
      t99 = spvak2k1(iv2)
      t100 = t20*t99
      t101 = t16*t99
      t102 = t17*t99
      t103 = t24*t33
      t104 = t16*t82
      t105 = t25*t33
      t106 = t16*t84
      t107 = t20*t35
      t108 = t20*t37
      t109 = t22*t30
      t110 = t17*t30
      t111 = t15*t33
      t112 = t16*t32
      t113 = t79*abb86n119
      t114 = t81*abb86n119
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t180*t26+t181*t26+t183*abb86n99+t1*t183*abb86n13&
         &1+t10*t18*abb86n96+t14*t21*abb86n140+t178*t183*abb86n138+t179*t183*abb&
         &86n128+t182*t183*abb86n141+t183*t2*abb86n144+t183*t3*abb86n158+t183*t4&
         &*abb86n112+t183*t6*abb86n160+t1*t183*t2*abb86n102+t1*t183*t4*abb86n93+&
         &t1*t183*t6*abb86n84+t1*t183*t8*abb86n92+t1*t183*t9*abb86n77+t183*t2*t3&
         &*abb86n83+t183*t2*t4*abb86n85+t183*t4*t6*abb86n78)+t113*t178+t113*t180&
         &+t114*t178+t114*t180+t31*abb86n109+t34*abb86n97+t36*abb86n80+t38*abb86&
         &n86+t39*abb86n109+t40*abb86n97+t41*abb86n80+t42*abb86n86+t43*abb86n104&
         &+t44*abb86n106+t45*abb86n107+t46*abb86n104+t47*abb86n106+t48*abb86n107&
         &+t49*abb86n110+t50*abb86n103+t51*abb86n106+t52*abb86n87+t53*abb86n110+&
         &t54*abb86n103+t55*abb86n106+t56*abb86n87+t57*abb86n98+t58*abb86n98+t59&
         &*abb86n113+t60*abb86n159+t61*abb86n132+t62*abb86n161+t63*abb86n145+t64&
         &*abb86n113+t65*abb86n159+t66*abb86n132+t67*abb86n161+t68*abb86n145+t69&
         &*abb86n105+t71*abb86n105+t72*abb86n100+t73*abb86n101+t74*abb86n100+t75&
         &*abb86n101+t76*abb86n79+t77*abb86n79+t78*abb86n108+t79*abb86n88+t80*ab&
         &b86n108+t81*abb86n88+t1*t100*abb86n124+t1*t102*abb86n150+t1*t107*abb86&
         &n116+t1*t108*abb86n130+t1*t109*abb86n116+t1*t110*abb86n130+t1*t31*abb8&
         &6n133+t1*t36*abb86n151+t1*t38*abb86n118+t1*t39*abb86n133+t1*t41*abb86n&
         &151+t1*t42*abb86n118+t1*t45*abb86n119+t1*t48*abb86n119+t1*t52*abb86n11&
         &9+t1*t56*abb86n119+t1*t59*abb86n134+t1*t62*abb86n152+t1*t63*abb86n120+&
         &t1*t64*abb86n134+t1*t67*abb86n152+t1*t68*abb86n120+t1*t76*abb86n153+t1&
         &*t77*abb86n153+t1*t83*abb86n135+t1*t85*abb86n167+t1*t86*abb86n135+t1*t&
         &87*abb86n167+t1*t88*abb86n137+t1*t89*abb86n165+t1*t90*abb86n137+t1*t91&
         &*abb86n165+t1*t92*abb86n136+t1*t93*abb86n166+t1*t94*abb86n136+t1*t95*a&
         &bb86n166+t1*t96*abb86n124+t1*t98*abb86n150+t10*t21*abb86n143+t10*t27*a&
         &bb86n89+t10*t28*abb86n91+t10*t29*abb86n95+t10*t32*abb86n81+t101*t2*abb&
         &86n150+t101*t4*abb86n124+t103*t179*abb86n137+t103*t181*abb86n135+t103*&
         &t182*abb86n92+t103*t2*abb86n149+t104*t179*abb86n137+t104*t181*abb86n13&
         &5+t104*t182*abb86n92+t104*t2*abb86n149+t105*t179*abb86n165+t105*t181*a&
         &bb86n167+t105*t182*abb86n77+t105*t2*abb86n168+t106*t179*abb86n165+t106&
         &*t181*abb86n167+t106*t182*abb86n77+t106*t2*abb86n168+t107*t181*abb86n1&
         &63+t107*t182*abb86n78+t108*t180*abb86n146+t108*t181*abb86n147+t108*t18&
         &2*abb86n85+t108*t3*abb86n164+t109*t181*abb86n163+t109*t182*abb86n78+t1&
         &1*t18*abb86n89+t11*t21*abb86n139+t110*t180*abb86n146+t110*t181*abb86n1&
         &47+t110*t182*abb86n85+t110*t3*abb86n164+t111*t2*abb86n153+t112*t2*abb8&
         &6n153+t12*t18*abb86n91+t12*t21*abb86n143+t12*t29*abb86n94+t13*t18*abb8&
         &6n95+t13*t21*abb86n129+t13*t28*abb86n94+t13*t32*abb86n82+t14*t18*abb86&
         &n143+t14*t27*abb86n139+t14*t28*abb86n143+t14*t29*abb86n129+t15*t18*abb&
         &86n81+t15*t29*abb86n82+t178*t76*abb86n157+t178*t77*abb86n157+t179*t78*&
         &abb86n154+t179*t80*abb86n154+t180*t76*abb86n155+t180*t77*abb86n155+t18&
         &1*t73*abb86n133+t181*t75*abb86n133+t181*t78*abb86n151+t181*t79*abb86n1&
         &18+t181*t80*abb86n151+t181*t81*abb86n118+t182*t73*abb86n93+t182*t75*ab&
         &b86n93+t182*t76*abb86n83+t182*t77*abb86n83+t182*t78*abb86n84+t182*t79*&
         &abb86n102+t182*t80*abb86n84+t182*t81*abb86n102+t2*t31*abb86n147+t2*t34&
         &*abb86n118+t2*t39*abb86n147+t2*t40*abb86n118+t2*t43*abb86n157+t2*t44*a&
         &bb86n119+t2*t46*abb86n157+t2*t47*abb86n119+t2*t49*abb86n146+t2*t50*abb&
         &86n155+t2*t51*abb86n119+t2*t53*abb86n146+t2*t54*abb86n155+t2*t55*abb86&
         &n119+t2*t59*abb86n148+t2*t60*abb86n156+t2*t61*abb86n120+t2*t64*abb86n1&
         &48+t2*t65*abb86n156+t2*t66*abb86n120+t2*t69*abb86n121+t2*t71*abb86n121&
         &+t2*t72*abb86n164+t2*t73*abb86n130+t2*t74*abb86n164+t2*t75*abb86n130+t&
         &2*t78*abb86n155+t2*t80*abb86n155+t2*t97*abb86n150+t3*t45*abb86n157+t3*&
         &t48*abb86n157+t3*t52*abb86n155+t3*t56*abb86n155+t3*t63*abb86n156+t3*t6&
         &8*abb86n156+t3*t79*abb86n153+t3*t81*abb86n153+t31*t6*abb86n163+t34*t4*&
         &abb86n133+t34*t6*abb86n151+t34*t8*abb86n135+t34*t9*abb86n167+t36*t4*ab&
         &b86n163+t38*t4*abb86n147+t39*t6*abb86n163+t4*t40*abb86n133+t4*t41*abb8&
         &6n163+t4*t42*abb86n147+t4*t52*abb86n146+t4*t56*abb86n146+t4*t61*abb86n&
         &134+t4*t62*abb86n162+t4*t63*abb86n148+t4*t66*abb86n134+t4*t67*abb86n16&
         &2+t4*t68*abb86n148+t4*t76*abb86n164+t4*t77*abb86n164+t4*t78*abb86n116+&
         &t4*t79*abb86n130+t4*t80*abb86n116+t4*t81*abb86n130+t4*t97*abb86n124+t4&
         &0*t6*abb86n151+t40*t8*abb86n135+t40*t9*abb86n167+t5*t79*abb86n121+t5*t&
         &81*abb86n121+t57*t6*abb86n154+t57*t8*abb86n137+t57*t9*abb86n165+t58*t6&
         &*abb86n154+t58*t8*abb86n137+t58*t9*abb86n165+t59*t6*abb86n162+t6*t61*a&
         &bb86n152+t6*t64*abb86n162+t6*t66*abb86n152+t6*t73*abb86n116+t6*t75*abb&
         &86n116+t6*t79*abb86n155+t6*t81*abb86n155+t61*t8*abb86n136+t61*t9*abb86&
         &n166+t66*t8*abb86n136+t66*t9*abb86n166+t7*t73*abb86n124+t7*t75*abb86n1&
         &24+t7*t79*abb86n150+t7*t81*abb86n150+t79*t8*abb86n149+t79*t9*abb86n168&
         &+t8*t81*abb86n149+t81*t9*abb86n168+t1*t100*t2*abb86n76+t1*t102*t4*abb8&
         &6n76+t1*t108*t7*abb86n76+t1*t110*t7*abb86n76+t1*t13*t35*abb86n154+t1*t&
         &17*t35*abb86n155+t1*t17*t70*abb86n121+t1*t17*t82*abb86n149+t1*t17*t84*&
         &abb86n168+t1*t19*t37*abb86n121+t1*t2*t96*abb86n76+t1*t22*t29*abb86n154&
         &+t1*t22*t37*abb86n155+t1*t24*t37*abb86n149+t1*t25*t37*abb86n168+t1*t4*&
         &t98*abb86n76+t101*t2*t4*abb86n76+t2*t4*t97*abb86n76+t2*t7*t73*abb86n76&
         &+t2*t7*t75*abb86n76+t4*t7*t79*abb86n76+t4*t7*t81*abb86n76)
         return
      end if
      t178 = d(iv2,iv3)
      t179 = d(iv1,iv3)
      t5 = k1(iv3)
      t26 = k2(iv3)
      t36 = k5(iv3)
      t38 = k6(iv3)
      t41 = qshift(iv3)
      t42 = t178*t20
      t45 = t179*t30
      t48 = spvak3k4(iv3)
      t52 = t183*t48
      t56 = t15*t178
      t62 = t179*t32
      t63 = spvak5k1(iv3)
      t67 = t183*t63
      t68 = t16*t178
      t98 = t179*t33
      t102 = spvak5k6(iv3)
      t113 = t102*t183
      t114 = t178*t22
      t115 = t179*t35
      t116 = spvak6k1(iv3)
      t117 = t116*t183
      t118 = t17*t178
      t119 = t179*t37
      t120 = spvak6k5(iv3)
      t121 = t120*t183
      t122 = spvak2k4(iv3)
      t123 = spvak3k1(iv3)
      t124 = t10*t48
      t125 = t10*t102
      t126 = t18*t48
      t127 = t102*t18
      t128 = t20*t5
      t129 = t30*t5
      t130 = t16*t5
      t131 = t33*t5
      t132 = t14*t48
      t133 = t102*t14
      t134 = t21*t48
      t135 = t102*t21
      t136 = t20*t41
      t137 = t30*t41
      t138 = t16*t41
      t139 = t33*t41
      t140 = t102*t96
      t141 = t23*t48
      t142 = t141*t33
      t97 = t120*t97
      t143 = t102*t23*t37
      t144 = t100*t102
      t145 = t48*t99
      t146 = t145*t16
      t101 = t101*t120
      t147 = t102*t17*t99
      t148 = spvak2k1(iv3)
      t149 = t148*t20
      t150 = t149*t33
      t151 = t148*t30
      t152 = t151*t16
      t153 = t148*t16*t37
      t154 = t148*t17*t33
      t155 = t102*t24
      t156 = t102*t82
      t157 = t122*t16
      t158 = t122*t33
      t159 = spvak2k5(iv3)
      t160 = t102*t25
      t161 = t102*t84
      t162 = t123*t16
      t163 = t123*t33
      t164 = t120*t73
      t165 = t102*t20
      t166 = t165*t37
      t167 = t120*t75
      t168 = t102*t30
      t169 = t168*t17
      t170 = t16*t48
      t171 = t170*t37
      t172 = t33*t48
      t173 = t17*t172
      t174 = t116*t16
      t175 = t116*t33
      t176 = t102*t22
      t177 = t102*t35
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t113*abb86n131+t114*abb86n160+t115*abb86n160+t11&
         &7*abb86n160+t118*abb86n144+t119*abb86n144+t121*abb86n144+t42*abb86n112&
         &+t45*abb86n112+t52*abb86n112+t56*abb86n158+t62*abb86n158+t67*abb86n158&
         &+t68*abb86n131+t98*abb86n131+t1*t114*abb86n84+t1*t115*abb86n84+t1*t117&
         &*abb86n84+t1*t118*abb86n102+t1*t119*abb86n102+t1*t121*abb86n102+t1*t42&
         &*abb86n93+t1*t45*abb86n93+t1*t52*abb86n93+t10*t178*abb86n142+t11*t178*&
         &abb86n138+t113*t2*abb86n102+t113*t4*abb86n93+t113*t6*abb86n84+t113*t8*&
         &abb86n92+t113*t9*abb86n77+t114*t4*abb86n78+t115*t4*abb86n78+t117*t4*ab&
         &b86n78+t118*t3*abb86n83+t118*t4*abb86n85+t119*t3*abb86n83+t119*t4*abb8&
         &6n85+t12*t178*abb86n142+t121*t3*abb86n83+t121*t4*abb86n85+t13*t178*abb&
         &86n128+t14*t178*abb86n140+t179*t18*abb86n142+t179*t21*abb86n140+t179*t&
         &27*abb86n138+t179*t28*abb86n142+t179*t29*abb86n128+t183*t26*abb86n138+&
         &t183*t36*abb86n142+t183*t38*abb86n128+t183*t41*abb86n140+t183*t5*abb86&
         &n142+t2*t42*abb86n85+t2*t45*abb86n85+t2*t52*abb86n85+t2*t56*abb86n83+t&
         &2*t62*abb86n83+t2*t67*abb86n83+t2*t68*abb86n102+t2*t98*abb86n102+t4*t6&
         &8*abb86n93+t4*t98*abb86n93+t42*t6*abb86n78+t45*t6*abb86n78+t52*t6*abb8&
         &6n78+t6*t68*abb86n84+t6*t98*abb86n84+t68*t8*abb86n92+t68*t9*abb86n77+t&
         &8*t98*abb86n92+t9*t98*abb86n77+t1*t122*t183*abb86n92+t1*t123*t183*abb8&
         &6n77+t1*t178*t24*abb86n92+t1*t178*t25*abb86n77+t1*t179*t82*abb86n92+t1&
         &*t179*t84*abb86n77)+t101*abb86n150+t140*abb86n124+t142*abb86n124+t143*&
         &abb86n150+t144*abb86n124+t146*abb86n124+t147*abb86n150+t150*abb86n124+&
         &t152*abb86n124+t153*abb86n150+t154*abb86n150+t164*abb86n130+t166*abb86&
         &n130+t167*abb86n130+t169*abb86n130+t171*abb86n130+t173*abb86n130+t97*a&
         &bb86n150+t101*t4*abb86n76+t102*t31*abb86n133+t102*t39*abb86n133+t102*t&
         &59*abb86n134+t102*t64*abb86n134+t102*t83*abb86n135+t102*t85*abb86n167+&
         &t102*t86*abb86n135+t102*t87*abb86n167+t102*t88*abb86n137+t102*t89*abb8&
         &6n165+t102*t90*abb86n137+t102*t91*abb86n165+t102*t92*abb86n136+t102*t9&
         &3*abb86n166+t102*t94*abb86n136+t102*t95*abb86n166+t103*t120*abb86n149+&
         &t104*t120*abb86n149+t105*t120*abb86n168+t106*t120*abb86n168+t111*t120*&
         &abb86n153+t112*t120*abb86n153+t116*t31*abb86n163+t116*t34*abb86n151+t1&
         &16*t39*abb86n163+t116*t40*abb86n151+t116*t57*abb86n154+t116*t58*abb86n&
         &154+t116*t59*abb86n162+t116*t61*abb86n152+t116*t64*abb86n162+t116*t66*&
         &abb86n152+t116*t73*abb86n116+t116*t75*abb86n116+t120*t31*abb86n147+t12&
         &0*t34*abb86n118+t120*t39*abb86n147+t120*t40*abb86n118+t120*t43*abb86n1&
         &57+t120*t44*abb86n119+t120*t46*abb86n157+t120*t47*abb86n119+t120*t49*a&
         &bb86n146+t120*t50*abb86n155+t120*t51*abb86n119+t120*t53*abb86n146+t120&
         &*t54*abb86n155+t120*t55*abb86n119+t120*t59*abb86n148+t120*t60*abb86n15&
         &6+t120*t61*abb86n120+t120*t64*abb86n148+t120*t65*abb86n156+t120*t66*ab&
         &b86n120+t120*t69*abb86n121+t120*t71*abb86n121+t120*t72*abb86n164+t120*&
         &t74*abb86n164+t120*t78*abb86n155+t120*t80*abb86n155+t124*t33*abb86n133&
         &+t124*t35*abb86n163+t124*t37*abb86n147+t125*t35*abb86n151+t125*t37*abb&
         &86n118+t126*t16*abb86n133+t126*t17*abb86n147+t126*t22*abb86n163+t127*t&
         &17*abb86n118+t127*t22*abb86n151+t128*t33*abb86n133+t128*t35*abb86n163+&
         &t128*t37*abb86n147+t129*t16*abb86n133+t129*t17*abb86n147+t129*t22*abb8&
         &6n163+t130*t35*abb86n151+t130*t37*abb86n118+t131*t17*abb86n118+t131*t2&
         &2*abb86n151+t132*t33*abb86n134+t132*t35*abb86n162+t132*t37*abb86n148+t&
         &133*t35*abb86n152+t133*t37*abb86n120+t134*t16*abb86n134+t134*t17*abb86&
         &n148+t134*t22*abb86n162+t135*t17*abb86n120+t135*t22*abb86n152+t136*t33&
         &*abb86n134+t136*t35*abb86n162+t136*t37*abb86n148+t137*t16*abb86n134+t1&
         &37*t17*abb86n148+t137*t22*abb86n162+t138*t35*abb86n152+t138*t37*abb86n&
         &120+t139*t17*abb86n120+t139*t22*abb86n152+t140*t2*abb86n76+t142*t2*abb&
         &86n76+t143*t4*abb86n76+t144*t2*abb86n76+t146*t2*abb86n76+t147*t4*abb86&
         &n76+t150*t2*abb86n76+t152*t2*abb86n76+t153*t4*abb86n76+t154*t4*abb86n7&
         &6+t155*t37*abb86n149+t156*t17*abb86n149+t157*t37*abb86n149+t158*t17*ab&
         &b86n149+t160*t37*abb86n168+t161*t17*abb86n168+t162*t37*abb86n168+t163*&
         &t17*abb86n168+t164*t7*abb86n76+t165*t35*abb86n116+t166*t7*abb86n76+t16&
         &7*t7*abb86n76+t168*t22*abb86n116+t169*t7*abb86n76+t17*t175*abb86n155+t&
         &17*t177*abb86n155+t170*t35*abb86n116+t171*t7*abb86n76+t172*t22*abb86n1&
         &16+t173*t7*abb86n76+t174*t37*abb86n155+t176*t37*abb86n155+t4*t97*abb86&
         &n76+t1*t100*t120*abb86n76+t1*t120*t96*abb86n76+t1*t141*t37*abb86n76+t1&
         &*t145*t17*abb86n76+t1*t149*t37*abb86n76+t1*t151*t17*abb86n76+t10*t122*&
         &t33*abb86n135+t10*t123*t33*abb86n167+t102*t11*t37*abb86n119+t102*t12*t&
         &37*abb86n119+t102*t13*t35*abb86n154+t102*t15*t37*abb86n153+t102*t17*t2&
         &7*abb86n119+t102*t17*t28*abb86n119+t102*t17*t32*abb86n153+t102*t17*t70&
         &*abb86n121+t102*t19*t37*abb86n121+t102*t22*t29*abb86n154+t11*t37*t63*a&
         &bb86n157+t12*t37*t48*abb86n146+t12*t37*t63*abb86n155+t122*t13*t33*abb8&
         &6n137+t122*t14*t33*abb86n136+t122*t16*t18*abb86n135+t122*t16*t21*abb86&
         &n136+t122*t16*t29*abb86n137+t123*t13*t33*abb86n165+t123*t14*t33*abb86n&
         &166+t123*t16*t18*abb86n167+t123*t16*t21*abb86n166+t123*t16*t29*abb86n1&
         &65+t14*t37*t63*abb86n156+t15*t26*t37*abb86n157+t15*t36*t37*abb86n155+t&
         &15*t37*t41*abb86n156+t15*t37*t48*abb86n164+t159*t16*t37*abb86n121+t159&
         &*t17*t33*abb86n121+t16*t26*t37*abb86n119+t16*t35*t38*abb86n154+t16*t36&
         &*t37*abb86n119+t16*t37*t63*abb86n153+t16*t38*t82*abb86n137+t16*t38*t84&
         &*abb86n165+t16*t41*t82*abb86n136+t16*t41*t84*abb86n166+t16*t5*t82*abb8&
         &6n135+t16*t5*t84*abb86n167+t17*t21*t63*abb86n156+t17*t26*t32*abb86n157&
         &+t17*t26*t33*abb86n119+t17*t27*t63*abb86n157+t17*t28*t48*abb86n146+t17&
         &*t28*t63*abb86n155+t17*t30*t36*abb86n146+t17*t30*t63*abb86n164+t17*t32&
         &*t36*abb86n155+t17*t32*t41*abb86n156+t17*t32*t48*abb86n164+t17*t33*t36&
         &*abb86n119+t17*t33*t63*abb86n153+t20*t36*t37*abb86n146+t20*t37*t63*abb&
         &86n164+t22*t33*t38*abb86n154+t24*t33*t38*abb86n137+t24*t33*t41*abb86n1&
         &36+t24*t33*t5*abb86n135+t25*t33*t38*abb86n165+t25*t33*t41*abb86n166+t2&
         &5*t33*t5*abb86n167)
         return
      end if
      t180 = d(iv3,iv4)
      t181 = d(iv2,iv4)
      t182 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak3k1(iv4)
      t4 = spvak6k1(iv4)
      t5 = spvak6k5(iv4)
      t6 = spvak3k4(iv4)
      t7 = spvak5k1(iv4)
      t8 = t23*t6
      t9 = t6*t99
      t10 = t148*t6
      t11 = spvak2k1(iv4)
      t12 = t11*t20
      t13 = t11*t30
      t11 = t11*t48
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t178*t182*abb86n90+t179*t181*abb86n90+t180*t183*&
         &abb86n90)+(2.0_ki)*(t103*t180*abb86n92+t104*t180*abb86n92+t105*t180*ab&
         &b86n77+t106*t180*abb86n77+t107*t180*abb86n78+t108*t180*abb86n85+t109*t&
         &180*abb86n78+t110*t180*abb86n85+t155*t181*abb86n92+t156*t182*abb86n92+&
         &t157*t181*abb86n92+t158*t182*abb86n92+t160*t181*abb86n77+t161*t182*abb&
         &86n77+t162*t181*abb86n77+t163*t182*abb86n77+t165*t181*abb86n93+t168*t1&
         &82*abb86n93+t170*t181*abb86n93+t172*t182*abb86n93+t174*t181*abb86n84+t&
         &175*t182*abb86n84+t176*t181*abb86n84+t177*t182*abb86n84+t180*t73*abb86&
         &n93+t180*t75*abb86n93+t180*t76*abb86n83+t180*t77*abb86n83+t180*t78*abb&
         &86n84+t180*t79*abb86n102+t180*t80*abb86n84+t180*t81*abb86n102+t1*t116*&
         &t183*abb86n84+t1*t120*t183*abb86n102+t1*t122*t183*abb86n92+t1*t123*t18&
         &3*abb86n77+t1*t17*t178*abb86n102+t1*t178*t20*abb86n93+t1*t178*t22*abb8&
         &6n84+t1*t178*t24*abb86n92+t1*t178*t25*abb86n77+t1*t179*t30*abb86n93+t1&
         &*t179*t35*abb86n84+t1*t179*t37*abb86n102+t1*t179*t82*abb86n92+t1*t179*&
         &t84*abb86n77+t1*t183*t48*abb86n93+t102*t17*t181*abb86n102+t102*t182*t3&
         &7*abb86n102+t102*t183*t2*abb86n92+t102*t183*t3*abb86n77+t102*t183*t4*a&
         &bb86n84+t102*t183*t5*abb86n102+t102*t183*t6*abb86n93+t116*t181*t20*abb&
         &86n78+t116*t182*t30*abb86n78+t116*t183*t6*abb86n78+t120*t15*t181*abb86&
         &n83+t120*t16*t181*abb86n102+t120*t181*t20*abb86n85+t120*t182*t30*abb86&
         &n85+t120*t182*t32*abb86n83+t120*t182*t33*abb86n102+t120*t183*t6*abb86n&
         &85+t120*t183*t7*abb86n83+t15*t178*t5*abb86n83+t16*t178*t2*abb86n92+t16&
         &*t178*t3*abb86n77+t16*t178*t4*abb86n84+t16*t178*t5*abb86n102+t16*t178*&
         &t6*abb86n93+t17*t178*t6*abb86n85+t17*t178*t7*abb86n83+t17*t181*t48*abb&
         &86n85+t17*t181*t63*abb86n83+t178*t20*t4*abb86n78+t178*t20*t5*abb86n85+&
         &t178*t22*t6*abb86n78+t179*t2*t33*abb86n92+t179*t3*t33*abb86n77+t179*t3&
         &0*t4*abb86n78+t179*t30*t5*abb86n85+t179*t32*t5*abb86n83+t179*t33*t4*ab&
         &b86n84+t179*t33*t5*abb86n102+t179*t33*t6*abb86n93+t179*t35*t6*abb86n78&
         &+t179*t37*t6*abb86n85+t179*t37*t7*abb86n83+t181*t22*t48*abb86n78+t182*&
         &t35*t48*abb86n78+t182*t37*t48*abb86n85+t182*t37*t63*abb86n83+t183*t4*t&
         &48*abb86n78+t183*t48*t5*abb86n85+t183*t5*t63*abb86n83)+t140*t5*abb86n7&
         &6+t142*t5*abb86n76+t144*t5*abb86n76+t146*t5*abb86n76+t150*t5*abb86n76+&
         &t152*t5*abb86n76+t1*t100*t120*abb86n76+t1*t120*t96*abb86n76+t1*t141*t3&
         &7*abb86n76+t1*t145*t17*abb86n76+t1*t149*t37*abb86n76+t1*t151*t17*abb86&
         &n76+t10*t16*t37*abb86n76+t10*t17*t33*abb86n76+t102*t12*t37*abb86n76+t1&
         &02*t13*t17*abb86n76+t102*t17*t9*abb86n76+t102*t37*t8*abb86n76+t11*t16*&
         &t37*abb86n76+t11*t17*t33*abb86n76+t12*t120*t33*abb86n76+t120*t13*t16*a&
         &bb86n76+t120*t16*t9*abb86n76+t120*t33*t8*abb86n76)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d86:
   subroutine     reconstruct_d86(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_86:
      coeffs%coeffs_86%c0 = derivative(czip)
      coeffs%coeffs_86%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_86%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_86%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_86%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_86%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_86%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_86%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_86%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_86%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_86%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_86%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_86%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_86%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_86%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_86%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_86%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_86%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_86%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_86%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_86%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_86%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_86%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_86%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_86%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_86%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_86%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_86%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_86%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_86%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_86%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_86%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_86%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_86%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_86%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_86%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_86%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_86%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_86%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_86%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_86%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_86%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_86%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_86%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_86%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_86%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_86%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_86%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_86%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_86%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_86%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_86%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_86%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_86%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_86%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_86%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_86%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_86%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_86%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_86%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_86%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_86%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_86%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_86%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_86%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_86%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_86%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_86%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_86%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_86%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_86:
   end subroutine reconstruct_d86
!---#] subroutine reconstruct_d86:
end module p9_udbar_neepgg_d86h3l1d
