module     p9_udbar_neepgg_d88h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d88h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d88
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd88h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      complex(ki) :: t113
      complex(ki) :: t114
      complex(ki) :: t115
      complex(ki) :: t116
      complex(ki) :: t117
      complex(ki) :: t118
      complex(ki) :: t119
      complex(ki) :: t120
      complex(ki) :: t121
      complex(ki) :: t122
      complex(ki) :: t123
      complex(ki) :: t124
      complex(ki) :: t125
      complex(ki) :: t126
      complex(ki) :: t127
      complex(ki) :: t128
      complex(ki) :: t129
      complex(ki) :: t130
      complex(ki) :: t131
      complex(ki) :: t132
      complex(ki) :: t133
      complex(ki) :: t134
      complex(ki) :: t135
      complex(ki) :: t136
      complex(ki) :: t137
      complex(ki) :: t138
      complex(ki) :: t139
      complex(ki) :: t140
      complex(ki) :: t141
      complex(ki) :: t142
      complex(ki) :: t143
      complex(ki) :: t144
      complex(ki) :: t145
      complex(ki) :: t146
      complex(ki) :: t147
      complex(ki) :: t148
      complex(ki) :: t149
      complex(ki) :: t150
      complex(ki) :: t151
      complex(ki) :: t152
      complex(ki) :: t153
      complex(ki) :: t154
      complex(ki) :: t155
      complex(ki) :: t156
      complex(ki) :: t157
      complex(ki) :: t158
      complex(ki) :: t159
      complex(ki) :: t160
      complex(ki) :: t161
      complex(ki) :: t162
      complex(ki) :: t163
      complex(ki) :: t164
      complex(ki) :: t165
      complex(ki) :: t166
      complex(ki) :: t167
      complex(ki) :: t168
      complex(ki) :: t169
      complex(ki) :: t170
      complex(ki) :: t171
      complex(ki) :: t172
      complex(ki) :: t173
      complex(ki) :: t174
      complex(ki) :: t175
      complex(ki) :: t176
      complex(ki) :: t177
      complex(ki) :: t178
      complex(ki) :: t179
      complex(ki) :: t180
      complex(ki) :: t181
      complex(ki) :: t182
      complex(ki) :: t183
      real(ki) :: t184
      real(ki) :: t185
      real(ki) :: t186
      real(ki) :: t187
      real(ki) :: t188
      real(ki) :: t189
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      t184 = dotproduct(k2, qshift)
      t185 = dotproduct(k5, qshift)
      t1 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t186 = dotproduct(k6, qshift)
      t2 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t3 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t187 = dotproduct(k1, qshift)
      t188 = dotproduct(qshift, qshift)
      t4 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t5 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t6 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t7 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t8 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t9 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb88n75+t1*abb88n115+t184*abb88n111+t185*abb88n112+t186*a&
         &bb88n117+t187*abb88n134+t187*t187*abb88n91+t188*abb88n94+t188*t188*abb&
         &88n90+t2*abb88n122+t3*abb88n124+t1*t184*abb88n107+t1*t185*abb88n87+t1*&
         &t186*abb88n107+t1*t187*abb88n86+t1*t188*abb88n144+t1*t3*abb88n96+t1*t4&
         &*abb88n101+t1*t5*abb88n106+t1*t6*abb88n108+t184*t187*abb88n99+t184*t18&
         &8*abb88n125+t184*t2*abb88n104+t184*t3*abb88n103+t185*t186*abb88n88+t18&
         &5*t187*abb88n89+t185*t188*abb88n138+t185*t2*abb88n80+t186*t187*abb88n9&
         &2+t186*t188*abb88n142+t186*t2*abb88n105+t186*t3*abb88n98+t186*t4*abb88&
         &n109+t187*t188*abb88n142+t187*t2*abb88n81+t187*t3*abb88n97+t187*t4*abb&
         &88n110+t187*t6*abb88n78+t188*t2*abb88n161+t188*t3*abb88n127+t188*t4*ab&
         &b88n113+t188*t6*abb88n163+t2*t3*abb88n79+t2*t4*abb88n100+t1*t184*t3*ab&
         &b88n119+t1*t185*t6*abb88n157+t1*t185*t8*abb88n149+t1*t185*t9*abb88n158&
         &+t1*t186*t3*abb88n119+t1*t187*t3*abb88n118+t1*t187*t4*abb88n135+t1*t18&
         &7*t6*abb88n154+t1*t187*t8*abb88n147+t1*t187*t9*abb88n160+t1*t188*t3*ab&
         &b88n102+t1*t188*t4*abb88n93+t1*t188*t6*abb88n83+t1*t188*t8*abb88n85+t1&
         &*t188*t9*abb88n82+t1*t2*t3*abb88n156+t1*t3*t4*abb88n146+t1*t3*t5*abb88&
         &n121+t1*t3*t6*abb88n151+t1*t3*t7*abb88n150+t1*t3*t8*abb88n132+t1*t3*t9&
         &*abb88n165+t1*t4*t6*abb88n116+t1*t4*t7*abb88n123+t184*t2*t3*abb88n153+&
         &t186*t2*t3*abb88n151+t186*t3*t4*abb88n129+t187*t3*t4*abb88n130+t187*t4&
         &*t6*abb88n167+t188*t2*t3*abb88n84+t188*t3*t4*abb88n95+t188*t4*t6*abb88&
         &n77+t2*t3*t4*abb88n166+t1*t3*t4*t7*abb88n76)
         return
      end if
      t10 = k1(iv1)
      t11 = k2(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak5k6(iv1)
      t16 = spvak6k1(iv1)
      t17 = spvak6k5(iv1)
      t18 = t14*abb88n143
      t19 = spvak2k6(iv1)
      t20 = spvak3k4(iv1)
      t21 = spvak5k1(iv1)
      t22 = t17*abb88n107
      t23 = spvak2k1(iv1)
      t24 = spvak2k4(iv1)
      t25 = spvak3k1(iv1)
      t26 = t15*abb88n119
      t27 = t15*abb88n151
      t28 = t17*abb88n119
      if(deg.eq.1) then
         numerator = (t10*abb88n134+t11*abb88n111+t12*abb88n112+t13*abb88n117+t1&
         &4*abb88n133+t15*abb88n124+t16*abb88n122+t17*abb88n115+t18*t186+t18*t18&
         &7+t184*t22+t186*t22+t1*t10*abb88n86+t1*t11*abb88n107+t1*t12*abb88n87+t&
         &1*t13*abb88n107+t1*t14*abb88n145+t1*t15*abb88n96+t1*t184*t26+t1*t186*t&
         &26+t1*t19*abb88n106+t1*t20*abb88n101+t1*t21*abb88n108+t1*t27*t6+t10*t1&
         &84*abb88n99+t10*t185*abb88n89+t10*t186*abb88n92+t10*t187*abb88n137+t10&
         &*t188*abb88n142+t10*t2*abb88n81+t10*t3*abb88n97+t10*t4*abb88n110+t10*t&
         &6*abb88n78+t11*t187*abb88n99+t11*t188*abb88n125+t11*t2*abb88n104+t11*t&
         &3*abb88n103+t12*t186*abb88n88+t12*t187*abb88n89+t12*t188*abb88n138+t12&
         &*t2*abb88n80+t13*t185*abb88n88+t13*t187*abb88n92+t13*t188*abb88n142+t1&
         &3*t2*abb88n105+t13*t3*abb88n98+t13*t4*abb88n109+t14*t184*abb88n126+t14&
         &*t185*abb88n139+t14*t188*abb88n140+t14*t2*abb88n162+t14*t3*abb88n128+t&
         &14*t4*abb88n114+t14*t6*abb88n164+t15*t184*abb88n103+t15*t186*abb88n98+&
         &t15*t187*abb88n97+t15*t188*abb88n127+t15*t2*abb88n79+t16*t184*abb88n10&
         &4+t16*t185*abb88n80+t16*t186*abb88n105+t16*t187*abb88n81+t16*t188*abb8&
         &8n161+t16*t3*abb88n79+t16*t4*abb88n100+t17*t185*abb88n87+t17*t187*abb8&
         &8n86+t17*t188*abb88n144+t17*t3*abb88n96+t17*t4*abb88n101+t17*t5*abb88n&
         &106+t17*t6*abb88n108+t184*t28*t3+t186*t2*t27+t186*t20*abb88n109+t186*t&
         &28*t3+t187*t20*abb88n110+t187*t21*abb88n78+t188*t20*abb88n113+t188*t21&
         &*abb88n163+t2*t20*abb88n100+t1*t10*t3*abb88n118+t1*t10*t4*abb88n135+t1&
         &*t10*t6*abb88n154+t1*t10*t8*abb88n147+t1*t10*t9*abb88n160+t1*t11*t3*ab&
         &b88n119+t1*t12*t6*abb88n157+t1*t12*t8*abb88n149+t1*t12*t9*abb88n158+t1&
         &*t13*t3*abb88n119+t1*t14*t3*abb88n120+t1*t14*t4*abb88n136+t1*t14*t6*ab&
         &b88n155+t1*t14*t8*abb88n148+t1*t14*t9*abb88n159+t1*t15*t187*abb88n118+&
         &t1*t15*t188*abb88n102+t1*t15*t2*abb88n156+t1*t15*t4*abb88n146+t1*t15*t&
         &5*abb88n121+t1*t15*t7*abb88n150+t1*t15*t8*abb88n132+t1*t15*t9*abb88n16&
         &5+t1*t16*t3*abb88n156+t1*t185*t21*abb88n157+t1*t185*t24*abb88n149+t1*t&
         &185*t25*abb88n158+t1*t187*t20*abb88n135+t1*t187*t21*abb88n154+t1*t187*&
         &t24*abb88n147+t1*t187*t25*abb88n160+t1*t188*t20*abb88n93+t1*t188*t21*a&
         &bb88n83+t1*t188*t24*abb88n85+t1*t188*t25*abb88n82+t1*t19*t3*abb88n121+&
         &t1*t20*t3*abb88n146+t1*t20*t6*abb88n116+t1*t20*t7*abb88n123+t1*t21*t3*&
         &abb88n151+t1*t21*t4*abb88n116+t1*t23*t3*abb88n150+t1*t23*t4*abb88n123+&
         &t1*t24*t3*abb88n132+t1*t25*t3*abb88n165+t10*t3*t4*abb88n130+t10*t4*t6*&
         &abb88n167+t11*t2*t3*abb88n153+t13*t2*t3*abb88n151+t13*t3*t4*abb88n129+&
         &t14*t2*t3*abb88n152+t14*t3*t4*abb88n131+t14*t4*t6*abb88n168+t15*t184*t&
         &2*abb88n153+t15*t186*t4*abb88n129+t15*t187*t4*abb88n130+t15*t188*t2*ab&
         &b88n84+t15*t188*t4*abb88n95+t15*t2*t4*abb88n166+t16*t184*t3*abb88n153+&
         &t16*t186*t3*abb88n151+t16*t188*t3*abb88n84+t16*t3*t4*abb88n166+t17*t18&
         &5*t6*abb88n157+t17*t185*t8*abb88n149+t17*t185*t9*abb88n158+t17*t187*t3&
         &*abb88n118+t17*t187*t4*abb88n135+t17*t187*t6*abb88n154+t17*t187*t8*abb&
         &88n147+t17*t187*t9*abb88n160+t17*t188*t3*abb88n102+t17*t188*t4*abb88n9&
         &3+t17*t188*t6*abb88n83+t17*t188*t8*abb88n85+t17*t188*t9*abb88n82+t17*t&
         &2*t3*abb88n156+t17*t3*t4*abb88n146+t17*t3*t5*abb88n121+t17*t3*t6*abb88&
         &n151+t17*t3*t7*abb88n150+t17*t3*t8*abb88n132+t17*t3*t9*abb88n165+t17*t&
         &4*t6*abb88n116+t17*t4*t7*abb88n123+t186*t20*t3*abb88n129+t187*t20*t3*a&
         &bb88n130+t187*t20*t6*abb88n167+t187*t21*t4*abb88n167+t188*t20*t3*abb88&
         &n95+t188*t20*t6*abb88n77+t188*t21*t4*abb88n77+t2*t20*t3*abb88n166+t1*t&
         &15*t4*t7*abb88n76+t1*t20*t3*t7*abb88n76+t1*t23*t3*t4*abb88n76+t17*t3*t&
         &4*t7*abb88n76)
         return
      end if
      t189 = d(iv1,iv2)
      t18 = k1(iv2)
      t22 = qshift(iv2)
      t26 = t189*abb88n142
      t27 = k2(iv2)
      t28 = k5(iv2)
      t29 = k6(iv2)
      t30 = spvak3k4(iv2)
      t31 = t10*t30
      t32 = spvak5k1(iv2)
      t33 = t10*t32
      t34 = spvak5k6(iv2)
      t35 = t10*t34
      t36 = spvak6k1(iv2)
      t37 = spvak6k5(iv2)
      t38 = t10*t37
      t39 = t18*t20
      t40 = t18*t21
      t41 = t15*t18
      t42 = t17*t18
      t43 = t11*t34
      t44 = t11*t36
      t45 = t11*t37
      t46 = t15*t27
      t47 = t16*t27
      t48 = t17*t27
      t49 = t12*t37
      t50 = t17*t28
      t51 = t13*t30
      t52 = t13*t34
      t53 = t13*t36
      t54 = t13*t37
      t55 = t20*t29
      t56 = t15*t29
      t57 = t16*t29
      t58 = t17*t29
      t59 = t14*t30
      t60 = t14*t32
      t61 = t14*t34
      t62 = t14*t36
      t63 = t14*t37
      t64 = t20*t22
      t65 = t21*t22
      t66 = t15*t22
      t67 = t16*t22
      t68 = t17*t22
      t69 = t19*t37
      t70 = spvak2k6(iv2)
      t71 = t17*t70
      t72 = t20*t36
      t73 = t20*t37
      t74 = t16*t30
      t75 = t17*t30
      t76 = t21*t37
      t77 = t17*t32
      t78 = t15*t36
      t79 = t15*t37
      t80 = t16*t34
      t81 = t17*t34
      t82 = spvak2k4(iv2)
      t83 = t10*t82
      t84 = spvak3k1(iv2)
      t85 = t10*t84
      t86 = t18*t24
      t87 = t18*t25
      t88 = t12*t82
      t89 = t12*t84
      t90 = t12*t32
      t91 = t24*t28
      t92 = t25*t28
      t93 = t21*t28
      t94 = t14*t82
      t95 = t14*t84
      t96 = t22*t24
      t97 = t22*t25
      t98 = t23*t30
      t99 = t23*t34
      t100 = t23*t37
      t101 = spvak2k1(iv2)
      t102 = t101*t20
      t103 = t101*t15
      t104 = t101*t17
      t105 = t24*t34
      t106 = t24*t37
      t107 = t15*t82
      t108 = t17*t82
      t109 = t19*t34
      t110 = t15*t70
      t111 = t25*t34
      t112 = t25*t37
      t113 = t15*t84
      t114 = t17*t84
      t115 = t20*t32
      t116 = t20*t34
      t117 = t21*t30
      t118 = t15*t30
      t119 = t21*t34
      t120 = t15*t32
      t121 = t79*abb88n119
      t122 = t81*abb88n119
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t186*t26+t187*t26+t189*abb88n94+t1*t189*abb88n14&
         &4+t10*t18*abb88n91+t14*t22*abb88n140+t184*t189*abb88n125+t185*t189*abb&
         &88n138+t188*t189*abb88n141+t189*t2*abb88n161+t189*t3*abb88n127+t189*t4&
         &*abb88n113+t189*t6*abb88n163+t1*t189*t3*abb88n102+t1*t189*t4*abb88n93+&
         &t1*t189*t6*abb88n83+t1*t189*t8*abb88n85+t1*t189*t9*abb88n82+t189*t2*t3&
         &*abb88n84+t189*t3*t4*abb88n95+t189*t4*t6*abb88n77)+t121*t184+t121*t186&
         &+t122*t184+t122*t186+t31*abb88n110+t33*abb88n78+t35*abb88n97+t38*abb88&
         &n86+t39*abb88n110+t40*abb88n78+t41*abb88n97+t42*abb88n86+t43*abb88n103&
         &+t44*abb88n104+t45*abb88n107+t46*abb88n103+t47*abb88n104+t48*abb88n107&
         &+t49*abb88n87+t50*abb88n87+t51*abb88n109+t52*abb88n98+t53*abb88n105+t5&
         &4*abb88n107+t55*abb88n109+t56*abb88n98+t57*abb88n105+t58*abb88n107+t59&
         &*abb88n114+t60*abb88n164+t61*abb88n128+t62*abb88n162+t63*abb88n145+t64&
         &*abb88n114+t65*abb88n164+t66*abb88n128+t67*abb88n162+t68*abb88n145+t69&
         &*abb88n106+t71*abb88n106+t72*abb88n100+t73*abb88n101+t74*abb88n100+t75&
         &*abb88n101+t76*abb88n108+t77*abb88n108+t78*abb88n79+t79*abb88n96+t80*a&
         &bb88n79+t81*abb88n96+t1*t102*abb88n123+t1*t103*abb88n150+t1*t105*abb88&
         &n132+t1*t107*abb88n132+t1*t109*abb88n121+t1*t110*abb88n121+t1*t111*abb&
         &88n165+t1*t113*abb88n165+t1*t115*abb88n116+t1*t116*abb88n146+t1*t117*a&
         &bb88n116+t1*t118*abb88n146+t1*t119*abb88n151+t1*t120*abb88n151+t1*t31*&
         &abb88n135+t1*t33*abb88n154+t1*t35*abb88n118+t1*t39*abb88n135+t1*t40*ab&
         &b88n154+t1*t41*abb88n118+t1*t43*abb88n119+t1*t46*abb88n119+t1*t52*abb8&
         &8n119+t1*t56*abb88n119+t1*t59*abb88n136+t1*t60*abb88n155+t1*t61*abb88n&
         &120+t1*t64*abb88n136+t1*t65*abb88n155+t1*t66*abb88n120+t1*t78*abb88n15&
         &6+t1*t80*abb88n156+t1*t83*abb88n147+t1*t85*abb88n160+t1*t86*abb88n147+&
         &t1*t87*abb88n160+t1*t88*abb88n149+t1*t89*abb88n158+t1*t90*abb88n157+t1&
         &*t91*abb88n149+t1*t92*abb88n158+t1*t93*abb88n157+t1*t94*abb88n148+t1*t&
         &95*abb88n159+t1*t96*abb88n148+t1*t97*abb88n159+t1*t98*abb88n123+t1*t99&
         &*abb88n150+t10*t22*abb88n143+t10*t27*abb88n99+t10*t28*abb88n89+t10*t29&
         &*abb88n92+t10*t36*abb88n81+t100*t3*abb88n150+t100*t4*abb88n123+t104*t3&
         &*abb88n150+t104*t4*abb88n123+t106*t185*abb88n149+t106*t187*abb88n147+t&
         &106*t188*abb88n85+t106*t3*abb88n132+t108*t185*abb88n149+t108*t187*abb8&
         &8n147+t108*t188*abb88n85+t108*t3*abb88n132+t11*t18*abb88n99+t11*t22*ab&
         &b88n126+t112*t185*abb88n158+t112*t187*abb88n160+t112*t188*abb88n82+t11&
         &2*t3*abb88n165+t114*t185*abb88n158+t114*t187*abb88n160+t114*t188*abb88&
         &n82+t114*t3*abb88n165+t115*t187*abb88n167+t115*t188*abb88n77+t116*t186&
         &*abb88n129+t116*t187*abb88n130+t116*t188*abb88n95+t116*t2*abb88n166+t1&
         &17*t187*abb88n167+t117*t188*abb88n77+t118*t186*abb88n129+t118*t187*abb&
         &88n130+t118*t188*abb88n95+t118*t2*abb88n166+t12*t18*abb88n89+t12*t22*a&
         &bb88n139+t12*t29*abb88n88+t12*t36*abb88n80+t13*t18*abb88n92+t13*t22*ab&
         &b88n143+t13*t28*abb88n88+t14*t18*abb88n143+t14*t27*abb88n126+t14*t28*a&
         &bb88n139+t14*t29*abb88n143+t16*t18*abb88n81+t16*t28*abb88n80+t184*t78*&
         &abb88n153+t184*t80*abb88n153+t185*t76*abb88n157+t185*t77*abb88n157+t18&
         &6*t78*abb88n151+t186*t80*abb88n151+t187*t73*abb88n135+t187*t75*abb88n1&
         &35+t187*t76*abb88n154+t187*t77*abb88n154+t187*t79*abb88n118+t187*t81*a&
         &bb88n118+t188*t73*abb88n93+t188*t75*abb88n93+t188*t76*abb88n83+t188*t7&
         &7*abb88n83+t188*t78*abb88n84+t188*t79*abb88n102+t188*t80*abb88n84+t188&
         &*t81*abb88n102+t2*t43*abb88n153+t2*t46*abb88n153+t2*t52*abb88n151+t2*t&
         &56*abb88n151+t2*t61*abb88n152+t2*t66*abb88n152+t2*t79*abb88n156+t2*t81&
         &*abb88n156+t3*t31*abb88n130+t3*t38*abb88n118+t3*t39*abb88n130+t3*t42*a&
         &bb88n118+t3*t44*abb88n153+t3*t45*abb88n119+t3*t47*abb88n153+t3*t48*abb&
         &88n119+t3*t51*abb88n129+t3*t53*abb88n151+t3*t54*abb88n119+t3*t55*abb88&
         &n129+t3*t57*abb88n151+t3*t58*abb88n119+t3*t59*abb88n131+t3*t62*abb88n1&
         &52+t3*t63*abb88n120+t3*t64*abb88n131+t3*t67*abb88n152+t3*t68*abb88n120&
         &+t3*t69*abb88n121+t3*t71*abb88n121+t3*t72*abb88n166+t3*t73*abb88n146+t&
         &3*t74*abb88n166+t3*t75*abb88n146+t3*t76*abb88n151+t3*t77*abb88n151+t31&
         &*t6*abb88n167+t33*t4*abb88n167+t35*t4*abb88n130+t38*t4*abb88n135+t38*t&
         &6*abb88n154+t38*t8*abb88n147+t38*t9*abb88n160+t39*t6*abb88n167+t4*t40*&
         &abb88n167+t4*t41*abb88n130+t4*t42*abb88n135+t4*t52*abb88n129+t4*t56*ab&
         &b88n129+t4*t60*abb88n168+t4*t61*abb88n131+t4*t63*abb88n136+t4*t65*abb8&
         &8n168+t4*t66*abb88n131+t4*t68*abb88n136+t4*t76*abb88n116+t4*t77*abb88n&
         &116+t4*t78*abb88n166+t4*t79*abb88n146+t4*t80*abb88n166+t4*t81*abb88n14&
         &6+t42*t6*abb88n154+t42*t8*abb88n147+t42*t9*abb88n160+t49*t6*abb88n157+&
         &t49*t8*abb88n149+t49*t9*abb88n158+t5*t79*abb88n121+t5*t81*abb88n121+t5&
         &0*t6*abb88n157+t50*t8*abb88n149+t50*t9*abb88n158+t59*t6*abb88n168+t6*t&
         &63*abb88n155+t6*t64*abb88n168+t6*t68*abb88n155+t6*t73*abb88n116+t6*t75&
         &*abb88n116+t6*t79*abb88n151+t6*t81*abb88n151+t63*t8*abb88n148+t63*t9*a&
         &bb88n159+t68*t8*abb88n148+t68*t9*abb88n159+t7*t73*abb88n123+t7*t75*abb&
         &88n123+t7*t79*abb88n150+t7*t81*abb88n150+t79*t8*abb88n132+t79*t9*abb88&
         &n165+t8*t81*abb88n132+t81*t9*abb88n165+t1*t102*t3*abb88n76+t1*t103*t4*&
         &abb88n76+t1*t116*t7*abb88n76+t1*t118*t7*abb88n76+t1*t3*t98*abb88n76+t1&
         &*t4*t99*abb88n76+t100*t3*t4*abb88n76+t104*t3*t4*abb88n76+t16*t3*t37*ab&
         &b88n156+t17*t3*t36*abb88n156+t3*t7*t73*abb88n76+t3*t7*t75*abb88n76+t4*&
         &t7*t79*abb88n76+t4*t7*t81*abb88n76)
         return
      end if
      t184 = d(iv2,iv3)
      t185 = d(iv1,iv3)
      t5 = k1(iv3)
      t26 = k2(iv3)
      t38 = k5(iv3)
      t42 = k6(iv3)
      t44 = qshift(iv3)
      t45 = t184*t20
      t47 = t185*t30
      t48 = spvak3k4(iv3)
      t49 = t189*t48
      t50 = t184*t21
      t53 = t185*t32
      t54 = spvak5k1(iv3)
      t57 = t189*t54
      t58 = t15*t184
      t62 = t185*t34
      t63 = spvak5k6(iv3)
      t67 = t189*t63
      t68 = t16*t184
      t69 = t185*t36
      t71 = spvak6k1(iv3)
      t72 = t189*t71
      t74 = t17*t184
      t100 = t185*t37
      t104 = spvak6k5(iv3)
      t121 = t104*t189
      t122 = spvak2k4(iv3)
      t123 = spvak3k1(iv3)
      t124 = t10*t48
      t125 = t18*t48
      t126 = t20*t5
      t127 = t30*t5
      t128 = t11*t63
      t129 = t27*t63
      t130 = t15*t26
      t131 = t26*t34
      t132 = t13*t63
      t133 = t29*t63
      t134 = t15*t42
      t135 = t34*t42
      t136 = t14*t48
      t137 = t14*t63
      t138 = t22*t48
      t139 = t22*t63
      t140 = t20*t44
      t141 = t30*t44
      t142 = t15*t44
      t143 = t34*t44
      t144 = t104*t98
      t145 = t23*t48
      t146 = t145*t37
      t99 = t104*t99
      t147 = t23*t37*t63
      t148 = t102*t104
      t149 = t101*t48
      t150 = t149*t17
      t103 = t103*t104
      t151 = t101*t17*t63
      t152 = spvak2k1(iv3)
      t153 = t152*t20
      t154 = t153*t37
      t155 = t152*t30
      t156 = t155*t17
      t157 = t15*t152*t37
      t158 = t152*t17*t34
      t159 = spvak2k6(iv3)
      t160 = t20*t54
      t161 = t104*t116
      t162 = t20*t63
      t163 = t162*t37
      t164 = t30*t54
      t165 = t104*t118
      t166 = t30*t63
      t167 = t166*t17
      t168 = t21*t48
      t169 = t32*t48
      t170 = t15*t48
      t171 = t170*t37
      t172 = t34*t48
      t173 = t17*t172
      t174 = t15*t71
      t175 = t34*t71
      t176 = t16*t63
      t177 = t36*t63
      t178 = t63*t98
      t179 = t145*t34
      t180 = t102*t63
      t181 = t149*t15
      t182 = t153*t34
      t183 = t15*t155
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t100*abb88n144+t121*abb88n144+t45*abb88n113+t47*&
         &abb88n113+t49*abb88n113+t50*abb88n163+t53*abb88n163+t57*abb88n163+t58*&
         &abb88n127+t62*abb88n127+t67*abb88n127+t68*abb88n161+t69*abb88n161+t72*&
         &abb88n161+t74*abb88n144+t1*t45*abb88n93+t1*t47*abb88n93+t1*t49*abb88n9&
         &3+t1*t50*abb88n83+t1*t53*abb88n83+t1*t57*abb88n83+t1*t58*abb88n102+t1*&
         &t62*abb88n102+t1*t67*abb88n102+t10*t184*abb88n142+t100*t3*abb88n102+t1&
         &00*t4*abb88n93+t100*t6*abb88n83+t100*t8*abb88n85+t100*t9*abb88n82+t11*&
         &t184*abb88n125+t12*t184*abb88n138+t121*t3*abb88n102+t121*t4*abb88n93+t&
         &121*t6*abb88n83+t121*t8*abb88n85+t121*t9*abb88n82+t13*t184*abb88n142+t&
         &14*t184*abb88n140+t18*t185*abb88n142+t185*t22*abb88n140+t185*t27*abb88&
         &n125+t185*t28*abb88n138+t185*t29*abb88n142+t189*t26*abb88n125+t189*t38&
         &*abb88n138+t189*t42*abb88n142+t189*t44*abb88n140+t189*t5*abb88n142+t2*&
         &t58*abb88n84+t2*t62*abb88n84+t2*t67*abb88n84+t3*t45*abb88n95+t3*t47*ab&
         &b88n95+t3*t49*abb88n95+t3*t68*abb88n84+t3*t69*abb88n84+t3*t72*abb88n84&
         &+t3*t74*abb88n102+t4*t50*abb88n77+t4*t53*abb88n77+t4*t57*abb88n77+t4*t&
         &58*abb88n95+t4*t62*abb88n95+t4*t67*abb88n95+t4*t74*abb88n93+t45*t6*abb&
         &88n77+t47*t6*abb88n77+t49*t6*abb88n77+t6*t74*abb88n83+t74*t8*abb88n85+&
         &t74*t9*abb88n82+t1*t122*t189*abb88n85+t1*t123*t189*abb88n82+t1*t184*t2&
         &4*abb88n85+t1*t184*t25*abb88n82+t1*t185*t82*abb88n85+t1*t185*t84*abb88&
         &n82)+t103*abb88n150+t144*abb88n123+t146*abb88n123+t147*abb88n150+t148*&
         &abb88n123+t150*abb88n123+t151*abb88n150+t154*abb88n123+t156*abb88n123+&
         &t157*abb88n150+t158*abb88n150+t161*abb88n146+t163*abb88n146+t165*abb88&
         &n146+t167*abb88n146+t171*abb88n146+t173*abb88n146+t99*abb88n150+t1*t17&
         &8*abb88n76+t1*t179*abb88n76+t1*t180*abb88n76+t1*t181*abb88n76+t1*t182*&
         &abb88n76+t1*t183*abb88n76+t103*t4*abb88n76+t104*t105*abb88n132+t104*t1&
         &07*abb88n132+t104*t109*abb88n121+t104*t110*abb88n121+t104*t111*abb88n1&
         &65+t104*t113*abb88n165+t104*t115*abb88n116+t104*t117*abb88n116+t104*t1&
         &19*abb88n151+t104*t120*abb88n151+t104*t31*abb88n135+t104*t33*abb88n154&
         &+t104*t35*abb88n118+t104*t39*abb88n135+t104*t40*abb88n154+t104*t41*abb&
         &88n118+t104*t43*abb88n119+t104*t46*abb88n119+t104*t52*abb88n119+t104*t&
         &56*abb88n119+t104*t59*abb88n136+t104*t60*abb88n155+t104*t61*abb88n120+&
         &t104*t64*abb88n136+t104*t65*abb88n155+t104*t66*abb88n120+t104*t78*abb8&
         &8n156+t104*t80*abb88n156+t104*t83*abb88n147+t104*t85*abb88n160+t104*t8&
         &6*abb88n147+t104*t87*abb88n160+t104*t88*abb88n149+t104*t89*abb88n158+t&
         &104*t90*abb88n157+t104*t91*abb88n149+t104*t92*abb88n158+t104*t93*abb88&
         &n157+t104*t94*abb88n148+t104*t95*abb88n159+t104*t96*abb88n148+t104*t97&
         &*abb88n159+t116*t71*abb88n166+t118*t71*abb88n166+t124*t32*abb88n167+t1&
         &24*t34*abb88n130+t124*t37*abb88n135+t125*t15*abb88n130+t125*t17*abb88n&
         &135+t125*t21*abb88n167+t126*t32*abb88n167+t126*t34*abb88n130+t126*t37*&
         &abb88n135+t127*t15*abb88n130+t127*t17*abb88n135+t127*t21*abb88n167+t12&
         &8*t36*abb88n153+t128*t37*abb88n119+t129*t16*abb88n153+t129*t17*abb88n1&
         &19+t130*t36*abb88n153+t130*t37*abb88n119+t131*t16*abb88n153+t131*t17*a&
         &bb88n119+t132*t36*abb88n151+t132*t37*abb88n119+t133*t16*abb88n151+t133&
         &*t17*abb88n119+t134*t36*abb88n151+t134*t37*abb88n119+t135*t16*abb88n15&
         &1+t135*t17*abb88n119+t136*t32*abb88n168+t136*t34*abb88n131+t136*t37*ab&
         &b88n136+t137*t36*abb88n152+t137*t37*abb88n120+t138*t15*abb88n131+t138*&
         &t17*abb88n136+t138*t21*abb88n168+t139*t16*abb88n152+t139*t17*abb88n120&
         &+t140*t32*abb88n168+t140*t34*abb88n131+t140*t37*abb88n136+t141*t15*abb&
         &88n131+t141*t17*abb88n136+t141*t21*abb88n168+t142*t36*abb88n152+t142*t&
         &37*abb88n120+t143*t16*abb88n152+t143*t17*abb88n120+t144*t3*abb88n76+t1&
         &46*t3*abb88n76+t147*t4*abb88n76+t148*t3*abb88n76+t150*t3*abb88n76+t151&
         &*t4*abb88n76+t154*t3*abb88n76+t156*t3*abb88n76+t157*t4*abb88n76+t158*t&
         &4*abb88n76+t16*t166*abb88n166+t16*t172*abb88n166+t160*t37*abb88n116+t1&
         &61*t7*abb88n76+t162*t36*abb88n166+t163*t7*abb88n76+t164*t17*abb88n116+&
         &t165*t7*abb88n76+t167*t7*abb88n76+t168*t37*abb88n116+t169*t17*abb88n11&
         &6+t17*t175*abb88n156+t17*t177*abb88n156+t170*t36*abb88n166+t171*t7*abb&
         &88n76+t173*t7*abb88n76+t174*t37*abb88n156+t176*t37*abb88n156+t31*t54*a&
         &bb88n167+t31*t63*abb88n130+t39*t54*abb88n167+t39*t63*abb88n130+t4*t99*&
         &abb88n76+t43*t71*abb88n153+t46*t71*abb88n153+t51*t63*abb88n129+t52*t71&
         &*abb88n151+t54*t59*abb88n168+t54*t64*abb88n168+t55*t63*abb88n129+t56*t&
         &71*abb88n151+t59*t63*abb88n131+t61*t71*abb88n152+t63*t64*abb88n131+t66&
         &*t71*abb88n152+t10*t122*t37*abb88n147+t10*t123*t37*abb88n160+t10*t37*t&
         &54*abb88n154+t10*t37*t63*abb88n118+t12*t122*t37*abb88n149+t12*t123*t37&
         &*abb88n158+t12*t37*t54*abb88n157+t122*t14*t37*abb88n148+t122*t15*t37*a&
         &bb88n132+t122*t17*t18*abb88n147+t122*t17*t22*abb88n148+t122*t17*t28*ab&
         &b88n149+t122*t17*t34*abb88n132+t123*t14*t37*abb88n159+t123*t15*t37*abb&
         &88n165+t123*t17*t18*abb88n160+t123*t17*t22*abb88n159+t123*t17*t28*abb8&
         &8n158+t123*t17*t34*abb88n165+t13*t34*t48*abb88n129+t14*t37*t54*abb88n1&
         &55+t15*t159*t37*abb88n121+t15*t29*t48*abb88n129+t15*t30*t42*abb88n129+&
         &t15*t37*t5*abb88n118+t15*t37*t54*abb88n151+t159*t17*t34*abb88n121+t17*&
         &t18*t54*abb88n154+t17*t18*t63*abb88n118+t17*t22*t54*abb88n155+t17*t28*&
         &t54*abb88n157+t17*t32*t38*abb88n157+t17*t32*t44*abb88n155+t17*t32*t5*a&
         &bb88n154+t17*t32*t63*abb88n151+t17*t34*t5*abb88n118+t17*t34*t54*abb88n&
         &151+t17*t38*t82*abb88n149+t17*t38*t84*abb88n158+t17*t44*t82*abb88n148+&
         &t17*t44*t84*abb88n159+t17*t5*t82*abb88n147+t17*t5*t84*abb88n160+t17*t6&
         &3*t70*abb88n121+t17*t63*t82*abb88n132+t17*t63*t84*abb88n165+t19*t37*t6&
         &3*abb88n121+t20*t34*t42*abb88n129+t21*t37*t38*abb88n157+t21*t37*t44*ab&
         &b88n155+t21*t37*t5*abb88n154+t21*t37*t63*abb88n151+t24*t37*t38*abb88n1&
         &49+t24*t37*t44*abb88n148+t24*t37*t5*abb88n147+t24*t37*t63*abb88n132+t2&
         &5*t37*t38*abb88n158+t25*t37*t44*abb88n159+t25*t37*t5*abb88n160+t25*t37&
         &*t63*abb88n165)
         return
      end if
      t186 = d(iv3,iv4)
      t187 = d(iv2,iv4)
      t188 = d(iv1,iv4)
      t1 = spvak6k5(iv4)
      t2 = spvak2k4(iv4)
      t3 = spvak3k1(iv4)
      t4 = spvak5k1(iv4)
      t5 = spvak5k6(iv4)
      t6 = spvak3k4(iv4)
      t7 = spvak6k1(iv4)
      t8 = t23*t6
      t9 = t101*t6
      t10 = t152*t6
      t11 = spvak2k1(iv4)
      t12 = t11*t20
      t13 = t11*t30
      t11 = t11*t48
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t184*t188*abb88n90+t185*t187*abb88n90+t186*t189*&
         &abb88n90)+(2.0_ki)*(t106*t186*abb88n85+t108*t186*abb88n85+t112*t186*ab&
         &b88n82+t114*t186*abb88n82+t115*t186*abb88n77+t116*t186*abb88n95+t117*t&
         &186*abb88n77+t118*t186*abb88n95+t160*t187*abb88n77+t162*t187*abb88n95+&
         &t164*t188*abb88n77+t166*t188*abb88n95+t168*t187*abb88n77+t169*t188*abb&
         &88n77+t170*t187*abb88n95+t172*t188*abb88n95+t174*t187*abb88n84+t175*t1&
         &88*abb88n84+t176*t187*abb88n84+t177*t188*abb88n84+t186*t73*abb88n93+t1&
         &86*t75*abb88n93+t186*t76*abb88n83+t186*t77*abb88n83+t186*t78*abb88n84+&
         &t186*t79*abb88n102+t186*t80*abb88n84+t186*t81*abb88n102+t1*t122*t189*a&
         &bb88n85+t1*t123*t189*abb88n82+t1*t15*t184*abb88n102+t1*t184*t20*abb88n&
         &93+t1*t184*t21*abb88n83+t1*t184*t24*abb88n85+t1*t184*t25*abb88n82+t1*t&
         &185*t30*abb88n93+t1*t185*t32*abb88n83+t1*t185*t34*abb88n102+t1*t185*t8&
         &2*abb88n85+t1*t185*t84*abb88n82+t1*t189*t48*abb88n93+t1*t189*t54*abb88&
         &n83+t1*t189*t63*abb88n102+t104*t15*t187*abb88n102+t104*t187*t20*abb88n&
         &93+t104*t187*t21*abb88n83+t104*t187*t24*abb88n85+t104*t187*t25*abb88n8&
         &2+t104*t188*t30*abb88n93+t104*t188*t32*abb88n83+t104*t188*t34*abb88n10&
         &2+t104*t188*t82*abb88n85+t104*t188*t84*abb88n82+t104*t189*t2*abb88n85+&
         &t104*t189*t3*abb88n82+t104*t189*t4*abb88n83+t104*t189*t5*abb88n102+t10&
         &4*t189*t6*abb88n93+t122*t17*t187*abb88n85+t122*t188*t37*abb88n85+t123*&
         &t17*t187*abb88n82+t123*t188*t37*abb88n82+t15*t184*t6*abb88n95+t15*t184&
         &*t7*abb88n84+t16*t184*t5*abb88n84+t17*t184*t2*abb88n85+t17*t184*t3*abb&
         &88n82+t17*t184*t4*abb88n83+t17*t184*t5*abb88n102+t17*t184*t6*abb88n93+&
         &t17*t187*t48*abb88n93+t17*t187*t54*abb88n83+t17*t187*t63*abb88n102+t18&
         &4*t20*t4*abb88n77+t184*t20*t5*abb88n95+t184*t21*t6*abb88n77+t185*t2*t3&
         &7*abb88n85+t185*t3*t37*abb88n82+t185*t30*t4*abb88n77+t185*t30*t5*abb88&
         &n95+t185*t32*t6*abb88n77+t185*t34*t6*abb88n95+t185*t34*t7*abb88n84+t18&
         &5*t36*t5*abb88n84+t185*t37*t4*abb88n83+t185*t37*t5*abb88n102+t185*t37*&
         &t6*abb88n93+t188*t37*t48*abb88n93+t188*t37*t54*abb88n83+t188*t37*t63*a&
         &bb88n102+t189*t4*t48*abb88n77+t189*t48*t5*abb88n95+t189*t5*t71*abb88n8&
         &4+t189*t54*t6*abb88n77+t189*t6*t63*abb88n95+t189*t63*t7*abb88n84)+t1*t&
         &178*abb88n76+t1*t179*abb88n76+t1*t180*abb88n76+t1*t181*abb88n76+t1*t18&
         &2*abb88n76+t1*t183*abb88n76+t10*t15*t37*abb88n76+t10*t17*t34*abb88n76+&
         &t102*t104*t5*abb88n76+t104*t12*t34*abb88n76+t104*t13*t15*abb88n76+t104&
         &*t15*t9*abb88n76+t104*t34*t8*abb88n76+t104*t5*t98*abb88n76+t11*t15*t37&
         &*abb88n76+t11*t17*t34*abb88n76+t12*t37*t63*abb88n76+t13*t17*t63*abb88n&
         &76+t145*t37*t5*abb88n76+t149*t17*t5*abb88n76+t153*t37*t5*abb88n76+t155&
         &*t17*t5*abb88n76+t17*t63*t9*abb88n76+t37*t63*t8*abb88n76)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d88:
   subroutine     reconstruct_d88(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group9
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group9), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_88:
      coeffs%coeffs_88%c0 = derivative(czip)
      coeffs%coeffs_88%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_88%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_88%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_88%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_88%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_88%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_88%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_88%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_88%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_88%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_88%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_88%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_88%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_88%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_88%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_88%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_88%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_88%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_88%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_88%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_88%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_88%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_88%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_88%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_88%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_88%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_88%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_88%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_88%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_88%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_88%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_88%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_88%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_88%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_88%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_88%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_88%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_88%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_88%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_88%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_88%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_88%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_88%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_88%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_88%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_88%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_88%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_88%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_88%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_88%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_88%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_88%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_88%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_88%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_88%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_88%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_88%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_88%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_88%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_88%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_88%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_88%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_88%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_88%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_88%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_88%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_88%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_88%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_88%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_88:
   end subroutine reconstruct_d88
!---#] subroutine reconstruct_d88:
end module p9_udbar_neepgg_d88h3l1d
