module     p9_udbar_neepgg_d90h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Wp2jets/1.4/Virtual
   ! /p9_udbar_neepgg/helicity3/d90h3l1d.f90
   ! generator: haggies (1.1)
   use p9_udbar_neepgg_config, only: ki
   use p9_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   integer, private :: iv4
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d90
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3, i4) result(numerator)
      use p9_udbar_neepgg_globalsl1, only: epspow
      use p9_udbar_neepgg_kinematics
      use p9_udbar_neepgg_abbrevd90h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      integer, intent(in), optional :: i4
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      complex(ki) :: t42
      complex(ki) :: t43
      complex(ki) :: t44
      complex(ki) :: t45
      complex(ki) :: t46
      complex(ki) :: t47
      complex(ki) :: t48
      complex(ki) :: t49
      complex(ki) :: t50
      complex(ki) :: t51
      complex(ki) :: t52
      complex(ki) :: t53
      complex(ki) :: t54
      complex(ki) :: t55
      complex(ki) :: t56
      complex(ki) :: t57
      complex(ki) :: t58
      complex(ki) :: t59
      complex(ki) :: t60
      complex(ki) :: t61
      complex(ki) :: t62
      complex(ki) :: t63
      complex(ki) :: t64
      complex(ki) :: t65
      complex(ki) :: t66
      complex(ki) :: t67
      complex(ki) :: t68
      complex(ki) :: t69
      complex(ki) :: t70
      complex(ki) :: t71
      complex(ki) :: t72
      complex(ki) :: t73
      complex(ki) :: t74
      complex(ki) :: t75
      complex(ki) :: t76
      complex(ki) :: t77
      complex(ki) :: t78
      complex(ki) :: t79
      complex(ki) :: t80
      complex(ki) :: t81
      complex(ki) :: t82
      complex(ki) :: t83
      complex(ki) :: t84
      complex(ki) :: t85
      complex(ki) :: t86
      complex(ki) :: t87
      complex(ki) :: t88
      complex(ki) :: t89
      complex(ki) :: t90
      complex(ki) :: t91
      complex(ki) :: t92
      complex(ki) :: t93
      complex(ki) :: t94
      complex(ki) :: t95
      complex(ki) :: t96
      complex(ki) :: t97
      complex(ki) :: t98
      complex(ki) :: t99
      complex(ki) :: t100
      complex(ki) :: t101
      complex(ki) :: t102
      complex(ki) :: t103
      complex(ki) :: t104
      complex(ki) :: t105
      complex(ki) :: t106
      complex(ki) :: t107
      complex(ki) :: t108
      complex(ki) :: t109
      complex(ki) :: t110
      complex(ki) :: t111
      complex(ki) :: t112
      real(ki) :: t113
      real(ki) :: t114
      real(ki) :: t115
      real(ki) :: t116
      real(ki) :: t117
      real(ki) :: t118
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(present(i4)) then
         iv4 = i4
         deg = 4
      else
         iv4 = 1
      end if
      if(deg.eq.0) then
         numerator = abb90n76
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k1(iv1)
      t7 = spvak5k6(iv1)
      t8 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb90n126+t2*abb90n136+t3*abb90n144+t4*abb90n148+t5*abb&
         &90n149+t6*abb90n138+t7*abb90n142+t8*abb90n137)
         return
      end if
      t113 = d(iv1,iv2)
      t9 = k2(iv2)
      t10 = k6(iv2)
      t11 = spvak3k1(iv2)
      t12 = t1*t11
      t13 = spvak3k4(iv2)
      t14 = t1*t13
      t15 = spvak6k5(iv2)
      t16 = k1(iv2)
      t17 = spvak3k1(iv1)
      t18 = t16*t17
      t19 = t16*t5
      t20 = k5(iv2)
      t21 = t13*t2
      t22 = spvak5k1(iv2)
      t23 = spvak5k6(iv2)
      t24 = t2*t23
      t25 = t5*t9
      t26 = t7*t9
      t27 = t11*t3
      t28 = t13*t3
      t29 = t23*t3
      t30 = t17*t20
      t31 = t20*t5
      t32 = t20*t7
      t33 = t23*t4
      t34 = t10*t7
      t35 = spvak2k1(iv1)
      t36 = t23*t35
      t37 = spvak2k1(iv2)
      t38 = t37*t7
      t39 = spvak2k5(iv1)
      t40 = t23*t39
      t41 = spvak2k5(iv2)
      t42 = t41*t7
      t43 = t17*t23
      t44 = t11*t7
      t45 = t22*t5
      t46 = t23*t5
      t47 = t15*t5
      t48 = t13*t6
      t49 = t13*t7
      t50 = t13*t8
      t51 = t23*t6
      t52 = t22*t7
      t53 = spvak6k1(iv2)
      t54 = t53*t7
      t55 = t15*t7
      t56 = spvak6k1(iv1)
      t57 = t23*t56
      t58 = t23*t8
      if(deg.eq.2) then
         numerator = ((2.0_ki)*t113*abb90n125+t12*abb90n94+t14*abb90n140+t18*abb&
         &90n94+t19*abb90n140+t21*abb90n146+t24*abb90n121+t25*abb90n146+t26*abb9&
         &0n121+t27*abb90n96+t28*abb90n140+t29*abb90n127+t30*abb90n96+t31*abb90n&
         &140+t32*abb90n127+t33*abb90n123+t34*abb90n123+t36*abb90n104+t38*abb90n&
         &104+t40*abb90n124+t42*abb90n124+t43*abb90n93+t44*abb90n93+t45*abb90n14&
         &3+t46*abb90n145+t47*abb90n147+t48*abb90n143+t49*abb90n145+t50*abb90n14&
         &7+t51*abb90n101+t52*abb90n101+t54*abb90n103+t55*abb90n113+t57*abb90n10&
         &3+t58*abb90n113+t1*t10*abb90n132+t1*t15*abb90n114+t1*t9*abb90n105+t10*&
         &t3*abb90n132+t10*t6*abb90n92+t15*t3*abb90n116+t15*t6*abb90n91+t16*t2*a&
         &bb90n105+t16*t4*abb90n132+t16*t8*abb90n114+t2*t20*abb90n110+t2*t22*abb&
         &90n85+t20*t4*abb90n132+t20*t8*abb90n116+t22*t4*abb90n92+t22*t8*abb90n9&
         &1+t3*t9*abb90n110+t6*t9*abb90n85)
         return
      end if
      t114 = d(iv2,iv3)
      t115 = d(iv1,iv3)
      t59 = k1(iv3)
      t60 = k2(iv3)
      t61 = k5(iv3)
      t62 = k6(iv3)
      t63 = spvak3k1(iv3)
      t64 = spvak3k4(iv3)
      t65 = spvak5k1(iv3)
      t66 = spvak5k6(iv3)
      t67 = spvak6k5(iv3)
      t68 = spvak2k5(iv3)
      t69 = t2*t64
      t70 = spvak6k1(iv3)
      t71 = t2*t66
      t72 = t64*t9
      t73 = t66*t9
      t74 = t5*t60
      t75 = t13*t60
      t76 = t60*t7
      t77 = t23*t60
      t78 = t13*t35
      t79 = t66*t78
      t80 = t35*t64
      t81 = t23*t80
      t82 = t37*t5
      t83 = t66*t82
      t84 = t37*t64
      t85 = t7*t84
      t86 = spvak2k1(iv3)
      t87 = t5*t86
      t88 = t23*t87
      t89 = t13*t86
      t90 = t7*t89
      t91 = spvak2k4(iv1)
      t92 = spvak2k4(iv2)
      t93 = spvak2k4(iv3)
      t94 = spvak2k6(iv1)
      t95 = spvak2k6(iv2)
      t96 = spvak2k6(iv3)
      t97 = t17*t66
      t98 = t11*t66
      t99 = t63*t7
      t100 = t23*t63
      t101 = t5*t65
      t102 = t5*t66
      t103 = t13*t65
      t104 = t13*t66
      t105 = t6*t64
      t106 = t22*t64
      t107 = t64*t7
      t108 = t23*t64
      t109 = t7*t70
      t110 = t23*t70
      t111 = t56*t66
      t112 = t53*t66
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t114*abb90n109+t10*t115*abb90n133+t11*t115*ab&
         &b90n95+t113*t59*abb90n109+t113*t60*abb90n107+t113*t61*abb90n106+t113*t&
         &62*abb90n133+t113*t63*abb90n95+t113*t64*abb90n141+t113*t65*abb90n84+t1&
         &13*t66*abb90n120+t113*t67*abb90n115+t114*t17*abb90n95+t114*t2*abb90n10&
         &7+t114*t3*abb90n106+t114*t4*abb90n133+t114*t5*abb90n141+t114*t6*abb90n&
         &84+t114*t7*abb90n120+t114*t8*abb90n115+t115*t13*abb90n141+t115*t15*abb&
         &90n115+t115*t16*abb90n109+t115*t20*abb90n106+t115*t22*abb90n84+t115*t2&
         &3*abb90n120+t115*t9*abb90n107)+t79*abb90n86+t81*abb90n86+t83*abb90n86+&
         &t85*abb90n86+t88*abb90n86+t90*abb90n86+t100*t8*abb90n80+t101*t15*abb90&
         &n87+t102*t15*abb90n122+t103*t8*abb90n87+t104*t8*abb90n122+t105*t15*abb&
         &90n87+t106*t8*abb90n87+t107*t15*abb90n122+t108*t8*abb90n122+t109*t15*a&
         &bb90n97+t110*t8*abb90n97+t111*t15*abb90n97+t112*t8*abb90n97+t12*t67*ab&
         &b90n90+t14*t67*abb90n111+t15*t71*abb90n134+t15*t76*abb90n134+t15*t97*a&
         &bb90n80+t15*t99*abb90n80+t18*t67*abb90n90+t19*t67*abb90n111+t21*t65*ab&
         &b90n79+t21*t66*abb90n118+t22*t69*abb90n79+t22*t74*abb90n79+t23*t69*abb&
         &90n118+t23*t74*abb90n118+t24*t67*abb90n134+t24*t70*abb90n100+t25*t65*a&
         &bb90n79+t25*t66*abb90n118+t26*t67*abb90n134+t26*t70*abb90n100+t27*t67*&
         &abb90n88+t28*t67*abb90n111+t29*t67*abb90n134+t30*t67*abb90n88+t31*t67*&
         &abb90n111+t32*t67*abb90n134+t33*t70*abb90n98+t34*t70*abb90n98+t36*t67*&
         &abb90n102+t38*t67*abb90n102+t43*t67*abb90n80+t44*t67*abb90n80+t45*t67*&
         &abb90n87+t46*t67*abb90n122+t48*t67*abb90n87+t49*t67*abb90n122+t51*t67*&
         &abb90n99+t52*t67*abb90n99+t53*t71*abb90n100+t53*t76*abb90n100+t54*t67*&
         &abb90n97+t56*t73*abb90n100+t56*t77*abb90n100+t57*t67*abb90n97+t6*t72*a&
         &bb90n79+t6*t75*abb90n79+t7*t72*abb90n118+t7*t75*abb90n118+t73*t8*abb90&
         &n134+t77*t8*abb90n134+t8*t98*abb90n80+t1*t15*t63*abb90n90+t1*t15*t64*a&
         &bb90n111+t10*t17*t66*abb90n83+t10*t39*t66*abb90n131+t10*t56*t66*abb90n&
         &98+t10*t63*t7*abb90n83+t10*t68*t7*abb90n131+t11*t2*t66*abb90n81+t11*t4&
         &*t66*abb90n83+t11*t59*t8*abb90n90+t11*t60*t7*abb90n81+t11*t61*t8*abb90&
         &n88+t11*t62*t7*abb90n83+t13*t39*t66*abb90n139+t13*t59*t8*abb90n111+t13&
         &*t61*t8*abb90n111+t13*t68*t7*abb90n139+t15*t17*t59*abb90n90+t15*t17*t6&
         &1*abb90n88+t15*t3*t63*abb90n88+t15*t3*t64*abb90n111+t15*t3*t66*abb90n1&
         &34+t15*t35*t66*abb90n102+t15*t5*t59*abb90n111+t15*t5*t61*abb90n111+t15&
         &*t6*t66*abb90n99+t15*t61*t7*abb90n134+t15*t65*t7*abb90n99+t15*t66*t91*&
         &abb90n117+t15*t66*t94*abb90n129+t15*t7*t86*abb90n102+t15*t7*t93*abb90n&
         &117+t15*t7*t96*abb90n129+t16*t63*t8*abb90n90+t16*t64*t8*abb90n111+t17*&
         &t23*t60*abb90n81+t17*t23*t62*abb90n83+t17*t66*t9*abb90n81+t2*t23*t63*a&
         &bb90n81+t2*t23*t68*abb90n128+t2*t41*t66*abb90n128+t20*t63*t8*abb90n88+&
         &t20*t64*t8*abb90n111+t20*t66*t8*abb90n134+t22*t66*t8*abb90n99+t23*t39*&
         &t60*abb90n128+t23*t39*t62*abb90n131+t23*t39*t64*abb90n139+t23*t4*t63*a&
         &bb90n83+t23*t4*t68*abb90n131+t23*t5*t68*abb90n139+t23*t56*t62*abb90n98&
         &+t23*t61*t8*abb90n134+t23*t65*t8*abb90n99+t23*t67*t91*abb90n117+t23*t6&
         &7*t94*abb90n129+t23*t8*t86*abb90n102+t23*t8*t93*abb90n117+t23*t8*t96*a&
         &bb90n129+t37*t66*t8*abb90n102+t39*t66*t9*abb90n128+t4*t41*t66*abb90n13&
         &1+t4*t53*t66*abb90n98+t41*t5*t66*abb90n139+t41*t60*t7*abb90n128+t41*t6&
         &2*t7*abb90n131+t41*t64*t7*abb90n139+t53*t62*t7*abb90n98+t63*t7*t9*abb9&
         &0n81+t66*t8*t92*abb90n117+t66*t8*t95*abb90n129+t67*t7*t92*abb90n117+t6&
         &7*t7*t95*abb90n129+t68*t7*t9*abb90n128)
         return
      end if
      t116 = d(iv3,iv4)
      t117 = d(iv2,iv4)
      t118 = d(iv1,iv4)
      t1 = spvak5k6(iv4)
      t2 = spvak2k5(iv4)
      t3 = spvak6k5(iv4)
      t4 = spvak3k1(iv4)
      t9 = spvak5k1(iv4)
      t10 = spvak3k4(iv4)
      t12 = spvak6k1(iv4)
      t14 = t10*t35
      t16 = t10*t37
      t18 = t10*t86
      t19 = spvak2k1(iv4)
      t20 = t19*t5
      t21 = t13*t19
      t19 = t19*t64
      if(deg.eq.4) then
         numerator = ((8.0_ki)*(t113*t116*abb90n108+t114*t118*abb90n108+t115*t11&
         &7*abb90n108)+(2.0_ki)*(t100*t118*abb90n82+t101*t117*abb90n78+t102*t117&
         &*abb90n119+t103*t118*abb90n78+t104*t118*abb90n119+t105*t117*abb90n78+t&
         &106*t118*abb90n78+t107*t117*abb90n119+t108*t118*abb90n119+t109*t117*ab&
         &b90n99+t110*t118*abb90n99+t111*t117*abb90n99+t112*t118*abb90n99+t116*t&
         &40*abb90n130+t116*t42*abb90n130+t116*t43*abb90n82+t116*t44*abb90n82+t1&
         &16*t45*abb90n78+t116*t46*abb90n119+t116*t47*abb90n112+t116*t48*abb90n7&
         &8+t116*t49*abb90n119+t116*t50*abb90n112+t116*t54*abb90n99+t116*t55*abb&
         &90n135+t116*t57*abb90n99+t116*t58*abb90n135+t117*t97*abb90n82+t117*t99&
         &*abb90n82+t118*t98*abb90n82+t1*t11*t115*abb90n82+t1*t113*t63*abb90n82+&
         &t1*t113*t64*abb90n119+t1*t113*t67*abb90n135+t1*t113*t68*abb90n130+t1*t&
         &113*t70*abb90n99+t1*t114*t17*abb90n82+t1*t114*t39*abb90n130+t1*t114*t5&
         &*abb90n119+t1*t114*t56*abb90n99+t1*t114*t8*abb90n135+t1*t115*t13*abb90&
         &n119+t1*t115*t15*abb90n135+t1*t115*t41*abb90n130+t1*t115*t53*abb90n99+&
         &t10*t113*t65*abb90n78+t10*t113*t66*abb90n119+t10*t113*t67*abb90n112+t1&
         &0*t114*t6*abb90n78+t10*t114*t7*abb90n119+t10*t114*t8*abb90n112+t10*t11&
         &5*t15*abb90n112+t10*t115*t22*abb90n78+t10*t115*t23*abb90n119+t11*t115*&
         &t3*abb90n89+t11*t116*t8*abb90n89+t11*t118*t67*abb90n89+t113*t12*t66*ab&
         &b90n99+t113*t2*t66*abb90n130+t113*t3*t63*abb90n89+t113*t3*t64*abb90n11&
         &2+t113*t3*t66*abb90n135+t113*t4*t66*abb90n82+t113*t4*t67*abb90n89+t113&
         &*t64*t9*abb90n78+t114*t12*t7*abb90n99+t114*t17*t3*abb90n89+t114*t2*t7*&
         &abb90n130+t114*t3*t5*abb90n112+t114*t3*t7*abb90n135+t114*t4*t7*abb90n8&
         &2+t114*t4*t8*abb90n89+t114*t5*t9*abb90n78+t115*t12*t23*abb90n99+t115*t&
         &13*t3*abb90n112+t115*t13*t9*abb90n78+t115*t15*t4*abb90n89+t115*t2*t23*&
         &abb90n130+t115*t23*t3*abb90n135+t115*t23*t4*abb90n82+t116*t15*t17*abb9&
         &0n89+t117*t17*t67*abb90n89+t117*t39*t66*abb90n130+t117*t5*t67*abb90n11&
         &2+t117*t63*t8*abb90n89+t117*t64*t8*abb90n112+t117*t66*t8*abb90n135+t11&
         &7*t67*t7*abb90n135+t117*t68*t7*abb90n130+t118*t13*t67*abb90n112+t118*t&
         &15*t63*abb90n89+t118*t15*t64*abb90n112+t118*t15*t66*abb90n135+t118*t23&
         &*t67*abb90n135+t118*t23*t68*abb90n130+t118*t41*t66*abb90n130)+t3*t79*a&
         &bb90n77+t3*t81*abb90n77+t3*t83*abb90n77+t3*t85*abb90n77+t3*t88*abb90n7&
         &7+t3*t90*abb90n77+t1*t15*t80*abb90n77+t1*t15*t87*abb90n77+t1*t67*t78*a&
         &bb90n77+t1*t67*t82*abb90n77+t1*t8*t84*abb90n77+t1*t8*t89*abb90n77+t14*&
         &t15*t66*abb90n77+t14*t23*t67*abb90n77+t15*t18*t7*abb90n77+t15*t19*t7*a&
         &bb90n77+t15*t20*t66*abb90n77+t16*t66*t8*abb90n77+t16*t67*t7*abb90n77+t&
         &18*t23*t8*abb90n77+t19*t23*t8*abb90n77+t20*t23*t67*abb90n77+t21*t66*t8&
         &*abb90n77+t21*t67*t7*abb90n77)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d90:
   subroutine     reconstruct_d90(coeffs)
      use p9_udbar_neepgg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 4 case:
      !---[# reconstruct coeffs%coeffs_90:
      coeffs%coeffs_90%c0 = derivative(czip)
      coeffs%coeffs_90%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_90%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_90%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_90%c1(1,4) = derivative(czip,1,1,1,1) / 24.0_ki
      coeffs%coeffs_90%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_90%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_90%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_90%c1(2,4) = derivative(czip,2,2,2,2) / 24.0_ki
      coeffs%coeffs_90%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_90%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_90%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_90%c1(3,4) = derivative(czip,3,3,3,3) / 24.0_ki
      coeffs%coeffs_90%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_90%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_90%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_90%c1(4,4) = derivative(czip,4,4,4,4) / 24.0_ki
      coeffs%coeffs_90%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_90%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_90%c2(1,3) = -derivative(czip,1,2,2,2) / 6.0_ki
      coeffs%coeffs_90%c2(1,4) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_90%c2(1,5) = derivative(czip,1,1,2,2) / 4.0_ki
      coeffs%coeffs_90%c2(1,6) = -derivative(czip,1,1,1,2) / 6.0_ki
      coeffs%coeffs_90%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_90%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_90%c2(2,3) = -derivative(czip,1,3,3,3) / 6.0_ki
      coeffs%coeffs_90%c2(2,4) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_90%c2(2,5) = derivative(czip,1,1,3,3) / 4.0_ki
      coeffs%coeffs_90%c2(2,6) = -derivative(czip,1,1,1,3) / 6.0_ki
      coeffs%coeffs_90%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_90%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_90%c2(3,3) = -derivative(czip,1,4,4,4) / 6.0_ki
      coeffs%coeffs_90%c2(3,4) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_90%c2(3,5) = derivative(czip,1,1,4,4) / 4.0_ki
      coeffs%coeffs_90%c2(3,6) = -derivative(czip,1,1,1,4) / 6.0_ki
      coeffs%coeffs_90%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_90%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_90%c2(4,3) = derivative(czip,2,3,3,3) / 6.0_ki
      coeffs%coeffs_90%c2(4,4) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_90%c2(4,5) = derivative(czip,2,2,3,3) / 4.0_ki
      coeffs%coeffs_90%c2(4,6) = derivative(czip,2,2,2,3) / 6.0_ki
      coeffs%coeffs_90%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_90%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_90%c2(5,3) = derivative(czip,2,4,4,4) / 6.0_ki
      coeffs%coeffs_90%c2(5,4) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_90%c2(5,5) = derivative(czip,2,2,4,4) / 4.0_ki
      coeffs%coeffs_90%c2(5,6) = derivative(czip,2,2,2,4) / 6.0_ki
      coeffs%coeffs_90%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_90%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_90%c2(6,3) = derivative(czip,3,4,4,4) / 6.0_ki
      coeffs%coeffs_90%c2(6,4) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_90%c2(6,5) = derivative(czip,3,3,4,4) / 4.0_ki
      coeffs%coeffs_90%c2(6,6) = derivative(czip,3,3,3,4) / 6.0_ki
      coeffs%coeffs_90%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_90%c3(1,2) = -derivative(czip,1,2,3,3) / 2.0_ki
      coeffs%coeffs_90%c3(1,3) = -derivative(czip,1,2,2,3) / 2.0_ki
      coeffs%coeffs_90%c3(1,4) = derivative(czip,1,1,2,3) / 2.0_ki
      coeffs%coeffs_90%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_90%c3(2,2) = -derivative(czip,1,2,4,4) / 2.0_ki
      coeffs%coeffs_90%c3(2,3) = -derivative(czip,1,2,2,4) / 2.0_ki
      coeffs%coeffs_90%c3(2,4) = derivative(czip,1,1,2,4) / 2.0_ki
      coeffs%coeffs_90%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_90%c3(3,2) = -derivative(czip,1,3,4,4) / 2.0_ki
      coeffs%coeffs_90%c3(3,3) = -derivative(czip,1,3,3,4) / 2.0_ki
      coeffs%coeffs_90%c3(3,4) = derivative(czip,1,1,3,4) / 2.0_ki
      coeffs%coeffs_90%c3(4,1) = -derivative(czip,2,3,4)
      coeffs%coeffs_90%c3(4,2) = derivative(czip,2,3,4,4) / 2.0_ki
      coeffs%coeffs_90%c3(4,3) = derivative(czip,2,3,3,4) / 2.0_ki
      coeffs%coeffs_90%c3(4,4) = derivative(czip,2,2,3,4) / 2.0_ki
      coeffs%coeffs_90%c4(1,1) = -derivative(czip,1,2,3,4)
      !---#] reconstruct coeffs%coeffs_90:
   end subroutine reconstruct_d90
!---#] subroutine reconstruct_d90:
end module p9_udbar_neepgg_d90h3l1d
